<?php
function activemember360()
{
	$GLOBALS['mbr'] = activemember360::getInstance();
}

function MBR()
{
	IF ( empty( $GLOBALS['mbr'] ) ) :
		$GLOBALS['mbr'] = activemember360::getInstance();
	ENDIF;

	return $GLOBALS['mbr'];
}

class mbr_redux_base_class
{

	public $arr_default_main_admin_panel_settings = [
		'dev_mode'           => FALSE,
		'update_notice'      => FALSE,
		'menu_type'          => 'menu',
		'show_import_export' => FALSE,
		'page_priority'      => 3,
		'admin_bar'          => FALSE
	];

	public $arr_default_sub_admin_panel_settings = [
		'menu_type'          => 'submenu',
		'allow_sub_menu'     => TRUE,
		'customizer'         => TRUE,
		'default_show'       => FALSE,
		'default_mark'       => '',
		'output'             => TRUE,
		'output_tag'         => TRUE,
		'settings_api'       => TRUE,
		'display_version'    => FALSE,
		'update_notice'      => FALSE,
		'admin_bar'          => FALSE,
		'cdn_check_time'     => '1440',
		'compiler'           => TRUE,
		'page_permissions'   => 'activate_plugins',
		'disable_save_warn'  => TRUE,
		'database'           => '',
		'transient_time'     => '',
		'network_sites'      => TRUE,
		'use_cdn'            => TRUE,
		'footer_credit'      => 'ActiveMember360 by responseFLOW Inc.',
		'dev_mode'           => FALSE,
		'show_import_export' => FALSE,
		'hide_reset'         => TRUE,
		'hide_save'          => FALSE,
		'ajax_save'          => FALSE,
		'save_defaults'      => FALSE
	];

	public $arr_default_hidden_admin_panel_settings = [
		'dev_mode'           => FALSE,
		'update_notice'      => FALSE,
		'menu_type'          => 'hidden'
	];

	function alternate_header()
	{
		return MBR_REDUX_HEADER_TEMPLATE;
	}

}

trait TRAIT__getInstance
{
	public static function getInstance()
	{
		// Store the instance locally to avoid private static replication
		static $instance = null;
		// Only run these methods if they haven't been ran previously
		IF (null === $instance) :
			$instance = new self();
			IF ( method_exists( $instance, '_load' ) ) :
				$instance->_load();
			ENDIF;
		ENDIF;
		// Always return the instance

		return $instance;
	}

	function __construct()
	{
		IF ( method_exists( $this, 'init_hooks' ) ) :
			add_action('mbr/init/hooks', [ $this, 'init_hooks' ] );
		ENDIF;

		IF ( method_exists( $this, 'plugins_loaded' ) ) :
			add_action('plugins_loaded', [ $this, 'plugins_loaded' ], 11 );
		ENDIF;
	}
}

function mbr_require_once( $file = NULL, $path = NULL )
{
	IF ( is_null( $file ) ) :
		TRY	{
		  throw new Exception( __( 'Trying to load a file with NULL value', 'activemember360' ) );
		} CATCH ( Exception $e ) {
			mbr_exit_with_error( $e->getMessage() );
		}
	ENDIF;

	IF ( is_null( $path ) ) :
		$path = __DIR__;
	ENDIF;

	$path_file = $path . '/' . $file;

	IF ( ! file_exists( $path_file ) ) :
		TRY	{
			throw new Exception(  __( 'The following file does not exist', 'activemember360') );
		} CATCH ( Exception $e ) {
			mbr_exit_with_error( $e->getMessage() . ':<br/>' .  $file );
		}
	ENDIF;

	IF ( ! ( include_once $path_file ) ) :
		TRY	{
			throw new Exception( __( 'The following file could not be loaded', 'activemember360' ) );
		} CATCH ( Exception $e ) {
			mbr_exit_with_error( $e->getMessage() . ':<br/>' .  $file );
		}
	ENDIF;

}

function mbr_sys_load()
{
	global $mbr, $MBR_OPTIONS, $MBR_PERMS;

	$GLOBALS['mbr']                     = FALSE;
	$GLOBALS['MBR_OPTIONS']             = [];
	$GLOBALS['MBR_PERMS']               = [];
	$GLOBALS['mbrpayment']              = FALSE;
	$GLOBALS['mbr_tracking']            = FALSE;

	
	mbr_constant( 'MBR_IGNORE_EXCERPT', TRUE );

	mbr_constant( 'MBR_TEXTDOMAIN', 'activemember360' );
	mbr_constant( 'MBR_MULTISITE', is_multisite() );

	mbr_constant( 'MBRVERSIONDB', '1.0.000' );

	mbr_constant( 'MBRPATH', dirname( __FILE__ ) . '/' );
	mbr_constant( 'MBRFULL', dirname( __FILE__ ) . '/' . basename( __FILE__ ) );

	mbr_constant( 'COOKIE_DOMAIN', false );

	mbr_constant( 'MBR_SELECTBOX_DO_DISPLAY_ID', true );
	mbr_constant( 'MBR_SELECTBOX_DO_NOT_DISPLAY_ID', false );
	mbr_constant( 'MBR_SELECTBOX_DO_MULTIPLE', true );
	mbr_constant( 'MBR_SELECTBOX_DO_NOT_MULTIPLE', false );
	mbr_constant( 'MBR_SELECTBOX_DO_SELECT2', true );
	mbr_constant( 'MBR_SELECTBOX_DO_NOT_SELECT2', false );

	mbr_constant('MBRWPURL',                        home_url());

	
	mbr_constant('NOUPDATES', false);

	mbr_constant('MBR_DIR',                         dirname(__FILE__));
	mbr_constant('MBR_MENU_PARENT_PAGE',            'mbr-admin-menu');

	mbr_constant('MBR_REDUX_FRAMEWORK_DIR',         MBR_DIR . '/libs/redux-framework');
	mbr_constant('MBR_REDUX_FRAMEWORK_LOADER',      MBR_REDUX_FRAMEWORK_DIR . '/framework.php');

	mbr_constant('MBR_REDUX_EXTENSIONS_DIR',        MBR_DIR . '/libs/redux-extensions');

	mbr_constant('MBR_REDUX_HEADER_TEMPLATE',       MBR_DIR . '/templates/header.tpl.php');

	mbr_constant('MBRCUSTSC',                       'mbrcustsc');
	mbr_constant('MBRCUSTPRODUCTS',                 'mbrcustproducts');
	mbr_constant('MBRCUSTSUBSCRIPTIONS',            'mbrcustsubscriptions');
	mbr_constant('MBRCUSTORDERS',                   'mbrcustorders');
	mbr_constant('MBRCUSTCHECKOUTTPL',              'mbrcustcheckouttpl');

	mbr_constant('MBR_PRODUCT_SETTINGS',            'mbr_product_settings');
	mbr_constant('MBR_SUBSCRIPTION_SETTINGS',       'mbr_subscription_settings');
	mbr_constant('MBR_CHECKOUTTPL_SETTINGS',        'mbr_checkouttpl_settings');

	mbr_constant('MBR_REDUX_INACTIVE_OITEM_HDR',    __('Warning: Inactive Product', 'activemember360'));
	mbr_constant('MBR_REDUX_INACTIVE_OITEM_MSG',    '<p>' . __('This product is currently deactivated and cannot be edited. Please activate it in order to proceed.', 'activemember360') . '</p>');

	mbr_constant('MBR_REDUX_STRIPE_INIT',           MBR_DIR . '/libs/stripe/init.php');
	mbr_constant('MBR_STRIPE_DASHBOARD_LIVE',       '<a href="https://dashboard.stripe.com/dashboard/"      target="_stripe_dashboard"><strong>'      . __('Live Stripe Dashboard', 'activemember360') . '</strong></a>');
	mbr_constant('MBR_STRIPE_DASHBOARD_TEST',       '<a href="https://dashboard.stripe.com/test/dashboard/" target="_stripe_dashboard"><strong>'      . __('Test Stripe Dashboard', 'activemember360') . '</strong></a>');
	mbr_constant('MBR_PASSWORD_BASE',               'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!@#$%^*()');

	mbr_constant( 'MBR_RESET_REDIRECT_SETTINGS_YES', TRUE );
	mbr_constant( 'MBR_RESET_REDIRECT_SETTINGS_NO',  FALSE );

	mbr_load_site_options();

	mbr_require_once( 'libs/meta-box/framework/meta-box.php' );
	//mbr_require_once( 'libs/meta-box/extensions/mb-custom-table/mb-custom-table.php' );
	//mbr_require_once( 'libs/meta-box/extensions/mb-settings-pagemb-settings-page.php' );
	mbr_require_once( 'libs/meta-box/extensions/meta-box-group/meta-box-group.php' );
	mbr_require_once( 'libs/meta-box/extensions/meta-box-tabs/meta-box-tabs.php' );
	mbr_require_once( 'libs/meta-box/extensions/meta-box-conditional-logic/meta-box-conditional-logic.php' );
	//mbr_require_once( 'libs/meta-box/extensions/mb-admin-columns/mb-admin-columns.php' );

	mbr_require_once( 'class.menu.php' );
	mbr_require_once( 'class.api_settings.php' );
	mbr_require_once( 'class.plugin_options.php' );
	mbr_require_once( 'class.memberships.php' );
	mbr_require_once( 'trait.methods.php' );
	mbr_require_once( 'trait.geoip.php' );
	mbr_require_once( 'trait.shortcodes.php' );
	mbr_require_once( 'trait.activesdk.php' );
	mbr_require_once( 'trait.mailtemplates.php' );
	mbr_require_once( 'trait.database.php' );
	mbr_require_once( 'trait.class_helpers.php' );
	IF ($MBR_OPTIONS['cond_widget_control_enabled']) :
		mbr_require_once( 'class.widget_control.php' );
	ENDIF;
	mbr_require_once( 'class.privacy.php' );
	mbr_require_once( 'class.error.php' );
	mbr_require_once( 'class.endpoints.php' );
	mbr_require_once( 'class.webhooks.php' );
	mbr_require_once( 'class.bulk_editor.php' );
	mbr_require_once( 'class.bbpress.php' );
	mbr_require_once( 'class.role_mapping.php' );
	mbr_require_once( 'class.extensions.php' );
	mbr_require_once( 'class.utilities.php' );
	mbr_require_once( 'class.templates.php' );
	mbr_require_once( 'class.contacts.php' );
	mbr_require_once( 'class.passwords.php' );
	mbr_require_once( 'class.wpcourseware.php' );

	mbr_require_once( 'class.conditionals.php' );

	$arr_license = get_gz_option('site_license_status');

	IF ( $arr_license['status'] <> 'inactive' ) :
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_ticket_system_enabled'] ) ) :
			mbr_require_once( 'tickets/mbr-tickets.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_themeswitcher_enabled'] ) ) :
			mbr_require_once( 'class.theme_switcher.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_alternate_member_menu_enabled'] ) ) :
			mbr_require_once( 'class.membership_menu.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_badgeos_enabled'] ) ) :
			mbr_require_once( 'class.badgeos.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_beaver_builder_enabled'] ) ) :
			mbr_require_once( 'class.beaver_builder.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_buddypress_enabled'] ) ) :
			mbr_require_once( 'class.buddypress.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_contactform7_enabled'] ) ) :
			mbr_require_once( 'class.contactform7.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_elementor_enabled'] ) ) :
			mbr_require_once( 'class.elementor.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_gamipress_enabled'] ) ) :
			mbr_require_once( 'class.gamipress.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_gutenberg_enabled'] ) ) :
			mbr_require_once( 'class.gutenberg.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_learndash_enabled'] ) ) :
			mbr_require_once( 'class.learndash.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_lifterlms_enabled'] ) ) :
			mbr_require_once( 'class.lifterlms.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_mailer_enabled'] ) ) :
			mbr_require_once( 'class.mailer.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_remoteauth_enabled'] ) ) :
			mbr_require_once( 'class.remoteauth.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_oxygenbuilder_enabled'] ) ) :
			mbr_require_once( 'class.oxygenbuilder.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_payments_enabled'] ) ) :
			mbr_require_once( 'class.payment_redux.php' );
			mbr_require_once( 'class.payment.php' );
		ENDIF;







		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_popup_maker_enabled'] ) ) :
			mbr_require_once( 'class.popup_maker.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_ac_tracking_enabled'] ) ) :
			mbr_require_once( 'class.tracking.php' );
		ENDIF;
		IF ( ! empty( $MBR_OPTIONS['extensions']['mbr_ext_woocommerce_enabled'] ) ) :
			mbr_require_once( 'class.woocommerce.php' );
		ENDIF;
		IF ( 'memberoni' === wp_get_theme()->template ) :
			mbr_require_once( 'class.memberoni.php' );
		ENDIF;
	ENDIF;

	IF ( is_admin() ) :

		mbr_require_once( 'trait.admin.php' );

		IF ( ! NOUPDATES ) :
			mbr_require_once( 'class.updates.php' );
		ENDIF;

		IF ( ! file_exists(__DIR__ . '/trait.custom_shortcodes.php' ) OR ! (include __DIR__ . '/trait.custom_shortcodes.php')) :
			trait TRAIT__custom_shortcodes { };
		ENDIF;

	ELSE :

		trait TRAIT__admin               { };
		trait TRAIT__custom_shortcodes   { };

	ENDIF;

	IF ( ! file_exists( __DIR__ . '/trait.miscellaneous.php' ) OR ! (include __DIR__ . '/trait.miscellaneous.php' ) ) :
		trait TRAIT__miscellaneous { };
	ENDIF;

	IF ( ! file_exists(__DIR__ . '/trait.plugin_loader.php' ) OR ! (include __DIR__ . '/trait.plugin_loader.php' ) ) :
		trait TRAIT__plugin_loader { };
	ENDIF;
}

function mbr_get_lock($lock_name)
{
	global $wpdb;

	IF (1 == (int)$wpdb->get_var("SELECT IS_FREE_LOCK('{$lock_name}')")) :
		IF (1 == (int)$wpdb->get_var("SELECT GET_LOCK('{$lock_name}', 0)")) :
			return TRUE;
		ENDIF;
	ENDIF;

	return FALSE;
}

function mbr_release_lock($lock_name)
{
	global $wpdb;

	$wpdb->get_var("SELECT RELEASE_LOCK('{$lock_name}')");
}

function mbr_wait_lock($lock_name, $wait=500000, $limit_loop=0)
{
	global $wpdb;

	$cnt_loop = 0;
	$do_loop = $limit_loop == 0 ? FALSE : TRUE;
	WHILE (1 <> (int)$wpdb->get_var("SELECT IS_FREE_LOCK('{$lock_name}')")) :
		usleep($wait);
		IF ($do_loop) :
			IF ($cnt_loop++ > $limit_loop) :
				return FALSE;
			ENDIF;
		ENDIF;
	ENDWHILE;

	return TRUE;
}

function get_file_contents( $pURL, $sslverify = false, $timeout = 60 )
{
	IF ( $tmpFILE = wp_remote_get( $pURL, ['timeout' => $timeout, 'sslverify' => $sslverify] ) ) :
		return wp_remote_retrieve_body( $tmpFILE );
	ENDIF;

	return false;
}

function post_file_contents( $pURL, $postDATA = [] )
{
	IF ( $tmpFILE = wp_remote_post( $pURL, $postDATA ) ) :
		return wp_remote_retrieve_body( $tmpFILE );
	ENDIF;

	return false;
}

function mbr_pre_get_posts( $query )
{
	$query->set( 'suppress_filters', false );
	global $wp_query;
	IF ( !is_null( $wp_query ) ) :
		$wp_query->set( 'suppress_filters', false );
	ENDIF;
}

function fake_class_infusionwp()
{
	
	class infusionWP { }
}




function mbr_init_redux()
{
	IF ( FALSE === ( require_once MBR_REDUX_FRAMEWORK_LOADER ) ) :
		IF ( FALSE === mbr_exit_with_error( 'redux_not_found' ) ) :
			wp_die( 'Redux Framework not found.' );
		ENDIF;
	ENDIF;
}

function checktrue( $val )
{
	return in_array( substr( lower_trim( $val ),0,1 ), [ '1','y','t' ] );
}

function checkfalse( $val )
{
	return in_array( substr( lower_trim( $val ),0,1 ), [ '0','n','f' ] );
}

function checknottrue( $val )
{
	return ! checktrue( $val );
}

function checknotfalsee( $val )
{
	return ! checkfalse( $val );
}

function mbr_plugin_deactivation( $plugin = '', $network_deactivate = FALSE )
{
	IF ( MBRNAME == $_GET['plugin'] ) :
		delete_option( 'cron' );
		do_action( 'mbr/webhooks/delete/local/all' );
		do_action( 'mbr_plugin_deactivation' );
	ENDIF;
}

IF ( ! function_exists('mbr_die' ) ) :
	function mbr_die( $what = null )
	{
		$buffer = '';
		WHILE (@ob_get_contents()) :
			$buffer = @ob_end_clean() . $buffer;
		ENDWHILE;
		defined( 'NO_PROCESS_OB' ) OR define( 'NO_PROCESS_OB', TRUE );
		die( '<pre>' . print_r( func_get_args(), true ) );
	}
ENDIF;

IF ( ! function_exists( 'swap' ) ) :
	function swap( &$x, &$y )
	{
		$t = $y;
		$y = $x;
		$x = $t;
	}
ENDIF;

IF ( ! function_exists( 'mbr_swap' ) ) :
	function mbr_swap( &$x, &$y )
	{
		$t = $y;
		$y = $x;
		$x = $t;
	}
ENDIF;

IF ( ! function_exists( 'mbr_log' ) ) :
	function mbr_log( $what = null )
	{
		global $current_user;
		$what = $what ? $what : '---';
		IF (is_array($what) OR is_object($what)) :
			$what = json_encode($what);
		ENDIF;
		$user = isset($current_user->user_email) ? $current_user->user_email : '---';
		MBR()->wpdb->insert(MBR()->wpdb->tbl_errorlog, ['user' => $user, 'ipnr' => MBR_IPADDR,  'log' => $what]);
	}
ENDIF;

IF (!function_exists('mbr_log_file')) :
	function mbr_log_file($what=null)
	{
		IF (!isset(MBR()->error_log)) :
			$error_log_dir = '/home/360woo/public_html/log/';
			IF (is_dir($error_log_dir)) :
				MBR()->error_log = $error_log_dir . date('Y-m-d_H:i:s') . '_' . $_SERVER['REMOTE_ADDR'];
			ENDIF;
		ENDIF;
		IF (isset(MBR()->error_log)) :
			error_log(date('Y-m-d H:i:s') . ': ' . print_r($what, true) . "\n", 3, MBR()->error_log);
		ENDIF;
	}
ENDIF;

IF (!function_exists('gzinflate')) :
	function gzinflate($data)
	{
		return $data;
	}
ENDIF;

IF (!function_exists('gzdeflate')) :
	function gzdeflate($data)
	{
		return $data;
	}
ENDIF;



function mbr_fetch_contact($parm=[], $update_session=true)
{
	return MBR()->fetch_contact($parm, $update_session);
}


function mbr_get_contact($contact_id=null, $email=null, $hash=null)
{
	return MBR()->fetch_contact(['id' => $contact_id, 'email' => $email, 'hash' => $hash]);
}


function mbr_get_contact_by_id($contact_id=null, $session=true)
{
	IF (empty($contact_id) OR !is_numeric($contact_id)) :
		return [];
	ENDIF;
	return MBR()->fetch_contact(['id' => $contact_id], $session);
}


function mbr_get_contact_by_email($email=null, $session=true)
{
	IF (empty($email) OR !is_email($email)) :
		return [];
	ENDIF;
	return MBR()->fetch_contact(['email' => $email], $session);
}


function mbr_get_contact_by_hash($hash=null, $session=true)
{
	IF (empty($hash)) :
		return [];
	ENDIF;
	return MBR()->fetch_contact(['hash' => $hash], $session);
}


function mbr_get_contact_id()
{
	IF (is_user_logged_in()) :
		return MBR()->fetch_contact_id();
	ENDIF;
	return null;
}


function mbr_get_contact_field($field=false)
{
	IF (is_user_logged_in() AND !empty($field)) :
		return !empty(MBR()->SESSION[$field]) ? MBR()->SESSION[$field] : '';
	ENDIF;
	return null;
}

function is_administrator()
{
	IF ( MBR_MULTISITE ) :
		global $blog_id;
		return is_super_admin() OR current_user_can_for_blog( $blog_id, 'administrator' );
	ENDIF;
	return current_user_can( 'activate_plugins' );
}


function mbr_is_contact()
{
	IF (is_user_logged_in()) :
		return MBR()->is_contact();
	ENDIF;
	return false;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


function mbr_process_tags($assign=null, $remove=null)
{
	IF (is_user_logged_in()) :
		return MBR()->process_tags($assign, $remove);
	ENDIF;
	return false;
}


function mbr_get_contact_tags()
{
	return MBR()->MBRTAGS;
}


function mbr_get_contact_membership_levels()
{
	return MBR()->MBRMEMB;
}


function mbr_get_contact_payment_failed_tags()
{
	return MBR()->MBRPAYF;
}


function mbr_is_failed_payment()
{
	return is_user_logged_in() AND !empty(MBR()->MBRPAYF);
}

function mbr_contact_has_tag( $tag_id = null )
{
	return !is_null($tag_id) AND isset( MBR()->MBRTAGS[ $tag_id ] );
}

function mbr_contact_has_membership_level( $tag_id = null )
{
	return !is_null($tag_id) AND isset( MBR()->MBRMEMB[ $tag_id ] );
}

function mbr_contact_has_payment_failed_tag( $tag_id = null )
{
	return !is_null($tag_id) AND isset( MBR()->MBRPAYF[ $tag_id ] );
}

function mbr_fetch_tags()
{
	MBR()->fetch_tags();
}


function mbr_has_tags($arrTAGS = [], $must_have_all_tags = 'any')
{
	IF (!is_array($arrTAGS)) :
		$arrTAGS = explode(',', $arrTAGS);
		IF (empty($arrTAGS)) :
			return FALSE;
		ENDIF;
	ENDIF;
	$arrTAGS = array_flip($arrTAGS);
	return MBR()->check_member_tags( $arrTAGS, $must_have_all_tags );
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


function mbr_get_contact_lists()
{
	IF (is_user_logged_in()) :
		return MBR()->MBRLISTS;
	ENDIF;
	return [];
}




function mbr_avatar($array=[])
{
	return MBR()->sc_avatar($array);
}


function mbr_date($array=[])
{
	return MBR()->sc_date($array);
}


function mbr_signup_link($text='')
{
	return MBR()->sc_signup_link(['text' => $text]);
}


function mbr_logout_link($array=[])
{
	return MBR()->sc_logout_link($array);
}


function mbr_related_posts($array=[])
{
	return MBR()->sc_related_posts($array);
}


function mbr_page($array=[])
{
	return MBR()->sc_get_post_info($array);
}


function mbr_is_email_unconfirmed($list_id=false)
{
	IF (empty($list_id)) :
		return null;
	ENDIF;
	IF (mbr_contact_id()) :
		IF (isset(MBR()->MBRLISTS[$list_id]) AND MBR()->MBRLISTS[$list_id] == '0') :
			return true;
		ENDIF;
	ENDIF;

	return false;
}


function mbr_is_email_active($list_id=false)
{
	IF (empty($list_id)) :
		return null;
	ENDIF;
	IF (mbr_contact_id()) :
		IF (isset(MBR()->MBRLISTS[$list_id]) AND MBR()->MBRLISTS[$list_id] == '1') :
			return true;
		ENDIF;
	ENDIF;

	return false;
}


function mbr_is_email_unsubscribed($list_id = false)
{
	IF (empty($list_id)) :
		return null;
	ENDIF;
	IF (mbr_contact_id()) :
		IF (isset(MBR()->MBRLISTS[$list_id]) AND MBR()->MBRLISTS[$list_id] == '2') :
			return true;
		ENDIF;
	ENDIF;

	return false;
}


function mbr_is_email_bounced($list_id = false)
{
	IF (empty($list_id)) :
		return null;
	ENDIF;
	IF (mbr_contact_id()) :
		IF (isset(MBR()->MBRLISTS[$list_id]) AND MBR()->MBRLISTS[$list_id] == '3') :
			return true;
		ENDIF;
	ENDIF;

	return false;
}


function mbr_constant($constant, $value)
{
	defined($constant) OR define($constant, $value);
}


function mbr_get_sec_codes()
{
	static $codes = FALSE;
	IF (empty($codes)) :
		$codes = array_filter(array_map('trim', unserialize($GLOBALS['MBR_OPTIONS']['security_codes'])));
		IF (empty($codes) OR !is_array($codes)) :
			$codes = FALSE;
		ENDIF;
	ENDIF;

	return $codes;
}

function mbr_save_contact_fields($fields)
{
	$obj = MBR()->api('contact_edit?overwrite=0', $fields);
	IF ($obj->result_code == 0) :
		return false;
	ENDIF;

	return true;
}

function mbr_clear_ob()
{
	MBR()->clear_ob();
}

function mbr_load_site_options()
{
	global $MBR_OPTIONS, $blog_id;

	
	$UGDEF       = TRUE;
	IF ( MBR_MULTISITE AND defined( 'MS360_IGNORE_BLOGS' ) AND MS360_IGNORE_BLOGS ) :
		$arrIGNORE = explode( ',', MS360_IGNORE_BLOGS );
		IF ( in_array( $blog_id, $arrIGNORE ) ) :
			$UGDEF   = FALSE;
		ENDIF;
	ENDIF;

	defined( 'UGDEF' ) OR define( 'UGDEF', $UGDEF );

	$MBR_OPTIONS['extensions'] = get_option( 'mbr_extensions', FALSE );
	$MBR_OPTIONS['templates']  = get_option( 'mbr_templates',  FALSE );

	IF ( UGDEF AND defined( 'MS360_API_URL' ) AND defined( 'MS360_API_KEY' ) ) :
		$MBR_OPTIONS['api_url']  = MS360_API_URL;
		$MBR_OPTIONS['api_key']  = MS360_API_KEY;
	ELSEIF ( $arr_api_settings = get_option( 'mbr_api_settings', FALSE ) ) :
		$MBR_OPTIONS['api_url']  = $arr_api_settings['mbr_api_url'];
		$MBR_OPTIONS['api_key']  = $arr_api_settings['mbr_api_key'];
	ELSE:
		$MBR_OPTIONS['api_url']  = '';
		$MBR_OPTIONS['api_key']  = '';
	ENDIF;

	$arr_plugin_options                           = get_option( 'mbr_plugin_options', FALSE );
	IF ( ! empty( $arr_plugin_options ) ) :
		
		$MBR_OPTIONS['force_login']                 = $arr_plugin_options['mbr_po_require_login'];
		$MBR_OPTIONS['allow_login_wo_ms']           = $arr_plugin_options['mbr_po_login_without_membership'];
		$MBR_OPTIONS['siteban_tag']                 = $arr_plugin_options['mbr_po_siteban_tag'];
		



		$MBR_OPTIONS['custfld_lastlogin']           = ! empty( $arr_plugin_options['mbr_po_last_login_field'] ) ? $arr_plugin_options['mbr_po_last_login_field'] : '';
		$MBR_OPTIONS['login_automation']            = $arr_plugin_options['mbr_po_login_automation'];
		$MBR_OPTIONS['logout_automation']           = $arr_plugin_options['mbr_po_logout_automation'];
		$MBR_OPTIONS['first_login_page']            = $arr_plugin_options['mbr_po_first_login_redirect'];

		
		$MBR_OPTIONS['login_page']                  = $arr_plugin_options['mbr_po_login_page'];
		$MBR_OPTIONS['registration_page']           = $arr_plugin_options['mbr_po_registration_page'];
		$MBR_OPTIONS['registration_static']         = $arr_plugin_options['mbr_po_registration_external_url'];
		$MBR_OPTIONS['upsell_page']                 = $arr_plugin_options['mbr_po_excerpt_upsell_page'];
		$MBR_OPTIONS['404_page']                    = $arr_plugin_options['mbr_po_alternate_404_page'];

		
		$MBR_OPTIONS['mbr_encrypted_passwords']     = $arr_plugin_options['mbr_po_passwords_encryption'];
		$MBR_OPTIONS['min_passlen']                 = $arr_plugin_options['mbr_po_passwords_min_character_length'];
		$MBR_OPTIONS['max_passlen']                 = $arr_plugin_options['mbr_po_passwords_max_character_length'];
		$MBR_OPTIONS['pass_charset']                = $arr_plugin_options['mbr_po_passwords_allowed_characters'];

		
		$MBR_OPTIONS['apilog_limit']                = $arr_plugin_options['mbr_po_api_log_max_calls'];
		$MBR_OPTIONS['webhooklog_limit']            = $arr_plugin_options['mbr_po_webhook_log_max_calls'];

		
		$MBR_OPTIONS['enable_cclogin']              = $arr_plugin_options['mbr_po_prevent_concurrent_login'];

		IF ( ! isset( $arr_plugin_options['mbr_po_email_detected_concurrent_logins'] ) ) :
			$arr_plugin_options['mbr_po_email_detected_concurrent_logins'] = 0;
		ENDIF;

		$MBR_OPTIONS['enable_cclogin_mail']         = $arr_plugin_options['mbr_po_email_detected_concurrent_logins'];
		$MBR_OPTIONS['max_logins']                  = $arr_plugin_options['mbr_po_limit_failed_login_attempts_max'];
		$MBR_OPTIONS['lock_logins']                 = $arr_plugin_options['mbr_po_lock_logins_seconds'];
		$MBR_OPTIONS['auto_logout']                 = $arr_plugin_options['mbr_po_auto_logout_seconds'];
		$MBR_OPTIONS['excl_ip_logins']              = serialize( $arr_plugin_options['mbr_po_whitelist_ip_addresses']['ip_address'] );
		$MBR_OPTIONS['security_codes']              = serialize( $arr_plugin_options['mbr_po_security_codes']['security_code'] );
		$MBR_OPTIONS['autologin_module']            = $arr_plugin_options['mbr_po_autologin_module'];
		$MBR_OPTIONS['thrivecart_secret']           = $arr_plugin_options['mbr_po_thrivecart_security_key'];
		$MBR_OPTIONS['jvzoo_secret']                = $arr_plugin_options['mbr_po_jvzoo_security_key'];
		$MBR_OPTIONS['clickbank_secret']            = $arr_plugin_options['mbr_po_clickbank_security_key'];
		$MBR_OPTIONS['digistore_secret']            = $arr_plugin_options['mbr_po_digistore24_security_key'];

		
		$MBR_OPTIONS['comments_options_activate']   = $arr_plugin_options['mbr_po_comments_options_enabled'];
		$MBR_OPTIONS['comments_options_reply']      = $arr_plugin_options['mbr_po_comments_display_reply_form'];
		$MBR_OPTIONS['comments_options_display']    = $arr_plugin_options['mbr_po_comments_display_in_protected_posts'];

		
		$MBR_OPTIONS['enable_wpadmin_cap']          = $arr_plugin_options['mbr_po_wp_admin_cap'];
		$MBR_OPTIONS['admin_bar']                   = $arr_plugin_options['mbr_po_suppress_wp_tool_bar'];

		
		$MBR_OPTIONS['cache_refresh_frequency']     = $arr_plugin_options['mbr_po_cache_refresh_frequency'];

		
		$MBR_OPTIONS['enable_excerpt']              = $arr_plugin_options['mbr_po_excerpts_force'];
		$MBR_OPTIONS['enable_excerpts_blur_effect'] = $arr_plugin_options['mbr_po_excerpts_blur_effect'];
		$MBR_OPTIONS['enable_excerpts_blur_gradient_start_color'] = $arr_plugin_options['mbr_po_excerpts_gradient_start_color'];
		$MBR_OPTIONS['enable_excerpts_blur_gradient_end_color']   = $arr_plugin_options['mbr_po_excerpts_gradient_end_color'];
		$MBR_OPTIONS['disable_excerpt_links']       = $arr_plugin_options['mbr_po_excerpts_disable_links'];
		$MBR_OPTIONS['excerpt_length']              = $arr_plugin_options['mbr_po_excerpts_max_length'];
		$MBR_OPTIONS['site_excerpt']                = $arr_plugin_options['mbr_po_excerpts_text'];

		
		$MBR_OPTIONS['mbr_s3_key']                  = $arr_plugin_options['mbr_po_amazon_s3_access_key'];
		$MBR_OPTIONS['mbr_s3_secret']               = $arr_plugin_options['mbr_po_amazon_s3_secret_key'];
		$MBR_OPTIONS['mbr_s3_expire']               = $arr_plugin_options['mbr_po_amazon_s3_default_expiration'];
		$MBR_OPTIONS['mbr_s3_host']                 = $arr_plugin_options['mbr_po_amazon_s3_default_host'];
		$MBR_OPTIONS['mbr_s3_bucket']               = $arr_plugin_options['mbr_po_amazon_s3_default_bucket'];

		
		$MBR_OPTIONS['avatar_size']                 = $arr_plugin_options['mbr_po_default_avatar_size'];
		$MBR_OPTIONS['suppress_empty_menu']         = $arr_plugin_options['mbr_po_suppress_empty_custom_menu_items'];
		$MBR_OPTIONS['admin_hide_menu']             = $arr_plugin_options['mbr_po_hide_menu_to_admins'];
		$MBR_OPTIONS['cond_widget_control_enabled'] = $arr_plugin_options['mbr_po_conditional_widgets'];
		$MBR_OPTIONS['site_payf_text']              = $arr_plugin_options['mbr_po_failed_payment_text'];

		
		$MBR_OPTIONS['mail_fromname']               = trim( $arr_plugin_options['mbr_po_mail_from_name'] );
		$MBR_OPTIONS['mail_fromaddr']               = trim( $arr_plugin_options['mbr_po_mail_from_email'] );
	ENDIF;

	$arr_membership_levels                        = get_option( 'mbr_membership_levels', FALSE );
	IF ( ! empty( $arr_membership_levels ) ) :
		$arr_membership_levels_mbr_options = [];
		IF ( ! empty( $arr_membership_levels['mbr_membership_levels']['access_tag'] ) ) :
			FOREACH ( $arr_membership_levels['mbr_membership_levels']['access_tag'] AS $key => $tag_id ) :
				$arr_membership_levels_mbr_options[ $tag_id ] = [
					'name'  => ! empty( $arr_membership_levels['mbr_membership_levels']['membership_name'][ $key ] ) ? $arr_membership_levels['mbr_membership_levels']['membership_name'][ $key ] : 'Tag #' . $tag_id,
					'payf'  => ! empty( $arr_membership_levels['mbr_membership_levels']['deny_tag'][ $key ] )        ? $arr_membership_levels['mbr_membership_levels']['deny_tag'][ $key ]        : '',
					'redr'  => ! empty( $arr_membership_levels['mbr_membership_levels']['login_redirect'][ $key ] )  ? $arr_membership_levels['mbr_membership_levels']['login_redirect'][ $key ]  : '',
					'lout'  => ! empty( $arr_membership_levels['mbr_membership_levels']['logout_redirect'][ $key ] ) ? $arr_membership_levels['mbr_membership_levels']['logout_redirect'][ $key ] : '',
					'theme' => ! empty( $arr_membership_levels['mbr_membership_levels']['theme'][ $key ] )           ? $arr_membership_levels['mbr_membership_levels']['theme'][ $key ]           : ''
				];
			ENDFOREACH;
		ENDIF;
		$MBR_OPTIONS['membership_levels'] = $arr_membership_levels_mbr_options;
	ENDIF;

	
	
	IF ( ! isset( $MBR_OPTIONS['membership_levels'] ) ) :
		$MBR_OPTIONS['membership_levels'] = [];
	ENDIF;

	IF (!isset($MBR_OPTIONS['mbr_s3_key'])) :
		$MBR_OPTIONS['mbr_s3_key']    = '';
	ENDIF;

	IF (!isset($MBR_OPTIONS['mbr_s3_secret']))  :
		$MBR_OPTIONS['mbr_s3_secret'] = '';
	ENDIF;

	IF (!isset($MBR_OPTIONS['mbr_s3_expire']))  :
		$MBR_OPTIONS['mbr_s3_expire'] = '';
	ENDIF;

	IF (!isset($MBR_OPTIONS['mbr_s3_host']))    :
		$MBR_OPTIONS['mbr_s3_host']   = '';
	ENDIF;

	IF (!isset($MBR_OPTIONS['mbr_s3_bucket']))  :
		$MBR_OPTIONS['mbr_s3_bucket'] = '';
	ENDIF;

	IF ( defined('MS360_COMMON_MEMBERSHIP_TAG' ) ) :
		IF ( !isset($MBR_OPTIONS['membership_levels'][ MS360_COMMON_MEMBERSHIP_TAG ] ) ) :
			$m_name  = defined('MS360_COMMON_MEMBERSHIP_NAME')  ? MS360_COMMON_MEMBERSHIP_NAME  : 'Common Membership';
			$m_redr  = defined('MS360_COMMON_MEMBERSHIP_REDR')  ? MS360_COMMON_MEMBERSHIP_REDR  : '';
			$m_lout  = defined('MS360_COMMON_MEMBERSHIP_LOUT')  ? MS360_COMMON_MEMBERSHIP_LOUT  : '';
			$MBR_OPTIONS['membership_levels'][ MS360_COMMON_MEMBERSHIP_TAG ] = ['name' => $m_name, 'redr' => $m_redr, 'lout' => $m_lout];
		ENDIF;
	ENDIF;

	IF ( UGDEF AND defined('MS360_SITEBAN_TAG' ) ) :
		$MBR_OPTIONS['siteban_tag'] = MS360_SITEBAN_TAG;
	ELSEIF ( ! isset($MBR_OPTIONS['siteban_tag'] ) ) :
		$MBR_OPTIONS['siteban_tag'] = 0;
	ENDIF;

	IF (UGDEF AND defined('MS360_LOGIN_WO_MS_TAG')) :
		$MBR_OPTIONS['allow_login_wo_ms'] = MS360_LOGIN_WO_MS_TAG;
	ELSEIF (!isset($MBR_OPTIONS['allow_login_wo_ms'])) :
		$MBR_OPTIONS['allow_login_wo_ms'] = 0;
	ENDIF;

	IF (UGDEF AND defined('MS360_FORCE_LOGIN')) :
		$MBR_OPTIONS['force_login'] = MS360_FORCE_LOGIN;
	ELSEIF (!isset($MBR_OPTIONS['force_login'])) :
		$MBR_OPTIONS['force_login'] = 0;
	ENDIF;

	IF (UGDEF AND defined('MS360_PASSWORD_MIN_LENGTH')) :
		$MBR_OPTIONS['min_passlen'] = MS360_PASSWORD_MIN_LENGTH;
	ELSEIF (empty($MBR_OPTIONS['min_passlen'])) :
		$MBR_OPTIONS['min_passlen'] = 8;
	ENDIF;

	IF (UGDEF AND defined('MS360_PASSWORD_MAX_LENGTH')) :
		$MBR_OPTIONS['max_passlen'] = MS360_PASSWORD_MAX_LENGTH;
	ELSEIF (empty($MBR_OPTIONS['max_passlen'])) :
		$MBR_OPTIONS['max_passlen'] = 16;
	ENDIF;

	IF ($MBR_OPTIONS['max_passlen'] < $MBR_OPTIONS['min_passlen']) :
		$MBR_OPTIONS['max_passlen'] = $MBR_OPTIONS['min_passlen'];
	ENDIF;

	IF (UGDEF AND defined('MS360_PASSWORD_BASE')) :
		$MBR_OPTIONS['pass_charset'] = MS360_PASSWORD_BASE;
	ELSEIF (empty($MBR_OPTIONS['pass_charset'])) :
		$MBR_OPTIONS['pass_charset'] = MBR_PASSWORD_BASE;
	ENDIF;

	IF (UGDEF AND defined('MS360_AUTOLOGOUT')) :
		$MBR_OPTIONS['auto_logout'] = MS360_AUTOLOGOUT;
	ELSEIF (!isset($MBR_OPTIONS['auto_logout'])) :
		$MBR_OPTIONS['auto_logout'] = 0;
	ENDIF;

	IF (UGDEF AND defined('MS360_LOGIN_NODUPE')) :
		$MBR_OPTIONS['enable_cclogin'] = MS360_LOGIN_NODUPE;
	ELSEIF (!isset($MBR_OPTIONS['enable_cclogin'])) :
		$MBR_OPTIONS['enable_cclogin'] = 0;
	ENDIF;

	IF (UGDEF AND defined('MS360_LOGIN_DUPE_MAIL')) :
		$MBR_OPTIONS['enable_cclogin_mail'] = MS360_LOGIN_DUPE_MAIL;
	ELSEIF (!isset($MBR_OPTIONS['enable_cclogin_mail'])) :
		$MBR_OPTIONS['enable_cclogin_mail'] = 0;
	ENDIF;

	IF (UGDEF AND defined('MS360_LOGIN_FAIL_LIMIT')) :
		$MBR_OPTIONS['max_logins'] = MS360_LOGIN_FAIL_LIMIT;
	ENDIF;

	IF (UGDEF AND defined('MS360_LOGIN_FAIL_LOCKDOWN')) :
		$MBR_OPTIONS['lock_logins'] = MS360_LOGIN_FAIL_LOCKDOWN;
	ENDIF;

	$MBR_OPTIONS['max_logins']  = (int) $MBR_OPTIONS['max_logins'];

	IF ($MBR_OPTIONS['max_logins'] > 0) :
		IF (empty($MBR_OPTIONS['lock_logins']) OR (int) $MBR_OPTIONS['lock_logins'] <= 0) :
			$MBR_OPTIONS['lock_logins'] = 3600;
		ENDIF;
	ELSE :
		$MBR_OPTIONS['max_logins']  = 0;
		$MBR_OPTIONS['lock_logins'] = 0;
	ENDIF;

	$MBR_OPTIONS['lock_logins'] = (int)$MBR_OPTIONS['lock_logins'];

	IF (UGDEF AND defined('MS360_LOGIN_FAIL_WHITELIST')) :
		$MBR_OPTIONS['excl_ip_logins'] = MS360_LOGIN_FAIL_WHITELIST;
	ELSEIF (!isset($MBR_OPTIONS['excl_ip_logins'])) :
		$MBR_OPTIONS['excl_ip_logins'] = '';
	ENDIF;

	IF (UGDEF AND defined('MS360_AUTOLOGIN_MODULE')) :
		$MBR_OPTIONS['autologin_module'] = MS360_AUTOLOGIN_MODULE;
	ELSEIF (!isset($MBR_OPTIONS['autologin_module'])) :
		$arr_security_codes = unserialize($MBR_OPTIONS['security_codes']);
		IF ( is_array( $arr_security_codes ) ) :
			$tmp_sec_codes = array_filter(array_map('trim', $arr_security_codes ));
		ELSE:
			$tmp_sec_codes = [];
		ENDIF;
		IF (!empty($tmp_sec_codes)) :
			$MBR_OPTIONS['autologin_module'] = 1;
		ELSE:
			$MBR_OPTIONS['autologin_module'] = 0;
		ENDIF;
	ENDIF;

	IF (UGDEF AND defined('MS360_SECURITY_CODES')) :
		$MBR_OPTIONS['security_codes'] = MS360_SECURITY_CODES;
	ELSEIF (!isset($MBR_OPTIONS['security_codes'])) :
		$MBR_OPTIONS['security_codes'] = '';
	ENDIF;

	IF (UGDEF AND defined('MS360_THRIVECART_SECRET')) :
		$MBR_OPTIONS['thrivecart_secret'] = MS360_THRIVECART_SECRET;
	ELSEIF (!isset($MBR_OPTIONS['thrivecart_secret'])) :
		$MBR_OPTIONS['thrivecart_secret'] = '';
	ENDIF;

	IF (UGDEF AND defined('MS360_JVZOO_SECRET')) :
		$MBR_OPTIONS['jvzoo_secret'] = MS360_JVZOO_SECRET;
	ELSEIF (!isset($MBR_OPTIONS['jvzoo_secret'])) :
		$MBR_OPTIONS['jvzoo_secret'] = '';
	ENDIF;

	IF (UGDEF AND defined('MS360_CLICKBANK_SECRET')) :
		$MBR_OPTIONS['clickbank_secret'] = MS360_CLICKBANK_SECRET;
	ELSEIF (!isset($MBR_OPTIONS['clickbank_secret'])) :
		$MBR_OPTIONS['clickbank_secret'] = '';
	ENDIF;

	IF (UGDEF AND defined('MS360_DIGISTORE_SECRET')) :
		$MBR_OPTIONS['digistore_secret'] = MS360_DIGISTORE_SECRET;
	ELSEIF (!isset($MBR_OPTIONS['digistore_secret'])) :
		$MBR_OPTIONS['digistore_secret'] = '';
	ENDIF;

	IF (UGDEF AND defined('MS360_FORCE_EXCERPTS')) :
		$MBR_OPTIONS['enable_excerpt'] = MS360_FORCE_EXCERPTS;
	ELSEIF (!isset($MBR_OPTIONS['enable_excerpt'])) :
		$MBR_OPTIONS['enable_excerpt'] = 0;
	ENDIF;

	IF (UGDEF AND defined('MS360_EXCERPTS_BLUR_EFFECT')) :
		$MBR_OPTIONS['enable_excerpts_blur_effect'] = MS360_EXCERPTS_BLUR_EFFECT;
	ELSEIF (!isset($MBR_OPTIONS['enable_excerpts_blur_effect'])) :
		$MBR_OPTIONS['enable_excerpts_blur_effect'] = 0;
	ENDIF;

	IF (UGDEF AND defined('MS360_EXCERPTS_BLUR_GRADIENT_START_COLOR')) :
		$MBR_OPTIONS['enable_excerpts_blur_gradient_start_color'] = MS360_EXCERPTS_BLUR_GRADIENT_START_COLOR;
	ELSEIF (!isset($MBR_OPTIONS['enable_excerpts_blur_gradient_start_color'])) :
		$MBR_OPTIONS['enable_excerpts_blur_gradient_start_color'] = '#000000';
	ENDIF;

	IF (UGDEF AND defined('MS360_EXCERPTS_BLUR_GRADIENT_END_COLOR')) :
		$MBR_OPTIONS['enable_excerpts_blur_gradient_end_color'] = MS360_EXCERPTS_BLUR_GRADIENT_END_COLOR;
	ELSEIF (!isset($MBR_OPTIONS['enable_excerpts_blur_gradient_end_color'])) :
		$MBR_OPTIONS['enable_excerpts_blur_gradient_end_color'] = '#ffffff';
	ENDIF;

	IF (UGDEF AND defined('MS360_DISABLE_EXCERPTS_LINKS')) :
		$MBR_OPTIONS['disable_excerpt_links'] = MS360_DISABLE_EXCERPTS_LINKS;
	ELSEIF (!isset($MBR_OPTIONS['disable_excerpt_links'])) :
		$MBR_OPTIONS['disable_excerpt_links'] = 0;
	ENDIF;

	IF (UGDEF AND defined('MS360_MAX_EXCERPT_LENGTH')) :
		$MBR_OPTIONS['excerpt_length'] = MS360_MAX_EXCERPT_LENGTH;
	ELSEIF (!isset($MBR_OPTIONS['excerpt_length'])) :
		$MBR_OPTIONS['excerpt_length'] = 55;
	ENDIF;

	IF (UGDEF AND defined('MS360_CACHE_REFRESH_FREQUENCY')) :
		$MBR_OPTIONS['cache_refresh_frequency'] = MS360_CACHE_REFRESH_FREQUENCY;
	ELSEIF (!isset($MBR_OPTIONS['mail_fromname'])) :
		$MBR_OPTIONS['cache_refresh_frequency'] = 1;
	ENDIF;
	IF (!defined('CACHEREFRESH')) :
		define('CACHEREFRESH', $MBR_OPTIONS['cache_refresh_frequency'] * 3600);
	ENDIF;

	IF (UGDEF AND defined('MS360_MAIL_FROM_NAME')) :
		$MBR_OPTIONS['mail_fromname'] = MS360_MAIL_FROM_NAME;
	ELSEIF (!isset($MBR_OPTIONS['mail_fromname'])) :
		$MBR_OPTIONS['mail_fromname'] = 'Site Admin';
	ENDIF;

	IF (UGDEF AND defined('MS360_MAIL_FROM_ADDRESS')) :
		$MBR_OPTIONS['mail_fromaddr'] = MS360_MAIL_FROM_ADDRESS;
	ELSEIF (!isset($MBR_OPTIONS['mail_fromaddr'])) :
		$MBR_OPTIONS['mail_fromaddr'] = get_bloginfo('admin_email');
	ENDIF;

	IF (UGDEF AND defined('MS360_AVATAR_SIZE')) :
		$MBR_OPTIONS['avatar_size'] = MS360_AVATAR_SIZE;
	ELSEIF (!isset($MBR_OPTIONS['avatar_size'])) :
		$MBR_OPTIONS['avatar_size'] = 48;
	ENDIF;

	IF (defined('MS360_ENABLE_DASHBOARD_CAP')) :
		$MBR_OPTIONS['enable_wpadmin_cap'] = MS360_ENABLE_DASHBOARD_CAP;
	ENDIF;
	IF (!isset($MBR_OPTIONS['enable_wpadmin_cap']) OR trim($MBR_OPTIONS['enable_wpadmin_cap']) == '') :
		$MBR_OPTIONS['enable_wpadmin_cap'] = 'activate_plugins';
	ENDIF;

	IF (UGDEF AND defined('MS360_SUPPRESS_ADMIN_BAR')) :
		$MBR_OPTIONS['admin_hide_menu'] = MS360_SUPPRESS_ADMIN_BAR;
	ELSEIF (!isset($MBR_OPTIONS['admin_hide_menu'])) :
		$MBR_OPTIONS['admin_hide_menu'] = 0;
	ENDIF;

	IF (defined('APILOG_LIMIT')) :
		$MBR_OPTIONS['apilog_limit'] = APILOG_LIMIT;
	ELSE:
		IF (!isset($MBR_OPTIONS['apilog_limit'])) :
			$MBR_OPTIONS['apilog_limit'] = 0;
		ENDIF;
		
		define('APILOG_LIMIT', $MBR_OPTIONS['apilog_limit']);
	ENDIF;

	IF (defined('WEBHOOKLOG_LIMIT')) :
		$MBR_OPTIONS['webhooklog_limit'] = WEBHOOKLOG_LIMIT;
	ELSE:
		IF (!isset($MBR_OPTIONS['webhooklog_limit'])) :
			$MBR_OPTIONS['webhooklog_limit'] = 0;
		ENDIF;
		
		define('WEBHOOKLOG_LIMIT', $MBR_OPTIONS['webhooklog_limit']);
	ENDIF;

	IF (!isset($MBR_OPTIONS['first_login_page']))            : $MBR_OPTIONS['first_login_page'] = 0;               ENDIF;
	IF (!isset($MBR_OPTIONS['upsell_page']))                 : $MBR_OPTIONS['upsell_page']      = 0;               ENDIF;
	IF (!isset($MBR_OPTIONS['404_page']))                    : $MBR_OPTIONS['404_page']         = 0;               ENDIF;

	IF (!isset($MBR_OPTIONS['login_page']))                  : $MBR_OPTIONS['login_page'] = 0;                     ENDIF;
	IF ((int)$MBR_OPTIONS['login_page'] < 1)                 : $MBR_OPTIONS['login_page'] = 0;                     ENDIF;

	IF (!isset($MBR_OPTIONS['registration_page']))           : $MBR_OPTIONS['registration_page'] = 0;              ENDIF;
	IF (!isset($MBR_OPTIONS['registration_static']))         : $MBR_OPTIONS['registration_static'] = '';           ENDIF;
	IF (trim($MBR_OPTIONS['registration_static']) <> '')     : $MBR_OPTIONS['registration_page'] = 0;              ENDIF;

	IF (!isset($MBR_OPTIONS['admin_bar']))                   : $MBR_OPTIONS['admin_bar'] = 1;                      ENDIF;

	IF (!isset($MBR_OPTIONS['suppress_empty_menu']))         : $MBR_OPTIONS['suppress_empty_menu'] = 1;            ENDIF; 

	IF (!isset($MBR_OPTIONS['comments_options_activate'])) :
		$MBR_OPTIONS['comments_options_activate'] = 0;
		$MBR_OPTIONS['comments_options_display']  = 0;
		$MBR_OPTIONS['comments_options_reply']    = 0;
	ENDIF;

	IF ($MBR_OPTIONS['comments_options_activate'] == 0) :
		$MBR_OPTIONS['comments_options_display']  = 0;
		$MBR_OPTIONS['comments_options_reply']    = 0;
	ENDIF;

	IF (!isset($MBR_OPTIONS['comments_options_display'])) :
		$MBR_OPTIONS['comments_options_display'] = 0;
	ENDIF;

	IF (!isset($MBR_OPTIONS['comments_options_reply'])) :
		$MBR_OPTIONS['comments_options_reply'] = 0;
	ENDIF;

	IF (!isset($MBR_OPTIONS['custfld_lastlogin'])) :
		$MBR_OPTIONS['custfld_lastlogin']      =  0;
	ENDIF;
	IF (!isset($MBR_OPTIONS['login_automation'])) :
		$MBR_OPTIONS['login_automation']       =  0;
	ENDIF;

	IF (!isset($MBR_OPTIONS['logout_automation'])) :
		$MBR_OPTIONS['logout_automation']      =  0;
	ENDIF;

	IF (!isset($MBR_OPTIONS['cond_widget_control_enabled'])) :
		$MBR_OPTIONS['cond_widget_control_enabled'] =  1;
	ENDIF;

	IF (isset($_REQUEST['mbr_genpass'])) :
		$MBR_OPTIONS['force_login'] = 0;
	ENDIF;

	IF ( ! is_admin() AND MBR_MULTISITE AND defined( 'MS360_MEMBERSHIP_LEVELS_FROM_BLOG' ) AND MS360_MEMBERSHIP_LEVELS_FROM_BLOG ) :
		IF ( $arr_membership_levels = get_blog_option( MS360_MEMBERSHIP_LEVELS_FROM_BLOG, 'mbr_membership_levels', FALSE ) ) :
			$arr_membership_levels_mbr_options = [];
			IF ( ! empty( $arr_membership_levels['mbr_membership_levels']['access_tag'] ) ) :
				FOREACH ( $arr_membership_levels['mbr_membership_levels']['access_tag'] AS $key => $tag_id ) :
					$arr_membership_levels_mbr_options[ $tag_id ] = [
						'name'  => ! empty( $arr_membership_levels['mbr_membership_levels']['membership_name'][ $key ] ) ? $arr_membership_levels['mbr_membership_levels']['membership_name'][ $key ] : 'Tag #' . $tag_id,
						'payf'  => ! empty( $arr_membership_levels['mbr_membership_levels']['deny_tag'][ $key ] )        ? $arr_membership_levels['mbr_membership_levels']['deny_tag'][ $key ]        : '',
						'redr'  => ! empty( $arr_membership_levels['mbr_membership_levels']['login_redirect'][ $key ] )  ? $arr_membership_levels['mbr_membership_levels']['login_redirect'][ $key ]  : '',
						'lout'  => ! empty( $arr_membership_levels['mbr_membership_levels']['logout_redirect'][ $key ] ) ? $arr_membership_levels['mbr_membership_levels']['logout_redirect'][ $key ] : '',
						'theme' => ! empty( $arr_membership_levels['mbr_membership_levels']['theme'][ $key ] )           ? $arr_membership_levels['mbr_membership_levels']['theme'][ $key ]           : ''
					];
				ENDFOREACH;
			ENDIF;
			$MBR_OPTIONS['membership_levels'] = $arr_membership_levels_mbr_options;
		ENDIF;
	ENDIF;
}

function mbr_save_site_options()
{
	do_action( 'mbr/plugin_options/save' );
}

function mbr_get_site_options()
{
	return $GLOBALS['MBR_OPTIONS'];
}







function mbr_load_site_options_db()
{
	global $MBR_OPTIONS, $wpdb;

	
	
	$old_options  = $wpdb->prefix . 'mbrOptions';
	$migrated_key = 'process_migration_001_completed';
	$has_migrated = get_option( $migrated_key, FALSE );

	
	IF ($has_migrated) :
		$MBR_OPTIONS = get_option('site_options');
		return $MBR_OPTIONS;
	ENDIF;

	
	IF ($old_options == $wpdb->get_var( "SHOW TABLES LIKE '{$old_options}'" ) ) :
		$options_table = $old_options;
	
	ELSE :
		update_option( $migrated_key, $migrated_key );
		$options_table = $wpdb->options;
	ENDIF;

	IF ($options = $wpdb->get_var( "SELECT option_value FROM {$options_table} WHERE option_name='site_options' LIMIT 1" )) :
		return unserialize($options);
	ENDIF;

	return [];
}

function mbr_get_site_option($option = null)
{
	IF (is_null($option)) :
		return null;
	ENDIF;
	IF (isset($GLOBALS['MBR_OPTIONS'][$option])) :
		return $GLOBALS['MBR_OPTIONS'][$option];
	ENDIF;
	return null;
}


function mbr_get_site_membership_levels()
{
	return $GLOBALS['MBR_OPTIONS']['membership_levels'];
}

function mbr_get_site_tags()
{
	return MBR()->site_tags;
}

function mbr_get_site_tag($tid=null)
{
	IF (empty($tid) OR empty(MBR()->site_tags[$tid])) :
		return null;
	ENDIF;
	return trim(MBR()->site_tags[$tid]);
}

function mbr_get_site_automations()
{
	return MBR()->site_automations;
}

function mbr_get_site_lists()
{
	return MBR()->site_lists;
}

function mbr_api($path, $post_data = [])
{
	return MBR()->api($path, $post_data);
}

function mbr_flush_rewrite_rules()
{
	static $flushed = null;
	IF (is_null($flushed)) :
		$GLOBALS['wp_rewrite']->flush_rules(FALSE);
		$flushed = true;
	ENDIF;
}

function get_protected_object_properties($object)
{
	$protected_prefix = chr(0).'*'.chr(0);
	$newObj = new StdClass;
	FOREACH ((array)$object AS $k => $v) :
		IF (substr($k,0,3) == $protected_prefix) :
			$k = substr($k,3);
		ENDIF;
		$newObj->$k = $v;
	ENDFOREACH;
	return $newObj;
}

function get_protected_object_property($object, $property)
{
	$aObj = (array)$object;
	IF (isset($aObj[$property])) :
		return $aObj[$property];
	ELSEIF (isset($aObj[chr(0).'*'.chr(0) . $property])) :
		return $aObj[chr(0).'*'.chr(0) . $property];
	ENDIF;
	return null;
}

function mbr_register_route_prefix($route_prefix = null)
{
	IF (!empty($route_prefix)) :
		global $wp_rewrite;
		add_rewrite_rule( '^' . $route_prefix . '/?$','index.php?rest_route=/','top' );
		add_rewrite_rule( '^' . $route_prefix . '/(.*)?','index.php?rest_route=/$matches[1]','top' );
		add_rewrite_rule( '^' . $wp_rewrite->index . '/' . $route_prefix . '/?$','index.php?rest_route=/','top' );
		add_rewrite_rule( '^' . $wp_rewrite->index . '/' . $route_prefix . '/(.*)?','index.php?rest_route=/$matches[1]','top' );
	ENDIF;
}

function mbr_contact_std_fields()
{
	return MBR()->contact_std_fields;
}

function mbr_site_cust_fields()
{
	return MBR()->site_cust_fields;
}

function mbr_redirect($location='')
{
	MBR()->redirect($location);
}

function mbr_redirect_no_access($location='')
{
	MBR()->redirect_no_access($location);
}

function mbr_redirect_op_sn($location='')
{
	MBR()->redirect_op_sn($location);
}

function mbr_session($field=null)
{
	IF (empty(MBR()->SESSION)) :
		return [];
	ELSEIF (is_null($field)) :
		return MBR()->SESSION;
	ELSEIF (isset(MBR()->SESSION[$field])) :
		return MBR()->SESSION[$field];
	ELSEIF (isset(MBR()->SESSION[$field])) :
		return MBR()->SESSION[$field];
	ELSE :
		return [];
	ENDIF;
}

function mbr_contact_id()
{
	return MBR()->CONTACTID;
}

function mbr_remote_contact()
{
	return MBR()->SESSION;
}

function mbr_fetch_remote_contact_by_email($email=false)
{
	return MBR()->fetch_contact(['email' => $email, 'local' => false, 'sync' => false], false);
}

function mbr_fetch_remote_contact_by_id($id=false)
{
	return MBR()->fetch_contact( ['id' => $id, 'local' => false, 'sync' => false], false);
}

function mbr_match_user_content($post = false, $ignore_excerpt = false)
{
	return MBR()->match_user_content($post, $ignore_excerpt);
}

function mbr_add_meta_box($_post, $callback, $header=null)
{
	MBR()->add_meta_box($_post, $callback, $header);
}

function mbr_force_render_meta_box( $_post, $box )
{
	MBR()->force_render_meta_box( $_post, $box );
}

function mbr_url_to_postid($url=null)
{
	return MBR()->url_to_postid($url);
}

function mbr_wp_trim_excerpt($text = '', $strip_shortcodes = true, $excerpt_len = 0)
{
	return MBR()->wp_trim_excerpt($text, $strip_shortcodes, $excerpt_len);
}

function mbr_plugcolor()
{
	static $value = null;
	IF (is_null($value)) :
		$value = MBR()->plugcolor;
	ENDIF;
	return $value;
}

function mbr_sync_automations_tags_lists($array)
{
	return MBR()->sync_automations_tags_lists($array);
}

function mbr_validate_sec_code($code)
{
	return MBR()->validate_sec_code($code);
}

function mbr_normalize_tag_ids($tags, $explode=false)
{
	return MBR()->normalize_tag_ids($tags, $explode);
}

function mbr_select_box_helper($arrOPTIONS, $current_options, $identifier, $display_id=true, $multiple=true, $select2=true)
{
	return MBR()->select_box_helper($arrOPTIONS, $current_options, $identifier, $display_id, $multiple, $select2);
}

function mbr_tracking_log_event($event=false, $event_data=false, $email=false)
{
	MBR()->log_event( $event, $event_data, $email );
}

function mbr_render_meta_boxes_protection_generic($_post, $settings)
{
	MBR()->render_meta_boxes_protection_generic($_post, $settings);
}

function mbr_render_meta_boxes_protection_memberships($_post, $settings)
{
	MBR()->render_meta_boxes_protection_memberships($_post, $settings);
}

function mbr_render_meta_boxes_protection_filters($_post, $settings)
{
	MBR()->render_meta_boxes_protection_filters($_post, $settings);
}

function mbr_render_meta_boxes_protection_addtl_tags($_post, $settings)
{
	MBR()->render_meta_boxes_protection_addtl_tags($_post, $settings);
}

function mbr_render_meta_boxes_protection_comment_automations($_post, $settings)
{
	MBR()->render_meta_boxes_protection_comment_automations($_post, $settings);
}

function mbr_render_meta_boxes_protection_redirect($_post, $settings)
{
	MBR()->render_meta_boxes_protection_redirect($_post, $settings);
}

function mbr_render_meta_boxes_protection($_post, $box)
{
	MBR()->render_meta_boxes_protection($_post, $box);
}

function mbr_get_meta_box_protection_settings($_post)
{
	return MBR()->get_meta_box_protection_settings( $_post );
}

function mbr_render_metabox_css_helper($box)
{
	MBR()->render_metabox_css_helper( $box );
}

function mbr_meta_box_header($_post_type, $generate = true)
{
	return MBR()->meta_box_header($_post_type, $generate);
}

function mbr_metabox_bg_color()
{
	return MBR()->metabox_bg_color;
}

function mbr_fetch_lists()
{
	MBR()->fetch_lists();
}

function mbr_fetch_automations()
{
	MBR()->fetch_automations();
}

function mbr_filter_active_automations( $automations = false )
{
	MBR()->filter_active_automations( $automations );
}

function mbr_site_automation_status( $automation_id )
{
	return MBR()->site_automation_status[ $automation_id ];
}

function mbr_login_helper( $thisEMAIL, $thisPASS, $callerMODULE = '' )
{
	return MBR()->login_helper( $thisEMAIL, $thisPASS, $callerMODULE );
}

function mbr_get_password_base()
{
	IF (empty($GLOBALS['MBR_OPTIONS']['pass_charset'])) :
		return MBR_PASSWORD_BASE;
	ENDIF;
	return $GLOBALS['MBR_OPTIONS']['pass_charset'];
}

function mbr_generate_password()
{
	return MBRPASS()->generate_password();
}

function mbr_passfield()
{
	static $value = null;
	IF (is_null($value)) :
		$value = MBR()->passfield;
	ENDIF;
	return $value;
}

function mbr_password_perstag()
{
	static $value = null;
	IF (is_null($value)) :
		$value = MBR()->password_perstag;
	ENDIF;
	return $value;
}

function mbr_update_cookie( $pUID, $pCookie )
{
	MBR()->update_cookie( $pUID, $pCookie );
}

function mbr_delete_cookie( $cookie_name = false )
{
	MBR()->delete_cookie( $cookie_name );
}

function mbr_create_user_cookie( $contact_hash = false )
{
	MBR()->create_user_cookie( $contact_hash );
}

function set_cookie( $cookie_name = false, $cookie_value = '', $time_offset = 0 )
{
	MBR()->set_cookie( $cookie_name, $cookie_value, $time_offset );
}

function mbr_send_password( $parms = [] )
{
	return MBRPASS()->send_password( $parms );
}

function mbr_regpage_url()
{
	global $MBR_OPTIONS;
	return $MBR_OPTIONS['registration_static'];
}

function mbr_regpage()
{
	global $MBR_OPTIONS;
	return $MBR_OPTIONS['registration_page'];
}

function mbr_redir_logout()
{
	return MBR()->redir_logout();
}

function mbr_admin_header_icon_url()
{
	return MBR()->admin_header_icon_url;
}

function lower_trim($txt='')
{
	return strtolower(trim($txt));
}

function upper_trim($txt='')
{
	return strtoupper(trim($txt));
}

function mbr_admin_msg($pMSG='', $pERR=FALSE, $return=FALSE)
{
	$ret = !empty($pMSG) ? '<div class="notice notice-' . ($pERR ? 'error' : 'success') . ' is-dismissible"><p>' . urldecode($pMSG) . '</p></div>' : '';
	IF ($return) :
		return $ret;
	ENDIF;
	echo $ret;
}

function mbr_admin_msg_info($pMSG='', $pERR=FALSE, $return=FALSE)
{
	$ret = trim($pMSG) ? '<div class="notice notice-' . ($pERR ? 'warning' : 'info') . ' is-dismissible"><p>' . urldecode($pMSG) . '</p></div>' : '';
	IF ($return) :
		return $ret;
	ENDIF;
	echo $ret;
}

function mbr_is_protectable($_post_type = null)
{
	return MBR()->is_protectable($_post_type);
}

function mbr_current_url()
{
	return MBR()->url();
}

// form helpers
function mbr_form_min_max_width($min_width=FALSE, $max_width=FALSE)
{
	$min_width     = !empty($min_width) ? $min_width : '';
	$max_width     = !empty($max_width) ? $max_width : '';
	$min_max_width = '';
	IF (!empty($min_width) OR !empty($max_width)) :
		IF (!empty($min_width)) :
			$min_max_width .= "min-width:{$min_width};";
		ENDIF;
		IF (!empty($max_width)) :
			$min_max_width .= "max-width:{$max_width};";
		ENDIF;
	ENDIF;
	return $min_max_width;
}

function mbr_form_attributes($arrATTR, $arrATTR_EXCL=[])
{
	$attributes = '';
	$arrEXCL    = array_merge(['before', 'after', 'label', 'options', 'show_label'], $arrATTR_EXCL);
	FOREACH ($arrATTR AS $attr_name => $attr_value) :
		IF (in_array($attr_name, $arrEXCL)) :
			continue;
		ENDIF;
		$attributes .= " {$attr_name}='{$attr_value}'";
	ENDFOREACH;
	return $attributes;
}

function mbr_form_tag_open($array)
{
	$attributes = mbr_form_attributes($array);
	return "<form{$attributes}>";
}

function mbr_form_tag_close()
{
	return '</form>';
}

function mbr_form_field_input($array)
{
	IF (empty($array['class'])) :
		$array['class'] = 'mbr-form-control';
	ENDIF;
	$attributes = mbr_form_attributes($array);
	$out = '';
	$out .= '<div class="mbr-input-field">';
	IF (isset($array['label'])) :
		$out .= "<label for='{$array['name']}'>{$array['label']}</label>";
	ENDIF;
	$out .= "<div class='mbr-input-input'><input{$attributes} /></div>";
	$out .= '</div>';
	return $out;
}

function mbr_form_field_textarea($array)
{
	IF (empty($array['class'])) :
		$array['class'] = 'mbr-form-control';
	ENDIF;
	$arrEXCL = [];
	$out  = '';
	$out .= '<div class="mbr-input-field mbr-label-start">';
	IF (isset($array['label'])) :
		// label above, label left
		$arrEXCL[] = 'placeholder';
		$out .= "<label for='{$array['name']}'>{$array['label']}</label>";
	ENDIF;
	$attributes = mbr_form_attributes($array, $arrEXCL);
	$out .= '<div class="mbr-input-input">';
	$out .= "<textarea name='{$array['name']}{$attributes}'>{$array['value']}</textarea>";
	$out .= '</div>';
	$out .= '</div>';
	return $out;
}

function mbr_form_field_hidden($array)
{
	$attributes = mbr_form_attributes($array);
	return "<input type='hidden'{$attributes} />";
}

function mbr_form_field_checkbox_single($array)
{
	$attributes = mbr_form_attributes($array, ['placeholder']);
	$out = '';
	IF (isset($array['placeholder'])) :
		// placeholder
		$out .= '<div class="mbr-input-field mbr-check mbr-label-start">';
		IF (!empty($array['show_label'])) :
			$out .= "<label for='{$array['name']}'>{$array['placeholder']}</label>";
		ENDIF;
		$label = $array['placeholder'];
	ELSE:
		// label above, label left
		$out .= '<div class="mbr-input-field mbr-label-start">';
		IF (!empty($array['show_label'])) :
			$out .= "<label for='{$array['name']}'>{$array['label']}</label>";
		ENDIF;
		$label = $array['label'];
	ENDIF;
	$out .= "<div class='mbr-input-input mbr-check-box'><div class='mbr-check-single'><label><input type='checkbox'{$attributes} /><span>{$label}</span></label></div></div>";
	$out .= '</div>';
	return $out;
}

function mbr_form_field_select_single($array)
{
	IF (empty($array['class'])) :
		$array['class'] = 'mbr-form-control';
	ENDIF;
	$attributes = mbr_form_attributes($array, ['placeholder']);
	$options    = '';
	$out        = '<div class="mbr-input-field">';
	IF (isset($array['placeholder'])) :
		$default_selected = empty($array['value']) ? "selected='selected'" : '';
		$options  = "<option value='' {$default_selected} disabled='disabled'>{$array['placeholder']}</option>";
	ELSE:
		$out     .= "<label for='{$array['name']}'>{$array['label']}</label>";
	ENDIF;
	FOREACH ($array['options'] AS $value => $label) :
		$selected   = '';
		IF (!empty($array['value']) AND $array['value'] == $value) :
			$selected = 'selected="selected"';
		ENDIF;
		$options .= "<option value='{$value}' {$selected}>{$label}</option>";
	ENDFOREACH;
	$out       .= "<div class='mbr-input-input'>";
	$out       .= "<select name='{$array['name']}' {$attributes} class='mbr-form-control'>";
	$out       .= $options;
	$out       .= "</select>";
	$out       .= "</div>";
	$out       .= "</div>";
	return $out;
}

function mbr_form_field_select_multiple($array)
{
	IF (empty($array['class'])) :
		$array['class'] = 'mbr-form-control';
	ENDIF;
	$attributes = mbr_form_attributes($array, ['placeholder']);
	$options    = '';
	$out        = '<div class="mbr-input-field mbr-label-start">';
	IF (isset($array['placeholder'])) :
		$options  = "<option value='' disabled='disabled'>{$array['placeholder']}</option>";
	ELSE:
		$out     .= "<label for='{$array['name']}'>{$array['label']}</label>";
	ENDIF;
	FOREACH ($array['options'] AS $value => $label) :
		$selected   = '';
		IF (!empty($array['value']) AND in_array($value, $array['value'])) :
			$selected = 'selected="selected"';
		ENDIF;
		$options .= "<option value='{$value}' {$selected}>{$label}</option>";
	ENDFOREACH;
	$out       .= "<div class='mbr-input-input'>";
	$out       .= "<select name='{$array['name']}[]' {$attributes} multiple='multiple' class='mbr-form-control'>";
	$out       .= $options;
	$out       .= "</select>";
	$out       .= "</div>";
	$out       .= "</div>";
	return $out;
}

function mbr_form_submit_button($array)
{
	IF (empty($array['class'])) :
		$array['class'] = 'mbr-submit';
	ENDIF;
	$attributes = mbr_form_attributes($array);
	return "<div class='mbr-submit'><input type='submit'{$attributes} /></div>";
}

function mbr_form_submit_image($array)
{
	IF (empty($array['class'])) :
		$array['class'] = 'mbr-submit';
	ENDIF;
	$attributes = mbr_form_attributes($array);
	return "<div class='mbr-submit'><input type='image'{$attributes} /></div>";
}

//=====================================================================
function mbr_get_default_option($field, $arr_options)
{
	IF (!empty($field)) :
		IF (isset($arr_options[$field])) :
			return $arr_options[$field];
		ENDIF;
	ENDIF;
}

function mbr_build_form($arr_form)
{
	return MBR()->build_form($arr_form);
}

function mbr_plugname()
{
	return MBR()->plugname;
}

function mbr_convert_datetime($datetime, $time=FALSE)
{
	IF (!is_numeric($datetime) OR (int)$datetime !== $datetime) :
		$datetime = strtotime($datetime)  + (get_option('gmt_offset') * 3600);
	ELSE:
		$datetime = $datetime + (get_option('gmt_offset') * 3600);
	ENDIF;

	$date = date_i18n(get_option('date_format'), $datetime);
	IF ($time) :
		$date .= ' ' . date_i18n(get_option('time_format'), $datetime);
	ENDIF;
	return $date;
}

function mbr_prefill_form_field($field)
{
	$tmp_contact           = [];
	IF (mbr_contact_id()) :
		$tmp_contact         =  mbr_remote_contact();
	ENDIF;
	IF (!isset($tmp_contact[$field])) :
		$tmp_contact[$field] = '';
	ENDIF;
	return isset($_POST[$field]) ? trim($_POST[$field]) : $tmp_contact[$field];
}

//===========================================================================================




function mbr_make_actions_box_section( $action = '' )
{
	IF ( $action == 'purchase' ) :
		$title = _x( 'Purchase Actions', 'wp_admin', 'activemember360' );
		$desc  = _x( 'Select the actions to take when a purchase takes place.', 'wp_admin', 'activemember360' );
		$icon  = 'el-icon-shopping-cart';
	ELSEIF ( $action == 'failed' ) :
		$title = _x( 'Failed Payment Actions', 'wp_admin', 'activemember360' );
		$desc  = _x( 'Select the actions to take when a failed payment takes place.', 'wp_admin', 'activemember360' );
		$icon  = 'el-icon-error';
	ELSEIF ( $action == 'cancel' ) :
		$title = _x( 'Cancellation Actions', 'wp_admin', 'activemember360' );
		$desc  = _x( 'Select the actions to take when a cancellation takes place.', 'wp_admin', 'activemember360' );
		$icon  = 'el-icon-remove-sign';
	ELSEIF ( $action == 'refund' ) :
		$title = _x( 'Refund Actions', 'wp_admin', 'activemember360' );
		$desc  = _x( 'Select the actions to take when a refund takes place.', 'wp_admin', 'activemember360' );
		$icon  = 'el-icon-return-key';
	ELSEIF ( $action == 'trial' ) :
		$title = _x( 'Trialing Actions', 'wp_admin', 'activemember360' );
		$desc  = _x( 'Select the actions to take when a trialing takes place.', 'wp_admin', 'activemember360' );
		$icon  = 'el-icon-question-sign';
	ELSEIF ( $action == 'reactivation' ) :
		$title = _x( 'Reactivation Actions', 'wp_admin', 'activemember360' );
		$desc  = _x( 'Select the actions to take when a reactivation takes place.', 'wp_admin', 'activemember360' );
		$icon  = 'el-icon-refresh';
	ENDIF;

	static $site_automations = NULL;
	static $site_tags        = NULL;
	static $site_lists       = NULL;
	static $site_pages       = NULL;

	IF ( is_null( $site_automations ) ) :
		$site_automations = apply_filters( 'mbr/site_automations/get/active', FALSE );
	ENDIF;

	IF ( is_null( $site_tags ) ) :
		$site_tags       = apply_filters( 'mbr/site_tags/get', NULL );
	ENDIF;

	IF ( is_null( $site_lists ) ) :
		$site_lists      = apply_filters( 'mbr/site_lists/get', NULL );
	ENDIF;

	IF ( is_null( $site_pages ) ) :
		$site_pages      = [];
		FOREACH ( apply_filters( 'mbr/pages/get', [] ) AS $page ) :
			$site_pages[ $page->ID ] = ! empty( $page->post_title ) ? $page->post_title : _x( 'No page title', 'wp_admin', 'activemember360' );
		ENDFOREACH;
	ENDIF;

	$fields            = [
			[
					'id'       => '_info_critical_' . $action,
					'type'     => 'info',
					'required' => [ '_mbr_oitem_status', 'equals', 0 ],
					'style'    => 'critical',
					'icon'     => 'el el-warning-sign',
					'title'    => MBR_REDUX_INACTIVE_OITEM_HDR,
					'desc'     => MBR_REDUX_INACTIVE_OITEM_MSG
			],
			[
					'id'       => '_mbr_oitem_' . $action . '_add_automations',
					'type'     => 'select',
					'multi'    => TRUE,
					'title'    => _x( 'Add to automation(s)', 'wp_admin', 'activemember360' ),
					'desc'     => _x( 'Select the ActiveCampaign automation(s) to which you would like to assign contacts.', 'wp_admin', 'activemember360' ),
					'options'  => $site_automations,
					'required' => [ '_mbr_oitem_status', '>', 0 ]
			],
			[
					'id'       => '_mbr_oitem_' . $action . '_remove_automations',
					'type'     => 'select',
					'multi'    => TRUE,
					'title'    => _x( 'Remove from automation(s)', 'wp_admin', 'activemember360' ),
					'desc'     => _x( 'Select the ActiveCampaign automation(s) from which you would like remove contacts.', 'wp_admin', 'activemember360' ),
					'options'  => $site_automations,
					'required' => [ '_mbr_oitem_status', '>', 0 ]
			],
			[
					'id'       => '_mbr_oitem_' . $action . '_assign_tags',
					'type'     => 'select',
					'multi'    => TRUE,
					'title'    => _x( 'Assign tag(s)', 'wp_admin', 'activemember360' ),
					'desc'     => _x( 'Select the ActiveCampaign tag(s) that you would like to assign to contacts.', 'wp_admin', 'activemember360' ),
					'options'  => $site_tags,
					'required' => [ '_mbr_oitem_status', '>', 0 ]
			],
			[
					'id'       => '_mbr_oitem_' . $action . '_remove_tags',
					'type'     => 'select',
					'multi'    => TRUE,
					'title'    => _x( 'Remove tag(s)', 'wp_admin', 'activemember360' ),
					'desc'     => _x( 'Select the ActiveCampaign tag(s) that you would to remove from contacts.', 'wp_admin', 'activemember360' ),
					'options'  => $site_tags,
					'required' => [ '_mbr_oitem_status', '>', 0 ]
			],
			[
					'id'       => '_mbr_oitem_' . $action . '_subscribe_lists',
					'type'     => 'select',
					'multi'    => TRUE,
					'title'    => _x( 'Subscribe to list(s)', 'wp_admin', 'activemember360' ),
					'desc'     => _x( 'Select the ActiveCampaign list(s) to which you would like subscribe contacts.', 'wp_admin', 'activemember360' ),
					'options'  => $site_lists,
					'required' => [ '_mbr_oitem_status', '>', 0 ]
			],
			[
					'id'       => '_mbr_oitem_' . $action . '_unsubscribe_lists',
					'type'     => 'select',
					'multi'    => TRUE,
					'title'    => _x( 'Unsubscribe from list(s)', 'wp_admin', 'activemember360' ),
					'desc'     => _x( 'Select the ActiveCampaign list(s) from which you would like unsubscribe contacts.', 'wp_admin', 'activemember360' ),
					'options'  => $site_lists,
					'required' => [ '_mbr_oitem_status', '>', 0 ]
			]
	];

	IF ( $action == 'purchase' ) :
		$fields[]      = [
				'id'       => '_mbr_oitem_' . $action . '_redirect_page',
				'type'     => 'select',
				'title'    => _x( 'Redirect Page', 'wp_admin', 'activemember360' ),
				'desc'     => _x( 'The page where ActiveMember360 redirects your customer after purchase. Choose static URL if you want to redirect to a e.g. external page.', 'wp_admin', 'activemember360' ),
				'options'  => [ 'no_redirect' => _x( 'No redirect', 'wp_admin', 'activemember360' ), 'static_url' => _x( 'Static URL', 'wp_admin', 'activemember360' ) ] + $site_pages,
				'select2'  => [ 'allowClear' => FALSE ],
				'default'  => 'no_redirect',
				'required' => [ '_mbr_oitem_status', '>', 0 ]
		];

		$fields[]      = [
				'id'       => '_mbr_oitem_' . $action . '_redirect_url',
				'type'     => 'text',
				'title'    => _x( 'Redirect URL', 'wp_admin', 'activemember360' ),
				'desc'     => _x( 'Your redirect URL can look like https://example.com/thank-you. Leave empty to disable this feature.', 'wp_admin', 'activemember360' ),
				'required' => [ '_mbr_oitem_' . $action . '_redirect_page', 'equals', 'static_url' ],
				'validate' => 'url',
				'required' => [ [ '_mbr_oitem_status', '>', 0 ], [ '_mbr_oitem_' . $action . '_redirect_page', 'equals', 'static_url' ] ]
		];
	ENDIF;

	return [ 'title' => $title, 'desc' => $desc, 'icon' => $icon, 'fields' => $fields ];
}

function mbr_get_currency_symbol($currency='')
{
	IF (empty($currency)) :
		return $currency;
	ENDIF;
	$symbols = [
			'AED' => '&#x62f;.&#x625;',
			'AFN' => '&#x60b;',
			'ALL' => 'L',
			'AMD' => 'AMD',
			'ANG' => '&fnof;',
			'AOA' => 'Kz',
			'ARS' => '&#36;',
			'AUD' => '&#36;',
			'AWG' => '&fnof;',
			'AZN' => 'AZN',
			'BAM' => 'KM',
			'BBD' => '&#36;',
			'BDT' => '&#2547;&nbsp;',
			'BGN' => '&#1083;&#1074;.',
			'BHD' => '.&#x62f;.&#x628;',
			'BIF' => 'Fr',
			'BMD' => '&#36;',
			'BND' => '&#36;',
			'BOB' => 'Bs.',
			'BRL' => '&#82;&#36;',
			'BSD' => '&#36;',
			'BTC' => '&#3647;',
			'BTN' => 'Nu.',
			'BWP' => 'P',
			'BYR' => 'Br',
			'BZD' => '&#36;',
			'CAD' => '&#36;',
			'CDF' => 'Fr',
			'CHF' => '&#67;&#72;&#70;',
			'CLP' => '&#36;',
			'CNY' => '&yen;',
			'COP' => '&#36;',
			'CRC' => '&#x20a1;',
			'CUC' => '&#36;',
			'CUP' => '&#36;',
			'CVE' => '&#36;',
			'CZK' => '&#75;&#269;',
			'DJF' => 'Fr',
			'DKK' => 'DKK',
			'DOP' => 'RD&#36;',
			'DZD' => '&#x62f;.&#x62c;',
			'EGP' => 'EGP',
			'ERN' => 'Nfk',
			'ETB' => 'Br',
			'EUR' => '&euro;',
			'FJD' => '&#36;',
			'FKP' => '&pound;',
			'GBP' => '&pound;',
			'GEL' => '&#x10da;',
			'GGP' => '&pound;',
			'GHS' => '&#x20b5;',
			'GIP' => '&pound;',
			'GMD' => 'D',
			'GNF' => 'Fr',
			'GTQ' => 'Q',
			'GYD' => '&#36;',
			'HKD' => '&#36;',
			'HNL' => 'L',
			'HRK' => 'Kn',
			'HTG' => 'G',
			'HUF' => '&#70;&#116;',
			'IDR' => 'Rp',
			'ILS' => '&#8362;',
			'IMP' => '&pound;',
			'INR' => '&#8377;',
			'IQD' => '&#x639;.&#x62f;',
			'IRR' => '&#xfdfc;',
			'ISK' => 'kr.',
			'JEP' => '&pound;',
			'JMD' => '&#36;',
			'JOD' => '&#x62f;.&#x627;',
			'JPY' => '&yen;',
			'KES' => 'KSh',
			'KGS' => '&#x441;&#x43e;&#x43c;',
			'KHR' => '&#x17db;',
			'KMF' => 'Fr',
			'KPW' => '&#x20a9;',
			'KRW' => '&#8361;',
			'KWD' => '&#x62f;.&#x643;',
			'KYD' => '&#36;',
			'KZT' => 'KZT',
			'LAK' => '&#8365;',
			'LBP' => '&#x644;.&#x644;',
			'LKR' => '&#xdbb;&#xdd4;',
			'LRD' => '&#36;',
			'LSL' => 'L',
			'LYD' => '&#x644;.&#x62f;',
			'MAD' => '&#x62f;. &#x645;.',
			'MAD' => '&#x62f;.&#x645;.',
			'MDL' => 'L',
			'MGA' => 'Ar',
			'MKD' => '&#x434;&#x435;&#x43d;',
			'MMK' => 'Ks',
			'MNT' => '&#x20ae;',
			'MOP' => 'P',
			'MRO' => 'UM',
			'MUR' => '&#x20a8;',
			'MVR' => '.&#x783;',
			'MWK' => 'MK',
			'MXN' => '&#36;',
			'MYR' => '&#82;&#77;',
			'MZN' => 'MT',
			'NAD' => '&#36;',
			'NGN' => '&#8358;',
			'NIO' => 'C&#36;',
			'NOK' => '&#107;&#114;',
			'NPR' => '&#8360;',
			'NZD' => '&#36;',
			'OMR' => '&#x631;.&#x639;.',
			'PAB' => 'B/.',
			'PEN' => 'S/.',
			'PGK' => 'K',
			'PHP' => '&#8369;',
			'PKR' => '&#8360;',
			'PLN' => '&#122;&#322;',
			'PRB' => '&#x440;.',
			'PYG' => '&#8370;',
			'QAR' => '&#x631;.&#x642;',
			'RMB' => '&yen;',
			'RON' => 'lei',
			'RSD' => '&#x434;&#x438;&#x43d;.',
			'RUB' => '&#8381;',
			'RWF' => 'Fr',
			'SAR' => '&#x631;.&#x633;',
			'SBD' => '&#36;',
			'SCR' => '&#x20a8;',
			'SDG' => '&#x62c;.&#x633;.',
			'SEK' => '&#107;&#114;',
			'SGD' => '&#36;',
			'SHP' => '&pound;',
			'SLL' => 'Le',
			'SOS' => 'Sh',
			'SRD' => '&#36;',
			'SSP' => '&pound;',
			'STD' => 'Db',
			'SYP' => '&#x644;.&#x633;',
			'SZL' => 'L',
			'THB' => '&#3647;',
			'TJS' => '&#x405;&#x41c;',
			'TMT' => 'm',
			'TND' => '&#x62f;.&#x62a;',
			'TOP' => 'T&#36;',
			'TRY' => '&#8378;',
			'TTD' => '&#36;',
			'TWD' => '&#78;&#84;&#36;',
			'TZS' => 'Sh',
			'UAH' => '&#8372;',
			'UGX' => 'UGX',
			'USD' => '&#36;',
			'UYU' => '&#36;',
			'UZS' => 'UZS',
			'VEF' => 'Bs F',
			'VND' => '&#8363;',
			'VUV' => 'Vt',
			'WST' => 'T',
			'XAF' => 'Fr',
			'XCD' => '&#36;',
			'XOF' => 'Fr',
			'XPF' => 'Fr',
			'YER' => '&#xfdfc;',
			'ZAR' => '&#82;',
			'ZMW' => 'ZK',
	];
	return isset($symbols[upper_trim($currency)]) ? $symbols[upper_trim($currency)] : $currency;
}

























//===========================================================================================




function mbr_shortcode_atts($defaults, $parm)
{
	return MBR()->shortcode_atts($defaults, $parm);
}

function mbr_get_cache_post($id)
{
	return get_post($id);
	
	
}





// used in redux
function mbr_get_payment_settings()
{
	return MBRPAY()->get_payment_settings();
}

// only used in redux metabox for subscriptions to choose stripe plans
function mbr_stripe_set_api_key($key)
{
	MBRPAY()->stripe_set_api_key($key);
	return;
}

// only used in redux metabox for subscriptions to choose stripe plans
function mbr_stripe_get_all_plans()
{
	return MBRPAY()->stripe_get_all_plans();
}

function mbr_stripe_get_account_id()
{
	static $stripe_account_id = NULL;
	IF (is_null($stripe_account_id)) :
		$account = mbr_stripe_get_account_details();
		IF (empty($account)) :
			$stripe_account_id = FALSE;
		ELSE :
			$stripe_account_id = $account['id'];
		ENDIF;
	ENDIF;
	return $stripe_account_id;
}

function mbr_stripe_get_account_details()
{
	static $account = NULL;
	IF (is_null($account)) :
		$account = MBRPAY()->stripe_get_account_details();
	ENDIF;
	return empty($account) ? FALSE : $account;
}

function mbr_stripe_get_keys($mode = 'live')
{
	IF ($mode == 'live') :
		return [ trim(MBRPAY()->payment['stripe_live_secret']), trim(MBRPAY()->payment['stripe_live_publishable']) ];
	ELSE:
		return [ trim(MBRPAY()->payment['stripe_test_secret']), trim(MBRPAY()->payment['stripe_test_publishable']) ];
	ENDIF;
}

function stripe_convert_amount($amount) {
	return intval($amount * 100);
}

function mbr_get_countries()
{
	$countries = [
			'AF' => 'Afghanistan',
			'AX' => 'Aland Islands',
			'AL' => 'Albania',
			'DZ' => 'Algeria',
			'AS' => 'American Samoa',
			'AD' => 'Andorra',
			'AO' => 'Angola',
			'AI' => 'Anguilla',
			'AQ' => 'Antarctica',
			'AG' => 'Antigua And Barbuda',
			'AR' => 'Argentina',
			'AM' => 'Armenia',
			'AW' => 'Aruba',
			'AU' => 'Australia',
			'AT' => 'Austria',
			'AZ' => 'Azerbaijan',
			'BS' => 'Bahamas',
			'BH' => 'Bahrain',
			'BD' => 'Bangladesh',
			'BB' => 'Barbados',
			'BY' => 'Belarus',
			'BE' => 'Belgium',
			'BZ' => 'Belize',
			'BJ' => 'Benin',
			'BM' => 'Bermuda',
			'BT' => 'Bhutan',
			'BO' => 'Bolivia',
			'BA' => 'Bosnia And Herzegovina',
			'BW' => 'Botswana',
			'BV' => 'Bouvet Island',
			'BR' => 'Brazil',
			'IO' => 'British Indian Ocean Territory',
			'BN' => 'Brunei Darussalam',
			'BG' => 'Bulgaria',
			'BF' => 'Burkina Faso',
			'BI' => 'Burundi',
			'KH' => 'Cambodia',
			'CM' => 'Cameroon',
			'CA' => 'Canada',
			'CV' => 'Cape Verde',
			'KY' => 'Cayman Islands',
			'CF' => 'Central African Republic',
			'TD' => 'Chad',
			'CL' => 'Chile',
			'CN' => 'China',
			'CX' => 'Christmas Island',
			'CC' => 'Cocos (Keeling) Islands',
			'CO' => 'Colombia',
			'KM' => 'Comoros',
			'CG' => 'Congo',
			'CD' => 'Congo, Democratic Republic',
			'CK' => 'Cook Islands',
			'CR' => 'Costa Rica',
			'CI' => 'Cote D\'Ivoire',
			'HR' => 'Croatia',
			'CU' => 'Cuba',
			'CY' => 'Cyprus',
			'CZ' => 'Czech Republic',
			'DK' => 'Denmark',
			'DJ' => 'Djibouti',
			'DM' => 'Dominica',
			'DO' => 'Dominican Republic',
			'EC' => 'Ecuador',
			'EG' => 'Egypt',
			'SV' => 'El Salvador',
			'GQ' => 'Equatorial Guinea',
			'ER' => 'Eritrea',
			'EE' => 'Estonia',
			'ET' => 'Ethiopia',
			'FK' => 'Falkland Islands (Malvinas)',
			'FO' => 'Faroe Islands',
			'FJ' => 'Fiji',
			'FI' => 'Finland',
			'FR' => 'France',
			'GF' => 'French Guiana',
			'PF' => 'French Polynesia',
			'TF' => 'French Southern Territories',
			'GA' => 'Gabon',
			'GM' => 'Gambia',
			'GE' => 'Georgia',
			'DE' => 'Germany',
			'GH' => 'Ghana',
			'GI' => 'Gibraltar',
			'GR' => 'Greece',
			'GL' => 'Greenland',
			'GD' => 'Grenada',
			'GP' => 'Guadeloupe',
			'GU' => 'Guam',
			'GT' => 'Guatemala',
			'GG' => 'Guernsey',
			'GN' => 'Guinea',
			'GW' => 'Guinea-Bissau',
			'GY' => 'Guyana',
			'HT' => 'Haiti',
			'HM' => 'Heard Island & Mcdonald Islands',
			'VA' => 'Holy See (Vatican City State)',
			'HN' => 'Honduras',
			'HK' => 'Hong Kong',
			'HU' => 'Hungary',
			'IS' => 'Iceland',
			'IN' => 'India',
			'ID' => 'Indonesia',
			'IR' => 'Iran, Islamic Republic Of',
			'IQ' => 'Iraq',
			'IE' => 'Ireland',
			'IM' => 'Isle Of Man',
			'IL' => 'Israel',
			'IT' => 'Italy',
			'JM' => 'Jamaica',
			'JP' => 'Japan',
			'JE' => 'Jersey',
			'JO' => 'Jordan',
			'KZ' => 'Kazakhstan',
			'KE' => 'Kenya',
			'KI' => 'Kiribati',
			'KR' => 'Korea',
			'KW' => 'Kuwait',
			'KG' => 'Kyrgyzstan',
			'LA' => 'Lao People\'s Democratic Republic',
			'LV' => 'Latvia',
			'LB' => 'Lebanon',
			'LS' => 'Lesotho',
			'LR' => 'Liberia',
			'LY' => 'Libyan Arab Jamahiriya',
			'LI' => 'Liechtenstein',
			'LT' => 'Lithuania',
			'LU' => 'Luxembourg',
			'MO' => 'Macao',
			'MK' => 'Macedonia',
			'MG' => 'Madagascar',
			'MW' => 'Malawi',
			'MY' => 'Malaysia',
			'MV' => 'Maldives',
			'ML' => 'Mali',
			'MT' => 'Malta',
			'MH' => 'Marshall Islands',
			'MQ' => 'Martinique',
			'MR' => 'Mauritania',
			'MU' => 'Mauritius',
			'YT' => 'Mayotte',
			'MX' => 'Mexico',
			'FM' => 'Micronesia, Federated States Of',
			'MD' => 'Moldova',
			'MC' => 'Monaco',
			'MN' => 'Mongolia',
			'ME' => 'Montenegro',
			'MS' => 'Montserrat',
			'MA' => 'Morocco',
			'MZ' => 'Mozambique',
			'MM' => 'Myanmar',
			'NA' => 'Namibia',
			'NR' => 'Nauru',
			'NP' => 'Nepal',
			'NL' => 'Netherlands',
			'AN' => 'Netherlands Antilles',
			'NC' => 'New Caledonia',
			'NZ' => 'New Zealand',
			'NI' => 'Nicaragua',
			'NE' => 'Niger',
			'NG' => 'Nigeria',
			'NU' => 'Niue',
			'NF' => 'Norfolk Island',
			'MP' => 'Northern Mariana Islands',
			'NO' => 'Norway',
			'OM' => 'Oman',
			'PK' => 'Pakistan',
			'PW' => 'Palau',
			'PS' => 'Palestinian Territory, Occupied',
			'PA' => 'Panama',
			'PG' => 'Papua New Guinea',
			'PY' => 'Paraguay',
			'PE' => 'Peru',
			'PH' => 'Philippines',
			'PN' => 'Pitcairn',
			'PL' => 'Poland',
			'PT' => 'Portugal',
			'PR' => 'Puerto Rico',
			'QA' => 'Qatar',
			'RE' => 'Reunion',
			'RO' => 'Romania',
			'RU' => 'Russian Federation',
			'RW' => 'Rwanda',
			'BL' => 'Saint Barthelemy',
			'SH' => 'Saint Helena',
			'KN' => 'Saint Kitts And Nevis',
			'LC' => 'Saint Lucia',
			'MF' => 'Saint Martin',
			'PM' => 'Saint Pierre And Miquelon',
			'VC' => 'Saint Vincent And Grenadines',
			'WS' => 'Samoa',
			'SM' => 'San Marino',
			'ST' => 'Sao Tome And Principe',
			'SA' => 'Saudi Arabia',
			'SN' => 'Senegal',
			'RS' => 'Serbia',
			'SC' => 'Seychelles',
			'SL' => 'Sierra Leone',
			'SG' => 'Singapore',
			'SK' => 'Slovakia',
			'SI' => 'Slovenia',
			'SB' => 'Solomon Islands',
			'SO' => 'Somalia',
			'ZA' => 'South Africa',
			'GS' => 'South Georgia And Sandwich Isl.',
			'ES' => 'Spain',
			'LK' => 'Sri Lanka',
			'SD' => 'Sudan',
			'SR' => 'Suriname',
			'SJ' => 'Svalbard And Jan Mayen',
			'SZ' => 'Swaziland',
			'SE' => 'Sweden',
			'CH' => 'Switzerland',
			'SY' => 'Syrian Arab Republic',
			'TW' => 'Taiwan',
			'TJ' => 'Tajikistan',
			'TZ' => 'Tanzania',
			'TH' => 'Thailand',
			'TL' => 'Timor-Leste',
			'TG' => 'Togo',
			'TK' => 'Tokelau',
			'TO' => 'Tonga',
			'TT' => 'Trinidad And Tobago',
			'TN' => 'Tunisia',
			'TR' => 'Turkey',
			'TM' => 'Turkmenistan',
			'TC' => 'Turks And Caicos Islands',
			'TV' => 'Tuvalu',
			'UG' => 'Uganda',
			'UA' => 'Ukraine',
			'AE' => 'United Arab Emirates',
			'GB' => 'United Kingdom',
			'US' => 'United States',
			'UM' => 'United States Outlying Islands',
			'UY' => 'Uruguay',
			'UZ' => 'Uzbekistan',
			'VU' => 'Vanuatu',
			'VE' => 'Venezuela',
			'VN' => 'Viet Nam',
			'VG' => 'Virgin Islands, British',
			'VI' => 'Virgin Islands, U.S.',
			'WF' => 'Wallis And Futuna',
			'EH' => 'Western Sahara',
			'YE' => 'Yemen',
			'ZM' => 'Zambia',
			'ZW' => 'Zimbabwe'
	];
	return $countries;
}

function mbr_get_us_states()
{
	$us_state_abbrevs_names = [
			'AL'=>'ALABAMA',
			'AK'=>'ALASKA',
			'AS'=>'AMERICAN SAMOA',
			'AZ'=>'ARIZONA',
			'AR'=>'ARKANSAS',
			'CA'=>'CALIFORNIA',
			'CO'=>'COLORADO',
			'CT'=>'CONNECTICUT',
			'DE'=>'DELAWARE',
			'DC'=>'DISTRICT OF COLUMBIA',
			'FM'=>'FEDERATED STATES OF MICRONESIA',
			'FL'=>'FLORIDA',
			'GA'=>'GEORGIA',
			'GU'=>'GUAM GU',
			'HI'=>'HAWAII',
			'ID'=>'IDAHO',
			'IL'=>'ILLINOIS',
			'IN'=>'INDIANA',
			'IA'=>'IOWA',
			'KS'=>'KANSAS',
			'KY'=>'KENTUCKY',
			'LA'=>'LOUISIANA',
			'ME'=>'MAINE',
			'MH'=>'MARSHALL ISLANDS',
			'MD'=>'MARYLAND',
			'MA'=>'MASSACHUSETTS',
			'MI'=>'MICHIGAN',
			'MN'=>'MINNESOTA',
			'MS'=>'MISSISSIPPI',
			'MO'=>'MISSOURI',
			'MT'=>'MONTANA',
			'NE'=>'NEBRASKA',
			'NV'=>'NEVADA',
			'NH'=>'NEW HAMPSHIRE',
			'NJ'=>'NEW JERSEY',
			'NM'=>'NEW MEXICO',
			'NY'=>'NEW YORK',
			'NC'=>'NORTH CAROLINA',
			'ND'=>'NORTH DAKOTA',
			'MP'=>'NORTHERN MARIANA ISLANDS',
			'OH'=>'OHIO',
			'OK'=>'OKLAHOMA',
			'OR'=>'OREGON',
			'PW'=>'PALAU',
			'PA'=>'PENNSYLVANIA',
			'PR'=>'PUERTO RICO',
			'RI'=>'RHODE ISLAND',
			'SC'=>'SOUTH CAROLINA',
			'SD'=>'SOUTH DAKOTA',
			'TN'=>'TENNESSEE',
			'TX'=>'TEXAS',
			'UT'=>'UTAH',
			'VT'=>'VERMONT',
			'VI'=>'VIRGIN ISLANDS',
			'VA'=>'VIRGINIA',
			'WA'=>'WASHINGTON',
			'WV'=>'WEST VIRGINIA',
			'WI'=>'WISCONSIN',
			'WY'=>'WYOMING',
			'AE'=>'ARMED FORCES AFRICA \ CANADA \ EUROPE \ MIDDLE EAST',
			'AA'=>'ARMED FORCES AMERICA (EXCEPT CANADA)',
			'AP'=>'ARMED FORCES PACIFIC'
	];
	return $us_state_abbrevs_names;
}





function mbr_validate_custom_currency($field, $value, $existing_value)
{
	parse_str($_POST['data'], $arrOPTIONS);
	$error              = false;
	IF ($arrOPTIONS['mbr_payment_settings']['currency'] == 'custom_currency') :
		IF (empty($value)) :
			$error          = true;
			$value          = strtolower($existing_value);
			$field['msg']   = __('Please fill in your custom currency.', 'activemember360');
		ELSE:
			$value          = strtolower($value);
		ENDIF;
	ELSE:
		$value            = '';
	ENDIF;
	$return['value']    = $value;
	IF ($error == true) :
		$return['error']  = $field;
	ENDIF;

	return $return;
}

function mbr_scprefix()
{
	static $sc_prefix = null;
	IF (is_null($sc_prefix)) :
		$sc_prefix = MBR()->scPREFIX;
	ENDIF;

	return $sc_prefix;
}

function mbr_get_perstag($title='')
{
	$title = lower_trim($title);
	IF (!empty($title) OR empty(MBR()->cust_fields_perstag_map[$title])) :
		return FALSE;
	ENDIF;

	return MBR()->cust_fields_perstag_map[$title];
}

function gz_decode($data)
{
	$data = base64_decode($data);
	IF ($data AND $inflated_data = gzinflate($data)) :
		$data = $inflated_data;
	ENDIF;

	return json_decode($data, true);
}

function gz_encode($data)
{
	$data = json_encode($data);
	IF ($data AND $deflated_data = gzdeflate($data)) :
		$data = $deflated_data;
	ENDIF;

	return base64_encode($data);
}

function get_gz_option($option, $default=false)
{
	IF ($option = get_option($option, $default)) :
		return gz_decode($option);
	ENDIF;

	return $default;
}

function update_gz_option($option, $value='')
{
	return update_option($option, gz_encode($value));
}

function add_gz_option($option='', $value='')
{
	return add_option($option, gz_encode($value));
}

function blog_get_option($option, $default=false) {
	return MBR_MULTISITE ? get_blog_option($GLOBALS['blog_id'], $option, $default) : get_option($option, $default);
}

function blog_add_option($option, $value, $deprecated='', $autoload='yes') {
	return MBR_MULTISITE ? add_blog_option($GLOBALS['blog_id'], $option, $value) : add_option($option, $value, '', $autoload);
}

function blog_delete_option($option) {
	return MBR_MULTISITE ? delete_blog_option($GLOBALS['blog_id'], $option) : delete_option($option);
}

function blog_update_option($option, $value) {
	return MBR_MULTISITE ? update_blog_option($GLOBALS['blog_id'], $option, $value) : update_option($option, $value);
}

function mbr_http200( $message = '' )
{
	mbr_clear_ob();
	header( $_SERVER["SERVER_PROTOCOL"] . ' 200 OK' );
	die( '200 OK - ' . $message );
}

function mbr_error412( $header = '', $msg = '' )
{
	mbr_clear_ob();
	IF ( empty( $header ) ) :
		$header = 'Undefined Error Condition';
	ENDIF;
	header( $_SERVER["SERVER_PROTOCOL"] . ' 412 ' . $header );
	IF ( empty( $msg ) ) :
		$msg = $header;
	ENDIF;
	die( 'HTTP ERROR 412 - ' . $msg );
}

function mbr_geoip($field = 'COUNTRY')
{
	static $geoip = null;
	IF (is_null($geoip)) :
		$geoip = MBR()->GEOIP;
	ENDIF;
	IF (empty($geoip)) :
		return null;
	ENDIF;
	$field = upper_trim($field);
	IF (array_key_exists($field, $geoip)) :
		return $geoip[$field];
	ENDIF;

	return null;
}

function mbr_geoip_city()
{
	return mbr_geoip('CITY');
}

function mbr_geoip_state()
{
	return mbr_geoip('REGION');
}

function mbr_geoip_region()
{
	return mbr_geoip('REGION');
}

function mbr_geoip_country()
{
	return mbr_geoip('COUNTRY');
}

function mbr_geoip_latitude()
{
	return mbr_geoip('LATITUDE');
}

function mbr_geoip_longitude()
{
	return mbr_geoip('LONGITUDE');
}

function mbr_is_post_published( $post_id = FALSE, $status = 'publish', $reset = FALSE )
{
	IF ( ! $post_id ) :
		return FALSE;
	ENDIF;

	IF ( ! $status ) :
		$status = 'publish';
	ENDIF;

	IF ( in_array( get_post_status( $post_id ), (array) $status ) ) :
		return TRUE;
	ENDIF;

	IF ( $reset ) :
		MBR()->reset_redirect_settings( $post_id );
	ENDIF;

	return FALSE;
}


function in_string( $needle, $haystack )
{
	IF ( stripos( $haystack, $needle ) !== FALSE ) :
		return TRUE;
	ENDIF;

	return FALSE;
}
