<?php
final class activemember360
{
	use
			TRAIT__getInstance
		 ,TRAIT__helpers
		 ,TRAIT__activesdk
		 ,TRAIT__admin
		 ,TRAIT__custom_shortcodes
		 ,TRAIT__miscellaneous
		 ,TRAIT__geoip
		 ,TRAIT__plugin_loader
		 ,TRAIT__methods
		 ,TRAIT__shortcodes
		 ,TRAIT__database
		 ,TRAIT__mailtemplates
	;

	public $SESSION                    = [];
	public $mbr_metabox                = [];
	public $plugname                   = 'ActiveMember360';
	public $plugabbr                   = 'aM360';
	
	public $resources                  = 'https://amember360.s3.amazonaws.com/';

	public $metabox_bg_color           = '#f4faff'; 

	public $site_passfield             = 'Password';

	public $plugcolor                  = '#345E95';
	public $scMAX                      = 20;

	public $session_updated            = false;

	public $cookie_name                = 'mbr';

	public $bbpress                    = false;
	public $bbforum                    = 'forum';
	public $bbtopic                    = 'topic';
	public $bbreply                    = 'reply';

	public $arr_optstatus_names        = [0 => 'unconfirmed', 1 => 'active', 2 => 'unsubscribed', 3 => 'bounced'];

	public $ignore_callback            = false;

	
	public $prvcmt_meta_key            = '_mbr_private_comments';

	public $site_lists_key             = 'site_lists';            
	public $site_lists_expires         = 1800;                    

	public $site_tags_list_key         = 'site_tags_list';        
	public $site_tags_lists_expires    = 1860;                    

	public $site_automations_key       = 'site_automations';      
	public $site_automations_expires   = 1920;                    

	public $ac_account_key             = 'site_ac_account_info';  

	


	public $postmeta_permissions_key            = '_mbr_permissions';
	public $postmeta_no_access_redirect_key     = '_mbr_no_access_redirect';
	public $postmeta_no_access_redirect_url_key = '_mbr_no_access_redirect_url';

	public $site_ac_fields_expires     = 21760;

	public $site_cust_fields_key       = 'site_cust_fields';
	public $site_cust_fields_expires   = 3780;

	public $site_cust_fields           = [];
	public $site_regular_fields        = ['first_name' => 'FIRSTNAME', 'last_name' => 'LASTNAME', 'email' => 'EMAIL', 'phone' => 'PHONE','organization' => 'ORGANIZATION'];

	public $cust_fields_perstag_map    = [];
	public $cust_fields_perstag_key    = [];

	public $site_standard_fields_key   = 'site_contact_standard_fields';
	public $contact_std_fields         = ['id', 'first_name', 'last_name', 'email', 'phone', 'hash', 'ip', 'socialdata_lastcheck', 'cdate', 'name', 'a_unsub_date', 'a_unsub_time', 'gravatar', 'orgid', 'orgname', 'phone', 'ua', 'email_local', 'email_domain', 'rating', 'rating_stamp'];

	
	public $builtin_custom_post_types  = ['product', 'activemember_course', 'activemember_lesson', 'activemember_module'];

	function _load()
	{
		register_deactivation_hook( MBRNAME, 'mbr_plugin_deactivation' );

		global $MBR_OPTIONS, $wpdb;

		$this->wpdb =& $wpdb;

		@set_time_limit( 0 );

		$this->mbr_perms                   = new stdClass();
		$this->mbr_perms->more             = 0;
		$this->mbr_perms->hide_menu        = 0;
		$this->mbr_perms->ignore_excerpt   = 0;
		$this->mbr_perms->public_only      = 0;
		$this->mbr_perms->group_access     = '';
		$this->mbr_perms->tag_pos_list     = '';
		$this->mbr_perms->tag_neg_list     = '';
		$this->mbr_perms->automation_list  = '';

		


		$this->fetch_remote_config_defaults();

		$arrREMOTE_STD_FIELDS = json_decode( get_option( $this->site_standard_fields_key ) );
		IF ( is_array( $arrREMOTE_STD_FIELDS ) ) :
			$this->contact_std_fields = $arrREMOTE_STD_FIELDS;
		ENDIF;

		$this->ac_account_info();

		$this->setup_wpdb_table_names();

		IF ( defined( 'MBR_SC_PREFIX' ) AND MBR_SC_PREFIX ) :
			$this->scPREFIX = MBR_SC_PREFIX;
		ENDIF;
		$this->scPREFIX = lower_trim( $this->scPREFIX );

		IF ( defined( 'MBR_SC_NEST_MAX' ) AND MBR_SC_NEST_MAX ) :
			$this->scMAX = MBR_SC_NEST_MAX;
		ENDIF;

		$this->favicon =& $this->favicon_url;

		$this->setup_error_reporting();
		$this->set_memory_limit();


		
		add_action( 'mbr/constants/setup', [ $this, 'setup_constants' ] );

		do_action( 'mbr/constants/setup' );

		$this->password_perstag = 'field[%' . MBR_SET_PASSFIELD . '%]';

		IF ( !is_admin() ) :

			$this->setup_process_ob();

			
			IF ( isset( $_GET['tcfailed'] ) AND $_GET['tcfailed'] == 'badorder' ) :
				echo "<script>alert('" . __( 'Your order could not be verified on this site.', 'activemember360' ) . "');</script>";
			ENDIF;

		ENDIF;

		$this->force_cookie_setup();
		$this->setup_db_tables();

		FOREACH (get_declared_traits() AS $k => $trait) :

			IF ( $trait <> 'TRAIT__getInstance' ) :

				IF ( method_exists( $this, '_load_' . $trait ) ) :
					add_action( 'mbr/load',       [ $this, '_load_' . $trait ],          20 );
				ENDIF;

				IF ( method_exists( $this, 'init_hooks_' . $trait ) ) :
					add_action( 'mbr/init/hooks', [ $this, 'init_hooks_' . $trait ],     20 );
				ENDIF;

				IF ( method_exists( $this, 'plugins_loaded_' . $trait ) ) :
					add_action( 'plugins_loaded', [ $this, 'plugins_loaded_' . $trait ], 20 );
				ENDIF;

			ENDIF;

		ENDFOREACH;

		do_action( 'mbr/load' );

		$this->load_site_automations();
		$this->load_site_tags();
		$this->load_site_lists();

		$this->CONTACTID = false;
		$this->MBRTAGS   = [];
		$this->MBRMEMB   = [];
		$this->MBRPAYF   = [];
		$this->MBRLISTS  = [];

		do_action( 'mbr/classes/init' );

		do_action( 'mbr/init/hooks' );

		$this->load_site_custom_fields();
	}

	function _init()
	{
		global $MBR_OPTIONS;

		add_thickbox();

		
		do_action('mbr_license_check');
		

		IF (is_admin() AND isset($_GET['mbr_convertuserlogin'])) :
			$this->convert_user_login();
		ENDIF;

		$this->bbpress = class_exists('bbpress');
		$this->bbforum = apply_filters('bbp_forum_post_type', 'forum');
		$this->bbtopic = apply_filters('bbp_topic_post_type', 'topic');
		$this->bbreply = apply_filters('bbp_reply_post_type', 'reply');

		$this->MBR_PROCESSOR_SKIP = $this->skip_visual_editors();

		do_action('early_parse_request');

		IF (FALSE === ($this->EXCERPT_TEXT = $MBR_OPTIONS['site_excerpt'])) :
			$this->EXCERPT_TEXT = __('This is an excerpt. You do not have sufficient rights to view the full content.', 'activemember360');
		ENDIF;

		do_action('mbr/database/init', TRUE);
		do_action('mbr/shortcodes/init');

		add_post_type_support('page', 'excerpt');

		IF (defined('OP_SN')) :
			fake_class_infusionwp();
		ENDIF;
	}

	function init_hooks()
	{
		global $MBR_OPTIONS;

		
		add_filter( 'fl_builder_editor_content',          function( $content ) {	return strip_shortcodes( $content ); } );

		add_filter( 'mbr/cust_fields/required',           [ $this, 'required_fields_password' ], 10, 1 );
		add_action( 'mbr/cust_fields/make_map',           [ $this, 'map_cust_fields_perstag' ] );

		add_action( 'mbr/save/permissions',               [ $this, 'save_permissions' ], 10, 2 );

		add_filter( 'wp_mail_from_name',                  [ $this, 'wp_mail_from_name' ], 999, 1 );
		add_filter( 'wp_mail_from',                       [ $this, 'wp_mail_from' ],      999, 1 );

		
		add_action( 'plugins_loaded',                     'mbr_init_redux', 999 );

		add_action( 'init',                               [ $this, 'load_textdomain' ], 0 );
		add_action( 'init',                               [ $this, 'limitlogins' ],   7 );

		
		add_action( 'init',                               [ $this, '_init' ],         11 );

		IF (isset($_GET['mbr_session'])) :
			add_action( 'init',                             [ $this, 'show_session' ], 99 );
		ENDIF;

		
		add_action( 'init',                               [ $this, 'setup_schedules' ],        0 );

		
		add_filter( 'mbr/protectable_post_types/built_in', [ $this, 'add_protectable_post_types' ],                10, 1 );
		add_filter( 'mbr/protectable_post_types/custom',   [ $this, 'custom_protectable_post_types' ],             10, 1 );
		add_filter( 'mbr/protectable_post_types/all',      [ $this, 'all_protectable_post_types' ],                10, 1 );
		add_action( 'init',                                [ $this, 'init_protection_support_cpt' ],               9999 );


		
		
		add_filter( 'comments_array',                     [ $this, 'prvcmt_filter_comments' ], 10, 2 );
		add_action( 'wp_insert_post',                     [ $this, 'prvcmt_update_private_comment_setting' ], 998, 3 );

		add_filter( 'doing_it_wrong_trigger_error',       '__return_false' );
		add_action( 'wp_enqueue_scripts',                 [ $this, 'enqueue_scripts' ], 0 );
		add_action( 'admin_enqueue_scripts',              [ $this, 'admin_enqueue_scripts' ] );

		
		add_action( 'parse_request',                      [ $this, 'autologin' ] );
		add_action( 'early_parse_request',                [ $this, 'http_post_router' ] );
		

		add_action( 'wp_insert_post',                     [ $this, 'wp_insert_post' ],  998, 3 );
		add_action( 'edit_attachment',                    [ $this, 'wp_insert_post' ],  998, 3 );
		add_action( 'add_attachment',                     [ $this, 'wp_insert_post' ],  998, 3 );

		add_action( 'deleted_post',                       [ $this, 'reset_redirect_settings' ], 0, 1 );
		add_action( 'wp_trash_post',                      [ $this, 'reset_redirect_settings' ], 0, 1 );

		
		add_filter( 'cron_schedules',                     [ $this, 'cron_schedules' ], 0 );

		
		
		add_action( 'mbr_purge_transients_event',         [ $this, 'purge_transients' ] );
		add_action( 'mbr_cron_data_update_event',         [ $this, 'data_update' ] );
		add_action( 'mbr_apilog_cleanup_event',           [ $this, 'apilog_cleanup' ] );
		add_action( 'mbr_cc_login_email_event',           [ $this, 'cc_login_email' ] );
		add_action( 'mbr_plugin_information_event',       [ $this, 'plugin_information' ] );
		add_action( 'mbr_ac_account_info_event',          [ $this, 'fetch_ac_account_info' ] );

		add_action( 'mbr_fetch_ac_standard_fields_event', [ $this, 'fetch_ac_standard_fields' ] );
		

		add_filter( 'sanitize_user',                      [ $this, 'sanitize_user' ], 999, 3 );

		add_action( 'widgets_init',                       [ $this, 'register_widgets' ] );

		add_filter( 'login_url',                          [ $this, 'wp_login_url' ], 1, 3 );
		add_filter( 'logout_url',                         [ $this, 'logout_url' ], 9999, 1 );

		IF (!is_admin()) :

			
			add_action( 'template_redirect',                [ $this, 'template_redirect_force_login' ],    0 );
			add_action( 'template_redirect',                [ $this, 'change_password' ],                  0 );
			add_action( 'template_redirect',                [ $this, 'email_change' ],                     0 );
			add_filter( 'bp_no_access_redirect',            [ $this, 'template_redirect_bp_no_access_redirect' ], 10, 4 );
			IF ( !isset( $_GET['mbr_autologin'] ) ) :
				add_action( 'template_redirect',              [ $this, 'template_redirect' ], 1 );
			ENDIF;

			
			add_filter( 'tcb_can_display_content',          [ $this, 'tcb_can_display_content' ] );

			
			add_filter( 'woocommerce_short_description',    [ $this, 'woo_short_description' ] );

			
			IF ( empty( $_GET['tve'] ) ) :
				add_filter( 'show_admin_bar',                 [ $this, 'show_admin_bar' ], 9999 );
			ENDIF;

			add_filter( 'run_wptexturize',                   '__return_false', 9999 );
			add_action( 'wp_head',                          [ $this, 'wp_head' ], 999 );

			add_action( 'wp_footer',                        [ $this, 'wp_foot_payf' ], 999 );

			add_action( 'wp_logout',                        [ $this, 'wp_logout' ], 1, 0 );

			add_action( 'login_message',                    [ $this, 'login_message' ],    7 );

			
			remove_action( 'register_new_user',             'wp_send_new_user_notifications' );
			add_action   ( 'register_new_user',             [ $this, 'wp_new_user_notification' ] );
			add_action   ( 'register_new_user',             [ $this, 'register_new_user' ],     5, 1 );

			add_filter( 'wp_nav_menu_objects',              [ $this, 'wp_nav_menu_objects' ],  10, 2 );

			add_action( 'pre_get_posts',                    'mbr_pre_get_posts',              10, 1 );
			add_filter( 'the_posts',                        [ $this, 'filter_the_posts' ],     7, 2 );
			add_filter( 'get_pages',                        [ $this, 'filter_the_posts' ],     7, 2 );

			add_filter( 'posts_request',                    [ $this, 'posts_request' ],      999, 1 );

			
			
			add_filter( 'registration_redirect',            [ $this, 'registration_redirect' ], 99, 1 );
			
			add_action( 'register_form',                    [ $this, 'register_form' ], 0 );
			add_action( 'login_form_register',              [ $this, 'login_form_register' ], 0 );

			
			add_filter( 'get_header',                       [ $this, 'remove_autop' ],    7, 3 );
			add_filter( 'post_class',                       [ $this, 'post_class' ],      7, 3 );

			add_filter( 'document_title_parts',             [ $this, 'prep_wp_title' ] );

			add_filter( 'login_headerurl',                  [ $this, 'login_headerurl' ] );
			add_filter( 'login_headertitle',                [ $this, 'login_headertitle' ] );

			add_filter( 'wp_redirect',                      [ $this, 'filter_wp_redirect' ], 0, 2 );

			add_filter( 'widget_title',                     'shortcode_unautop',            6 );
			add_filter( 'widget_title',                     [ $this, 'shortcode' ],         7 );
			add_filter( 'widget_title',                     'do_shortcode',                 8 );

			add_filter( 'widget_text',                      'shortcode_unautop',            6 );
			add_filter( 'widget_text',                      [ $this, 'shortcode' ],          7 );
			add_filter( 'widget_text',                      'do_shortcode',                  8 );

			add_filter( 'the_title',                        'shortcode_unautop',             6 );
			add_filter( 'the_title',                        [ $this, 'ncr2ent' ],            6 );
			add_filter( 'the_title',                        [ $this, 'shortcode' ],          7 );
			add_filter( 'the_title',                        'do_shortcode',                  8 );

			remove_filter( 'the_content',                   'wp_trim_excerpt',              10 );
			add_filter(    'the_content',                   [ $this, 'filter_the_content' ], 8, 2 );
			add_filter(    'the_content',                   [ $this, 'shortcode' ],         10, 1 );

			IF ( ! is_admin() ) :
				add_filter( 'get_the_terms',                  [ $this, 'get_the_terms' ], 10, 3 );
			ENDIF;

			
			

			
			







			add_filter( 'sensei_access_permissions',        [ $this, 'filter_sensei_access_permissions' ], 99, 2 );
			add_filter( 'preprocess_comment',               [ $this, 'filter_preprocess_comment' ], 1 );
			IF ($MBR_OPTIONS['comments_options_activate'] <> 0) :
				add_filter( 'comments_array',                 [ $this, 'filter_comments_array' ], 7, 2 );
				add_filter( 'comment_text',                   [ $this, 'filter_comment_text' ],   1, 3 );
				add_filter( 'comments_open',                  [ $this, 'filter_comments_open' ],  7, 2 );
			ENDIF;

			add_action( 'wp_head',                          [ $this, 'auto_logout_actions' ],    7 );
			add_action( 'login_head',                       [ $this, 'auto_logout_actions' ],    7 );

			add_filter( 'authenticate',                     [ $this, 'authenticate' ],   999, 3 );
			add_action( 'admin_bar_menu',                   [ $this, 'remove_wp_admin_bar_nodes' ], 999 );

			add_filter( 'login_redirect',                   [ $this, 'login_redirect_filter' ], 998, 3 );
			add_action( 'login_form',                       [ $this, 'login_form_action' ],     999, 3 );
			add_action( 'login_init',                       [ $this, 'login_init' ] );

			add_filter( 'woocommerce_login_redirect',       [ $this, 'login_redirect_filter' ], 999, 2 );
			add_filter( 'woocommerce_get_username_from_email', '__return_false',                  0, 0 );
		ENDIF;

		add_action( 'pre_post_update',                    [ $this, 'fetch_tags' ] );

		add_action( 'wp_insert_comment',                  [ $this, 'wp_insert_comment' ],       2, 7 );
	}

	function plugins_loaded()
	{
		global $MBR_OPTIONS;

		IF ( is_user_logged_in() ) :
			header( 'Cache-Control: private, no-cache, no-store, must-revalidate, max-age=0, post-check=0, pre-check=0, proxy-revalidate, s-maxage=0' );
			header( 'Pragma: no-cache' );
			header( 'Expires: Fri, 01 Jan 1990 00:00:00 GMT' );
		ENDIF;

		
		mbr_constant( 'MBRADMIN', is_administrator() );

		$this->current_user =& $GLOBALS['current_user'];

		IF ( is_user_logged_in() ) :

			IF ( ! MBRADMIN AND $MBR_OPTIONS['enable_cclogin'] == 1 ) :
				$user_allowed = $this->prevent_concurrent_logins( $this->current_user->ID );
			ENDIF;

			IF ( ! empty( $_COOKIE[ MBR_COOKIE_NAME ] ) ) :
				
				
				$this->load_session();
				
				$this->CONTACTID = (int) $this->SESSION['id'];
				$tmpTAGS         = array_flip( explode( ',', $this->SESSION['tag_ids'] ) );

				FOREACH ( $this->site_tags AS $tag_id => $tag_name ) :

					IF ( array_key_exists( $tag_id, $MBR_OPTIONS['membership_levels'] ) AND array_key_exists( $tag_id, $tmpTAGS ) ):
						$this->MBRMEMB[ $tag_id ] = $tag_name;
					ENDIF;

					IF ( ! empty( $MBR_OPTIONS['membership_levels'][ $tag_id ]['payf'] ) AND array_key_exists( $MBR_OPTIONS['membership_levels'][ $tag_id ]['payf'], $tmpTAGS ) ) :
						$this->MBRPAYF[ $tag_id ] = $MBR_OPTIONS['membership_levels'][ $tag_id ]['payf'];
					ENDIF;

					IF ( array_key_exists( $tag_id, $tmpTAGS ) ):
						$this->MBRTAGS[ $tag_id ] = $tag_name;
					ENDIF;

				ENDFOREACH;

				


				do_action('mbr/role_tags_mapping/map_roles', $this->MBRTAGS);

				IF ( empty( $this->SESSION['lists'] ) ) :
					$this->SESSION['lists'] = [];
					$this->MBRLISTS         = [];
				ELSE :
					FOREACH ( $this->SESSION['lists'] AS $list_id => $arrLIST ) :
						$this->MBRLISTS[ $list_id ] = $arrLIST['status'];
					ENDFOREACH;
				ENDIF;

				
				
				
				IF ( $this->MBRPAYF AND isset( $_COOKIE['mbr_login_attempt'] ) ) :
					$this->PAYFTB = true;
				ENDIF;

				
				$this->delete_cookie( 'mbr_login_attempt' );

				IF ( ! is_admin() AND $MBR_OPTIONS['auto_logout'] ) :
					IF ( ! isset( $_COOKIE['mbr_auto_logout'] ) ) :
						$this->set_cookie( 'mbr_auto_logout', time() + $MBR_OPTIONS['auto_logout'], 3600 );
					ELSEIF ( isset( $_COOKIE['mbr_auto_logout'] ) AND $_COOKIE['mbr_auto_logout'] < time() ) :
						$this->mbr_logout( __( 'We apologize for the inconvenience. You have been inactive too long and have been logged out for security reasons.', 'activemember360' ) );
					ENDIF;
					$this->set_cookie( 'mbr_auto_logout', time() + $MBR_OPTIONS['auto_logout'], 3600 );
				ENDIF;
			ENDIF;
		ENDIF;
	}

}
