<?php









final class mbr_beaver_builder {

	use TRAIT__getInstance;

	









	public function _load()
	{
		
		IF ( is_plugin_active( 'bb-theme-builder/bb-theme-builder.php' ) ) :
			add_action( 'bb_logic_enqueue_scripts',            [ $this, 'enqueue_bb_themer_scripts' ], 0, 0 );
			add_action( 'bb_logic_init',                       [ $this, 'register_bb_themer_rules' ],  0, 0 );
		ENDIF;

		function MBRBEB()
		{
			IF ( empty( $GLOBALS['mbr_beaver_builder' ] ) ) :
				$GLOBALS['mbr_beaver_builder'] = mbr_beaver_builder::getInstance();
			ENDIF;

			return $GLOBALS['mbr_beaver_builder'];
		}
	}

	










	public function plugins_loaded()
	{
		IF ( ! defined( 'FL_BUILDER_VERSION' ) ) :
			return NULL;
		ENDIF;

		add_action( 'fl_ajax_before_fl_builder_autosuggest', [ $this, 'get_suggest_field_terms' ],  10, 1 );
		add_filter( 'fl_builder_register_settings_form',     [ $this, 'register_settings_form' ],   10, 2 );
		add_filter( 'fl_builder_is_node_visible',            [ $this, 'is_node_visible' ],        9999, 2 );
	}

	












	public function get_suggest_field_terms( $keys_args )
	{
		IF ( 'mbr_beaverbuilder_suggest_tags' == $_REQUEST['fl_as_action'] ) :
			static $arr_tmp_crm_tags      = NULL;
			IF ( is_null( $arr_tmp_crm_tags ) ) :
				$arr_tmp_crm_tags           = apply_filters( 'mbr/site_tags/get', NULL );
			ENDIF;

			$arr_crm_tags       = [];
			IF ( ! empty( $arr_tmp_crm_tags ) ) :
				FOREACH ( $arr_tmp_crm_tags AS $tag_id => $tag_name ) :
					$arr_crm_tags[] = [ 'name' => $tag_name, 'value' => $tag_id ];
				ENDFOREACH;
			ENDIF;

			echo json_encode( $arr_crm_tags );
			die();
		ENDIF;

		IF ( 'mbr_beaverbuilder_suggest_fields' == $_REQUEST['fl_as_action'] ) :
			static $arr_tmp_crm_fields    = NULL;
			IF ( is_null( $arr_tmp_crm_fields ) ) :
				$arr_tmp_regular_fields = apply_filters( 'mbr/site_contact_std_fields/get', NULL );
				IF ( ! empty( $arr_tmp_regular_fields ) ) :
					FOREACH ( $arr_tmp_regular_fields AS $filler => $field_name ) :
						$arr_tmp_crm_fields[ $field_name ] = $field_name;
					ENDFOREACH;
				ENDIF;
				$arr_tmp_custom_fields  = apply_filters( 'mbr/site_custom_fields/get', NULL );
				IF ( ! empty( $arr_tmp_custom_fields ) ) :
					FOREACH ( $arr_tmp_custom_fields AS $field_name => $arr_field ) :
						$arr_tmp_crm_fields[ strtolower( $arr_field['perstag'] ) ] = $arr_field['title'];
					ENDFOREACH;
				ENDIF;
			ENDIF;

			$arr_crm_fields       = [];
			IF ( ! empty( $arr_tmp_crm_fields ) ) :
				FOREACH ( $arr_tmp_crm_fields AS $pers_tag => $field_title ) :
					$arr_crm_fields[] = [ 'name' => $field_title, 'value' => $pers_tag ];
				ENDFOREACH;
			ENDIF;

			echo json_encode( $arr_crm_fields );
			die();
		ENDIF;
	}

	













	public function register_settings_form( $form, $id )
	{
		IF ( ! isset( $form['tabs']['advanced']['sections']['visibility'] ) AND ! isset( $form['sections']['visibility'] ) ) :
			return $form;
		ENDIF;

		static $plugin_name       = NULL;
		IF ( is_null( $plugin_name ) ) :
			$plugin_name            = apply_filters( 'mbr/plugin_name', NULL );
		ENDIF;

		static $arr_conditionals = NULL;
		IF ( is_null( $arr_conditionals ) ) :
			$arr_conditionals      = apply_filters( 'mbr/conditionals/conditionals/get', [] );
		ENDIF;

		$tmp_form                = [];

		$tmp_form['fields']['mbr_element_control_mode']      = [
			'label'                => sprintf( _x( 'Control mode (by %s)', 'beaver-builder', 'activemember360' ), $plugin_name ),
			'type'                 => 'select',
			'options'              => [ 'individual' => _x( 'Individual', 'beaver-builder', 'activemember360' ), 'conditional' => _x( 'Conditional', 'beaver-builder', 'activemember360' ) ],
			'toggle'               => [
				'individual'         => [
					'fields'           => [ 
						'mbr_element_control_pos_tags', 
						'mbr_element_control_neg_tags',
						'mbr_element_control_compare_field',
						'mbr_element_control_compare_field_operator',
						'mbr_element_control_compare_field_value',
						'mbr_element_control_php_statement'
					]
				],
				'conditional'        => [
					'fields'           => [
						'mbr_element_control_conditional_eval',
						'mbr_element_control_conditional_id'
					]
				]
			]
		];

		$tmp_form['fields']['mbr_element_control_conditional_eval']      = [
			'label'                => sprintf( _x( 'Confirm display setting if conditional evaluates (by %s)', 'beaver-builder', 'activemember360' ), $plugin_name ),
			'type'                 => 'select',
			'options'              => [ 'true' => _x( 'True', 'beaver-builder', 'activemember360' ), 'false' => _x( 'False', 'beaver-builder', 'activemember360' ) ],
		];

		$tmp_form['fields']['mbr_element_control_conditional_id']      = [
			'type'                 => 'select',
			'label'                =>  sprintf( _x( 'Select a predefined conditional (by %s)', 'beaver-builder', 'activemember360' ), $plugin_name ),
			'options'              => ! empty( $arr_conditionals ) ? [ 0 => '---' ] + $arr_conditionals : [ 0 => '---' ]
		];

		$tmp_form['fields']['mbr_element_control_pos_tags']      = [
			'label'                => sprintf( _x( 'Tags (Any) (by %s)', 'beaver-builder', 'activemember360' ), $plugin_name ),
			'type'                 => 'suggest',
			'action'               => 'mbr_beaverbuilder_suggest_tags',
			'help'                 => _x( 'Choose one or multiple tags of which a contact must have at least one in order to see the element.', 'beaver-builder', 'activemember360' ),
			'preview'              => [ 'type' => 'none' ]
		];

		$tmp_form['fields']['mbr_element_control_neg_tags']      = [
			'label'                => sprintf( _x( 'Tags (Not) (by %s)', 'beaver-builder', 'activemember360' ), $plugin_name ),
			'type'                 => 'suggest',
			'action'               => 'mbr_beaverbuilder_suggest_tags',
			'help'                 => _x( 'Choose one or multiple tags of which a contact must not have all tags in order to see the element.', 'beaver-builder', 'activemember360' ),
			'preview'              => [ 'type' => 'none' ]
		];

		$tmp_form['fields']['mbr_element_control_compare_field']      = [
			'label'                => sprintf( _x( 'Field (by %s)', 'beaver-builder', 'activemember360' ), $plugin_name ),
			'type'                 => 'suggest',
			'action'               => 'mbr_beaverbuilder_suggest_fields',
			'limit'                => 1,
			'help'                 => _x( 'Compare a contact field against a specific value.', 'beaver-builder', 'activemember360' ),
			'preview'              => [ 'type' => 'none' ]
		];

		$tmp_form['fields']['mbr_element_control_compare_field_operator']      = [
			'type'                 => 'select',
			'label'                =>  sprintf( _x( 'Operator (by %s)', 'beaver-builder', 'activemember360' ), $plugin_name ),
			'options'              => [
				''                   => '---',
				'equals'             => _x( 'Equals',           'beaver-builder', 'activemember360' ),
				'not_equal'          => _x( 'Not equal',        'beaver-builder', 'activemember360' ),
				'greater_than'       => _x( 'Greater than',     'beaver-builder', 'activemember360' ),
				'less_than'          => _x( 'Less than',        'beaver-builder', 'activemember360' ),
				'greater_or_equal'   => _x( 'Greater or equal', 'beaver-builder', 'activemember360' ),
				'less_or_equal'      => _x( 'Less or equal',    'beaver-builder', 'activemember360' ),
				'begins_with'        => _x( 'Begins with',      'beaver-builder', 'activemember360' ),
				'ends_with'          => _x( 'Ends with',        'beaver-builder', 'activemember360' ),
				'contains'           => _x( 'Contains',         'beaver-builder', 'activemember360' ),
				'not_contains'       => _x( 'Not contains',     'beaver-builder', 'activemember360' )
			]
		];

		$tmp_form['fields']['mbr_element_control_compare_field_value'] = [
			'label'                => sprintf( _x( 'Value (by %s)', 'beaver-builder', 'activemember360' ), $plugin_name ),
			'type'                 => 'text'
		];

		$tmp_form['fields']['mbr_element_control_php_statement'] = [
			'label'                => sprintf( _x( 'PHP statement (by %s)', 'beaver-builder', 'activemember360' ), $plugin_name ),
			'type'                 => 'textarea',
			'help'                 => _x( 'PHP statement must return TRUE in order to display the element.', 'beaver-builder', 'activemember360' )
		];

		$tmp_form['fields']['mbr_element_control_internal_notes'] = [
			'label'                => sprintf( _x( 'Internal notes (by %s)', 'beaver-builder', 'activemember360' ), $plugin_name ),
			'type'                 => 'textarea',
			'help'                 => _x( 'Your internal notes about this element. This is not displayed or used elsewhere.', 'beaver-builder', 'activemember360' )
		];

		IF ( isset( $form['tabs']['advanced']['sections']['visibility'] ) ) :
			$form['tabs']['advanced']['sections']['visibility']['fields'] = array_merge( $form['tabs']['advanced']['sections']['visibility']['fields'], $tmp_form['fields'] );
		ELSEIF ( isset( $form['sections']['visibility'] ) ) :
			$form['sections']['visibility']['fields']                     = array_merge( $form['sections']['visibility']['fields'], $tmp_form['fields'] );
		ENDIF;

		return $form;
	}

	














	public function is_node_visible( $is_visible, $node )
	{
		IF ( defined( 'MBRADMIN' ) AND MBRADMIN ) :
			return TRUE;
		ENDIF;

		IF ( ! $is_visible ):
			return FALSE;
		ENDIF;

		IF ( ! isset( $node->settings ) ) :
			return $is_visible;
		ENDIF;

		return $this->match_element_content( $node->settings );
	}

	










	public function match_element_content( $settings )
	{
		IF ( ! empty( $settings->mbr_element_control_mode ) AND 'conditional' == $settings->mbr_element_control_mode ) :
			IF ( ! empty( $settings->mbr_element_control_conditional_id ) AND ! empty( $settings->mbr_element_control_conditional_eval ) ) :
				$match = apply_filters( 'mbr/conditionals/conditional/check', NULL, $settings->mbr_element_control_conditional_id );
				IF ( 'true' == strtolower( $settings->mbr_element_control_conditional_eval ) AND FALSE === $match ) :
					return FALSE;
				ELSEIF ( 'false' == strtolower( $settings->mbr_element_control_conditional_eval ) AND FALSE !== $match ) :
					return FALSE;
				ENDIF;
			ENDIF;
		ELSE:
			IF ( ! empty( $settings->mbr_element_control_pos_tags ) ) :
				$arr_pos_tags = explode(',', $settings->mbr_element_control_pos_tags );
				IF ( ! mbr_has_tags( $arr_pos_tags ) ) :
					return FALSE;
				ENDIF;
			ENDIF;

			IF ( ! empty( $settings->mbr_element_control_neg_tags ) ) :
				$arr_neg_tags = explode(',', $settings->mbr_element_control_neg_tags );
				IF ( mbr_has_tags( $arr_neg_tags ) ) :
					return FALSE;
				ENDIF;
			ENDIF;

			$operator      = $settings->mbr_element_control_compare_field_operator;
			$field         = $settings->mbr_element_control_compare_field;
			$compare_value = $settings->mbr_element_control_compare_field_value;
			IF ( ! empty( $operator ) AND ! empty( $field ) ) :
				$remote_logged_in = apply_filters( 'mbr/contact_id', NULL );
				IF ( empty( $remote_logged_in ) ) :
					return FALSE;
				ENDIF;

				$field_value = apply_filters( 'mbr/get_contact_field', $field );
				IF ( 'equals' == $operator ) :
					$match = ( $field_value == $compare_value ? TRUE : FALSE );
				ELSEIF ( 'not_equal' == $operator ) :
					$match = ( $field_value <> $compare_value ? TRUE : FALSE );
				ELSEIF ( 'less_than' == $operator ) :
					$match = ( $field_value <  $compare_value ? TRUE : FALSE );
				ELSEIF ( 'greater_than' == $operator ) :
					$match = ( $field_value >  $compare_value ? TRUE : FALSE );
				ELSEIF ( 'greater_or_equal' == $operator ) :
					$match = ( $field_value >= $compare_value ? TRUE : FALSE );
				ELSEIF ( 'less_or_equal' == $operator ) :
					$match = ( $field_value <= $compare_value ? TRUE : FALSE );
				ELSEIF ( 'begins_with' == $operator ) :
					$match = ( substr( $field_value,0, strlen( $compare_value ) ) == $compare_value ? TRUE : FALSE );
				ELSEIF ( 'ends_with' == $operator ) :
					$match = ( substr( $field_value,strlen( $compare_value ) * -1 ) == $compare_value ? TRUE : FALSE);
				ELSEIF ( 'contains' == $operator ) :
					$match = ( FALSE !== stripos( $field_value, $compare_value ) ? TRUE : FALSE );
				ELSEIF ( 'not_contains' == $operator ) :
					$match = ( FALSE !== stripos( $field_value, $compare_value ) ? FALSE : TRUE );
				ELSE :
					$match = FALSE;
				ENDIF;
				IF ( empty( $match ) ) :
					return FALSE;
				ENDIF;
			ENDIF;

			IF ( ! empty( $settings->mbr_element_control_php_statement ) ) :
				$php_statement = trim( $settings->mbr_element_control_php_statement );
				$php_statement = ( stristr( $php_statement,  'return' ) ) ? $php_statement : 'return (' . $php_statement . ');';
				$php_statement = stripcslashes( $php_statement );
				IF ( ! eval( $php_statement ) ) :
					return FALSE;
				ENDIF;
			ENDIF;
		ENDIF;

		return TRUE;
	}

	








	public function enqueue_bb_themer_scripts()
	{
		wp_enqueue_script( 'mbr-bb-themer-rules', plugins_url( 'js/bb-themer-rules.js', __FILE__ ), [ 'bb-logic-core' ], MBRVERSION, TRUE );
	}

	








	public function register_bb_themer_rules()
	{
		IF ( ! method_exists( 'BB_Logic_Rules', 'register' ) ) :
			return NULL;
		ENDIF;

		BB_Logic_Rules::register( [
			'mbr/predefined_conditional' => __CLASS__ . '::themer_rule_predefined_conditional',
		 ] );
	}

	








	public static function themer_rule_predefined_conditional( $rule )
	{
		$match = apply_filters( 'mbr/conditionals/conditional/check', NULL, $rule->conditional_id );

		IF ( 'true' == $rule->evaluation_mode AND FALSE === $match ) :
			return FALSE;
		ELSEIF ( 'false' == $rule->evaluation_mode AND FALSE !== $match ) :
			return FALSE;
		ENDIF;

		return TRUE;
	}

}













function mbr_beaverbuilder_suggest_tags_value( $value, $data )
{
	static $arr_crm_tags      = NULL;
	IF ( is_null( $arr_crm_tags ) ) :
		$arr_crm_tags           = apply_filters( 'mbr/site_tags/get', NULL );
	ENDIF;

	$values   = explode( ',', $value );
	$data     = [];

	FOREACH ( $values AS $tag_id ) :
		$data[] = [ 'name' => $arr_crm_tags[ $tag_id ], 'value' => $tag_id ];
	ENDFOREACH;

	return $data;
}













function mbr_beaverbuilder_suggest_fields_value( $value, $data )
{
	$values   = explode( ',', $value );
	$data     = [];

	FOREACH ( $values AS $field_name ) :
		$data[] = [ 'name' => $field_name, 'value' => $field_name ];
	ENDFOREACH;

	return $data;
}




$GLOBALS['mbr_beaver_builder'] = mbr_beaver_builder::getInstance();
