<?php









final class mbr_conditionals {
	use TRAIT__getInstance, TRAIT__helpers;
	


	public $conditional_post_type = 'mbrconditionals';

	


	public $conditional_category  = 'mbrconditionals-category';

	










	public function plugins_loaded() {
		add_action( 'init',                                                             [ $this, 'register_post_type' ],                      0, 0 );
		add_filter( 'manage_edit-' . $this->conditional_category . '_columns',          [ $this, 'remove_taxonomy_columns' ],                10, 1 );
		add_filter( $this->conditional_category . '_row_actions',                       [ $this, 'remove_taxonomy_quick_edit' ],             10, 2 );
		add_filter( 'manage_' . $this->conditional_post_type . '_posts_columns',        [ $this, 'add_admin_columns' ],                      10, 1 );
		add_action( 'manage_' . $this->conditional_post_type . '_posts_custom_column' , [ $this, 'add_admin_columns_data' ],                 10, 2 );
		add_action( 'restrict_manage_posts',                                            [ $this, 'admin_custom_category_filter' ],           10, 2 );
		add_filter( 'parse_query',                                                      [ $this, 'convert_id_to_term_in_query' ],            10 ,1 );
		add_filter( 'post_updated_messages',                                            [ $this, 'set_messages' ],                           10, 1 );
		add_filter( 'rwmb_meta_boxes',                                                  [ $this, 'meta_boxes'],                               1, 1 );
		add_action( 'add_meta_boxes_' . $this->conditional_post_type,                   [ $this, 'remove_tag_search_meta_box' ],             10, 0 );
		add_action( 'admin_enqueue_scripts',                                            [ $this, 'admin_enqueue_scripts' ],                  10, 0 );
		add_action( 'pre_post_update',                                                  [ $this, 'pre_post_update' ],                      9999, 2 );
		add_filter( 'mbr/conditionals/condition/add',                                   [ $this, 'condition_contact_list_status' ],           0, 1 );
		add_filter( 'mbr/conditionals/condition/check/mbr_contact_list_status',         [ $this, 'check_condition_contact_list_status' ],     0, 2 );
		add_filter( 'mbr/conditionals/condition/add',                                   [ $this, 'condition_contact_tag_status' ],            0, 1 );
		add_filter( 'mbr/conditionals/condition/check/mbr_contact_tag_status',          [ $this, 'check_condition_contact_tag_status' ],      0, 2 );
		add_filter( 'mbr/conditionals/condition/add',                                   [ $this, 'condition_contact_field_compare' ],         0, 1 );
		add_filter( 'mbr/conditionals/condition/check/mbr_contact_field_compare',       [ $this, 'check_condition_contact_field_compare' ],   0, 2 );
		add_filter( 'mbr/conditionals/condition/add',                                   [ $this, 'condition_user_login_status' ],             0, 1 );
		add_filter( 'mbr/conditionals/condition/check/mbr_user_login_status',           [ $this, 'check_condition_user_login_status' ],       0, 2 );
		add_filter( 'mbr/conditionals/condition/add',                                   [ $this, 'condition_user_role_status' ],             0, 1 );
		add_filter( 'mbr/conditionals/condition/check/mbr_user_role_status',            [ $this, 'check_condition_user_role_status' ],       0, 2 );
		add_filter( 'mbr/conditionals/condition/add',                                   [ $this, 'condition_php_statement' ],                 0, 1 );
		add_filter( 'mbr/conditionals/condition/check/mbr_php_statement',               [ $this, 'check_condition_php_statement' ],           0, 2 );
		add_filter( 'mbr/conditionals/condition/add',                                   [ $this, 'condition_predefined_conditional' ],        0, 1 );
		add_filter( 'mbr/conditionals/condition/check/mbr_predefined_conditional',      [ $this, 'check_condition_predefined_conditional' ],  0, 2 );

		IF ( defined( 'GAMIPRESS_VER' ) ) :
			add_filter( 'mbr/conditionals/condition/add',                                 [ $this, 'condition_gamipress_user_status' ],         0, 1 );
			add_filter( 'mbr/conditionals/condition/check/mbr_gamipress_user_status',     [ $this, 'check_condition_gamipress_user_status' ],   0, 2 );
		ENDIF;

		IF ( defined( 'LEARNDASH_VERSION' ) ) :
			add_filter( 'mbr/conditionals/condition/add',                                 [ $this, 'condition_learndash_user_status' ],         0, 1 );
			add_filter( 'mbr/conditionals/condition/check/mbr_learndash_user_status',     [ $this, 'check_condition_learndash_user_status' ],   0, 2 );
		ENDIF;

		IF ( class_exists( 'WooCommerce' ) ) :
			add_filter( 'mbr/conditionals/condition/add',                                 [ $this, 'condition_woocommerce_user_status' ],       0, 1 );
			add_filter( 'mbr/conditionals/condition/check/mbr_woocommerce_user_status',   [ $this, 'check_condition_woocommerce_user_status' ], 0, 2 );
		ENDIF;

		add_filter( 'mbr/conditionals/conditional/check',                               [ $this, 'check_conditional' ],                      0, 2 );
		add_filter( 'mbr/conditionals/conditionals/get',                                [ $this, 'get_conditionals' ],                       0, 1 );
		add_filter( 'mbr/shortcodes/extend',                                            [ $this, 'extend_conditionals_shortcodes' ],         0, 1 );

		add_action( 'rest_api_init',                                                    [ $this, 'register_routes' ],                       10, 1 );
	}

	








	public function register_post_type()
	{
		$args                     = [
			'labels'                => [
				'name'                => _x( 'Conditionals', 'conditionals', 'activemember360' ),
				'singular_name'       => _x( 'Conditionals', 'conditionals', 'activemember360' ),
				'add_new_item'        => _x( 'Add New Conditional', 'conditionals', 'activemember360' ),
				'edit_item'           => _x( 'Edit Conditional', 'conditionals', 'activemember360' ),
				'new_item'            => _x( 'New Conditional', 'conditionals', 'activemember360' ),
				'view_item'           => _x( 'View Conditional', 'conditionals', 'activemember360' ),
				'all_items'           => _x( 'All Conditionals', 'conditionals', 'activemember360' ),
				'search_items'        => _x( 'Search conditionals', 'conditionals', 'activemember360' ),
				'not_found'           => _x( 'No Conditionals found.', 'conditionals', 'activemember360' ),
				'not_found_in_trash'  => _x( 'No Conditionals found in trash.', 'conditionals', 'activemember360' )
			],
			'description'           => sprintf( _x( 'Conditionals for %s', 'conditionals', 'activemember360' ), apply_filters( 'mbr/plugin_name', '' ) ),
			'public'                => FALSE,
			'exclude_from_search'   => TRUE,
			'publicly_queryable'    => FALSE,
			'show_ui'               => current_user_can( 'activate_plugins' ),
			'show_in_nav_menus'     => FALSE,
			'show_in_menu'          => TRUE,
			'menu_position'         => 3,
			'menu_icon'             => apply_filters( 'mbr/plugin_favicon', '' ),
			'show_in_admin_bar'     => current_user_can( 'activate_plugins' ),
			'capability_type'       => 'post',
			'can_export'            => TRUE,
			'taxonomies'            => [ $this->conditional_category ],
			'supports'              => [ 'title', 'revisions' ],
			'rewrite'               => [ 'slug' => false, 'with_front' => false ]
		];

		register_post_type( $this->conditional_post_type, $args );
		register_taxonomy( $this->conditional_category, [ $this->conditional_post_type ],
			[
				'hierarchical'       => TRUE,
				'public'             => FALSE,
				'publicly_queryable' => FALSE,
				'show_in_nav_menus'  => FALSE,
				'show_in_rest'       => FALSE,
				'show_ui'            => TRUE,
				'query_var'          => TRUE,
				'show_admin_column'  => TRUE,
				'label'              => _x( 'Categories', 'wp_admin', 'activemember360' ),
				'singular_label'     => _x( 'Category', 'wp_admin', 'activemember360' ),
				'rewrite'            => [ 'slug' => FALSE, 'with_front' => FALSE ]
			]
		);
	}

	










	public function remove_taxonomy_columns( $columns )
	{
		unset( $columns['slug'] );

		return $columns;
	}

	














	public function remove_taxonomy_quick_edit( $actions )
	{
		IF ( isset( $actions['inline hide-if-no-js'] ) ) :
			unset( $actions['inline hide-if-no-js'] );
		ENDIF;

		return $actions;
	}

	











	public function admin_custom_category_filter( $post_type, $which )
	{
		IF ( $this->conditional_post_type == $post_type) :
			$category_count       = wp_count_terms( $this->conditional_category, [
				'hide_empty'        => FALSE,
				'parent'            => 0
			 ] );
			IF ( ! empty( $category_count ) ) :
				$selected           = isset( $_GET[ $this->conditional_category ] ) ? $_GET[ $this->conditional_category ] : '';
				$info_taxonomy      = get_taxonomy( $this->conditional_category );
				wp_dropdown_categories( [
					'show_option_all' => sprintf( _x( 'Show all %s', 'wp_admin', 'activemember360' ), $info_taxonomy->label ),
					'taxonomy'        => $this->conditional_category,
					'name'            => $this->conditional_category,
					'orderby'         => 'name',
					'selected'        => $selected,
					'show_count'      => TRUE,
					'hide_empty'      => FALSE,
				] );
			ENDIF;
		ENDIF;
	}

	














	public function convert_id_to_term_in_query( $query )
	{
		global $pagenow;
	
		
		$q_vars    = &$query->query_vars;
		IF ( $pagenow == 'edit.php' AND isset( $q_vars['post_type'] ) AND $q_vars['post_type'] == $this->conditional_post_type AND isset( $q_vars[ $this->conditional_category ] ) AND is_numeric( $q_vars[ $this->conditional_category ] ) AND $q_vars[ $this->conditional_category ] <> 0 ) :
			$term = get_term_by( 'id', $q_vars[ $this->conditional_category ], $this->conditional_category );
			$q_vars[ $this->conditional_category ] = $term->slug;
		ENDIF;
	}

	










	public function add_admin_columns( $columns )
	{
		$new_columns                              = [];
		FOREACH ( $columns AS $key => $column ) :
			$new_columns[ $key ]                    = $column;
			IF ( 'title' == $key ) :
				$new_columns['mbr_conditions']        = _x( 'Conditions',      'wp_admin', 'activemember360' );
				$new_columns['mbr_conditional_logic'] = _x( 'Condition logic', 'wp_admin', 'activemember360' );
				$new_columns['mbr_conditional_id']    = _x( 'Conditional ID',  'wp_admin', 'activemember360' );
			ENDIF;
		ENDFOREACH;

		return $new_columns;
	}

	











	public function add_admin_columns_data( $column, $post_id )
	{
		static $arr_conditions_definition = NULL;
		static $arr_triggers              = [];
		IF ( is_null( $arr_conditions_definition ) ) :
			$arr_conditions_definition      = apply_filters( 'mbr/conditionals/condition/add', [] );
			FOREACH ( $arr_conditions_definition AS $key => $arr_condition_definition ) :
				FOREACH ( $arr_condition_definition['trigger'] AS $trigger => $trigger_name ) :
					$arr_triggers[ $trigger ]   = $trigger_name;
				ENDFOREACH;
			ENDFOREACH;
		ENDIF;

		SWITCH ( $column ) :
			CASE 'mbr_conditions' :
				$arr_conditions = get_post_meta( $post_id, '_mbr_condition_definition', TRUE );
				IF ( empty( $arr_conditions ) OR ! is_array( $arr_conditions ) ) :
					echo _x( 'No conditions defined yet.', 'wp_admin', 'activemember360' );
				ELSE:
					FOREACH ( $arr_conditions AS $key => $arr_condition ) :
						$status   = '';
						IF ( ( isset( $arr_condition['condition_type'] ) AND empty( $arr_triggers[ $arr_condition['condition_type'] ] ) ) OR ( isset( $arr_condition['condition_status'] ) AND 'inactive' == $arr_condition['condition_status'] ) ) :
							$status = _x( '(inactive)', 'wp_admin', 'activemember360' );
						ENDIF;
						$third_party_disabled        = '';
						IF ( 'mbr_woocommerce_user_status' == $arr_condition['condition_type'] ) :
							IF ( ! class_exists( 'WooCommerce' ) ) :
								$status                  = '<span class="mbr_conditionals_listing_warning">' . _x( '(WARNING)', 'wp_admin', 'activemember360' ) . '</span>';
								$third_party_disabled    = '<br /><span class="mbr_conditionals_listing_warning">' . _x( '(WooCommerce is deactivated)', 'wp_admin', 'activemember360' ) . '</span>';
							ENDIF;
							IF ( isset( $arr_condition['condition_woocommerce_user_status_type'] ) AND ( FALSE !== stripos( $arr_condition['condition_woocommerce_user_status_type'], 'subscription' ) ) ) :
								IF ( ! class_exists( 'WC_Subscription' ) ) :
								$status                  = '<span class="mbr_conditionals_listing_warning">' . _x( '(WARNING)', 'wp_admin', 'activemember360' ) . '</span>';
									$third_party_disabled .= '<br /><span class="mbr_conditionals_listing_warning">' . _x( '(WooCommerce Subscriptions is deactivated)', 'wp_admin', 'activemember360' ) . '</span>';
								ENDIF;
							ENDIF;
						ELSEIF ( 'mbr_learndash_user_status' == $arr_condition['condition_type'] ) :
							IF ( ! defined( 'LEARNDASH_VERSION' ) ) :
							$status                  = '<span class="mbr_conditionals_listing_warning">' . _x( '(WARNING)', 'wp_admin', 'activemember360' ) . '</span>';
							$third_party_disabled    = '<br /><span class="mbr_conditionals_listing_warning">' . _x( '(LearnDash is deactivated)', 'wp_admin', 'activemember360' ) . '</span>';
							ENDIF;
						ELSEIF ( 'mbr_gamipress_user_status' == $arr_condition['condition_type'] ) :
							IF ( ! defined( 'GAMIPRESS_VER' ) ) :
							$status                  = '<span class="mbr_conditionals_listing_warning">' . _x( '(WARNING)', 'wp_admin', 'activemember360' ) . '</span>';
							$third_party_disabled    = '<br /><span class="mbr_conditionals_listing_warning">' . _x( '(GamiPress is deactivated)', 'wp_admin', 'activemember360' ) . '</span>';
							ENDIF;
						ENDIF;
						IF ( ! empty( $arr_condition['condition_name'] ) ) :
							echo sprintf( $arr_condition['condition_name'] . ' %s %s', $status, $third_party_disabled ) . '<br />';
						ELSE:
							IF ( isset( $arr_triggers[ $arr_condition['condition_type'] ] ) ) :
								echo sprintf( $arr_triggers[ $arr_condition['condition_type'] ] . ' %s %s', $status, $third_party_disabled ) . '<br />';
							ELSE:
								echo sprintf( $arr_condition['condition_type'] . ' %s %s', $status, $third_party_disabled ) . '<br />';
							ENDIF;
						ENDIF;
					ENDFOREACH;
				ENDIF;
				break;
			CASE 'mbr_conditional_logic' :
				$condition_logic = get_post_meta( $post_id, '_mbr_condition_logic', TRUE );
				echo ! empty( $condition_logic ) ?  strtoupper( $condition_logic ) : '';
				break;
			CASE 'mbr_conditional_id' :
				echo $post_id;
				break;
		ENDSWITCH;
	}

	














	public function set_messages( $messages )
	{
		global $post_ID;

		IF ( ! empty( $post_ID ) AND $post_type = get_post_type( $post_ID ) ) :
			IF ( ! empty( $post_type ) AND $post_type == $this->conditional_post_type ) :
				$messages[ $post_type ] = [
					0  => '', // Unused. Messages start at index 1.
					1  => _x( 'Conditional was updated.', 'conditionals', 'activemember360' ),
					2  => '',
					3  => '',
					4  => _x( 'Conditional was updated.', 'conditionals', 'activemember360' ),
					5  => isset( $_GET['revision'] ) ? sprintf( _x( 'Conditional was restored to revision from %s', 'conditionals', 'activemember360' ), wp_post_revision_title( (int) $_GET['revision'], FALSE ) ) : FALSE,
					6  => _x( 'Conditional was published.', 'conditionals', 'activemember360' ),
					7  => _x( 'Conditional was saved.', 'conditionals', 'activemember360'),
					8  => _x( 'Conditional was submitted.', 'conditionals', 'activemember360' ),
					9  => '',
					10 => ''
				];
			ENDIF;
		ENDIF;

		return $messages;
	}

	










	public function meta_boxes( $meta_boxes )
	{
		$doing_ajax              = FALSE;
		IF ( defined( 'DOING_AJAX' ) AND DOING_AJAX ) :
			$doing_ajax            = TRUE;
		ENDIF;

		IF ( ! is_admin() AND ! $doing_ajax ) :
			return $meta_boxes;
		ENDIF;

		$current_post_type       = $this->get_current_post_type();
		IF ( $current_post_type <> $this->conditional_post_type AND ! $doing_ajax ) :
			return $meta_boxes;
		ENDIF;

		$arr_conditions          = apply_filters( 'mbr/conditionals/condition/add', [] );
		$arr_triggers            = [];
		$arr_fields              = [];
		IF ( ! empty( $arr_conditions ) AND is_array( $arr_conditions ) ) :
			FOREACH ( $arr_conditions AS $key => $arr_condition ) :
				IF ( ! empty( $arr_condition['trigger'] ) AND is_array( $arr_condition['trigger'] ) ) :
					$arr_triggers      = array_merge( $arr_triggers, $arr_condition['trigger'] );
				ENDIF;
				IF ( ! empty( $arr_condition['fields'] ) AND is_array( $arr_condition['fields'] ) ) :
					$arr_fields        = array_merge( $arr_fields, $arr_condition['fields'] );
				ENDIF;
			ENDFOREACH;
		ENDIF;

		$arr_required_fields     = [];
		$arr_required_fields[]   = [
			'id'                   => 'condition_name',
			'name'                 => _x( 'Condition name', 'wp_admin', 'activememebr360' ),
			'type'                 => 'text'
		];
		$arr_required_fields[]   = [
			'id'                   => 'condition_status',
			'name'                 => _x( 'Condition status', 'wp_admin', 'activememebr360' ),
			'type'                 => 'select_advanced',
			'options'              => [ 'active' => _x( 'Active', 'wp_admin', 'activemember360' ), 'inactive' => _x( 'Inactive', 'wp_admin', 'activemember360' ) ],
			'std'                  => 'active',
			'placeholder'          => _x( 'Select condition status', 'wp_admin', 'activemember360' ),
			'js_options'           => [ 'width' => '100%' ]
		];
		$arr_required_fields[]   = [
			'id'                   => 'condition_type',
			'name'                 => _x( 'Condition type', 'wp_admin', 'activememebr360' ),
			'type'                 => 'select_advanced',
			'options'              => $arr_triggers,
			'placeholder'          => _x( 'Select a condition', 'wp_admin', 'activemember360' ),
			'js_options'           => [ 'width' => '100%' ]
		];

		IF ( ! empty( $arr_fields ) AND is_array( $arr_fields ) ) :
			$arr_fields            = array_merge( $arr_required_fields, $arr_fields );
		ENDIF;

		$meta_boxes[]            = [
			'id'                   => 'mbr_conditionals_meta_box_definition',
			'title'                => sprintf( _x( '%s Conditional Condition Set', 'wp_admin', 'activemember360' ), apply_filters( 'mbr/plugin_name', '' ) ),
			'post_types'           => [ $this->conditional_post_type ],
			'context'              => 'normal',
			'priority'             => 'high',
			'fields'               => [
				[
					'id'               => '_mbr_condition_logic',
					'name'             => _x( 'Condition Logic', 'wp_admin', 'activemember360' ),
					'type'             => 'radio',
					'options'          => [ 'and' => _x( 'AND', 'wp_admin', 'activemember360' ), 'or' => _x( 'OR', 'wp_admin', 'activemember360' ) ],
					'std'              => 'and',
				],
				[
					'id'               => '_mbr_condition_definition',
					'name'             => _x( 'Conditions', 'admin', 'activemember360' ),
					'group_title'      => '{condition_name} ({condition_status})',
					'add_button'       => _x( 'Add Condition', 'wp_admin', 'activemember360' ),
					'type'             => 'group',
					'clone'            => TRUE,
					'sort_clone'       => TRUE,
					'collapsible'      => TRUE,
					'default_state'    => 'expanded',
					'save_state'       => FALSE,
					'fields'           => $arr_fields
				]
			]
		];

		$meta_boxes[]            = [
			'id'                   => 'mbr_conditionals_meta_box_notes',
			'title'                => sprintf( _x( '%s Conditional Note', 'wp_admin', 'activemember360' ), apply_filters( 'mbr/plugin_name', '' ) ),
			'post_types'           => [ $this->conditional_post_type ],
			'context'              => 'normal',
			'priority'             => 'high',
			'fields'               => [
				[
					'id'               => '_mbr_condition_note',
					'desc'             => _x( 'Your internal notes about this element. This is not displayed or used elsewhere.', 'wp_admin', 'activemember360' ),
					'type'             => 'textarea',
					'rows'             => 10
				]
			]
		];

		$meta_boxes[]            = [
			'id'                   => 'mbr_conditionals_meta_box_shortcode',
			'title'                => _x( 'Conditional Shortcode', 'wp_admin', 'activemember360' ),
			'post_types'           => [ $this->conditional_post_type ],
			'context'              => 'side',
			'priority'             => 'low',
			'fields'               => [
				[
					'id'               => '_mbr_condition_shortcode',
					'type'             => 'custom_html',
					'std'              => ! empty( $_GET['post'] ) ? '[mbr_is_conditional id=\'' . $_GET['post'] . '\']<br />&nbsp;&nbsp;&nbsp;&nbsp;Condition met.<br />[ELSE_is_conditional]<br />&nbsp;&nbsp;&nbsp;&nbsp;Condition not met.<br />[/mbr_is_conditional]' : _x( 'Please save your condition to get the shortcode.', 'wp_admin', 'activemember360' )
				]
			]
		];

		$meta_boxes[]            = [
			'id'                   => 'mbr_conditionals_meta_box_api_method',
			'title'                => _x( 'PHP API Method', 'wp_admin', 'activemember360' ),
			'post_types'           => [ $this->conditional_post_type ],
			'context'              => 'side',
			'priority'             => 'low',
			'fields'               => [
				[
					'id'               => '_mbr_condition_api_emthod',
					'type'             => 'custom_html',
					'std'              => ! empty( $_GET['post'] ) ? 'mbr_is_conditional( ' . $_GET['post'] . ' )' : _x( 'Please save your condition to get the shortcode.', 'wp_admin', 'activemember360' )
				]
			]
		];

		return $meta_boxes;
	}

	











	public function condition_user_login_status( $arr_conditions )
	{
		$arr_conditions[]   = [
			'trigger'         => [ 'mbr_user_login_status' => _x( 'User login status', 'wp_admin', 'activemember360' ) ],
			'fields'          => [
				[
					'id'          => 'condition_user_login_status_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose a login status a User must have in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ 'condition_type', '=', 'mbr_user_login_status' ]
				],
				[
					'id'          => 'condition_user_login_status',
					'name'        => _x( 'User login status', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => [ 'logged_in' => _x( 'User is logged in', 'wp_admin', 'activemember360' ), 'not_logged_in' => _x( 'User is not logged in', 'wp_admin', 'activemember360' ), 'first_login' => _x( 'First login', 'wp_admin', 'activemember360' ), 'failed_payment' => _x( 'Failed payment', 'wp_admin', 'activemember360' ) ],
					'visible'     => [ 'condition_type', '=', 'mbr_user_login_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select user login status', 'wp_admin', 'activemember360' )
				]
			]
		];

		return $arr_conditions;
	}

	















	public function check_condition_user_login_status( $match, $arr_condition )
	{
		IF ( ! empty( $arr_condition['condition_user_login_status'] ) ) :
			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			IF ( 'first_login' == $arr_condition['condition_user_login_status'] ) :
				IF ( is_user_logged_in() AND isset( $_COOKIE['mbr_first_login_session'] ) AND 'yes' == $_COOKIE['mbr_first_login_session'] ) :
					return TRUE;
				ELSE:
					return FALSE;
				ENDIF;
			ELSEIF ( 'failed_payment' == $arr_condition['condition_user_login_status'] ) :
				IF ( ! empty( $GLOBALS['mbr']->CONTACTID ) AND ! empty( $GLOBALS['mbr']->MBRPAYF ) ) :
					return TRUE;
				ELSE :
					return FALSE;
				ENDIF;
			ELSEIF ( 'logged_in' == $arr_condition['condition_user_login_status'] ) :
				IF ( is_user_logged_in() ) :
					return TRUE;
				ELSE:
					return FALSE;
				ENDIF;
			ELSE:
				IF ( ! is_user_logged_in() ) :
					return TRUE;
				ELSE:
					return FALSE;
				ENDIF;
			ENDIF;
		ENDIF;

		return $match;
	}

		











	public function condition_user_role_status( $arr_conditions )
	{
		$arr_conditions[]   = [
			'trigger'         => [ 'mbr_user_role_status' => _x( 'User role status', 'wp_admin', 'activemember360' ) ],
			'fields'          => [
				[
					'id'          => 'condition_user_role_status',
					'name'        => _x( 'User status', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => [ 'user_has_roles' => _x( 'User has roles', 'wp_admin', 'activemember360' ), 'user_has_not_roles' => _x( 'User does not have roles', 'wp_admin', 'activemember360' ) ],
					'visible'     => [ 'condition_type', '=', 'mbr_user_role_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select user role status', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_user_has_roles_status_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose roles a User must have in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_user_role_status' ], [ 'condition_user_role_status', '=', 'user_has_roles' ] ]
				],
				[
					'id'          => 'condition_user_has_not_roles_status_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose roles a User must not have in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_user_role_status' ], [ 'condition_user_role_status', '=', 'user_has_not_roles' ] ]
				],
				[
					'id'          => 'condition_user_role_status_determined_by',
					'name'        => _x( 'Determined by', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => [ 'any' => _x( 'any', 'wp_admin', 'activemember360' ), 'all' => _x( 'all', 'wp_admin', 'activemember360' ) ],
					'visible'     => [ 'condition_type', '=', 'mbr_user_role_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select rule', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_user_roles',
					'name'        => _x( 'Roles', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'multiple'    => TRUE,
					'options'     => array_filter( wp_roles()->get_names() ),
					'visible'     => [ 'condition_type', '=', 'mbr_user_role_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select roles', 'wp_admin', 'activemember360' ),
					'select_all_none' => TRUE
				]
			]
		];

		return $arr_conditions;
	}

	















	public function check_condition_user_role_status( $match, $arr_condition )
	{
		IF ( ! empty( $arr_condition['condition_type'] ) AND 'mbr_user_role_status' == $arr_condition['condition_type'] ) :
			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			IF ( ! is_user_logged_in() ) :
				return FALSE;
			ENDIF;

			IF ( 'user_has_roles' == $arr_condition['condition_user_role_status'] ) :
				return $this->check_user_has_roles( $arr_condition );
			ELSEIF ( 'user_has_not_roles' == $arr_condition['condition_user_role_status'] ) :
				return $this->check_user_has_not_roles( $arr_condition );
			ENDIF;
		ENDIF;

		return $match;
	}

	












	private function check_user_has_roles( $arr_condition )
	{
		global $current_user;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_user_roles'] ) OR ! is_array( $arr_condition['condition_user_roles'] ) ) :
			return TRUE;
		ENDIF;

		$rule                 = 'any';
		IF ( isset( $arr_condition['condition_user_role_status_determined_by'] ) ) :
			$rule               = lower_trim( $arr_condition['condition_user_role_status_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule               = 'any';
		ENDIF;

		$arr_user_roles       = [];
		FOREACH ( $arr_condition['condition_user_roles'] AS $key => $role ) :
			IF ( in_array( $role, (array) $current_user->roles ) ) :
				$arr_user_roles[] = $role;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$user_roles           = count( $arr_user_roles );
		IF ( 'all' == $rule ) :
			$required_roles     = count( $arr_condition['condition_user_roles'] );
			IF ( $required_roles == $user_roles ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $user_roles ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

		












	private function check_user_has_not_roles( $arr_condition )
	{
		global $current_user;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_user_roles'] ) OR ! is_array( $arr_condition['condition_user_roles'] ) ) :
			return TRUE;
		ENDIF;

		$rule                     = 'any';
		IF ( isset( $arr_condition['condition_user_role_status_determined_by'] ) ) :
			$rule                   = lower_trim( $arr_condition['condition_user_role_status_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                   = 'any';
		ENDIF;

		$arr_not_user_roles       = [];
		FOREACH ( $arr_condition['condition_user_roles'] AS $key => $role ) :
			IF ( ! in_array( $role, (array) $current_user->roles ) ) :
				$arr_not_user_roles[] = $role;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$not_user_roles           = count( $arr_not_user_roles );
		IF ( 'all' == $rule ) :
			$required_roles         = count( $arr_condition['condition_user_roles'] );
			IF ( $required_roles == $not_user_roles ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $not_user_roles ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	











	public function condition_contact_list_status( $arr_conditions )
	{
		static $site_lists  = NULL;
		IF ( is_null( $site_lists ) ) :
			$site_lists       = apply_filters( 'mbr/site_lists/get', NULL );
			asort( $site_lists );
		ENDIF;

		$arr_conditions[]   = [
			'trigger'         => [ 'mbr_contact_list_status' => _x( 'Contact list status', 'wp_admin', 'activemember360' ) ],
			'fields'          => [
				[
					'id'          => 'condition_contact_status_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose a list status a contact must have in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ 'condition_type', '=', 'mbr_contact_list_status' ]
				],
				[
					'id'          => 'condition_contact_list_status',
					'name'        => _x( 'Contact list status', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => [ 'active' => _x( 'Active', 'wp_admin', 'activemember360' ), 'unconfirmed' => _x( 'Unconfirmed', 'wp_admin', 'activemember360' ), 'unsubscribed' => _x( 'Unsubscribed', 'wp_admin', 'activemember360' ), 'bounced' => _x( 'Bounced', 'wp_admin', 'activemember360' ) ],
					'visible'     => [ 'condition_type', '=', 'mbr_contact_list_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select contact list status', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_contact_list_status_list_id',
					'name'        => _x( 'List', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => $site_lists,
					'visible'     => [ 'condition_type', '=', 'mbr_contact_list_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select list', 'wp_admin', 'activemember360' )
				]
			]
		];

		return $arr_conditions;
	}

	




















	public function check_condition_contact_list_status( $match, $arr_condition )
	{
		IF ( ! empty( $arr_condition['condition_contact_list_status'] ) ) :
			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			$contact_id = apply_filters( 'mbr/contact_id', NULL );
			IF ( empty( $contact_id ) ) :
				return FALSE;
			ENDIF;

			IF ( ! isset( $GLOBALS['mbr']->MBRLISTS[ $arr_condition['condition_contact_list_status_list_id'] ] ) ) :
				return FALSE;
			ENDIF;

			IF ( 'unconfirmed' == $arr_condition['condition_contact_list_status'] ) :
				$list_opt_status = $GLOBALS['mbr']->get_list_optstatus( $contact_id, $arr_condition['condition_contact_list_status_list_id'] );
				IF ( 0 == $list_opt_status ) :
					return TRUE;
				ELSE:
					return FALSE;
				ENDIF;
			ELSEIF ( 'active' == $arr_condition['condition_contact_list_status'] ) :
				IF ( 1 == $GLOBALS['mbr']->MBRLISTS[ $arr_condition['condition_contact_list_status_list_id'] ] ) :
					return TRUE;
				ELSE:
					return FALSE;
				ENDIF;
			ELSEIF ( 'unsubscribed' == $arr_condition['condition_contact_list_status'] ) :
				IF ( 2 == $GLOBALS['mbr']->MBRLISTS[ $arr_condition['condition_contact_list_status_list_id'] ] ) :
					return TRUE;
				ELSE:
					return FALSE;
				ENDIF;
			ELSEIF ( 'bounced' == $arr_condition['condition_contact_list_status'] ) :
				$list_opt_status = $GLOBALS['mbr']->get_list_optstatus( $contact_id, $arr_condition['condition_contact_list_status_list_id'] );
				IF ( 3 == $list_opt_status ) :
					return TRUE;
				ELSE:
					return FALSE;
				ENDIF;
			ENDIF;
		ENDIF;

		return $match;
	}

	











	public function condition_contact_tag_status( $arr_conditions )
	{
		static $site_tags   = NULL;
		IF ( is_null( $site_tags ) ) :
			$site_tags        = apply_filters( 'mbr/site_tags/get', NULL );
		ENDIF;

		$arr_conditions[]   = [
			'trigger'         => [ 'mbr_contact_tag_status' => _x( 'Contact tag status', 'wp_admin', 'activemember360' ) ],
			'fields'          => [
				[
					'id'          => 'condition_contact_tag_status_type',
					'name'        => _x( 'Contact status', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => [ 
						'contact_has_tags'     => _x( 'Contact has tags',           'wp_admin', 'activemember360' ),
						'contact_has_not_tags' => _x( 'Contact does not have tags', 'wp_admin', 'activemember360' )
					],
					'visible'     => [ 'condition_type', '=', 'mbr_contact_tag_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select condition type', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_contact_has_tags_rule_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose tags a contact must have in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_contact_tag_status' ], [ 'condition_contact_tag_status_type', '=', 'contact_has_tags' ] ]
				],
				[
					'id'          => 'condition_contact_has_not_tags_rule_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose tags a contact must not have in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_contact_tag_status' ], [ 'condition_contact_tag_status_type', '=', 'contact_has_not_tags' ] ]
				],
				[
					'id'          => 'condition_contact_tags_determined_by',
					'name'        => _x( 'Determined by', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => [ 'any' => _x( 'any', 'wp_admin', 'activemember360' ), 'all' => _x( 'all', 'wp_admin', 'activemember360' ) ],
					'visible'     => [ 'condition_type', '=', 'mbr_contact_tag_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select rule', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_contact_tags',
					'name'        => _x( 'Tags', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'multiple'    => TRUE,
					'options'     => $site_tags,
					'visible'     => [ 'condition_type', '=', 'mbr_contact_tag_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select tags', 'wp_admin', 'activemember360' )
				]
			]
		];

		return $arr_conditions;
	}

	








	public function check_condition_contact_tag_status( $match, $arr_condition )
	{
		IF ( ! empty( $arr_condition['condition_type'] ) AND 'mbr_contact_tag_status' == $arr_condition['condition_type'] ) :
			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			IF ( 'contact_has_tags' == $arr_condition['condition_contact_tag_status_type'] ) :
				return $this->check_contact_has_tags( $arr_condition );
			ELSEIF ( 'contact_has_not_tags' == $arr_condition['condition_contact_tag_status_type'] ) :
				return $this->check_contact_has_not_tags( $arr_condition );
			ENDIF;
		ENDIF;

		return $match;
	}

	













	private function check_contact_has_tags( $arr_condition )
	{
		$rule   = 'any';
		IF ( isset( $arr_condition['condition_contact_tags_determined_by'] ) ) :
			$rule = lower_trim( $arr_condition['condition_contact_tags_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule = 'any';
		ENDIF;
		IF ( mbr_has_tags( $arr_condition['condition_contact_tags'], $rule ) ) :
			return TRUE;
		ELSE:
			return FALSE;
		ENDIF;
	}

	













	private function check_contact_has_not_tags( $arr_condition )
	{
		$rule   = 'any';
		IF ( isset( $arr_condition['condition_contact_tags_determined_by'] ) ) :
			$rule = lower_trim( $arr_condition['condition_contact_tags_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule = 'any';
		ENDIF;
		IF ( ! mbr_has_tags( $arr_condition['condition_contact_tags'], $rule ) ) :
			return TRUE;
		ELSE:
			return FALSE;
		ENDIF;
	}

	











	public function condition_contact_field_compare( $arr_conditions )
	{
		static $arr_crm_fields    = NULL;
		IF ( is_null( $arr_crm_fields ) ) :
			$arr_tmp_regular_fields = apply_filters( 'mbr/site_contact_std_fields/get', NULL );
			$arr_crm_fields['']     = '---';
			IF ( ! empty( $arr_tmp_regular_fields ) ) :
				FOREACH ( $arr_tmp_regular_fields AS $filler => $field_name ) :
					$arr_crm_fields[ $field_name ] = $field_name;
				ENDFOREACH;
			ENDIF;
			$arr_tmp_custom_fields  = apply_filters( 'mbr/site_custom_fields/get', NULL );
			IF ( ! empty( $arr_tmp_custom_fields ) ) :
				FOREACH ( $arr_tmp_custom_fields AS $field_name => $arr_field ) :
					$arr_crm_fields[ strtolower( $arr_field['perstag'] ) ] = $arr_field['title'];
				ENDFOREACH;
			ENDIF;
			asort( $arr_crm_fields );
		ENDIF;

		$arr_conditions[]          = [
			'trigger'                => [ 'mbr_contact_field_compare' => _x( 'Contact field comparison', 'wp_admin', 'activemember360' ) ],
			'fields'                 => [
				[
					'id'                 => 'condition_contact_field_compare_description',
					'type'               => 'custom_html',
					'std'                => _x( 'Compare a contact field against a specific value. This must evaluate to TRUE in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'            => [ 'condition_type', '=', 'mbr_contact_field_compare' ]
				],
				[
					'id'                 => 'condition_contact_field_compare_field',
					'name'               => _x( 'Contact field', 'wp_admin', 'activemember360' ),
					'type'               => 'select_advanced',
					'options'            => $arr_crm_fields,
					'placeholder'        => _x( 'Select a field', 'wp_admin', 'activemember360' ),
					'js_options'         => [ 'width' => '100%' ],
					'visible'            => [ 'condition_type', '=', 'mbr_contact_field_compare' ],
					'placeholder'        => _x( 'Select contact field', 'wp_admin', 'activemember360' )
				],
				[
					'id'                 => 'condition_contact_field_compare_operator',
					'name'               => _x( 'Compare operator', 'wp_admin', 'activemember360' ),
					'type'               => 'select_advanced',
					'options'            => [
						'equals'           => _x( 'Equals',           'wp_admin', 'activemember360' ),
						'not_equal'        => _x( 'Not equal',        'wp_admin', 'activemember360' ),
						'greater_than'     => _x( 'Greater than',     'wp_admin', 'activemember360' ),
						'less_than'        => _x( 'Less than',        'wp_admin', 'activemember360' ),
						'greater_or_equal' => _x( 'Greater or equal', 'wp_admin', 'activemember360' ),
						'less_or_equal'    => _x( 'Less or equal',    'wp_admin', 'activemember360' ),
						'begins_with'      => _x( 'Begins with',      'wp_admin', 'activemember360' ),
						'ends_with'        => _x( 'Ends with',        'wp_admin', 'activemember360' ),
						'contains'         => _x( 'Contains',         'wp_admin', 'activemember360' ),
						'not_contains'     => _x( 'Not contains',     'wp_admin', 'activemember360' ),
						'is_empty'         => _x( 'Is empty',         'wp_admin', 'activemember360' ),
						'not_empty'        => _x( 'Not empty',        'wp_admin', 'activemember360' ),
					],
					'js_options'         => [ 'width' => '100%' ],
					'visible'            => [ 'condition_type', '=', 'mbr_contact_field_compare' ],
					'placeholder'        => _x( 'Select compare operator', 'wp_admin', 'activemember360' )
				],
				[
					'id'                 => 'condition_contact_field_compare_mode',
					'name'               => _x( 'Compare mode', 'wp_admin', 'activemember360' ),
					'type'               => 'select_advanced',
					'options'            => [ 'custom_value' => _x( 'Custom value', 'wp_admin', 'activemember360' ), 'contact_field' => _x( 'Contact field', 'wp_admin', 'activemember360' ) ],
					'visible'            => [ [ 'condition_type', '=', 'mbr_contact_field_compare' ] , [ 'condition_contact_field_compare_operator', 'not contains', 'empty' ] ],
					'js_options'         => [ 'width' => '100%' ],
					'placeholder'        => _x( 'Select compare mode', 'wp_admin', 'activemember360' )
				],
				[
					'id'                 => 'condition_contact_field_compare_value',
					'name'               => _x( 'Compare value', 'wp_admin', 'activemember360' ),
					'type'               => 'text',
					'visible'            => [ [ 'condition_type', '=', 'mbr_contact_field_compare' ], [ 'condition_contact_field_compare_operator', 'not contains', 'empty' ], [ 'condition_contact_field_compare_mode', '=', 'custom_value' ] ]
				],
				[
					'id'                 => 'condition_contact_field_compare_against_field',
					'name'               => _x( 'Contact field to compare against', 'wp_admin', 'activemember360' ),
					'type'               => 'select_advanced',
					'options'            => $arr_crm_fields,
					'placeholder'        => _x( 'Select a field', 'wp_admin', 'activemember360' ),
					'js_options'         => [ 'width' => '100%' ],
					'visible'            => [ [ 'condition_type', '=', 'mbr_contact_field_compare' ], [ 'condition_contact_field_compare_operator', 'not contains', 'empty' ], [ 'condition_contact_field_compare_mode', '=',  'contact_field' ] ],
					'placeholder'        => _x( 'Select contact field', 'wp_admin', 'activemember360' )
				]
			]
		];

		return $arr_conditions;
	}

	















	public function check_condition_contact_field_compare( $match, $arr_condition ) 
	{
		IF ( ! empty( $arr_condition['condition_contact_field_compare_operator'] ) AND ! empty( $arr_condition['condition_contact_field_compare_field'] ) ) :
			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			$remote_logged_in = apply_filters( 'mbr/contact_id', NULL );
			IF ( empty( $remote_logged_in ) ) :
				return FALSE;
			ENDIF;

			$operator         = $arr_condition['condition_contact_field_compare_operator'];
			$field            = $arr_condition['condition_contact_field_compare_field'];
			$compare_mode     = $arr_condition['condition_contact_field_compare_mode'];
			IF ( 'contact_field' == $compare_mode ) :
				$compare_value  = apply_filters( 'mbr/get_contact_field', $arr_condition['condition_contact_field_compare_against_field'] );
			ELSE:
				$compare_value  = $arr_condition['condition_contact_field_compare_value'];
			ENDIF;

			$field_value   = apply_filters( 'mbr/get_contact_field', $field );
			IF ( 'equals' == $operator ) :
				$match       = ( $field_value == $compare_value ? TRUE : FALSE );
			ELSEIF ( 'not_equal' == $operator ) :
				$match       = ( $field_value <> $compare_value ? TRUE : FALSE );
			ELSEIF ( 'less_than' == $operator ) :
				$match       = ( $field_value <  $compare_value ? TRUE : FALSE );
			ELSEIF ( 'greater_than' == $operator ) :
				$match       = ( $field_value >  $compare_value ? TRUE : FALSE );
			ELSEIF ( 'greater_or_equal' == $operator ) :
				$match       = ( $field_value >= $compare_value ? TRUE : FALSE );
			ELSEIF ( 'less_or_equal' == $operator ) :
				$match       = ( $field_value <= $compare_value ? TRUE : FALSE );
			ELSEIF ( 'begins_with' == $operator ) :
				$match       = ( substr( $field_value,0, strlen( $compare_value ) ) == $compare_value ? TRUE : FALSE );
			ELSEIF ( 'ends_with' == $operator ) :
				$match       = ( substr( $field_value,strlen( $compare_value ) * -1 ) == $compare_value ? TRUE : FALSE);
			ELSEIF ( 'contains' == $operator ) :
				$match       = ( FALSE !== stripos( $field_value, $compare_value ) ? TRUE : FALSE );
			ELSEIF ( 'not_contains' == $operator ) :
				$match       = ( FALSE !== stripos( $field_value, $compare_value ) ? FALSE : TRUE );
			ELSEIF ( 'is_empty' == $operator ) :
				$match       = empty( $field_value) ? TRUE : FALSE;
			ELSEIF ( 'not_empty' == $operator ) :
				$match       = ! empty( $field_value) ? TRUE : FALSE;
			ELSE :
				$match       = FALSE;
			ENDIF;

			return $match;
		ENDIF;

		return $match;
	}

	











	public function condition_php_statement( $arr_conditions )
	{
		$arr_conditions[]   = [
			'trigger'         => [ 'mbr_php_statement' => _x( 'PHP statement', 'wp_admin', 'activemember360' ) ],
			'fields'          => [
				[
					'id'          => 'condition_php_statement_description',
					'type'        => 'custom_html',
					'std'         => _x( 'PHP statement must return TRUE in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ 'condition_type', '=', 'mbr_php_statement' ]
				],
				[
					'id'          => 'condition_php_statement',
					'name'        => _x( 'PHP statement', 'wp_admin', 'activemember360' ),
					'type'        => 'textarea',
					'visible'     => [ 'condition_type', '=', 'mbr_php_statement' ]
				]
			]
		];

		return $arr_conditions;
	}

	















	public function check_condition_php_statement( $match, $arr_condition )
	{
		IF ( ! empty( $arr_condition['condition_php_statement'] ) ) :
			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			$php_statement = trim( $arr_condition['condition_php_statement'] );
			$php_statement = ( stristr( $php_statement,  'return' ) ) ? $php_statement : 'return (' . $php_statement . ');';
			$php_statement = stripcslashes( $php_statement );
			IF ( eval( $php_statement ) ) :
				return TRUE;
			ENDIF;
			return FALSE;
		ENDIF;

		return $match;
	}

	











	public function condition_predefined_conditional( $arr_conditions )
	{
		$arr_conditions[]   = [
			'trigger'         => [ 'mbr_predefined_conditional' => _x( 'Predefined conditional', 'wp_admin', 'activemember360' ) ],
			'fields'          => [
				[
					'id'          => 'condition_predefined_conditional_evaluation_mode',
					'name'        => _x( 'Condition is TRUE if predefined conditional is', 'wp_admin', 'activememebr360' ),
					'type'        => 'select_advanced',
					'options'     => [ 'true' => _x( 'True', 'wp_admin', 'activemember360' ), 'false' => _x( 'False', 'wp_admin', 'activemember360' ) ],
					'placeholder' => _x( 'Select evaluation mode', 'wp_admin', 'activemember360' ),
					'std'         => 'true',
					'visible'     => [ 'condition_type', '=', 'mbr_predefined_conditional' ],
					'js_options'  => [ 'width' => '100%' ]
				],
				[
					'id'          => 'condition_predefined_conditional_evaluation_mode_true_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Predefined conditional must return TRUE in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_predefined_conditional' ], [ 'condition_predefined_conditional_evaluation_mode', '=', 'true' ] ]
				],
				[
					'id'          => 'condition_predefined_conditional_evaluation_mode_false_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Predefined conditional must return FALSE in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_predefined_conditional' ], [ 'condition_predefined_conditional_evaluation_mode', '=', 'false' ] ]
				],
				[
					'id'          => 'condition_predefined_conditional_id',
					'name'        => _x( 'Predefined conditional', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'multiple'    => FALSE,
					'options'     => apply_filters( 'mbr/conditionals/conditionals/get', [] ),
					'js_options'  => [ 'width' => '100%' ],
					'visible'     => [ 'condition_type', '=', 'mbr_predefined_conditional' ],
					'placeholder' => _x( 'Select predefined conditional', 'wp_admin', 'activemember360' )
				]
			]
		];

		return $arr_conditions;
	}

	















	public function check_condition_predefined_conditional( $match, $arr_condition )
	{
		IF ( ! empty( $arr_condition['condition_predefined_conditional_id'] ) ) :
			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			IF ( empty( $arr_condition['condition_predefined_conditional_evaluation_mode'] ) ) :
				$eval_mode = 'true';
			ELSE:
				$eval_mode = $arr_condition['condition_predefined_conditional_evaluation_mode'];
			ENDIF;

			$match = apply_filters( 'mbr/conditionals/conditional/check', NULL, $arr_condition['condition_predefined_conditional_id'] );

			IF ( 'true' == $eval_mode AND FALSE === $match ) :
				return FALSE;
			ELSEIF ( 'false' == $eval_mode AND FALSE !== $match ) :
				return FALSE;
			ENDIF;

			return TRUE;
		ENDIF;

		return $match;
	}

	











	public function condition_woocommerce_user_status( $arr_conditions )
	{
		IF ( ! class_exists( 'WooCommerce' ) ) :
			return $arr_conditions;
		ENDIF;

		$arr_woocommerce_user_status_types = [];
		$arr_woocommerce_user_status_types['user_has_purchased_products']                      = _x( 'User has purchased products',                           'wp_admin', 'activemember360' );
		$arr_woocommerce_user_status_types['user_has_not_purchased_products']                  = _x( 'User has not purchased products',                       'wp_admin', 'activemember360' );
		IF ( class_exists( 'WC_Subscription' ) ) :
			$arr_woocommerce_user_status_types['user_subscriptions_status_pending']              = _x( 'User has subscriptions that are pending',               'wp_admin', 'activemember360' );
			$arr_woocommerce_user_status_types['user_subscriptions_status_active']               = _x( 'User has subscriptions that are active',                'wp_admin', 'activemember360' );
			$arr_woocommerce_user_status_types['user_subscriptions_status_on_hold']              = _x( 'User has subscriptions that are on hold',               'wp_admin', 'activemember360' );
			$arr_woocommerce_user_status_types['user_subscriptions_status_pending_cancellation'] = _x( 'User has subscriptions that are pending cancellations', 'wp_admin', 'activemember360' );
			$arr_woocommerce_user_status_types['user_subscriptions_status_cancelled']            = _x( 'User has subscriptions that are cancelled',             'wp_admin', 'activemember360' );
			$arr_woocommerce_user_status_types['user_subscriptions_status_expired']              = _x( 'User has subscriptions that are expired',               'wp_admin', 'activemember360' );
		ENDIF;

		$arr_wc_product_types            = wc_get_product_types();
		$arr_not_allowed_subscriptions   = [];
		IF ( ! empty( $arr_wc_product_types ) ) :
			unset( $arr_wc_product_types['subscription'] );
			$arr_not_allowed_subscriptions = array_keys( $arr_wc_product_types );
		ENDIF;

		$arr_conditions[]   = [
			'trigger'         => [ 'mbr_woocommerce_user_status' => _x( 'WooCommerce user status', 'wp_admin', 'activemember360' ) ],
			'fields'          => [
				[
					'id'          => 'condition_woocommerce_user_status_type',
					'name'        => _x( 'User status', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => $arr_woocommerce_user_status_types,
					'visible'     => [ 'condition_type', '=', 'mbr_woocommerce_user_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select user status', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_woocommmerce_user_has_purchased_products_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose products a user must have purchased in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_woocommerce_user_status' ], [ 'condition_woocommerce_user_status_type', '=', 'user_has_purchased_products' ] ]
				],
				[
					'id'          => 'condition_woocommerce_user_has_not_purchased_products_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose products a user must not have purchased in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_woocommerce_user_status' ], [ 'condition_woocommerce_user_status_type', '=', 'user_has_not_purchased_products' ] ]
				],
				[
					'id'          => 'condition_woocommerce_determined_by',
					'name'        => _x( 'Determined by', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => [ 'any' => _x( 'any', 'wp_admin', 'activemember360' ), 'all' => _x( 'all', 'wp_admin', 'activemember360' ) ],
					'visible'     => [ 'condition_type', '=', 'mbr_woocommerce_user_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select rule', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_woocommerce_products',
					'name'        => _x( 'Products', 'wp_admin', 'activemember360' ),
					'type'        => 'post',
					'post_type'   => [ 'product', 'product_variation' ],
					'field_type'  => 'select_advanced',
					'query_args'  => [
						'post_status'    => 'publish',
						'posts_per_page' => - 1,
						'orderby'        => 'title',
						'order'          => 'asc',
						'tax_query'      => [
							[
								'taxonomy'   => 'product_type',
								'field'      => 'slug',
								'terms'      => [ 'external', 'grouped', 'variable', 'variable-subscription' ],
								'operator'   => 'NOT IN'
							]
						]
						
					],
					'multiple'    => TRUE,
					'visible'     => [ [ 'condition_type', '=', 'mbr_woocommerce_user_status' ], [ 'condition_woocommerce_user_status_type', 'contains', 'products' ] ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select products', 'wp_admin', 'activemember360' ),
					'select_all_none' => TRUE
				],
				[
					'id'          => 'condition_woocommerce_subscriptions',
					'name'        => _x( 'Subscriptions', 'wp_admin', 'activemember360' ),
					'type'        => 'post',
					'post_type'   => [ 'product', 'product_variation' ],
					'field_type'  => 'select_advanced',
					'query_args'  => [
						'post_status'    => 'publish',
						'posts_per_page' => - 1,
						'orderby'        => 'title',
						'order'          => 'asc',
						'meta_query'     => [
							[
								'key'        => '_subscription_price',
								'compare'    => 'EXISTS'
							]
						],
						'tax_query'      => [
							[
								'taxonomy'   => 'product_type',
								'field'      => 'slug',
								'terms'      => $arr_not_allowed_subscriptions,
								'operator'   => 'NOT IN'
							]
						]
					],
					'multiple'    => TRUE,
					'visible'     => [ [ 'condition_type', '=', 'mbr_woocommerce_user_status' ], [ 'condition_woocommerce_user_status_type', 'contains', 'subscriptions' ] ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select subs.', 'wp_admin', 'activemember360' ),
					'select_all_none' => TRUE
				]
			]
		];

		return $arr_conditions;
	}

	















	public function check_condition_woocommerce_user_status( $match, $arr_condition )
	{
		IF ( ! empty( $arr_condition['condition_type'] ) AND 'mbr_woocommerce_user_status' == $arr_condition['condition_type'] ) :
			IF ( ! class_exists( 'WooCommerce' ) ) :
				return TRUE;
			ENDIF;

			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			IF ( ! is_user_logged_in() ) :
				return FALSE;
			ENDIF;

			IF ( 'user_has_purchased_products' == $arr_condition['condition_woocommerce_user_status_type'] ) :
				return $this->check_woocommerce_user_has_purchased_products( $arr_condition );
			ELSEIF ( 'user_has_not_purchased_products' == $arr_condition['condition_woocommerce_user_status_type'] ) :
				return $this->check_woocommerce_user_has_not_purchased_products( $arr_condition );
			ELSEIF ( 'user_subscriptions_status_pending' == $arr_condition['condition_woocommerce_user_status_type'] ) :
				return $this->check_woocommerce_user_subscriptions_status( $arr_condition, 'pending' );
			ELSEIF ( 'user_subscriptions_status_active' == $arr_condition['condition_woocommerce_user_status_type'] ) :
				return $this->check_woocommerce_user_subscriptions_status( $arr_condition, 'active' );
			ELSEIF ( 'user_subscriptions_status_on_hold' == $arr_condition['condition_woocommerce_user_status_type'] ) :
				return $this->check_woocommerce_user_subscriptions_status( $arr_condition, 'on-hold' );
			ELSEIF ( 'user_subscriptions_status_pending_cancellation' == $arr_condition['condition_woocommerce_user_status_type'] ) :
				return $this->check_woocommerce_user_subscriptions_status( $arr_condition, 'pending-cancel' );
			ELSEIF ( 'user_subscriptions_status_cancelled' == $arr_condition['condition_woocommerce_user_status_type'] ) :
				return $this->check_woocommerce_user_subscriptions_status( $arr_condition, 'cancelled' );
			ELSEIF ( 'user_subscriptions_status_expired' == $arr_condition['condition_woocommerce_user_status_type'] ) :
				return $this->check_woocommerce_user_subscriptions_status( $arr_condition, 'expired' );
			ENDIF;
		ENDIF;

		return $match;
	}

	












	private function check_woocommerce_user_has_purchased_products( $arr_condition )
	{
		global $current_user;

		IF ( ! class_exists( 'WooCommerce' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_woocommerce_products'] ) OR ! is_array( $arr_condition['condition_woocommerce_products'] ) ) :
			return TRUE;
		ENDIF;

		$rule                         = 'any';
		IF ( isset( $arr_condition['condition_woocommerce_determined_by'] ) ) :
			$rule                       = lower_trim( $arr_condition['condition_woocommerce_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                       = 'any';
		ENDIF;

		$arr_purchased_products       = [];
		FOREACH ( $arr_condition['condition_woocommerce_products'] AS $key => $product_id ) :
			IF ( wc_customer_bought_product( $current_user->user_email, $current_user->ID, $product_id ) ) :
				$arr_purchased_products[] = $product_id;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$purchased_products           = count( $arr_purchased_products );
		IF ( 'all' == $rule ) :
			$required_products          = count( $arr_condition['condition_woocommerce_products'] );
			IF ( $required_products == $purchased_products ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $purchased_products ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	












	private function check_woocommerce_user_has_not_purchased_products( $arr_condition )
	{
		global $current_user;

		IF ( ! class_exists( 'WooCommerce' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_woocommerce_products'] ) OR ! is_array( $arr_condition['condition_woocommerce_products'] ) ) :
			return TRUE;
		ENDIF;

		$rule                              = 'any';
		IF ( isset( $arr_condition['condition_woocommerce_determined_by'] ) ) :
			$rule                            = lower_trim( $arr_condition['condition_woocommerce_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                            = 'any';
		ENDIF;

		$arr_not_purchased_products        = [];
		FOREACH ( $arr_condition['condition_woocommerce_products'] AS $key => $product_id ) :
			IF ( ! wc_customer_bought_product( $current_user->user_email, $current_user->ID, $product_id ) ) :
				$arr_not_purchased_products[]  = $product_id;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$not_purchased_products            = count( $arr_not_purchased_products );
		IF ( 'all' == $rule ) :
			$required_not_purchased_products = count( $arr_condition['condition_woocommerce_products'] );
			IF ( $required_not_purchased_products == $not_purchased_products ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $not_purchased_products ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	














	private function check_woocommerce_user_subscriptions_status( $arr_condition, $required_subscription_status )
	{
		global $current_user;

		IF ( ! class_exists( 'WooCommerce' ) OR ! class_exists( 'WC_Subscription' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_woocommerce_subscriptions'] ) OR ! is_array( $arr_condition['condition_woocommerce_subscriptions'] ) ) :
			return TRUE;
		ENDIF;

		IF ( empty( $required_subscription_status ) OR ! in_array( $required_subscription_status, [ 'pending', 'active', 'on-hold', 'pending-cancel', 'cancelled', 'expired' ] ) ) :
			return FALSE;
		ENDIF;

		$rule                            = 'any';
		IF ( isset( $arr_condition['condition_woocommerce_determined_by'] ) ) :
			$rule                          = lower_trim( $arr_condition['condition_woocommerce_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                          = 'any';
		ENDIF;

		$arr_matched_subscriptions       = [];

		FOREACH ( $arr_condition['condition_woocommerce_subscriptions'] AS $key => $subscription_id ) :
			IF ( $required_subscription_status == wcs_user_has_subscription( $current_user->ID, (int) $subscription_id, $required_subscription_status ) ) :
				$arr_matched_subscriptions[] = $subscription_id;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$matched_subscriptions = count( $arr_matched_subscriptions );
		IF ( 'all' == $rule ) :
			$required_subscriptions        = count( $arr_condition['condition_woocommerce_subscriptions'] );
			IF ( $required_subscriptions == $matched_subscriptions ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $matched_subscriptions ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	











	public function condition_learndash_user_status( $arr_conditions )
	{
		IF ( ! defined( 'LEARNDASH_VERSION' ) ) :
			return $arr_conditions;
		ENDIF;

		$arr_conditions[]   = [
			'trigger'         => [ 'mbr_learndash_user_status' => _x( 'LearnDash user status', 'wp_admin', 'activemember360' ) ],
			'fields'          => [
				[
					'id'          => 'condition_learndash_user_status_type',
					'name'        => _x( 'User status', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => [ 
						'user_enrolled_in_courses'     => _x( 'User is enrolled in courses',     'wp_admin', 'activemember360' ),
						'user_not_enrolled_in_courses' => _x( 'User is not enrolled in courses', 'wp_admin', 'activemember360' ),
						'user_completed_courses'       => _x( 'User has completed courses',      'wp_admin', 'activemember360' ),
						'user_in_progress_courses'     => _x( 'User has in progress courses',    'wp_admin', 'activemember360' ),
						'user_not_started_courses'     => _x( 'User has not started courses',    'wp_admin', 'activemember360' ),
						'user_completed_lessons'       => _x( 'User has completed lessons',      'wp_admin', 'activemember360' ),
						'user_not_completed_lessons'   => _x( 'User has not completed lessons',  'wp_admin', 'activemember360' ),
						'user_completed_topics'        => _x( 'User has completed topics',       'wp_admin', 'activemember360' ),
						'user_not_completed_topics'    => _x( 'User has not completed topics',   'wp_admin', 'activemember360' )
					],
					'visible'     => [ 'condition_type', '=', 'mbr_learndash_user_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select user status', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_learndash_user_enrolled_courses_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose courses a user must be enrolled to in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_learndash_user_status' ], [ 'condition_learndash_user_status_type', '=', 'user_enrolled_in_courses' ] ]
				],
				[
					'id'          => 'condition_learndash_user_not_enrolled_courses_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose courses a user must not be enrolled to in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_learndash_user_status' ], [ 'condition_learndash_user_status_type', '=', 'user_not_enrolled_in_courses' ] ]
				],
				[
					'id'          => 'condition_learndash_determined_by',
					'name'        => _x( 'Determined by', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => [ 'any' => _x( 'any', 'wp_admin', 'activemember360' ), 'all' => _x( 'all', 'wp_admin', 'activemember360' ) ],
					'visible'     => [ 'condition_type', '=', 'mbr_learndash_user_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select rule', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_learndash_courses',
					'name'        => _x( 'Courses', 'wp_admin', 'activemember360' ),
					'type'        => 'post',
					'post_type'   => 'sfwd-courses',
					'field_type'  => 'select_advanced',
					'query_args'  => [
						'post_status'    => 'publish',
						'posts_per_page' => - 1,
						'orderby'        => 'title',
						'order'          => 'asc'
					],
					'multiple'    => TRUE,
					'visible'     => [ [ 'condition_type', '=', 'mbr_learndash_user_status' ], [ 'condition_learndash_user_status_type', 'contains', 'courses' ] ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select courses', 'wp_admin', 'activemember360' ),
					'select_all_none' => TRUE
				],
				[
					'id'          => 'condition_learndash_lessons',
					'name'        => _x( 'Lessons', 'wp_admin', 'activemember360' ),
					'type'        => 'post',
					'post_type'   => 'sfwd-lessons',
					'field_type'  => 'select_advanced',
					'query_args'  => [
						'post_status'    => 'publish',
						'posts_per_page' => - 1,
						'orderby'        => 'title',
						'order'          => 'asc'
					],
					'multiple'    => TRUE,
					'visible'     => [ [ 'condition_type', '=', 'mbr_learndash_user_status' ], [ 'condition_learndash_user_status_type', 'contains', 'lessons' ] ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select lessons', 'wp_admin', 'activemember360' ),
					'select_all_none' => TRUE
				],
				[
					'id'          => 'condition_learndash_topics',
					'name'        => _x( 'Topics', 'wp_admin', 'activemember360' ),
					'type'        => 'post',
					'post_type'   => 'sfwd-topic',
					'field_type'  => 'select_advanced',
					'query_args'  => [
						'post_status'    => 'publish',
						'posts_per_page' => - 1,
						'orderby'        => 'title',
						'order'          => 'asc'
					],
					'multiple'    => TRUE,
					'visible'     => [ [ 'condition_type', '=', 'mbr_learndash_user_status' ], [ 'condition_learndash_user_status_type', 'contains', 'topics' ] ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select topics', 'wp_admin', 'activemember360' ),
					'select_all_none' => TRUE
				]
			]
		];

		return $arr_conditions;
	}

	















	public function check_condition_learndash_user_status( $match, $arr_condition )
	{
		IF ( ! empty( $arr_condition['condition_type'] ) AND 'mbr_learndash_user_status' == $arr_condition['condition_type'] ) :
			IF ( ! defined( 'LEARNDASH_VERSION' ) ) :
				return TRUE;
			ENDIF;

			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			IF ( ! is_user_logged_in() ) :
				return FALSE;
			ENDIF;

			IF ( 'user_enrolled_in_courses' == $arr_condition['condition_learndash_user_status_type'] ) :
				return $this->check_learndash_user_enrolled_in_courses( $arr_condition );
			ELSEIF ( 'user_not_enrolled_in_courses' == $arr_condition['condition_learndash_user_status_type'] ) :
				return $this->check_learndash_user_not_enrolled_in_courses( $arr_condition );
			ELSEIF ( 'user_completed_courses' == $arr_condition['condition_learndash_user_status_type'] ) :
				return $this->check_learndash_user_status_courses( $arr_condition, 'completed' );
			ELSEIF ( 'user_not_started_courses' == $arr_condition['condition_learndash_user_status_type'] ) :
				return $this->check_learndash_user_status_courses( $arr_condition, 'not-started' );
			ELSEIF ( 'user_in_progress_courses' == $arr_condition['condition_learndash_user_status_type'] ) :
				return $this->check_learndash_user_status_courses( $arr_condition, 'in-progress' );
			ELSEIF ( 'user_completed_lessons' == $arr_condition['condition_learndash_user_status_type'] ) :
				return $this->check_learndash_user_completed_lessons( $arr_condition );
			ELSEIF ( 'user_not_completed_lessons' == $arr_condition['condition_learndash_user_status_type'] ) :
				return $this->check_learndash_user_not_completed_lessons( $arr_condition );
			ELSEIF ( 'user_completed_topics' == $arr_condition['condition_learndash_user_status_type'] ) :
				return $this->check_learndash_user_completed_topics( $arr_condition );
			ELSEIF ( 'user_not_completed_topics' == $arr_condition['condition_learndash_user_status_type'] ) :
				return $this->check_learndash_user_not_completed_topics( $arr_condition );
			ENDIF;
		ENDIF;

		return $match;
	}

	












	private function check_learndash_user_enrolled_in_courses( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'LEARNDASH_VERSION' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_learndash_courses'] ) OR ! is_array( $arr_condition['condition_learndash_courses'] ) ) :
			return TRUE;
		ENDIF;

		$arr_user_enrolled_courses             = learndash_user_get_enrolled_courses( $current_user->ID );

		$rule                                  = 'any';
		IF ( isset( $arr_condition['condition_learndash_determined_by'] ) ) :
			$rule                                = lower_trim( $arr_condition['condition_learndash_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                                = 'any';
		ENDIF;

		$arr_user_match_enrolled_courses       = [];
		FOREACH ( $arr_condition['condition_learndash_courses'] AS $key => $course_id ) :
			$course_id                           = (int) $course_id;
			IF ( in_array( $course_id, $arr_user_enrolled_courses ) ) :
				$arr_user_match_enrolled_courses[] = $course_id;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$enrolled_courses                      = count( $arr_user_match_enrolled_courses );
		IF ( 'all' == $rule ) :
			$required_courses                    = count( $arr_condition['condition_learndash_courses'] );
			IF ( $required_courses == $enrolled_courses ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $enrolled_courses ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	












	private function check_learndash_user_not_enrolled_in_courses( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'LEARNDASH_VERSION' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_learndash_courses'] ) OR ! is_array( $arr_condition['condition_learndash_courses'] ) ) :
			return TRUE;
		ENDIF;

		$arr_user_enrolled_courses           = learndash_user_get_enrolled_courses( $current_user->ID );

		$rule                                = 'any';
		IF ( isset( $arr_condition['condition_learndash_determined_by'] ) ) :
			$rule                              = lower_trim( $arr_condition['condition_learndash_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                              = 'any';
		ENDIF;

		$arr_user_not_enrolled_courses       = [];
		FOREACH ( $arr_condition['condition_learndash_courses'] AS $key => $course_id ) :
			$course_id                         = (int) $course_id;
			IF ( ! in_array( $course_id, $arr_user_enrolled_courses ) ) :
				$arr_user_not_enrolled_courses[] = $course_id;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$not_enrolled_courses                = count( $arr_user_not_enrolled_courses );
		IF ( 'all' == $rule ) :
			$required_courses                  = count( $arr_condition['condition_learndash_courses'] );
			IF ( $required_courses == $not_enrolled_courses ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $not_enrolled_courses ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	













	private function check_learndash_user_status_courses( $arr_condition, $required_course_status )
	{
		global $current_user;

		IF ( ! defined( 'LEARNDASH_VERSION' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_learndash_courses'] ) OR ! is_array( $arr_condition['condition_learndash_courses'] ) ) :
			return TRUE;
		ENDIF;

		IF ( empty( $required_course_status ) OR ! in_array( $required_course_status, [ 'completed', 'not-started', 'in-progress' ] ) ) :
			return FALSE;
		ENDIF;

		$rule                        = 'any';
		IF ( isset( $arr_condition['condition_learndash_determined_by'] ) ) :
			$rule                      = lower_trim( $arr_condition['condition_learndash_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                      = 'any';
		ENDIF;

		$arr_matched_courses         = [];

		FOREACH ( $arr_condition['condition_learndash_courses'] AS $key => $course_id ) :
			IF ( sfwd_lms_has_access( $course_id, $current_user->ID ) ) :
				IF ( $required_course_status == learndash_course_status( $course_id, $current_user->ID, TRUE ) ) :
					$arr_matched_courses[] = $course_id;
					IF ( 'any' == $rule ) :
						break;
					ENDIF;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$matched_courses = count( $arr_matched_courses );
		IF ( 'all' == $rule ) :
			$required_courses          = count( $arr_condition['condition_learndash_courses'] );
			IF ( $required_courses == $matched_courses ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $matched_courses ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	












	private function check_learndash_user_completed_lessons( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'LEARNDASH_VERSION' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_learndash_lessons'] ) OR ! is_array( $arr_condition['condition_learndash_lessons'] ) ) :
			return TRUE;
		ENDIF;

		$rule                             = 'any';
		IF ( isset( $arr_condition['condition_learndash_determined_by'] ) ) :
			$rule                           = lower_trim( $arr_condition['condition_learndash_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                           = 'any';
		ENDIF;

		$arr_user_completed_lessons       = [];

		FOREACH ( $arr_condition['condition_learndash_lessons'] AS $key => $lesson_id ) :
			$lesson_id                      = (int) $lesson_id;
			IF ( learndash_is_lesson_complete( $current_user->ID, $lesson_id ) ) :
				$arr_user_completed_lessons[] = $lesson_id;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$completed_lessons                = count( $arr_user_completed_lessons );
		IF ( 'all' == $rule ) :
			$required_lessons               = count( $arr_condition['condition_learndash_lessons'] );
			IF ( $required_lessons == $completed_lessons ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $completed_lessons ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	












	private function check_learndash_user_not_completed_lessons( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'LEARNDASH_VERSION' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_learndash_lessons'] ) OR ! is_array( $arr_condition['condition_learndash_lessons'] ) ) :
			return TRUE;
		ENDIF;

		$rule                                 = 'any';
		IF ( isset( $arr_condition['condition_learndash_determined_by'] ) ) :
			$rule                               = lower_trim( $arr_condition['condition_learndash_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                               = 'any';
		ENDIF;

		$arr_user_not_completed_lessons       = [];

		FOREACH ( $arr_condition['condition_learndash_lessons'] AS $key => $lesson_id ) :
			$lesson_id                         = (int) $lesson_id;
			IF ( ! learndash_is_lesson_complete( $current_user->ID, $lesson_id ) ) :
				$arr_user_not_completed_lessons[] = $lesson_id;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$not_completed_lessons                = count( $arr_user_not_completed_lessons );
		IF ( 'all' == $rule ) :
			$required_lessons                   = count( $arr_condition['condition_learndash_lessons'] );
			IF ( $required_lessons == $not_completed_lessons ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $not_completed_lessons ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	












	private function check_learndash_user_completed_topics( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'LEARNDASH_VERSION' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_learndash_topics'] ) OR ! is_array( $arr_condition['condition_learndash_topics'] ) ) :
			return TRUE;
		ENDIF;

		$rule                             = 'any';
		IF ( isset( $arr_condition['condition_learndash_determined_by'] ) ) :
			$rule                           = lower_trim( $arr_condition['condition_learndash_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                           = 'any';
		ENDIF;

		$arr_user_completed_topics       = [];

		FOREACH ( $arr_condition['condition_learndash_topics'] AS $key => $topic_id ) :
			$topic_id                      = (int) $topic_id;
			IF ( learndash_is_topic_complete( $current_user->ID, $topic_id ) ) :
				$arr_user_completed_topics[] = $topic_id;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$completed_topics                = count( $arr_user_completed_topics );
		IF ( 'all' == $rule ) :
			$required_topics               = count( $arr_condition['condition_learndash_topics'] );
			IF ( $required_topics == $completed_topics ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $completed_topics ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

		












	private function check_learndash_user_not_completed_topics( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'LEARNDASH_VERSION' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_learndash_topics'] ) OR ! is_array( $arr_condition['condition_learndash_topics'] ) ) :
			return TRUE;
		ENDIF;

		$rule                                 = 'any';
		IF ( isset( $arr_condition['condition_learndash_determined_by'] ) ) :
			$rule                               = lower_trim( $arr_condition['condition_learndash_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                               = 'any';
		ENDIF;

		$arr_user_not_completed_topics       = [];

		FOREACH ( $arr_condition['condition_learndash_topics'] AS $key => $topic_id ) :
			$topic_id                         = (int) $topic_id;
			IF ( ! learndash_is_topic_complete( $current_user->ID, $topic_id ) ) :
				$arr_user_not_completed_topics[] = $topic_id;
				IF ( 'any' == $rule ) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$not_completed_topics                = count( $arr_user_not_completed_topics );
		IF ( 'all' == $rule ) :
			$required_topics                   = count( $arr_condition['condition_learndash_topics'] );
			IF ( $required_topics == $not_completed_topics ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $not_completed_topics ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	











	public function condition_gamipress_user_status( $arr_conditions )
	{
		IF ( ! defined( 'GAMIPRESS_VER' ) ) :
			return $arr_conditions;
		ENDIF;

		$arr_gamipress_user_status_types = [];
		$arr_gamipress_user_status_types['user_has_achievements']       = _x( 'User has achievements',            'wp_admin', 'activemember360' );
		$arr_gamipress_user_status_types['user_has_not_achievements']   = _x( 'User does not have achievements',  'wp_admin', 'activemember360' );
		$arr_gamipress_user_status_types['user_has_ranks']              = _x( 'User has ranks',                   'wp_admin', 'activemember360' );
		$arr_gamipress_user_status_types['user_has_not_ranks']          = _x( 'User does not have ranks',         'wp_admin', 'activemember360' );
		$arr_gamipress_user_status_types['user_points_compare']         = _x( 'User points comparison',           'wp_admin', 'activemember360' );

		$arr_conditions[]   = [
			'trigger'         => [ 'mbr_gamipress_user_status' => _x( 'GamiPress user status', 'wp_admin', 'activemember360' ) ],
			'fields'          => [
				[
					'id'          => 'condition_gamipress_user_status_type',
					'name'        => _x( 'User status', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => $arr_gamipress_user_status_types,
					'visible'     => [ 'condition_type', '=', 'mbr_gamipress_user_status' ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select user status', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_gamipress_user_has_achievements_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose achievements a user must have in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_gamipress_user_status' ], [ 'condition_gamipress_user_status_type', '=', 'user_has_achievements' ] ]
				],
				[
					'id'          => 'condition_gamipress_user_has_not_achievements_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose achievements a user must not have in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_gamipress_user_status' ], [ 'condition_gamipress_user_status_type', '=', 'user_has_not_achievements' ] ]
				],
				[
					'id'          => 'condition_gamipress_user_has_ranks_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose ranks a user must have in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_gamipress_user_status' ], [ 'condition_gamipress_user_status_type', '=', 'user_has_ranks' ] ]
				],
				[
					'id'          => 'condition_gamipress_user_has_not_ranks_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Choose ranks a user must not have in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_gamipress_user_status' ], [ 'condition_gamipress_user_status_type', '=', 'user_has_not_ranks' ] ]
				],
				[
					'id'          => 'condition_gamipress_user_points_compare_description',
					'type'        => 'custom_html',
					'std'         => _x( 'Compare a user\'s points type against a specific value. This must evaluate to TRUE in order to meet the criteria of this condition.', 'wp_admin', 'activemember360' ),
					'visible'     => [ [ 'condition_type', '=', 'mbr_gamipress_user_status' ], [ 'condition_gamipress_user_status_type', '=', 'user_points_compare' ] ]
				],
				[
					'id'          => 'condition_gamipress_determined_by',
					'name'        => _x( 'Determined by', 'wp_admin', 'activemember360' ),
					'type'        => 'select_advanced',
					'options'     => [ 'any' => _x( 'any', 'wp_admin', 'activemember360' ), 'all' => _x( 'all', 'wp_admin', 'activemember360' ) ],
					'visible'     => [ [ 'condition_type', '=', 'mbr_gamipress_user_status' ], [ 'condition_gamipress_user_status_type', '!=', 'user_points_compare'] ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select rule', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_gamipress_achievements',
					'name'        => _x( 'Achievements', 'wp_admin', 'activemember360' ),
					'type'        => 'post',
					'post_type'   => gamipress_get_achievement_types_slugs(),
					'field_type'  => 'select_advanced',
					'query_args'  => [
						'post_status'    => 'publish',
						'posts_per_page' => - 1,
						'orderby'        => 'title',
						'order'          => 'asc'
					],
					'multiple'    => TRUE,
					'visible'     => [ [ 'condition_type', '=', 'mbr_gamipress_user_status' ], [ 'condition_gamipress_user_status_type', 'contains', 'achievements' ] ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select achievements', 'wp_admin', 'activemember360' ),
					'select_all_none' => TRUE
				],
				[
					'id'          => 'condition_gamipress_ranks',
					'name'        => _x( 'Ranks', 'wp_admin', 'activemember360' ),
					'type'        => 'post',
					'post_type'   => gamipress_get_rank_types_slugs(),
					'field_type'  => 'select_advanced',
					'query_args'  => [
						'post_status'    => 'publish',
						'posts_per_page' => - 1,
						'orderby'        => 'title',
						'order'          => 'asc'
					],
					'multiple'    => TRUE,
					'visible'     => [ [ 'condition_type', '=', 'mbr_gamipress_user_status' ], [ 'condition_gamipress_user_status_type', 'contains', 'ranks' ] ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select ranks', 'wp_admin', 'activemember360' ),
					'select_all_none' => TRUE
				],
				[
					'id'          => 'condition_gamipress_points_type_compare',
					'name'        => _x( 'Points type', 'wp_admin', 'activemember360' ),
					'type'        => 'post',
					'post_type'   => 'points-type',
					'field_type'  => 'select_advanced',
					'query_args'  => [
						'post_status'    => 'publish',
						'posts_per_page' => - 1,
						'orderby'        => 'title',
						'order'          => 'asc'
					],
					'multiple'    => FALSE,
					'visible'     => [ [ 'condition_type', '=', 'mbr_gamipress_user_status' ], [ 'condition_gamipress_user_status_type', '=', 'user_points_compare' ] ],
					'js_options'  => [ 'width' => '100%' ],
					'placeholder' => _x( 'Select points type', 'wp_admin', 'activemember360' ),
					'select_all_none' => TRUE
				],
				[
					'id'                 => 'condition_gamipress_points_compare_operator',
					'name'               => _x( 'Compare operator', 'wp_admin', 'activemember360' ),
					'type'               => 'select_advanced',
					'options'            => [
						'equals'           => _x( 'Equals',           'wp_admin', 'activemember360' ),
						'not_equal'        => _x( 'Not equal',        'wp_admin', 'activemember360' ),
						'greater_than'     => _x( 'Greater than',     'wp_admin', 'activemember360' ),
						'less_than'        => _x( 'Less than',        'wp_admin', 'activemember360' ),
						'greater_or_equal' => _x( 'Greater or equal', 'wp_admin', 'activemember360' ),
						'less_or_equal'    => _x( 'Less or equal',    'wp_admin', 'activemember360' ),
						'is_empty'         => _x( 'Is empty',         'wp_admin', 'activemember360' ),
						'not_empty'        => _x( 'Not empty',        'wp_admin', 'activemember360' ),
					],
					'js_options'         => [ 'width' => '100%' ],
					'visible'            => [ 'condition_gamipress_user_status_type', '=', 'user_points_compare' ],
					'placeholder'        => _x( 'Select compare operator', 'wp_admin', 'activemember360' )
				],
				[
					'id'          => 'condition_gamipress_points_compare_value',
					'name'        => _x( 'Compare value', 'wp_admin', 'activemember360' ),
					'type'        => 'number',
					'visible'     => [ [ 'condition_type', '=', 'mbr_gamipress_user_status' ], [ 'condition_gamipress_points_compare_operator', 'not contains', 'empty' ] ]
				]
			]
		];

		return $arr_conditions;
	}

		















	public function check_condition_gamipress_user_status( $match, $arr_condition )
	{
		IF ( ! empty( $arr_condition['condition_type'] ) AND 'mbr_gamipress_user_status' == $arr_condition['condition_type'] ) :
			IF ( ! defined( 'GAMIPRESS_VER' ) ) :
				return TRUE;
			ENDIF;

			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			IF ( ! is_user_logged_in() ) :
				return FALSE;
			ENDIF;

			IF ( 'user_has_achievements' == $arr_condition['condition_gamipress_user_status_type'] ) :
				return $this->check_gamipress_user_has_achievements( $arr_condition );
			ELSEIF ( 'user_has_not_achievements' == $arr_condition['condition_gamipress_user_status_type'] ) :
				return $this->check_gamipress_user_has_not_achievements( $arr_condition );
			ELSEIF ( 'user_has_ranks' == $arr_condition['condition_gamipress_user_status_type'] ) :
				return $this->check_gamipress_user_has_ranks( $arr_condition );
			ELSEIF ( 'user_has_not_ranks' == $arr_condition['condition_gamipress_user_status_type'] ) :
				return $this->check_gamipress_user_has_not_ranks( $arr_condition );
			ELSEIF ( 'user_points_compare' == $arr_condition['condition_gamipress_user_status_type'] ) :
				return $this->check_gamipress_user_points_compare( $arr_condition );
			ENDIF;
		ENDIF;

		return $match;
	}

	












	private function check_gamipress_user_has_achievements( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'GAMIPRESS_VER' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_gamipress_achievements'] ) OR ! is_array( $arr_condition['condition_gamipress_achievements'] ) ) :
			return TRUE;
		ENDIF;

		$rule                               = 'any';
		IF ( isset( $arr_condition['condition_gamipress_determined_by'] ) ) :
			$rule                             = lower_trim( $arr_condition['condition_gamipress_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                             = 'any';
		ENDIF;

		$arr_user_achievements              = [];
		$arr_tmp_user_achievements          = gamipress_get_user_achievements( [ 'user_id' => $current_user->ID ] );
		IF ( ! empty( $arr_tmp_user_achievements ) ) :
			FOREACH ( $arr_tmp_user_achievements AS $achievement ) :
				$arr_user_achievements[]        = $achievement->ID;
			ENDFOREACH;
		ENDIF;

		$arr_user_has_achievements          = [];

		IF ( ! empty( $arr_user_achievements ) ) :
			FOREACH ( $arr_condition['condition_gamipress_achievements'] AS $key => $achievement_id ) :
				$achievement_id                 = (int) $achievement_id;
				IF ( in_array( $achievement_id, $arr_user_achievements ) ) :
					$arr_user_has_achievements[]  = $achievement_id;
					IF ( 'any' == $rule ) :
						break;
					ENDIF;
				ENDIF;
			ENDFOREACH;
		ENDIF;

		$user_achievements                  = count( $arr_user_has_achievements );
		IF ( 'all' == $rule ) :
			$required_achievements            = count( $arr_condition['condition_gamipress_achievements'] );
			IF ( $required_achievements == $user_achievements ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $user_achievements ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	












	private function check_gamipress_user_has_not_achievements( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'GAMIPRESS_VER' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_gamipress_achievements'] ) OR ! is_array( $arr_condition['condition_gamipress_achievements'] ) ) :
			return TRUE;
		ENDIF;

		$rule                               = 'any';
		IF ( isset( $arr_condition['condition_gamipress_determined_by'] ) ) :
			$rule                             = lower_trim( $arr_condition['condition_gamipress_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                             = 'any';
		ENDIF;

		$arr_user_achievements              = [];
		$arr_tmp_user_achievements          = gamipress_get_user_achievements( [ 'user_id' => $current_user->ID ] );
		IF ( ! empty( $arr_tmp_user_achievements ) ) :
			FOREACH ( $arr_tmp_user_achievements AS $achievement ) :
				$arr_user_achievements[]        = $achievement->ID;
			ENDFOREACH;
		ENDIF;

		$arr_user_has_not_achievements      = [];

		IF ( ! empty( $arr_user_achievements ) ) :
			FOREACH ( $arr_condition['condition_gamipress_achievements'] AS $key => $achievement_id ) :
				$achievement_id                 = (int) $achievement_id;
				IF ( ! in_array( $achievement_id, $arr_user_achievements ) ) :
					$arr_user_has_not_achievements[] = $achievement_id;
					IF ( 'any' == $rule ) :
						break;
					ENDIF;
				ENDIF;
			ENDFOREACH;
		ENDIF;

		$not_user_achievements              = count( $arr_user_has_not_achievements );
		IF ( 'all' == $rule ) :
			$required_achievements            = count( $arr_condition['condition_gamipress_achievements'] );
			IF ( $required_achievements == $not_user_achievements ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $not_user_achievements ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	












	private function check_gamipress_user_has_ranks( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'GAMIPRESS_VER' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_gamipress_ranks'] ) OR ! is_array( $arr_condition['condition_gamipress_ranks'] ) ) :
			return TRUE;
		ENDIF;

		$rule                        = 'any';
		IF ( isset( $arr_condition['condition_gamipress_determined_by'] ) ) :
			$rule                      = lower_trim( $arr_condition['condition_gamipress_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                      = 'any';
		ENDIF;

		$arr_user_ranks              = [];
		$arr_rank_types              = gamipress_get_rank_types_slugs();
		IF ( ! empty( $arr_rank_types ) AND is_array( $arr_rank_types ) ) :
			FOREACH ( $arr_rank_types AS $key => $rank_type ) :
				$rank                    = gamipress_get_user_rank( $current_user->ID, $rank_type );
				IF ( ! empty( $rank->ID ) ) :
					$arr_user_ranks[]      = (int) $rank->ID;
				ENDIF;
			ENDFOREACH;
		ENDIF;

		$arr_user_has_ranks          = [];

		IF ( ! empty( $arr_user_ranks ) ) :
			FOREACH ( $arr_condition['condition_gamipress_ranks'] AS $key => $rank_id ) :
				$rank_id                 = (int) $rank_id;
				IF ( in_array( $rank_id, $arr_user_ranks ) ) :
					$arr_user_has_ranks[]  = $rank_id;
					IF ( 'any' == $rule ) :
						break;
					ENDIF;
				ENDIF;
			ENDFOREACH;
		ENDIF;

		$user_ranks                  = count( $arr_user_has_ranks );
		IF ( 'all' == $rule ) :
			$required_ranks            = count( $arr_condition['condition_gamipress_ranks'] );
			IF ( $required_ranks == $user_ranks ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $user_ranks ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	












	private function check_gamipress_user_has_not_ranks( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'GAMIPRESS_VER' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( empty( $arr_condition['condition_gamipress_ranks'] ) OR ! is_array( $arr_condition['condition_gamipress_ranks'] ) ) :
			return TRUE;
		ENDIF;

		$rule                        = 'any';
		IF ( isset( $arr_condition['condition_gamipress_determined_by'] ) ) :
			$rule                      = lower_trim( $arr_condition['condition_gamipress_determined_by'] );
		ENDIF;
		IF ( empty( $rule ) OR ! in_array( $rule , [ 'any', 'all' ] ) ) :
			$rule                      = 'any';
		ENDIF;

		$arr_user_ranks              = [];
		$arr_rank_types              = gamipress_get_rank_types_slugs();
		IF ( ! empty( $arr_rank_types ) AND is_array( $arr_rank_types ) ) :
			FOREACH ( $arr_rank_types AS $key => $rank_type ) :
				$rank                    = gamipress_get_user_rank( $current_user->ID, $rank_type );
				IF ( ! empty( $rank->ID ) ) :
					$arr_user_ranks[]      = (int) $rank->ID;
				ENDIF;
			ENDFOREACH;
		ENDIF;

		$arr_user_has_not_ranks      = [];

		IF ( ! empty( $arr_user_ranks ) ) :
			FOREACH ( $arr_condition['condition_gamipress_ranks'] AS $key => $rank_id ) :
				$rank_id                 = (int) $rank_id;
				IF ( ! in_array( $rank_id, $arr_user_ranks ) ) :
					$arr_user_has_not_ranks[] = $rank_id;
					IF ( 'any' == $rule ) :
						break;
					ENDIF;
				ENDIF;
			ENDFOREACH;
		ENDIF;

		$not_user_ranks              = count( $arr_user_has_not_ranks );
		IF ( 'all' == $rule ) :
			$required_ranks            = count( $arr_condition['condition_gamipress_ranks'] );
			IF ( $required_ranks == $not_user_ranks ) :
				return TRUE;
			ENDIF;
		ELSE:
			IF ( 0 < $not_user_ranks ) :
				return TRUE;
			ENDIF;
		ENDIF;

		return FALSE;
	}

	















	public function check_gamipress_user_points_compare( $arr_condition )
	{
		global $current_user;

		IF ( ! defined( 'GAMIPRESS_VER' ) ) :
			return TRUE;
		ENDIF;

		IF ( ! is_user_logged_in() ) :
			return FALSE;
		ENDIF;

		IF ( ! empty( $arr_condition['condition_gamipress_points_compare_operator'] ) AND ! empty( $arr_condition['condition_gamipress_points_type_compare'] ) ) :
			IF ( 'inactive' == $arr_condition['condition_status'] ) :
				return TRUE;
			ENDIF;

			$operator       = $arr_condition['condition_gamipress_points_compare_operator'];
			$points_type_id = $arr_condition['condition_gamipress_points_type_compare'];
			IF ( ! empty( $points_type_id ) ) :
				$points_type  = get_post( (int) $points_type_id );
			ENDIF;
			$compare_value  = $arr_condition['condition_gamipress_points_compare_value'];

			$points         = gamipress_get_user_points( $current_user->ID, $points_type->post_name );
			$points         = (int) $points;

			IF ( 'equals' == $operator ) :
				$match       = ( $points == $compare_value ? TRUE : FALSE );
			ELSEIF ( 'not_equal' == $operator ) :
				$match       = ( $points <> $compare_value ? TRUE : FALSE );
			ELSEIF ( 'less_than' == $operator ) :
				$match       = ( $points <  $compare_value ? TRUE : FALSE );
			ELSEIF ( 'greater_than' == $operator ) :
				$match       = ( $points >  $compare_value ? TRUE : FALSE );
			ELSEIF ( 'greater_or_equal' == $operator ) :
				$match       = ( $points >= $compare_value ? TRUE : FALSE );
			ELSEIF ( 'less_or_equal' == $operator ) :
				$match       = ( $points <= $compare_value ? TRUE : FALSE );
			ELSEIF ( 'is_empty' == $operator ) :
				$match       = empty( $points) ? TRUE : FALSE;
			ELSEIF ( 'not_empty' == $operator ) :
				$match       = ! empty( $points) ? TRUE : FALSE;
			ELSE :
				$match       = FALSE;
			ENDIF;

			return $match;
		ENDIF;

		return FALSE;
	}

	













	public function admin_enqueue_scripts()
	{
		global $pagenow, $post;

		
		IF ( ( ! empty( $post ) AND $this->conditional_post_type == $post->post_type ) OR ( ! empty( $_GET['post_type'] ) AND $_GET['post_type'] == $this->conditional_post_type ) OR ( in_array( $pagenow, [ 'post.php', 'post-new.php' ], TRUE ) ) ) :
			wp_enqueue_style( 'mbr-conditionals', plugin_dir_url( __FILE__ ) . 'css/conditionals.css' );
		ENDIF;
	}

		











	public function pre_post_update( $post_id, $arr_data )
	{
		IF ( ! empty( $_POST['_mbr_condition_definition'] ) AND is_array( $_POST['_mbr_condition_definition'] ) ) :
			FOREACH ( $_POST['_mbr_condition_definition'] AS $key => $arr_condition ) :

				IF ( empty( $arr_condition['condition_type'] ) ) :
					unset( $_POST['_mbr_condition_definition'][ $key ] );
					continue;
				ENDIF;

				$condition_name                     = trim( $arr_condition['condition_name'] );
				IF ( empty( $condition_name ) ) :
					static $arr_conditions_definition = NULL;
					static $arr_triggers              = [];
					IF ( is_null( $arr_conditions_definition ) ) :
						$arr_conditions_definition      = apply_filters( 'mbr/conditionals/condition/add', [] );
						FOREACH ( $arr_conditions_definition AS $k => $arr_condition_definition ) :
							FOREACH ( $arr_condition_definition['trigger'] AS $trigger => $trigger_name ) :
								$arr_triggers[ $trigger ]   = $trigger_name;
							ENDFOREACH;
						ENDFOREACH;
					ENDIF;
					IF ( isset( $arr_triggers[ $arr_condition['condition_type'] ] ) ) :
						$_POST['_mbr_condition_definition'][ $key ]['condition_name'] = $arr_triggers[ $arr_condition['condition_type'] ];
					ELSE:
						$_POST['_mbr_condition_definition'][ $key ]['condition_name'] = $arr_condition['condition_type'];
					ENDIF;
				ENDIF;
			ENDFOREACH;
		ENDIF;
	}

	






	public function remove_tag_search_meta_box()
	{
		remove_meta_box( 'tag_list_search_' , $this->conditional_post_type , 'side'   );
		remove_meta_box( 'slugdiv',           $this->conditional_post_type,  'normal' );
	}

	








	public function extend_conditionals_shortcodes( $SHORT = [] )
	{
		$SHORT['is_conditional'] = [ [ $this, 'sc_is_conditional' ], 1 ];

		return $SHORT;
	}

	












	public function sc_is_conditional( $parms = '', $content = NULL, $scname = '' )
	{
		$defaults       = [ 'id' => '' ];
		$parms          = apply_filters( 'mbr/shortcodes/atts', $defaults, $parms, $scname );

		IF ( ! empty( $parms['id'] ) ) :
			$match        = apply_filters( 'mbr/conditionals/conditional/check', NULL, $parms['id'] );

			IF ( is_null( $match ) ) :
				return NULL;
			ENDIF;

			return $GLOBALS['mbr']->split_else_content( $content, $scname, $match );
		ENDIF;

		return NULL;
	}

	














	public function check_conditional( $match = FALSE, $conditional_id = FALSE )
	{
		IF ( empty( $conditional_id ) ) :
			return NULL;
		ENDIF;

		$conditional_id              = (int) $conditional_id;
		$conditional_status          = get_post_status( $conditional_id );

		IF ( empty( $conditional_status ) OR 'publish' <> $conditional_status ) :
			return NULL;
		ENDIF;

		IF ( MBRADMIN ) :
			return TRUE;
		ENDIF;

		$match                     = FALSE;

		$condition_logic           = get_post_meta( $conditional_id, '_mbr_condition_logic', TRUE );
		$arr_condition_definitions = get_post_meta( $conditional_id, '_mbr_condition_definition', TRUE );
		IF ( empty( $condition_logic ) OR ! in_array( $condition_logic, [ 'and', 'or' ] ) ) :
			$condition_logic         = 'and';
		ENDIF;

		IF ( ! empty( $arr_condition_definitions ) AND is_array( $arr_condition_definitions ) ) :
			$arr_match               = [];
			FOREACH ( $arr_condition_definitions AS $key => $arr_condition ) :
				IF ( has_filter( 'mbr/conditionals/condition/check/' . $arr_condition['condition_type'] ) AND 'inactive' <> $arr_condition['condition_status'] ) :
					$arr_match[]          = apply_filters( 'mbr/conditionals/condition/check/' . $arr_condition['condition_type'], TRUE, $arr_condition );
				ELSE:
					$arr_match[]          = TRUE;
				ENDIF;
			ENDFOREACH;

			IF ( 'and' == $condition_logic ) :
				$match                  = TRUE;
				FOREACH ( $arr_match AS $key => $condition_match ) :
					IF ( ! $condition_match ) :
						$match              = FALSE;
						break;
					ENDIF;
				ENDFOREACH;
			ELSE:
				FOREACH ( $arr_match AS $key => $condition_match ) :
					IF ( $condition_match ) :
						$match              = TRUE;
						break;
					ENDIF;
				ENDFOREACH;
			ENDIF;
		ENDIF;

		return $match;
	}

	










	public function get_conditionals( $arr_conditions = [] )
	{
		$args                   = [];
		$args['posts_per_page'] = -1;
		$args['post_type']      = $this->conditional_post_type;
		$args['post_status']    = [ 'publish', 'pending', 'draft', 'future', 'private', 'inherit', 'trash' ];
		$args['orderby']        = 'title';
		$args['order']          = 'asc';
		IF ( ! empty( $_GET['post'] ) ) :
			$args['post__not_in'] = [ $_GET['post'] ];
		ENDIF;

		$arr_tmp_conditionals   = get_posts( $args );

		$arr_conditionals       = [];
		FOREACH ( $arr_tmp_conditionals AS $key => $conditional ) :
			$arr_conditionals[ $conditional->ID ] = $conditional->post_title . ' ( ' . $conditional->post_status . ' )'; 
		ENDFOREACH;

		return $arr_conditionals;
	}

	











	public function register_routes( )
	{
		register_rest_route( 'mbr-conditionals', '/get/', [ 'methods' => 'GET', 'callback' => [ $this, 'json_get_conditionals' ] ] );
	}

	








	public function json_get_conditionals()
	{
		$response           = [];
		IF ( MBR_ADMIN ) :
			$arr_conditionals = apply_filters( 'mbr/conditionals/conditionals/get', [] );

			IF ( ! empty( $arr_conditionals ) AND is_array( $arr_conditionals ) ) :
				FOREACH ( $arr_conditionals AS $conditional_id => $conditional_name ) :
					$response[]   = [
						'value'     => $conditional_id,
						'label'     => $conditional_name
					];
				ENDFOREACH;
			ENDIF;
		ENDIF;

		return rest_ensure_response( $response );
	}

}












function mbr_is_conditional( $conditional_id )
{
	IF ( ! empty( $conditional_id ) ) :
		$match = apply_filters( 'mbr/conditionals/conditional/check', NULL, $conditional_id );

		return $match;
	ENDIF;

	return NULL;
}




$GLOBALS['mbr_inst_conditionals'] = mbr_conditionals::getInstance();
