<?php









final class mbr_elementor {

	use TRAIT__getInstance;

	


	private $protected_widgets = [];

	









	public function _load()
	{
		function MBRELE()
		{
			IF ( empty( $GLOBALS['mbr_elementor' ] ) ) :
				$GLOBALS['mbr_elementor'] = mbr_elementor::getInstance();
			ENDIF;

			return $GLOBALS['mbr_elementor'];
		}
	}

	










	public function plugins_loaded()
	{
		IF ( ! defined( 'ELEMENTOR_VERSION' ) ) :
			return NULL;
		ENDIF;

		add_action( 'elementor/editor/after_enqueue_styles',                    [ $this, 'editor_enqueue_scripts' ],                            10, 0 );
		add_action( 'elementor/element/after_section_end',                      [ $this, 'register_controls' ],                                 10, 3 );
		add_action( 'elementor/element/popup_timing/timing/before_section_end', [ $this, 'register_controls_popup_timing_display' ],          9999, 3 );
		add_action( 'elementor/element/popup_timing/timing/before_section_end', [ $this, 'register_controls_popup_timing_pos_tags' ],         9999, 3 );
		add_action( 'elementor/element/popup_timing/timing/before_section_end', [ $this, 'register_controls_popup_timing_neg_tags' ],         9999, 3 );
		add_action( 'elementor/element/popup_timing/timing/before_section_end', [ $this, 'register_controls_popup_timing_field_comparison' ], 9999, 3 );
		add_action( 'elementor/element/popup_timing/timing/before_section_end', [ $this, 'register_controls_popup_timing_conditional' ],      9999, 3 );
		add_filter( 'elementor/frontend/section/should_render',                 [ $this, 'element_check_permissions' ],                         10, 2 );
		add_filter( 'elementor/frontend/column/should_render',                  [ $this, 'element_check_permissions' ],                         10, 2 );
		add_filter( 'elementor/frontend/widget/should_render',                  [ $this, 'element_check_permissions' ],                         10, 2 );
		add_filter( 'elementor/theme/get_location_templates/template_id',       [ $this, 'get_template' ],                                      10, 1 );
	}

	








	public function editor_enqueue_scripts()
	{
		wp_register_style( 'mbr-elementor', plugin_dir_url( __FILE__ ) . 'css/elementor.css' , [], MBRVERSION, 'all' );
		wp_enqueue_style( 'mbr-elementor' );
	}

	














	public function register_controls( $element, $section_id, $args )
	{
		$element_type             = $element->get_type();
		IF ( ! in_array( $element_type, [ 'widget', 'section', 'column' ] ) ) :
			return NULL;
		ENDIF;

		IF ( ! in_array( $section_id, [ 'section_advanced', '_section_style' ] ) ) :
			return NULL;
		ENDIF;

		static $plugin_name       = NULL;
		IF ( is_null( $plugin_name ) ) :
			$plugin_name            = apply_filters( 'mbr/plugin_name', NULL );
		ENDIF;

		static $arr_crm_tags      = NULL;
		IF ( is_null( $arr_crm_tags ) ) :
			$arr_crm_tags           = apply_filters( 'mbr/site_tags/get', NULL );
		ENDIF;

		static $arr_crm_fields    = NULL;
		IF ( is_null( $arr_crm_fields ) ) :
			$arr_tmp_regular_fields = apply_filters( 'mbr/site_contact_std_fields/get', NULL );
			$arr_crm_fields['']     = '---';
			IF ( ! empty( $arr_tmp_regular_fields ) ) :
				FOREACH ( $arr_tmp_regular_fields AS $filler => $field_name ) :
					$arr_crm_fields[ $field_name ] = $field_name;
				ENDFOREACH;
			ENDIF;
			$arr_tmp_custom_fields  = apply_filters( 'mbr/site_custom_fields/get', NULL );
			IF ( ! empty( $arr_tmp_custom_fields ) ) :
				FOREACH ( $arr_tmp_custom_fields AS $field_name => $arr_field ) :
					$arr_crm_fields[ strtolower( $arr_field['perstag'] ) ] = $arr_field['title'];
				ENDFOREACH;
			ENDIF;
		ENDIF;

		static $arr_conditionals  = NULL;
		IF ( is_null( $arr_conditionals ) ) :
			$arr_conditionals       = apply_filters( 'mbr/conditionals/conditionals/get', [] );
		ENDIF;

		$element->start_controls_section(
			'mbr_element_control',
			[
				'label'               => $plugin_name,
				'tab'                 => Elementor\Controls_Manager::TAB_ADVANCED,
			]
		);

		$element->add_control(
			'mbr_element_control_mode',
			[
				'label'               => _x( 'Control mode', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::SELECT,
				'options'             => [ 'individual' => _x( 'Individual', 'elementor', 'activemember360' ), 'conditional' => _x( 'Conditional', 'elementor', 'activemember360' ) ],
				'label_block'         => TRUE,
				'default'             => 'individual'
			]
		);

		$element->add_control(
			'mbr_element_control_conditional_eval',
			[
				'label'               => _x( 'Display if conditional evaluates', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::SELECT,
				'options'             => [ 'true' => _x( 'True', 'elementor', 'activemember360' ), 'false' => _x( 'False', 'elementor', 'activemember360' ) ],
				'default'             => 'true',
				'label_block'         => TRUE,
				'condition'           => [ 'mbr_element_control_mode' => 'conditional' ]
			]
		);

		$element->add_control(
			'mbr_element_control_conditional_id',
			[
				'label'               => _x( 'Select a predefined conditional', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::SELECT2,
				'options'             => ! empty( $arr_conditionals ) ? [ 0 => '---' ] + $arr_conditionals : [ 0 => '---' ],
				'default'             => 0,
				'label_block'         => TRUE,
				'condition'           => [ 'mbr_element_control_mode' => 'conditional' ]
			]
		);

		$element->add_control(
			'mbr_element_control_description',
			[
				'type'                => Elementor\Controls_Manager::RAW_HTML,
				'raw'                 => _x( 'All conditions are AND conditions, therefore ALL conditions must be achieved for the element/section display setting to take effect. Otherwise the element/section will not be displayed.', 'elementor', 'activemember360' ),
				'content_classes'     => 'elementor-descriptor',
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_divider_' . uniqid(),
			[
				'type'                => Elementor\Controls_Manager::DIVIDER,
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_description_display_if',
			[
				'type'                => Elementor\Controls_Manager::RAW_HTML,
				'raw'                 => _x( 'Choose the element/section display setting.', 'elementor', 'activemember360' ),
				'content_classes'     => 'elementor-descriptor',
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_display_if',
			[
				'label'               => _x( 'Display if/when', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::SELECT,
				'options'             => [ 'always' => _x( 'Always', 'elementor', 'activemember360' ), 'is_logged_in' => _x( 'Is logged in', 'elementor', 'activemember360' ), 'not_logged_in' => _x ( 'Not logged in', 'elementor', 'activemember360' ), 'never' => _x( 'Never', 'elementor', 'activemember360' ) ],
				'default'             => 'always',
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_divider_' . uniqid(),
			[
				'type'                => Elementor\Controls_Manager::DIVIDER,
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_description_tags',
			[
				'type'                => Elementor\Controls_Manager::RAW_HTML,
				'raw'                 => _x( 'Choose tags a contact must (at least one) and must not have (all) in order to confirm the element/section display setting.', 'elementor', 'activemember360' ),
				'content_classes'     => 'elementor-descriptor',
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_pos_tags',
			[
				'label'               => _x( 'Tags (Any)', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::SELECT2,
				'multiple'            => TRUE,
				'options'             => $arr_crm_tags,
				'label_block'         => TRUE,
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_neg_tags',
			[
				'label'               => _x( 'Tags (Not All)', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::SELECT2,
				'multiple'            => TRUE,
				'options'             => $arr_crm_tags,
				'label_block'         => TRUE,
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_divider_' . uniqid(),
			[
				'type'                => Elementor\Controls_Manager::DIVIDER,
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_description_compare_field',
			[
				'type'                => Elementor\Controls_Manager::RAW_HTML,
				'raw'                 => _x( 'Compare a contact field against a specific value. This must evaluate to TRUE in order to confirm the element/section display setting.', 'elementor', 'activemember360' ),
				'content_classes'     => 'elementor-descriptor',
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_compare_field',
			[
				'label'               => _x( 'Field', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::SELECT,
				'options'             => $arr_crm_fields,
				'default'             => '',
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_compare_field_operator',
			[
				'label'               => _x( 'Operator', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::SELECT,
				'options'             => [
					''                  => '---',
					'equals'            => _x( 'Equals',           'elementor', 'activemember360' ),
					'not_equal'         => _x( 'Not equal',        'elementor', 'activemember360' ),
					'greater_than'      => _x( 'Greater than',     'elementor', 'activemember360' ),
					'less_than'         => _x( 'Less than',        'elementor', 'activemember360' ),
					'greater_or_equal'  => _x( 'Greater or equal', 'elementor', 'activemember360' ),
					'less_or_equal'     => _x( 'Less or equal',    'elementor', 'activemember360' ),
					'begins_with'       => _x( 'Begins with',      'elementor', 'activemember360' ),
					'ends_with'         => _x( 'Ends with',        'elementor', 'activemember360' ),
					'contains'          => _x( 'Contains',         'elementor', 'activemember360' ),
					'not_contains'      => _x( 'Not contains',     'elementor', 'activemember360' )
				],
				'default'             => '',
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_compare_field_value',
			[
				'label'               => _x( 'Value', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::TEXT,
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_divider_' . uniqid(),
			[
				'type'                => Elementor\Controls_Manager::DIVIDER,
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_description_php_statement',
			[
				'type'                => Elementor\Controls_Manager::RAW_HTML,
				'raw'                 => _x( 'PHP statement must return TRUE in order to confirm the element/section display setting.', 'elementor', 'activemember360' ),
				'content_classes'     => 'elementor-descriptor',
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_php_statement',
			[
				'label'               => _x( 'PHP statement', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::TEXTAREA,
				'condition'           => [ 'mbr_element_control_mode' => 'individual' ]
			]
		);

		$element->add_control(
			'mbr_element_control_divider_' . uniqid(),
			[
				'type'                => Elementor\Controls_Manager::DIVIDER
			]
		);

		$element->add_control(
			'mbr_element_control_description_internal_notes',
			[
				'type'                => Elementor\Controls_Manager::RAW_HTML,
				'raw'                 => _x( 'Your internal notes about this element. This is not displayed or used elsewhere.', 'elementor', 'activemember360' ),
				'content_classes'     => 'elementor-descriptor'
			]
		);

		$element->add_control(
			'mbr_element_control_internal_notes',
			[
				'label'               => _x( 'Internal notes', 'elementor', 'activemember360' ),
				'type'                => Elementor\Controls_Manager::TEXTAREA
			]
		);

		$element->end_controls_section();
	}

	

















	public function register_controls_popup_timing_display( $element, $args )
	{
		$element->add_control(
			'mbr_popup_control_display_heading',
			[
				'label'              => _x( 'Display if/when', 'elementor', 'activemember360' ),
				'type'               => Elementor\Controls_Manager::HEADING
			]
		);

		$element->add_control(
			'mbr_popup_control_display_condition',
			[
				'type'               => Elementor\Controls_Manager::SELECT,
				'options'            => [ 'always' => _x( 'Always', 'elementor', 'activemember360' ), 'is_logged_in' => _x( 'Is logged in', 'elementor', 'activemember360' ), 'not_logged_in' => _x ( 'Not logged in', 'elementor', 'activemember360' ), 'never' => _x( 'Never', 'elementor', 'activemember360' ) ],
				'default'            => 'always',
				'condition'          => [ 'mbr_popup_control_display_enabled' => 'yes' ],
				'frontend_available' => TRUE
			]
		);

		$element->add_control(
			'mbr_popup_control_display_enabled',
			[
				'type'               => Elementor\Controls_Manager::SWITCHER,
				'classes'            => 'elementor-popup__display-settings__group-toggle',
				'frontend_available' => TRUE
			]
		);
	}

	













	public function register_controls_popup_timing_pos_tags( $element, $args )
	{
		static $arr_crm_tags     = NULL;
		IF ( is_null( $arr_crm_tags ) ) :
			$arr_crm_tags          = apply_filters( 'mbr/site_tags/get', NULL );
		ENDIF;

		$element->add_control(
			'mbr_popup_control_pos_tags_heading',
			[
				'label'              => _x( 'Tags (Any)', 'elementor', 'activemember360' ),
				'type'               => Elementor\Controls_Manager::HEADING
			]
		);

		$element->add_control(
			'mbr_popup_control_pos_tags_condition',
			[
				'type'               => Elementor\Controls_Manager::SELECT2,
				'multiple'           => TRUE,
				'options'            => $arr_crm_tags,
				'condition'          => [ 'mbr_popup_control_pos_tags_enabled' => 'yes' ],
				'frontend_available' => TRUE
			]
		);
		$element->add_control(
			'mbr_popup_control_pos_tags_enabled',
			[
				'type'               => Elementor\Controls_Manager::SWITCHER,
				'classes'            => 'elementor-popup__display-settings__group-toggle',
				'frontend_available' => TRUE
			]
		);
	}

	













	public function register_controls_popup_timing_neg_tags( $element, $args )
	{
		static $arr_crm_tags      = NULL;
		IF ( is_null( $arr_crm_tags ) ) :
			$arr_crm_tags           = apply_filters( 'mbr/site_tags/get', NULL );
		ENDIF;

		$element->add_control(
			'mbr_popup_control_neg_tags_heading',
			[
				'label'              => _x( 'Tags (Not All)', 'elementor', 'activemember360' ),
				'type'               => Elementor\Controls_Manager::HEADING
			]
		);

		$element->add_control(
			'mbr_popup_control_neg_tags_condition',
			[
				'type'               => Elementor\Controls_Manager::SELECT2,
				'multiple'           => TRUE,
				'options'            => $arr_crm_tags,
				'condition'          => [ 'mbr_popup_control_neg_tags_enabled' => 'yes' ],
				'frontend_available' => TRUE
			]
		);
		$element->add_control(
			'mbr_popup_control_neg_tags_enabled',
			[
				'type'               => Elementor\Controls_Manager::SWITCHER,
				'classes'            => 'elementor-popup__display-settings__group-toggle',
				'frontend_available' => TRUE
			]
		);
	}

	













	public function register_controls_popup_timing_field_comparison( $element, $args )
	{
		static $arr_crm_fields    = NULL;
		IF ( is_null( $arr_crm_fields ) ) :
			$arr_tmp_regular_fields = apply_filters( 'mbr/site_contact_std_fields/get', NULL );
			$arr_crm_fields['']     = '---';
			IF ( ! empty( $arr_tmp_regular_fields ) ) :
				FOREACH ( $arr_tmp_regular_fields AS $filler => $field_name ) :
					$arr_crm_fields[ $field_name ] = $field_name;
				ENDFOREACH;
			ENDIF;
			$arr_tmp_custom_fields  = apply_filters( 'mbr/site_custom_fields/get', NULL );
			IF ( ! empty( $arr_tmp_custom_fields ) ) :
				FOREACH ( $arr_tmp_custom_fields AS $field_name => $arr_field ) :
					$arr_crm_fields[ strtolower( $arr_field['perstag'] ) ] = $arr_field['title'];
				ENDFOREACH;
			ENDIF;
		ENDIF;

		$element->add_control(
			'mbr_popup_control_field_compare_heading',
			[
				'label'              => _x( 'Field compare', 'elementor', 'activemember360' ),
				'type'               => Elementor\Controls_Manager::HEADING
			]
		);

		$element->add_control(
			'mbr_popup_control_field_compare_condition_field',
			[
				'type'               => Elementor\Controls_Manager::SELECT,
				'options'            => $arr_crm_fields,
				'default'            => '',
				'condition'          => [ 'mbr_popup_control_field_compare_enabled' => 'yes' ],
				'frontend_available' => TRUE
			]
		);

		$element->add_control(
			'mbr_popup_control_field_compare_condition_operator',
			[
				'type'               => Elementor\Controls_Manager::SELECT,
				'options'            => [
					''                 => '---',
					'equals'           => _x( 'Equals',           'elementor', 'activemember360' ),
					'not_equal'        => _x( 'Not equal',        'elementor', 'activemember360' ),
					'greater_than'     => _x( 'Greater than',     'elementor', 'activemember360' ),
					'less_than'        => _x( 'Less than',        'elementor', 'activemember360' ),
					'greater_or_equal' => _x( 'Greater or equal', 'elementor', 'activemember360' ),
					'less_or_equal'    => _x( 'Less or equal',    'elementor', 'activemember360' ),
					'begins_with'      => _x( 'Begins with',      'elementor', 'activemember360' ),
					'ends_with'        => _x( 'Ends with',        'elementor', 'activemember360' ),
					'contains'         => _x( 'Contains',         'elementor', 'activemember360' ),
					'not_contains'     => _x( 'Not contains',     'elementor', 'activemember360' )
				],
				'default'            => '',
				'condition'          => [ 'mbr_popup_control_field_compare_enabled' => 'yes' ],
				'frontend_available' => TRUE
			]
		);

		$element->add_control(
			'mbr_popup_control_field_compare_condition_field_value',
			[
				'type'               => Elementor\Controls_Manager::TEXT,
				'condition'          => [ 'mbr_popup_control_field_compare_enabled' => 'yes' ],
				'frontend_available' => TRUE
			]
		);

		$element->add_control(
			'mbr_popup_control_field_compare_enabled',
			[
				'type'               => Elementor\Controls_Manager::SWITCHER,
				'classes'            => 'elementor-popup__display-settings__group-toggle',
				'frontend_available' => TRUE
			]
		);
	}

	













	public function register_controls_popup_timing_conditional( $element, $args )
	{
		static $arr_conditionals  = NULL;
		IF ( is_null( $arr_conditionals ) ) :
			$arr_conditionals       = apply_filters( 'mbr/conditionals/conditionals/get', [] );
		ENDIF;

		$element->add_control(
			'mbr_popup_control_conditional_heading',
			[
				'label'              => _x( 'Conditionals', 'elementor', 'activemember360' ),
				'type'               => Elementor\Controls_Manager::HEADING
			]
		);

		$element->add_control(
			'mbr_popup_control_conditional_eval',
			[
				'label'              => _x( 'Eval mode', 'elementor', 'activemember360' ),
				'type'               => Elementor\Controls_Manager::SELECT,
				'options'            => [ 'true' => _x( 'True', 'elementor', 'activemember360' ), 'false' => _x( 'False', 'elementor', 'activemember360' ) ],
				'condition'          => [ 'mbr_popup_control_conditional_enabled' => 'yes' ],
				'default'            => 'true'
			]
		);

		$element->add_control(
			'mbr_popup_control_conditional_id',
			[
				'type'               => Elementor\Controls_Manager::SELECT2,
				'options'            => ! empty( $arr_conditionals ) ? [ 0 => '---' ] + $arr_conditionals : [ 0 => '---' ],
				'condition'          => [ 'mbr_popup_control_conditional_enabled' => 'yes' ],
				'default'            => 0
			]
		);

		$element->add_control(
			'mbr_popup_control_conditional_enabled',
			[
				'type'               => Elementor\Controls_Manager::SWITCHER,
				'classes'            => 'elementor-popup__display-settings__group-toggle',
				'frontend_available' => TRUE
			]
		);

	}

	













	public function element_check_permissions( $should_render, $element )
	{
		IF ( defined( 'MBRADMIN' ) AND MBRADMIN ) :
			return $should_render;
		ENDIF;

		$element_settings = $element->get_settings();
		IF ( ! $this->match_element_content( $element_settings ) ) :
			return FALSE;
		ENDIF;

		return $should_render;
	}

	












	public function get_template( $post_id )
	{
		IF ( ( defined( 'MBRADMIN') AND MBRADMIN ) OR MBR()->skip_visual_editors() ) :
			return $post_id;
		ENDIF;

		$popup_settings = get_post_meta( $post_id, '_elementor_popup_display_settings', TRUE );

		$arr_settings   = [];
		$arr_settings['mbr_element_control_mode']                     = 'popup';
		IF ( ! empty( $popup_settings['timing']['mbr_popup_control_display_enabled'] ) AND checktrue( $popup_settings['timing']['mbr_popup_control_display_enabled'] ) ) :
			$arr_settings['mbr_element_control_display_if']             = $popup_settings['timing']['mbr_popup_control_display_condition'];
		ENDIF;
		IF ( ! empty( $popup_settings['timing']['mbr_popup_control_pos_tags_enabled'] ) AND checktrue( $popup_settings['timing']['mbr_popup_control_pos_tags_enabled'] ) ) :
			$arr_settings['mbr_element_control_pos_tags']               = $popup_settings['timing']['mbr_popup_control_pos_tags_condition'];
		ENDIF;
		IF ( ! empty( $popup_settings['timing']['mbr_popup_control_neg_tags_enabled'] ) AND checktrue( $popup_settings['timing']['mbr_popup_control_neg_tags_enabled'] ) ) :
			$arr_settings['mbr_element_control_neg_tags']               = $popup_settings['timing']['mbr_popup_control_neg_tags_condition'];
		ENDIF;
		IF ( ! empty( $popup_settings['timing']['mbr_popup_control_field_compare_enabled'] ) AND checktrue( $popup_settings['timing']['mbr_popup_control_field_compare_enabled'] ) ) :
			$arr_settings['mbr_element_control_compare_field_operator'] = $popup_settings['timing']['mbr_popup_control_field_compare_condition_operator'];
			$arr_settings['mbr_element_control_compare_field']          = $popup_settings['timing']['mbr_popup_control_field_compare_condition_field'];
			$arr_settings['mbr_element_control_compare_field_value']    = $popup_settings['timing']['mbr_popup_control_field_compare_condition_field_value'];
		ENDIF;
		IF ( ! empty( $popup_settings['timing']['mbr_popup_control_conditional_enabled'] ) AND checktrue( $popup_settings['timing']['mbr_popup_control_conditional_enabled'] ) ) :
			$arr_settings['mbr_element_control_conditional_eval']       = isset( $popup_settings['timing']['mbr_popup_control_conditional_eval'] ) ? $popup_settings['timing']['mbr_popup_control_conditional_eval'] : 'true';
			$arr_settings['mbr_element_control_conditional_id']         = $popup_settings['timing']['mbr_popup_control_conditional_id'];
		ENDIF;

		IF ( ! empty( $arr_settings ) ) :
			IF ( ! $this->match_element_content( $arr_settings ) ) :
				return FALSE;
			ENDIF;
		ENDIF;

		return $post_id;
	}

	










	private function match_element_content( $settings )
	{
		IF ( ( ! empty( $settings['mbr_element_control_mode'] ) AND 'conditional' == $settings['mbr_element_control_mode'] ) OR ! empty( $settings['mbr_element_control_mode'] ) AND 'popup' == $settings['mbr_element_control_mode'] ) :
			IF ( ! empty( $settings['mbr_element_control_conditional_id'] ) AND ! empty( $settings['mbr_element_control_conditional_eval'] ) ) :
				$match = apply_filters( 'mbr/conditionals/conditional/check', NULL, $settings['mbr_element_control_conditional_id'] );
				IF ( 'true' == $settings['mbr_element_control_conditional_eval'] AND FALSE === $match ) :
					return FALSE;
				ELSEIF ( 'false' == $settings['mbr_element_control_conditional_eval'] AND FALSE !== $match ) :
					return FALSE;
				ENDIF;
			ENDIF;
		ENDIF;

		IF ( empty( $settings['mbr_element_control_mode'] ) OR ( ! empty( $settings['mbr_element_control_mode'] ) AND 'individual' == $settings['mbr_element_control_mode'] ) OR ! empty( $settings['mbr_element_control_mode'] ) AND 'popup' == $settings['mbr_element_control_mode'] ) :
			IF ( 'always' <> $settings['mbr_element_control_display_if'] ) :
				IF ( 'never' == $settings['mbr_element_control_display_if'] ) :
					return FALSE;
				ENDIF;
				IF ( 'is_logged_in' == $settings['mbr_element_control_display_if'] AND ! is_user_logged_in() ) :
					return FALSE;
				ENDIF;
				IF ( 'not_logged_in' == $settings['mbr_element_control_display_if'] AND is_user_logged_in() ) :
					return FALSE;
				ENDIF;
			ENDIF;

			IF ( ! empty( $settings['mbr_element_control_pos_tags'] ) AND is_array( $settings['mbr_element_control_pos_tags'] ) ) :
				IF ( ! mbr_has_tags( $settings['mbr_element_control_pos_tags'] ) ) :
					return FALSE;
				ENDIF;
			ENDIF;

			IF ( ! empty( $settings['mbr_element_control_neg_tags'] ) AND is_array( $settings['mbr_element_control_neg_tags'] ) ) :
				IF ( mbr_has_tags( $settings['mbr_element_control_neg_tags'] ) ) :
					return FALSE;
				ENDIF;
			ENDIF;

			$operator      = $settings['mbr_element_control_compare_field_operator'];
			$field         = $settings['mbr_element_control_compare_field'];
			$compare_value = $settings['mbr_element_control_compare_field_value'];
			IF ( ! empty( $operator ) AND ! empty( $field ) ) :
				$remote_logged_in = apply_filters( 'mbr/contact_id', NULL );
				IF ( empty( $remote_logged_in ) ) :
					return FALSE;
				ENDIF;

				$field_value = apply_filters( 'mbr/get_contact_field', $field );
				IF ( 'equals' == $operator ) :
					$match = ( $field_value == $compare_value ? TRUE : FALSE );
				ELSEIF ( 'not_equal' == $operator ) :
					$match = ( $field_value <> $compare_value ? TRUE : FALSE );
				ELSEIF ( 'less_than' == $operator ) :
					$match = ( $field_value <  $compare_value ? TRUE : FALSE );
				ELSEIF ( 'greater_than' == $operator ) :
					$match = ( $field_value >  $compare_value ? TRUE : FALSE );
				ELSEIF ( 'greater_or_equal' == $operator ) :
					$match = ( $field_value >= $compare_value ? TRUE : FALSE );
				ELSEIF ( 'less_or_equal' == $operator ) :
					$match = ( $field_value <= $compare_value ? TRUE : FALSE );
				ELSEIF ( 'begins_with' == $operator ) :
					$match = ( substr( $field_value,0, strlen( $compare_value ) ) == $compare_value ? TRUE : FALSE );
				ELSEIF ( 'ends_with' == $operator ) :
					$match = ( substr( $field_value,strlen( $compare_value ) * -1 ) == $compare_value ? TRUE : FALSE);
				ELSEIF ( 'contains' == $operator ) :
					$match = ( FALSE !== stripos( $field_value, $compare_value ) ? TRUE : FALSE );
				ELSEIF ( 'not_contains' == $operator ) :
					$match = ( FALSE !== stripos( $field_value, $compare_value ) ? FALSE : TRUE );
				ELSE :
					$match = FALSE;
				ENDIF;
				IF ( empty( $match ) ) :
					return FALSE;
				ENDIF;
			ENDIF;

			IF ( ! empty( $settings['mbr_element_control_php_statement'] ) ) :
				$php_statement = trim( $settings['mbr_element_control_php_statement'] );
				$php_statement = ( stristr( $php_statement,  'return' ) ) ? $php_statement : 'return (' . $php_statement . ');';
				$php_statement = stripcslashes( $php_statement );
				IF ( ! eval( $php_statement ) ) :
					return FALSE;
				ENDIF;
			ENDIF;
		ENDIF;

		return TRUE;
	}

}




$GLOBALS['mbr_elementor'] = mbr_elementor::getInstance();
