<?php
class mbrErrHdlr
{
	use TRAIT__getInstance;

	public static function mbr_error_exit($e = '')
	{
		// Needs to be included if system crashes BEFORE user.php and pluggable.php have loaded
		include_once ABSPATH . '/wp-includes/user.php';
		include_once ABSPATH . '/wp-includes/pluggable.php';

		$error = mbrErrHdlr::catch_error_messages( $e );

		





		IF ( ! empty( $error ) ) :
			$error->type      = 0;
			$error->file      = basename( $error->file );
		ELSEIF ( $last_error = error_get_last() ) :
			$error->type      = $last_error['type'];
			$error->message   = $last_error['message'];
			$error->line      = $last_error['line'];
			$error->file      = basename( $last_error['file'] );
		ELSE :
			$error->type      = 0;
			$error->message   = __( 'An unknown error has occurred', 'activemember360' );
			$error->line      = __( 'unknown', 'activemember360' );
			$error->file      = __( 'unknown', 'activemember360' );
		ENDIF;

		IF ( !is_admin() ) :
			wp_die(
				"<img src='" . plugins_url( 'img/activemember360_slogan.jpg', __FILE__ ) . "' style='width:100%;' />"
				. '<div style="word-wrap:break-word;">'
				. "<p><strong>{$error->message}</strong></p>"
				. "<p>" . sprintf( __( '<strong>Location:</strong> Line %s in file %s', 'activemember360' ), $error->line, $error->file ) . "</p>"
				. '</div>'
				. "<p style='text-align:center;'><a href='" . $_SERVER['REQUEST_URI'] . "' style='font-weight: bold;'>" . __( 'Click here to return', 'activemember360' ) . "</a></p>"
			);
		ELSE:
			echo '<div class="notice notice-error is-dismissible"><p><strong>' . $error->message. '</strong><br />'. sprintf( __( '<strong>Location:</strong> Line %s in file %s', 'activemember360' ), $error->line, $error->file ) . '</p></div>';
		ENDIF;
	}

	public static function mbr_fatal_error_handler( $exception = 'hello' )
	{
		$error            = error_get_last();
		IF ( ! empty( $GLOBALS['ERROR_LAST_TRY'] ) ) :
			$ERROR_LAST_TRY = $GLOBALS['ERROR_LAST_TRY'];
			unset( $GLOBALS['ERROR_LAST_TRY'] );
		ENDIF;

		IF ( $error !== NULL AND in_array( $error['type'], [ E_ERROR, E_CORE_ERROR, E_COMPILE_ERROR, E_PARSE ] ) ) :
			$ferror = new stdClass();
			$ferror->source = 'activemember360';
			$ferror->type   = $error['type'];

			IF ( ! empty( $ERROR_LAST_TRY ) ) :
				$ferror->message = $ERROR_LAST_TRY;
			ELSE :
				$ferror->message = $error['message'];
			ENDIF;

			$ferror->line = $error['line'];
			$ferror->file = $error['file'];
			mbrErrHdlr::mbr_error_exit( $ferror );
		ENDIF;
	}

	public static function create_error_std_object( $message, $line, $file )
	{
		$e           = new stdClass();
		$e->message  = $message;
		$e->line     = $line;
		$e->file     = $file;
		$e->source   = 'activemember360';

		return $e;
	}

	// Central error message processing
	public static function catch_error_messages( $error )
	{
		IF ( empty( $error ) OR ! is_object( $error ) ) :
			IF ( $error = error_get_last() ) :
				$e           = new stdClass();
				$e->message  = $error['message'];
				$e->line     = $error['line'];
				$e->file     = basename( $error['file'] );
			ELSE :
				$e           = new stdClass();
				$e->message  = $GLOBALS['php_errormsg'];
				$e->line     = 0;
				$e->file     = 'unknown';
			ENDIF;
		ELSE :
			IF ( ! empty( $error->source ) AND $error->source == 'activemember360' ) :
				$e           = new stdClass();
				$e->message  = $error->message;
				$e->line     = $error->line;
				$e->file     = $error->file;
			ELSE :
				$e           = new stdClass();
				$e->message  = $error->getMessage();
				$e->code     = $error->getCode();
				$e->file     = $error->getFile();
				$e->line     = $error->getLine();
				$e->trace    = $error->getTrace();
				$e->previous = $error->getPrevious();
			ENDIF;
		ENDIF;

		IF ( $e->message == 'COULD-NOT-VERIFY-NONCE' ) :
			$e->message = __( 'Could not verify nonce.', 'activemember360' );
		ELSEIF ( $e->message == 'COULD-NOT-CREATE-ORDER' ) :
			$e->message = __( 'Could not create order, please contact the system administrator.', 'activemember360' );
		ELSEIF ( $e->message == 'NO-PRODUCT-ID' ) :
			$e->message = __( 'No product id given.', 'activemember360' );
		ELSEIF ( $e->message == 'INACTIVE-PRODUCT' ) :
			$e->message = __( 'Product inactive.', 'activemember360' );
		ELSEIF ( $e->message == 'NO-AMOUNT-SPECIFIED' ) :
			$e->message = __( 'No amount specified.', 'activemember360' );
		ELSEIF ( $e->message == 'PRODUCT-HAS-PLAN-AND-AMOUNT' ) :
			$e->message = __( 'Product type unknown.', 'activemember360' );
		ELSEIF ( $e->message == 'COULD-NOT-RETRIEVE-PLAN' ) :
			$e->message = __( 'Could not retrieve plan.', 'activemember360' );
		ELSEIF ( $e->message == 'STRIPE-COULD-NOT-CREATE-CUSTOMER' ) :
			$e->message = __( 'Could not create Stripe Customer.', 'activemember360' );
		ELSEIF ( $e->message == 'STRIPE-COULD-NOT-CREATE-CARD' ) :
			$e->message = __( 'Could not create Stripe Card.', 'activemember360' );
		ELSEIF ( $e->message == 'STRIPE-COULD-NOT-CREATE-OR-FIND-CUSTOMER' ) :
			$e->message = __( 'A customer could not be created, or no customer was found.', 'activemember360' );
		ELSEIF ( $e->message == 'STRIPE-COULD-NOT-GET-ACCOUNT-DETAILS' ) :
			$e->message = __( 'Could not retrieve Stripe Account Details.', 'activemember360' );
		ELSEIF ( $e->message == 'STRIPE-API-SECRET-KEY-MISSING' ) :
			$e->message = __( 'ActiveMember360 was unable to authenticate with Stripe using an empty secret key.', 'activemember360' );
		ELSEIF ( $e->message == 'STRIPE-API-SECRET-KEY-WRONG-FORMAT' ) :
			$e->message = __( 'ActiveMember360 was unable to authenticate with Stripe using an incorrect secret key.', 'activemember360' );
		ELSEIF ( $e->message == 'STRIPE-API-SECRET-KEY-LIVE-CONNECTION-ERROR' ) :
			$e->message = __( 'ActiveMember360 was unable to authenticate with Stripe using the current <em>LIVE</em> secret key provided.', 'activemember360' );
		ELSEIF ( $e->message == 'STRIPE-API-SECRET-KEY-TEST-CONNECTION-ERROR' ) :
			$e->message = __( 'ActiveMember360 was unable to authenticate with Stripe using the current <em>TEST</em> secret key provided.', 'activemember360' );
		ELSEIF ( $e->message == 'STRIPE-API-SECRET-KEY-GENERAL-CONNECTION-ERROR' ) :
			$e->message = __( 'ActiveMember360 was unable to authenticate with Stripe using the current settings.', 'activemember360' );
		ENDIF;

		return $e;
	}

	


	














} // end class
$mbrErrHdlr = mbrErrHdlr::getInstance();
