<?php









final class mbr_gamipress {

	use TRAIT__getInstance;

	









	public function _load()
	{
		function MBRGAMI()
		{
			IF ( empty( $GLOBALS['mbr_gamipress' ] ) ) :
				$GLOBALS['mbr_gamipress'] = mbr_gamipress::getInstance();
			ENDIF;

			return $GLOBALS['mbr_gamipress'];
		}
	}

	










	public function plugins_loaded()
	{
		IF ( ! defined( 'GAMIPRESS_VER' ) ) :
			return NULL;
		ENDIF;

		add_action( 'admin_enqueue_scripts',                                [ $this, 'admin_enqueue_scripts' ],                      9999, 0 );
		add_filter( 'mbr/cpt/integration/get',                              [ $this, 'remove_gamipress_post_types' ],                9999, 1 );

		add_filter( 'gamipress_activity_triggers',                          [ $this, 'custom_activity_triggers' ],                      0, 1 );
		add_filter( 'gamipress_activity_trigger_label',                     [ $this, 'custom_activity_trigger_label' ],                 0, 3 );
		add_filter( 'gamipress_requirement_object',                         [ $this, 'requirement_object' ],                         9999, 2 );
		add_action( 'gamipress_requirement_ui_html_after_achievement_post', [ $this, 'requirement_ui_fields' ],                        10, 2 );
		add_action( 'gamipress_ajax_update_requirement',                    [ $this, 'requirement_update' ],                           10, 2 );
		add_action( 'init',                                                 [ $this, 'requirement_event_listener' ],                 9999, 0 );
		add_filter( 'user_has_access_to_achievement',                       [ $this, 'requirement_user_has_access_to_achievement' ],   10, 6 );

		add_filter( 'gamipress_achievement_data_fields',                    [ $this, 'achievement_earned_data_fields' ],               10, 1 );
		add_action( 'cmb2_render_achievement_earned_actions',               [ $this, 'achievement_earned_actions_cmb2_render' ],       10, 5 );
		add_action( 'save_post',                                            [ $this, 'achievement_earned_actions_save' ],              10, 1 );
		add_action( 'gamipress_award_achievement',                          [ $this, 'achievement_awarded_to_user' ],                  10, 5 );

		add_filter( 'gamipress_rank_data_fields',                           [ $this, 'rank_earned_data_fields' ],                      10, 1 );
		add_action( 'cmb2_render_rank_earned_actions',                      [ $this, 'rank_earned_actions_cmb2_render' ],              10, 5 );
		add_action( 'save_post',                                            [ $this, 'rank_earned_actions_save' ],                     10, 1 );
		add_action( 'gamipress_update_user_rank',                           [ $this, 'rank_awarded_to_user' ],                         10, 5 );

		add_action( 'add_meta_boxes',                                       [ $this, 'points_type_metabox_store_points_to_crm' ],      10, 0 );
		add_action( 'save_post',                                            [ $this, 'points_type_metabox_store_points_to_crm_save' ], 10, 1 );
		add_action( 'gamipress_update_user_points',                         [ $this, 'points_type_store_points_to_crm' ],              10, 8 );
	}

	






	public function get_gamipress_post_types()
	{
		$arr_gamipress_post_types     = [ 'points-type', 'achievement-type', 'rank-type' ];
		FOREACH ( gamipress_get_achievement_types_slugs() AS $key => $post_type ) :
			$arr_gamipress_post_types[] = $post_type;
		ENDFOREACH;

		FOREACH ( gamipress_get_rank_types_slugs() AS $key => $post_type ) :
			$arr_gamipress_post_types[] = $post_type;
		ENDFOREACH;

		FOREACH ( gamipress_get_points_types_slugs() AS $key => $post_type ) :
			$arr_gamipress_post_types[] = $post_type;
		ENDFOREACH;

		FOREACH ( gamipress_get_requirement_types_slugs() AS $key => $post_type ) :
			$arr_gamipress_post_types[] = $post_type;
		ENDFOREACH;

		return $arr_gamipress_post_types;
	}

	








	public function remove_gamipress_post_types( $arr_post_types )
	{
		IF ( ! empty( $arr_post_types ) AND is_array( $arr_post_types ) ) :
			FOREACH ( $arr_post_types AS $key => $post_type ) :
				IF ( in_array( $post_type, $this->get_gamipress_post_types() ) ) :
					unset( $arr_post_types[ $key ] );
				ENDIF;
			ENDFOREACH;
		ENDIF;

		return $arr_post_types;
	}

	










	public function admin_enqueue_scripts()
	{
		global $post_type;

		IF ( ! in_array( $post_type, $this->get_gamipress_post_types() ) ) :
			return NULL;
		ENDIF;

		wp_enqueue_style( 'mbr-gamipress', plugins_url( 'css/gamipress.css', __FILE__ ), [], MBRVERSION );
		wp_enqueue_script( 'mbr-gamipress', plugins_url( 'js/gamipress.js', __FILE__ ), [ 'jquery', 'gamipress-select2-js' ], MBRVERSION, TRUE );
	}

	










	public function custom_activity_triggers( $triggers )
	{
		$triggers['ActiveMember360'] = [
			'mbr_gamipress_contact_has_tag'       => _x( 'Contact has tag(s)',               'gamipress', 'activemember360' ),
			'mbr_gamipress_contact_in_list'       => _x( 'Contact is subscribed to list(s)', 'gamipress', 'activemember360' ),
			'mbr_gamipress_contact_field_compare' => _x( 'Contact field comparison',         'gamipress', 'activemember360' )
		];

		return $triggers;
	}

	












	public function custom_activity_trigger_label( $title, $requirement_id, $requirement )
	{
		static $arr_crm_tags      = NULL;
		IF ( is_null( $arr_crm_tags ) ) :
			$arr_crm_tags           = apply_filters( 'mbr/site_tags/get', NULL );
		ENDIF;

		static $arr_crm_lists     = NULL;
		IF ( is_null( $arr_crm_lists ) ) :
			$arr_crm_lists          = apply_filters( 'mbr/site_lists/get', NULL );
		ENDIF;

		IF ( 'mbr_gamipress_contact_has_tag' == $requirement['trigger_type'] ) :
			$arr_tags               = [];
			IF ( ! empty( $requirement['mbr_gamipress_requirement_contact_has_tag'] ) AND is_array( $requirement['mbr_gamipress_requirement_contact_has_tag'] ) ) :
				FOREACH ( $requirement['mbr_gamipress_requirement_contact_has_tag'] AS $key => $tag_id ) :
					$arr_tags[]         = '#' . $tag_id . ' - ' . $arr_crm_tags[ $tag_id ];
				ENDFOREACH;
			ENDIF;
			$contact_has_tag        = ! empty( $arr_tags ) ? implode( ', ', $arr_tags ) : '';
			$contact_has_tag_mode   = isset( $requirement['mbr_gamipress_requirement_contact_has_tag_mode'] ) ? $requirement['mbr_gamipress_requirement_contact_has_tag_mode']                  : '';

			return sprintf( _x( 'Contact has %s ActiveCampaign tag(s) %s', 'gamipress', 'activemember360' ), $contact_has_tag_mode, $contact_has_tag );
		ELSEIF ( 'mbr_gamipress_contact_in_list' == $requirement['trigger_type'] ) :
			$arr_lists              = [];
			IF ( ! empty( $requirement['mbr_gamipress_requirement_contact_in_list'] ) AND is_array( $requirement['mbr_gamipress_requirement_contact_in_list'] ) ) :
				FOREACH ( $requirement['mbr_gamipress_requirement_contact_in_list'] AS $key => $list_id ) :
					$arr_lists[]        = '#' . $list_id . ' - ' . $arr_crm_lists[ $list_id ];
				ENDFOREACH;
			ENDIF;

			$contact_in_list        = ! empty( $arr_lists ) ? implode( ', ', $arr_lists ) : '';
			$contact_in_list_mode   = isset( $requirement['mbr_gamipress_requirement_contact_in_list_mode'] ) ? $requirement['mbr_gamipress_requirement_contact_in_list_mode']                  : '';

			return sprintf( _x( 'Contact is subscribed to %s ActiveCampaign list(s) %s', 'gamipress', 'activemember360' ), $contact_in_list_mode, $contact_in_list );
		ELSEIF ( 'mbr_gamipress_contact_field_compare' == $requirement['trigger_type'] ) :
			$contact_field_compare  = isset( $requirement['mbr_gamipress_requirement_contact_field_compare'] )  ? $requirement['mbr_gamipress_requirement_contact_field_compare']  : '';
			$contact_field_operator = isset( $requirement['mbr_gamipress_requirement_contact_field_operator'] ) ? $requirement['mbr_gamipress_requirement_contact_field_operator'] : '';
			$contact_field_value    = isset( $requirement['mbr_gamipress_requirement_contact_field_value'] )    ? $requirement['mbr_gamipress_requirement_contact_field_value']    : '';

			return sprintf( _x( 'The ActiveCampaign Contact field %s %s %s', 'gamipress', 'activemember360' ), $contact_field_compare, $contact_field_operator, $contact_field_value );
		ENDIF;

		return $title;
	}

	











	public function requirement_object( $requirement, $requirement_id )
	{
		IF ( isset( $requirement['trigger_type'] ) ) :
			$mbr_trigger_type   = FALSE;
			IF ( 'mbr_gamipress_contact_has_tag' === $requirement['trigger_type'] ) :
				$mbr_trigger_type = TRUE;
				$requirement['mbr_gamipress_requirement_contact_has_tag']        = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_has_tag',        true );
				$requirement['mbr_gamipress_requirement_contact_has_tag_mode']   = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_has_tag_mode',   true );
			ELSEIF ( 'mbr_gamipress_contact_in_list' === $requirement['trigger_type'] ) :
				$mbr_trigger_type = TRUE;
				$requirement['mbr_gamipress_requirement_contact_in_list']        = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_in_list',        true );
				$requirement['mbr_gamipress_requirement_contact_in_list_mode']   = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_in_list_mode',   true );
			ELSEIF ( 'mbr_gamipress_contact_field_compare' === $requirement['trigger_type'] ) :
				$mbr_trigger_type = TRUE;
				$requirement['mbr_gamipress_requirement_contact_field_compare']  = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_compare',  true );
				$requirement['mbr_gamipress_requirement_contact_field_operator'] = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_operator', true );
				$requirement['mbr_gamipress_requirement_contact_field_value']    = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_value',    true );
			ENDIF;

			IF ( $mbr_trigger_type AND isset( $requirement['maximum_earnings'] ) ) :
				$requirement['maximum_earnings'] = 0;
			ENDIF;
		ENDIF;

		return $requirement;
	}

	











	public function requirement_ui_fields( $requirement_id, $post_id )
	{
		static $arr_crm_tags      = NULL;
		IF ( is_null( $arr_crm_tags ) ) :
			$arr_crm_tags           = apply_filters( 'mbr/site_tags/get', NULL );
		ENDIF;

		static $arr_crm_lists     = NULL;
		IF ( is_null( $arr_crm_lists ) ) :
			$arr_crm_lists          = apply_filters( 'mbr/site_lists/get', NULL );
		ENDIF;

		static $arr_crm_fields    = NULL;
		IF ( is_null( $arr_crm_fields ) ) :
			$arr_tmp_regular_fields = apply_filters( 'mbr/site_contact_std_fields/get', NULL );
			IF ( ! empty( $arr_tmp_regular_fields ) ) :
				FOREACH ( $arr_tmp_regular_fields AS $filler => $field_name ) :
					$arr_crm_fields[ $field_name ] = $field_name;
				ENDFOREACH;
			ENDIF;
			$arr_tmp_custom_fields  = apply_filters( 'mbr/site_custom_fields/get', NULL );
			IF ( ! empty( $arr_tmp_custom_fields ) ) :
				FOREACH ( $arr_tmp_custom_fields AS $field_name => $arr_field ) :
					$arr_crm_fields[ strtolower( $arr_field['perstag'] ) ] = $arr_field['title'];
				ENDFOREACH;
			ENDIF;
		ENDIF;

		$arr_field_compare_operators = [
			'equals'                   => _x( 'Equals',           'gamipress', 'activemember360' ),
			'not_equal'                => _x( 'Not equal',        'gamipress', 'activemember360' ),
			'greater_than'             => _x( 'Greater than',     'gamipress', 'activemember360' ),
			'less_than'                => _x( 'Less than',        'gamipress', 'activemember360' ),
			'greater_or_equal'         => _x( 'Greater or equal', 'gamipress', 'activemember360' ),
			'less_or_equal'            => _x( 'Less or equal',    'gamipress', 'activemember360' ),
			'begins_with'              => _x( 'Begins with',      'gamipress', 'activemember360' ),
			'ends_with'                => _x( 'Ends with',        'gamipress', 'activemember360' ),
			'contains'                 => _x( 'Contains',         'gamipress', 'activemember360' ),
			'not_contains'             => _x( 'Not contains',     'gamipress', 'activemember360' )
		];

		$arr_contact_has_tag         = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_has_tag',        true );
		$contact_has_tag_mode        = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_has_tag_mode',   true );

		$arr_contact_in_list         = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_in_list',        true );
		$contact_in_list_mode        = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_in_list_mode',   true );

		$contact_field_compare       = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_compare',  true );
		$contact_field_operator      = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_operator', true );
		$contact_field_value         = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_value',    true );

		echo '<select name="mbr_gamipress_requirement_contact_has_tag_mode" class="select-mbr-gamipress-requirement-contact-has-tag-mode">';
		FOREACH ( [ 'any' => _x( 'Any', 'gamipress', 'activemember360' ), 'all' => _x( 'All', 'gamipress', 'activemember360' ) ] AS $value => $label ) :
			echo '<option value="' . $value . '" ' . selected( $contact_has_tag_mode, $value, FALSE ) . '>' . $label . '</option>';
		ENDFOREACH;
		echo '</select>';

		echo '<select name="mbr_gamipress_requirement_contact_has_tag[]" multiple="multiple" class="select-mbr-gamipress-requirement-contact-has-tag">';
		FOREACH ( $arr_crm_tags AS $tag_id => $tag_name ) :
			IF ( ! empty( $arr_contact_has_tag ) AND is_array( $arr_contact_has_tag ) ) :
				$selected = in_array( $tag_id, $arr_contact_has_tag ) ? ' selected="selected"' : '';
			ENDIF;
			echo '<option value="' . $tag_id . '" ' . $selected . '>#' . $tag_id . ' - ' . $tag_name . '</option>';
		ENDFOREACH;
		echo '</select>';

		echo '<select name="mbr_gamipress_requirement_contact_in_list_mode" class="select-mbr-gamipress-requirement-contact-in-list-mode">';
		FOREACH ( [ 'any' => _x( 'Any', 'gamipress', 'activemember360' ), 'all' => _x( 'All', 'gamipress', 'activemember360' ) ] AS $value => $label ) :
			echo '<option value="' . $value . '" ' . selected( $contact_in_list_mode, $value, FALSE ) . '>' . $label . '</option>';
		ENDFOREACH;
		echo '</select>';

		echo '<select name="mbr_gamipress_requirement_contact_in_list[]" multiple="multiple" class="select-mbr-gamipress-requirement-contact-in-list">';
		FOREACH ( $arr_crm_lists AS $list_id => $list_name ) :
			IF ( ! empty( $arr_contact_in_list ) AND is_array( $arr_contact_in_list ) ) :
				$selected = in_array( $list_id, $arr_contact_in_list ) ? ' selected="selected"' : '';
			ENDIF;
			echo '<option value="' . $list_id . '" ' . $selected . '>#' . $list_id . ' - ' . $list_name . '</option>';
		ENDFOREACH;
		echo '</select>';

		echo '<select name="mbr_gamipress_requirement_contact_field_compare" class="select-mbr-gamipress-requirement-contact-field-compare">';
		FOREACH ( $arr_crm_fields AS $perstag => $title ) :
			echo '<option value="' . $perstag . '" ' . selected( $contact_field_compare, $perstag, FALSE ) . '>' . $perstag . '</option>';
		ENDFOREACH;
		echo '</select>';

		echo '<select name="mbr_gamipress_requirement_contact_field_operator" class="select-mbr-gamipress-requirement-contact-field-operator">';
		FOREACH ( $arr_field_compare_operators AS $operator => $label ) :
			echo '<option value="' . $operator . '" ' . selected( $contact_field_operator, $operator, FALSE ) . '>' . $label . '</option>';
		ENDFOREACH;
		echo '</select>';

		echo '<input type="text" name="mbr_gamipress_requirement_contact_field_value" class="input-mbr-gamipress-requirement-contact-field-value" value="' . $contact_field_value . '" />';
	}

	











	public function requirement_update( $requirement_id, $requirement )
	{
		IF ( isset( $requirement['trigger_type'] ) ) :
			$mbr_trigger_type   = FALSE;
			IF ( 'mbr_gamipress_contact_has_tag' === $requirement['trigger_type'] ) :
				$mbr_trigger_type = TRUE;
				update_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_has_tag',        $requirement['mbr_gamipress_requirement_contact_has_tag'] );
				update_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_has_tag_mode',   $requirement['mbr_gamipress_requirement_contact_has_tag_mode'] );
			ELSEIF ( 'mbr_gamipress_contact_in_list' === $requirement['trigger_type'] ) :
				$mbr_trigger_type = TRUE;
				update_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_in_list',        $requirement['mbr_gamipress_requirement_contact_in_list'] );
				update_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_in_list_mode',   $requirement['mbr_gamipress_requirement_contact_in_list_mode'] );
			ELSEIF ( 'mbr_gamipress_contact_field_compare' === $requirement['trigger_type'] ) :
				$mbr_trigger_type = TRUE;
				update_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_compare',  $requirement['mbr_gamipress_requirement_contact_field_compare'] );
				update_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_operator', $requirement['mbr_gamipress_requirement_contact_field_operator'] );
				update_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_value',    $requirement['mbr_gamipress_requirement_contact_field_value'] );
			ENDIF;

			IF ( $mbr_trigger_type AND isset( $requirement['maximum_earnings'] ) ) :
				update_post_meta( $requirement_id, '_gamipress_maximum_earnings', 1 );
			ENDIF;
		ENDIF;
	}

	








	public function requirement_event_listener()
	{
		IF ( MBRADMIN ) :
			return NULL;
		ENDIF;

		$remote_logged_in = apply_filters( 'mbr/contact_id', NULL );
		IF ( empty( $remote_logged_in ) ) :
			return NULL;
		ENDIF;

		gamipress_trigger_event( [ 'event' => 'mbr_gamipress_contact_has_tag' ] );
		gamipress_trigger_event( [ 'event' => 'mbr_gamipress_contact_in_list' ] );
		gamipress_trigger_event( [ 'event' => 'mbr_gamipress_contact_field_compare' ] );
	}

	















	public function requirement_user_has_access_to_achievement( $return = false, $user_id = 0, $requirement_id = 0, $trigger = '', $site_id = 0, $args = [] )
	{
		IF ( FALSE === $return ) :
			return $return;
		ENDIF;

		IF ( ! in_array( get_post_type( $requirement_id ), gamipress_get_requirement_types_slugs() ) ) :
			return $return;
		ENDIF;

		IF ( ! in_array( $trigger, [ 'mbr_gamipress_contact_has_tag', 'mbr_gamipress_contact_in_list', 'mbr_gamipress_contact_field_compare' ] ) ) :
			return $return;
		ENDIF;

		IF ( 'mbr_gamipress_contact_has_tag' == $trigger ) :
			$arr_contact_has_tag  = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_has_tag',      true );
			$contact_has_tag_mode = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_has_tag_mode', true );
			IF ( ! empty( $arr_contact_has_tag ) AND is_array( $arr_contact_has_tag )) :
				IF ( mbr_has_tags( $arr_contact_has_tag, $contact_has_tag_mode ) ) :
					return TRUE;
				ELSE:
					return FALSE;
				ENDIF;
			ENDIF;
		ELSEIF ( 'mbr_gamipress_contact_in_list' == $trigger ) :
			$arr_lists            = apply_filters( 'mbr/contact/lists', NULL );
			$arr_contact_in_list  = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_in_list',      true );
			$contact_in_list_mode = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_in_list_mode', true );

			IF ( 'all' === $contact_in_list_mode ) :
				$needed = count( $arr_contact_in_list );
			ELSE :
				$needed = 1;
			ENDIF;

			$found    = 0;
			FOREACH ( $arr_contact_in_list AS $key => $list_id ) :
				IF ( array_key_exists( $list_id, $arr_lists ) ) :
					IF ( '1' !== $arr_lists[ $list_id ] ) :
						continue;
					ENDIF;
					$found++;
					IF ( $found >= $needed ) :
						return TRUE;
					ENDIF;
				ENDIF;
			ENDFOREACH;

			return FALSE;
		ELSEIF ( 'mbr_gamipress_contact_field_compare' == $trigger ) :
			$field         = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_compare',  true );
			$operator      = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_operator', true );
			$compare_value = get_post_meta( $requirement_id, '_mbr_gamipress_requirement_contact_field_value',    true );

			$field_value   = apply_filters( 'mbr/get_contact_field', $field );
			IF ( 'equals' == $operator ) :
				$match = ( $field_value == $compare_value ? TRUE : FALSE );
			ELSEIF ( 'not_equal' == $operator ) :
				$match = ( $field_value <> $compare_value ? TRUE : FALSE );
			ELSEIF ( 'less_than' == $operator ) :
				$match = ( $field_value <  $compare_value ? TRUE : FALSE );
			ELSEIF ( 'greater_than' == $operator ) :
				$match = ( $field_value >  $compare_value ? TRUE : FALSE );
			ELSEIF ( 'greater_or_equal' == $operator ) :
				$match = ( $field_value >= $compare_value ? TRUE : FALSE );
			ELSEIF ( 'less_or_equal' == $operator ) :
				$match = ( $field_value <= $compare_value ? TRUE : FALSE );
			ELSEIF ( 'begins_with' == $operator ) :
				$match = ( substr( $field_value,0, strlen( $compare_value ) ) == $compare_value ? TRUE : FALSE );
			ELSEIF ( 'ends_with' == $operator ) :
				$match = ( substr( $field_value,strlen( $compare_value ) * -1 ) == $compare_value ? TRUE : FALSE);
			ELSEIF ( 'contains' == $operator ) :
				$match = ( FALSE !== stripos( $field_value, $compare_value ) ? TRUE : FALSE );
			ELSEIF ( 'not_contains' == $operator ) :
				$match = ( FALSE !== stripos( $field_value, $compare_value ) ? FALSE : TRUE );
			ELSE :
				$match = FALSE;
			ENDIF;

			return $match;
		ENDIF;

		return $return;
	}

	










	public function achievement_earned_data_fields( $fields )
	{
		$fields['_mbr_gamipress_achievement_earned_apply_tags'] = [
			'name' => 'ActiveMember360 Add Tags',
			'desc' => _x( 'Select tags to be added once the achievement is earned.', 'gamipress', 'activemember360' ),
			'type' => 'achievement_earned_actions'
		];

		$fields['_mbr_gamipress_achievement_earned_remove_tags'] = [
			'name' => 'ActiveMember360 Remove Tags',
			'desc' => _x( 'Select tags to be removed once the achievement is earned.', 'gamipress', 'activemember360' ),
			'type' => 'achievement_earned_actions'
		];

		$fields['_mbr_gamipress_achievement_earned_set_field_value'] = [
			'name' => 'ActiveMember360 Set Contact Field',
			'desc' => _x( 'Select a contact field and specify the value to be set once the achievement is earned. Only text input and text area contact fields are supported.', 'gamipress', 'activemember360' ),
			'type' => 'achievement_earned_actions'
		];

		return $fields;
	}

	














	public function achievement_earned_actions_cmb2_render( $field, $escaped_value, $object_id, $object_type, $field_type_object )
	{
		wp_nonce_field( 'mbr_gamipress_achievement_earned_actions', 'mbr_gamipress_achievement_earned_actions_nonce' );

		static $arr_crm_tags      = NULL;
		IF ( is_null( $arr_crm_tags ) ) :
			$arr_crm_tags           = apply_filters( 'mbr/site_tags/get', NULL );
		ENDIF;

		$arr_crm_fields           = $this->get_usable_custom_fields();

		$arr_actions              = get_post_meta( $object_id, '_mbr_gamipress_achievement_earned_actions', TRUE );
		IF ( '_mbr_gamipress_achievement_earned_apply_tags' == $field->args['id'] ) :
			echo '<select name="mbr_gamipress_achievement_earned_apply_tags[]" multiple="multiple" class="mbr-gamipress-achievement-earned">';
			FOREACH ( $arr_crm_tags AS $tag_id => $tag_name ) :
				$selected             = in_array( $tag_id, $arr_actions['apply_tags'] ) ? ' selected="selected"' : '';
				echo '<option value="' . $tag_id . '"' . $selected . '>#' . $tag_id . ' - ' . $tag_name . '</option>';
			ENDFOREACH;
			echo '</select>';
		ELSEIF ( '_mbr_gamipress_achievement_earned_remove_tags' == $field->args['id'] ) :
			echo '<select name="mbr_gamipress_achievement_earned_remove_tags[]" multiple="multiple" class="mbr-gamipress-achievement-earned">';
			FOREACH ( $arr_crm_tags AS $tag_id => $tag_name ) :
				$selected             = in_array( $tag_id, $arr_actions['remove_tags'] ) ? ' selected="selected"' : '';
				echo '<option value="' . $tag_id . '"' . $selected . '>#' . $tag_id . ' - ' . $tag_name . '</option>';
			ENDFOREACH;
			echo '</select>';
		ELSEIF ( '_mbr_gamipress_achievement_earned_set_field_value' == $field->args['id'] ) :
			echo '<select name="mbr_gamipress_achievement_earned_set_field" class="mbr-gamipress-achievement-earned-set-field">';
			echo '<option value="">---</option>';
			FOREACH ( $arr_crm_fields AS $perstag => $title ) :
				echo '<option value="' . $perstag . '" ' . selected( $arr_actions['set_field'], $perstag, FALSE ) . '>' . $perstag . '</option>';
			ENDFOREACH;
			echo '</select>&nbsp;';
			echo '<input type="text" name="mbr_gamipress_achievement_earned_set_field_value" value="' . ( isset( $arr_actions['set_field_value'] ) ? $arr_actions['set_field_value'] : '' ) . '" />';
		ENDIF;

		echo '<p class="cmb2-metabox-description">' . $field->args['desc'] . '</p>';
	}

	










	public function achievement_earned_actions_save( $post_id )
	{
		IF ( ! isset( $_POST['mbr_gamipress_achievement_earned_actions_nonce'] ) ) :
			return NULL;
		ENDIF;

		IF ( ! wp_verify_nonce( $_POST['mbr_gamipress_achievement_earned_actions_nonce'], 'mbr_gamipress_achievement_earned_actions' ) ) :
			return NULL;
		ENDIF;

		IF ( defined( 'DOING_AUTOSAVE' ) AND DOING_AUTOSAVE ) :
			return NULL;
		ENDIF;

		IF ( 'revision' == $_POST['post_type'] ) :
			return NULL;
		ENDIF;

		$arr_actions = [ 'apply_tags' => $_POST['mbr_gamipress_achievement_earned_apply_tags'], 'remove_tags' => $_POST['mbr_gamipress_achievement_earned_remove_tags'], 'set_field' => $_POST['mbr_gamipress_achievement_earned_set_field'], 'set_field_value' => $_POST['mbr_gamipress_achievement_earned_set_field_value'] ];
		update_post_meta( $post_id, '_mbr_gamipress_achievement_earned_actions', $arr_actions );
	}

	














	public function achievement_awarded_to_user( $user_id, $achievement_id, $trigger, $site_id, $args )
	{
		$ac_contact_id     = apply_filters( 'mbr/contact_id', NULL );
		IF ( empty( $ac_contact_id ) ) :
			$ac_contact_id   = get_user_meta( $user_id, 'mbr_user_id', TRUE );
		ENDIF;

		IF ( empty( $ac_contact_id ) ) :
			return NULL;
		ENDIF;

		$arr_actions       = get_post_meta( $achievement_id, '_mbr_gamipress_achievement_earned_actions', TRUE );
		IF ( empty( $arr_actions ) ) :
			return NULL;
		ENDIF;

		IF ( ! empty( $arr_actions['remove_tags'] ) AND is_array( $arr_actions['remove_tags'] ) ) :
			$remove_tags     = apply_filters( 'mbr/tags/normalize/names', $arr_actions['remove_tags'], TRUE );
			apply_filters( 'mbr/api', 'contact_tag_remove', [ 'id' => $ac_contact_id, 'tags' => explode( ',', $remove_tags ) ] );
		ENDIF;

		IF ( ! empty( $arr_actions['apply_tags'] ) AND is_array( $arr_actions['apply_tags'] ) ) :
			$add_tags        = apply_filters( 'mbr/tags/normalize/names', $arr_actions['apply_tags'], TRUE );
			apply_filters( 'mbr/api', 'contact_tag_add', [ 'id' => $ac_contact_id, 'tags' => $add_tags ] );
		ENDIF;

		IF ( ! empty( $arr_actions['set_field'] ) ) :
			apply_filters( 'mbr/save_contact_fields', [ 'id' => $ac_contact_id, 'field[%' . $arr_actions['set_field'] . '%]' => $arr_actions['set_field_value'] ] );
		ENDIF;
	}

	










	public function rank_earned_data_fields( $fields )
	{
		$fields['_mbr_gamipress_rank_earned_apply_tags'] = [
			'name' => 'ActiveMember360 Add Tags',
			'desc' => _x( 'Select tags to be added once the rank is earned.', 'gamipress', 'activemember360' ),
			'type' => 'rank_earned_actions'
		];

		$fields['_mbr_gamipress_rank_earned_remove_tags'] = [
			'name' => 'ActiveMember360 Remove Tags',
			'desc' => _x( 'Select tags to be removed once the rank is earned.', 'gamipress', 'activemember360' ),
			'type' => 'rank_earned_actions'
		];

		$fields['_mbr_gamipress_rank_earned_set_field_value'] = [
			'name' => 'ActiveMember360 Set Contact Field',
			'desc' => _x( 'Select a contact field and specify the value to be set once the rank is earned. Only text input and text area contact fields are supported.', 'gamipress', 'activemember360' ),
			'type' => 'rank_earned_actions'
		];

		return $fields;
	}

	














	public function rank_earned_actions_cmb2_render( $field, $escaped_value, $object_id, $object_type, $field_type_object )
	{
		wp_nonce_field( 'mbr_gamipress_rank_earned_actions', 'mbr_gamipress_rank_earned_actions_nonce' );

		static $arr_crm_tags      = NULL;
		IF ( is_null( $arr_crm_tags ) ) :
			$arr_crm_tags           = apply_filters( 'mbr/site_tags/get', NULL );
		ENDIF;

		$arr_crm_fields           = $this->get_usable_custom_fields();

		$arr_actions              = get_post_meta( $object_id, '_mbr_gamipress_rank_earned_actions', TRUE );
		IF ( '_mbr_gamipress_rank_earned_apply_tags' == $field->args['id'] ) :
			echo '<select name="mbr_gamipress_rank_earned_apply_tags[]" multiple="multiple" class="mbr-gamipress-rank-earned">';
			FOREACH ( $arr_crm_tags AS $tag_id => $tag_name ) :
				$selected             = in_array( $tag_id, $arr_actions['apply_tags'] ) ? ' selected="selected"' : '';
				echo '<option value="' . $tag_id . '"' . $selected . '>#' . $tag_id . ' - ' . $tag_name . '</option>';
			ENDFOREACH;
			echo '</select>';
		ELSEIF ( '_mbr_gamipress_rank_earned_remove_tags' == $field->args['id'] ) :
			echo '<select name="mbr_gamipress_rank_earned_remove_tags[]" multiple="multiple" class="mbr-gamipress-rank-earned">';
			FOREACH ( $arr_crm_tags AS $tag_id => $tag_name ) :
				$selected             = in_array( $tag_id, $arr_actions['remove_tags'] ) ? ' selected="selected"' : '';
				echo '<option value="' . $tag_id . '"' . $selected . '>#' . $tag_id . ' - ' . $tag_name . '</option>';
			ENDFOREACH;
			echo '</select>';
		ELSEIF ( '_mbr_gamipress_rank_earned_set_field_value' == $field->args['id'] ) :
			echo '<select name="mbr_gamipress_rank_earned_set_field" class="mbr-gamipress-rank-earned-set-field">';
			echo '<option value="">---</option>';
			FOREACH ( $arr_crm_fields AS $perstag => $title ) :
				echo '<option value="' . $perstag . '" ' . selected( $arr_actions['set_field'], $perstag, FALSE ) . '>' . $perstag . '</option>';
			ENDFOREACH;
			echo '</select>&nbsp;';
			echo '<input type="text" name="mbr_gamipress_rank_earned_set_field_value" value="' . ( isset( $arr_actions['set_field_value'] ) ? $arr_actions['set_field_value'] : '' ) . '" />';
		ENDIF;

		echo '<p class="cmb2-metabox-description">' . $field->args['desc'] . '</p>';
	}

	










	public function rank_earned_actions_save( $post_id )
	{
		IF ( ! isset( $_POST['mbr_gamipress_rank_earned_actions_nonce'] ) ) :
			return NULL;
		ENDIF;

		IF ( ! wp_verify_nonce( $_POST['mbr_gamipress_rank_earned_actions_nonce'], 'mbr_gamipress_rank_earned_actions' ) ) :
			return NULL;
		ENDIF;

		IF ( defined( 'DOING_AUTOSAVE' ) AND DOING_AUTOSAVE ) :
			return NULL;
		ENDIF;

		IF ( 'revision' == $_POST['post_type'] ) :
			return NULL;
		ENDIF;

		$arr_actions = [ 'apply_tags' => $_POST['mbr_gamipress_rank_earned_apply_tags'], 'remove_tags' => $_POST['mbr_gamipress_rank_earned_remove_tags'], 'set_field' => $_POST['mbr_gamipress_rank_earned_set_field'], 'set_field_value' => $_POST['mbr_gamipress_rank_earned_set_field_value'] ];
		update_post_meta( $post_id, '_mbr_gamipress_rank_earned_actions', $arr_actions );
	}

	














	public function rank_awarded_to_user( $user_id, $new_rank, $old_rank, $admin_id, $achievement_id )
	{
		$ac_contact_id     = apply_filters( 'mbr/contact_id', NULL );
		IF ( empty( $ac_contact_id ) ) :
			$ac_contact_id   = get_user_meta( $user_id, 'mbr_user_id', TRUE );
		ENDIF;

		IF ( empty( $ac_contact_id ) ) :
			return NULL;
		ENDIF;

		$arr_actions       = get_post_meta( $new_rank->ID, '_mbr_gamipress_rank_earned_actions', TRUE );
		IF ( empty( $arr_actions ) ) :
			return NULL;
		ENDIF;

		IF ( ! empty( $arr_actions['remove_tags'] ) AND is_array( $arr_actions['remove_tags'] ) ) :
			$remove_tags     = apply_filters( 'mbr/tags/normalize/names', $arr_actions['remove_tags'], TRUE );
			apply_filters( 'mbr/api', 'contact_tag_remove', [ 'id' => $ac_contact_id, 'tags' => explode( ',', $remove_tags ) ] );
		ENDIF;

		IF ( ! empty( $arr_actions['apply_tags'] ) AND is_array( $arr_actions['apply_tags'] ) ) :
			$add_tags        = apply_filters( 'mbr/tags/normalize/names', $arr_actions['apply_tags'], TRUE );
			apply_filters( 'mbr/api', 'contact_tag_add', [ 'id' => $ac_contact_id, 'tags' => $add_tags ] );
		ENDIF;

		IF ( ! empty( $arr_actions['set_field'] ) ) :
			apply_filters( 'mbr/save_contact_fields', [ 'id' => $ac_contact_id, 'field[%' . $arr_actions['set_field'] . '%]' => $arr_actions['set_field_value'] ] );
		ENDIF;
	}

	








	public function points_type_metabox_store_points_to_crm()
	{
		add_meta_box(
			'mbr-gamipress-store-points-to-crm',
			'ActiveMember360',
			[ $this, 'points_type_meta_box_store_points_to_crm_render' ],
			'points-type',
			'normal',
			'default'
		);
	}

	












	public function points_type_meta_box_store_points_to_crm_render( $post )
	{
		wp_nonce_field( 'mbr_gamipress_store_points_to_crm', 'mbr_gamipress_store_points_to_crm_nonce' );

		$arr_crm_fields = $this->get_usable_custom_fields();

		$custom_field   = get_post_meta( $post->ID, '_mbr_gamipress_store_points_to_custom_field', TRUE );
		echo '<strong>' . _x( 'Store points total to ActiveCampaign Contact Field:', 'gamipress', 'activemember360' ) . '</strong>&nbsp;';
		echo '<select name="mbr_gamipress_store_points_to_custom_field" class="mbr-gamipress-store-points-to-custom-field">';
		echo '<option value="">' . _x( 'Do not store this Points Type to ActiveCampaign', 'gamipress', 'activemember360' ) . '</option>';
		FOREACH ( $arr_crm_fields AS $perstag => $title ) :
			echo '<option value="' . $perstag . '" ' . selected( $custom_field, $perstag, FALSE ) . '>' . $perstag . '</option>';
		ENDFOREACH;
		echo '</select>';
		echo '<p class="cmb2-metabox-description">' . _x( 'Select a contact field to store the points total. Only text input and text area contact fields are supported.', 'gamipress', 'activememebr360' ) . '</p>';
	}

	










	public function points_type_metabox_store_points_to_crm_save( $post_id )
	{
		IF ( ! isset( $_POST['mbr_gamipress_store_points_to_crm_nonce'] ) ) :
			return NULL;
		ENDIF;

		IF ( ! wp_verify_nonce( $_POST['mbr_gamipress_store_points_to_crm_nonce'], 'mbr_gamipress_store_points_to_crm' ) ) :
			return NULL;
		ENDIF;

		IF ( defined( 'DOING_AUTOSAVE' ) AND DOING_AUTOSAVE ) :
			return NULL;
		ENDIF;

		IF ( 'revision' == $_POST['post_type'] ) :
			return NULL;
		ENDIF;

		update_post_meta( $post_id, '_mbr_gamipress_store_points_to_custom_field', $_POST['mbr_gamipress_store_points_to_custom_field'] );
	}

	

















	public function points_type_store_points_to_crm( $user_id, $new_points, $total_points, $admin_id, $requirement_id, $points_type, $reason, $log_type )
	{
		$ac_contact_id   = apply_filters( 'mbr/contact_id', NULL );
		IF ( empty( $ac_contact_id ) ) :
			$ac_contact_id = get_user_meta( $user_id, 'mbr_user_id', TRUE );
		ENDIF;

		IF ( empty( $ac_contact_id ) ) :
			return NULL;
		ENDIF;

		$args            = [
			'name'         => $points_type,
			'post_type'    => 'points-type',
			'post_status'  => 'publish',
			'numberposts'  => 1
		];

		$points_post     = get_posts( $args );
		IF ( ! empty( $points_post[0]->ID ) ) :
			$custom_field  = get_post_meta( $points_post[0]->ID, '_mbr_gamipress_store_points_to_custom_field', TRUE );
			IF ( ! empty( $custom_field ) ) :
				apply_filters( 'mbr/save_contact_fields', [ 'id' => $ac_contact_id, 'field[%' . $custom_field . '%]' => $total_points ] );
			ENDIF;
		ENDIF;
	}

	






	private function get_usable_custom_fields()
	{
		static $arr_crm_fields = NULL;

		IF ( is_null( $arr_crm_fields ) ) :
			$arr_tmp_custom_fields  = apply_filters( 'mbr/site_custom_fields/get', NULL );
			IF ( ! empty( $arr_tmp_custom_fields ) ) :
				FOREACH ( $arr_tmp_custom_fields AS $field_name => $arr_field ) :
					IF ( ! in_array( $arr_field['type'], [ 'text', 'textarea'] ) ) :
						continue;
					ENDIF;
					$arr_crm_fields[ strtolower( $arr_field['perstag'] ) ] = $arr_field['title'];
				ENDFOREACH;
			ENDIF;
		ENDIF;

		return $arr_crm_fields;
	}
}




$GLOBALS['mbr_gamipress'] = mbr_gamipress::getInstance();
