<?php









final class mbr_gutenberg {

	use TRAIT__getInstance;

	









	public function _load()
	{
		function MBRGTB()
		{
			IF ( empty( $GLOBALS['mbr_gutenberg' ] ) ) :
				$GLOBALS['mbr_gutenberg'] = mbr_gutenberg::getInstance();
			ENDIF;

			return $GLOBALS['mbr_gutenberg'];
		}
		add_action( 'wp_loaded',      [ $this, 'prevent_rest_api_issues_for_dynamic_blocks' ], 9999, 0 );
	}

	








	public function prevent_rest_api_issues_for_dynamic_blocks()
	{
		$registered_blocks = WP_Block_Type_Registry::get_instance()->get_all_registered();

		FOREACH ( $registered_blocks AS $name => $block ) :
			$block->attributes['mbr_mode']    = [
				'type'    => 'string',
				'default' => 'individual'
			];
			$block->attributes['mbr_conditional_eval']    = [
				'type'    => 'string',
				'default' => 'true'
			];
			$block->attributes['mbr_conditional_id']    = [
				'type'    => 'integer',
				'default' => ''
			];
			$block->attributes['mbr_display_if']    = [
				'type'    => 'string',
				'default' => 'always'
			];
			$block->attributes['mbr_pos_tags']      = [
				'type'    => 'array',
				'default' => ''
			];
			$block->attributes['mbr_neg_tags']      = [
				'type'    => 'array',
				'default' => ''
			];
			$block->attributes['mbr_compare_field'] = [
				'type'    => 'string',
				'default' => ''
			];
			$block->attributes['mbr_compare_field_operator'] = [
				'type'    => 'string',
				'default' => ''
			];
			$block->attributes['mbr_compare_field_value']    = [
				'type'    => 'string',
				'default' => ''
			];
			$block->attributes['mbr_php_statement'] = [
				'type'    => 'string',
				'default' => ''
			];
		ENDFOREACH;
	}

	










	public function plugins_loaded()
	{

		add_action( 'init',          [ $this, 'register_block_control' ],        10, 0 );
		add_filter( 'render_block',  [ $this, 'should_render_block_content' ], 9999, 2 );
		add_action( 'rest_api_init', [ $this, 'register_endpoints' ],            10, 0 );
	}

	








	public function register_block_control()
 	{
		$asset_file = include( plugin_dir_path( __FILE__ ) . 'libs/gutenberg/build/index.asset.php');
		wp_register_script( 'mbr-block-control',     plugins_url( 'libs/gutenberg/build/index.js', __FILE__ ), $asset_file['dependencies'], $asset_file['version'] );

		wp_register_style( 'mbr-block-control', plugins_url( 'libs/gutenberg/build/css/style.css', __FILE__ ) );
		register_block_type( 'activemember360/block-control', [ 'editor_script' => 'mbr-block-control', 'editor_style' => 'mbr-block-control' ] );

		wp_localize_script( 'mbr-block-control', 'wpApiSettings', [ 'root' => esc_url_raw( rest_url() ), 'nonce' => wp_create_nonce( 'wp_rest' ), 'mbr_url' => rtrim( home_url(), '/' ) ] );
	}

	








	public function register_endpoints()
	{
		register_rest_route( 'mbr/blocks/v1', 'get_block_options', [ 'methods' => 'GET', 'callback' => [ $this, 'get_block_options' ], 'permission_callback' => function() { return current_user_can( 'edit_posts' ); } ] );
	}

	






	public function get_block_options()
	{
		static $arr_options            = NULL;

		IF ( is_null( $arr_options ) ) :
			$arr_options                 = [];

			IF ( is_null( $arr_crm_tags ) ) :
				$arr_crm_tags              = apply_filters( 'mbr/site_tags/get', NULL );
				FOREACH ( $arr_crm_tags AS $tag_id => $tag_name ) :
					$arr_options['tags'][]   = [ 'value' => $tag_id, 'label' => $tag_name ];
				ENDFOREACH;
			ENDIF;

			$arr_options['fields'][]     = [ 'value' => '', 'label' => '---' ];

			$arr_tmp_regular_fields      = apply_filters( 'mbr/site_contact_std_fields/get', NULL );
			$arr_crm_fields['']          = '---';
			IF ( ! empty( $arr_tmp_regular_fields ) ) :
				FOREACH ( $arr_tmp_regular_fields AS $filler => $field_name ) :
					$arr_options['fields'][] = [ 'value' => $field_name, 'label' => $field_name ];
				ENDFOREACH;
			ENDIF;
			$arr_tmp_custom_fields       = apply_filters( 'mbr/site_custom_fields/get', NULL );
			IF ( ! empty( $arr_tmp_custom_fields ) ) :
				FOREACH ( $arr_tmp_custom_fields AS $field_name => $arr_field ) :
					$perstag                                  = strtolower( $arr_field['perstag'] );
					$arr_options['fields'][]                  = [ 'value' => $perstag, 'label' => $arr_field['title'] ];
					$arr_options['fields_labels'][ $perstag ] = $arr_field['title'];
				ENDFOREACH;
			ENDIF;

			$arr_conditionals                = apply_filters( 'mbr/conditionals/conditionals/get', [] );
			$arr_options['conditionals'][]   = [ 'value' => '', 'label' => '---' ];
			IF ( ! empty( $arr_conditionals ) ) :
				FOREACH ( $arr_conditionals AS $conditional_id => $conditional_name ) :
					$arr_options['conditionals'][]                         = [ 'value' => $conditional_id, 'label' => $conditional_name ];
					$arr_options['conditionals_labels'][ $conditional_id ] = $conditional_name;
				ENDFOREACH;
			ENDIF;

			$arr_options['compare_field_operators']    = [
				[ 'value' => '',                 'label' => '---' ],
				[ 'value' => 'equals',           'label' => _x( 'Equals',           'gutenberg', 'activemember360' ) ],
				[ 'value' => 'not_equal',        'label' => _x( 'Not equal',        'gutenberg', 'activemember360' ) ],
				[ 'value' => 'greater_than' ,    'label' => _x( 'Greater than',     'gutenberg', 'activemember360' ) ],
				[ 'value' => 'less_than',        'label' => _x( 'Less than',        'gutenberg', 'activemember360' ) ],
				[ 'value' => 'greater_or_equal', 'label' => _x( 'Greater or equal', 'gutenberg', 'activemember360' ) ],
				[ 'value' => 'less_or_equal',    'label' => _x( 'Less or equal',    'gutenberg', 'activemember360' ) ],
				[ 'value' => 'begins_with' ,     'label' => _x( 'Begins with',      'gutenberg', 'activemember360' ) ],
				[ 'value' => 'ends_with',        'label' => _x( 'Ends with',        'gutenberg', 'activemember360' ) ],
				[ 'value' => 'contains',         'label' => _x( 'Contains',         'gutenberg', 'activemember360' ) ],
				[ 'value' => 'not_contains',     'label' => _x( 'Not contains',     'gutenberg', 'activemember360' ) ]
			];

			$arr_options['compare_field_operators_labels'] = [
				''                 => '---',
				'equals'           => _x( 'Equals',           'gutenberg', 'activemember360' ),
				'not_equal'        => _x( 'Not equal',        'gutenberg', 'activemember360' ),
				'greater_than'     => _x( 'Greater than',     'gutenberg', 'activemember360' ),
				'less_than'        => _x( 'Less than',        'gutenberg', 'activemember360' ),
				'greater_or_equal' => _x( 'Greater or equal', 'gutenberg', 'activemember360' ),
				'less_or_equal'    => _x( 'Less or equal',    'gutenberg', 'activemember360' ),
				'begins_with'      => _x( 'Begins with',      'gutenberg', 'activemember360' ),
				'ends_with'        => _x( 'Ends with',        'gutenberg', 'activemember360' ),
				'contains'         => _x( 'Contains',         'gutenberg', 'activemember360' ),
				'not_contains'     => _x( 'Not contains',     'gutenberg', 'activemember360' ),
			];

			$arr_options['display_if'] = [
				[ 'value' => 'always',           'label' => _x( 'Always',           'gutenberg', 'activemember360' ) ],
				[ 'value' => 'is_logged_in',     'label' => _x( 'Is logged in',     'gutenberg', 'activemember360' ) ],
				[ 'value' => 'is_logged_out',    'label' => _x( 'Is logged out',    'gutenberg', 'activemember360' ) ],
				[ 'value' => 'never',            'label' => _x( 'Never',            'gutenberg', 'activemember360' ) ]
			];

			$arr_options['display_if_labels'] = [
				'always'        => _x( 'Always',        'gutenberg', 'activemember360' ),
				'is_logged_in'  => _x( 'Is logged in',  'gutenberg', 'activemember360' ),
				'is_logged_out' => _x( 'Is logged out', 'gutenberg', 'activemember360' ),
				'never'         => _x( 'Never',         'gutenberg', 'activemember360' )
			];

			$arr_options['mode'] = [
				[ 'value' => 'individual',   'label' => _x( 'Individual',  'gutenberg', 'activemember360' ) ],
				[ 'value' => 'conditional',  'label' => _x( 'Conditional', 'gutenberg', 'activemember360' ) ]
			];

			$arr_options['mode_labels'] = [
				'individual'  => _x( 'Individual',  'gutenberg', 'activemember360' ),
				'conditional' => _x( 'Conditional', 'gutenberg', 'activemember360' )
			];

			$arr_options['conditional_eval'] = [
				[ 'value' => 'true',   'label' => _x( 'True',  'gutenberg', 'activemember360' ) ],
				[ 'value' => 'false',  'label' => _x( 'False', 'gutenberg', 'activemember360' ) ]
			];

			$arr_options['conditional_eval_labels'] = [
				'true'    => _x( 'True',  'gutenberg', 'activemember360' ),
				'false'   => _x( 'False', 'gutenberg', 'activemember360' )
			];

			$arr_options['labels']           = [
				'panel_title'                  => 'ActiveMember360',
				'general_note'                 => _x( 'All conditions are AND conditions, therefore ALL conditions must be achieved for the block display setting to take effect. Otherwise the block will not be displayed.', 'gutenberg', 'activemember360' ),
				'learndash_blocks_note'        => _x( 'Learndash blocks currently cannot be supported due to limitations in Learndash.', 'gutenberg', 'activemember360' ),
				'mode_label'                   => _x( 'Control mode', 'gutenberg', 'activemember360' ),
				'conditional_eval_label'       => _x( 'Display if conditional evaluates', 'gutenberg', 'activemember360' ),
				'conditionals_label'           => _x( 'Select conditional', 'gutenberg', 'activemember360' ),
				'display_if_help'              => _x( 'Choose the block display setting.', 'gutenberg', 'activemember360' ),
				'display_if_label'             => _x( 'Display if/when', 'gutenberg', 'activemember360' ),
				'tags_help'                    => _x( 'Choose tags a contact must have (at least one) and must not have (all) in order to confirm the block display setting.', 'gutenberg', 'activemember360' ),
				'pos_tags_label'               => _x( 'Tags (any)', 'gutenberg', 'activemember360' ),
				'neg_tags_label'               => _x( 'Tags (not all)', 'gutenberg', 'activemember360' ),
				'compare_help'                 => _x( 'Compare a contact field against a specific value. This must evaluate to TRUE in order to confirm the block display setting.', 'gutenberg', 'activemember360' ),
				'compare_field_label'          => _x( 'Field', 'gutenberg', 'activemember360' ),
				'compare_field_operator_label' => _x( 'Operator', 'gutenberg', 'activemember360' ),
				'compare_field_value_label'    => _x( 'Value', 'gutenberg', 'activemember360' ),
				'php_statement_help'           => _x( 'PHP Statement must return TRUE in order to confirm the block display setting.', 'gutenberg', 'activemember360' ),
				'php_statement_label'          => _x( 'PHP Statement', 'gutenberg', 'activemember360' )
			];
		ENDIF;

		return json_encode( $arr_options );
	}

	














	public function should_render_block_content( $block_content, $block )
	{
		IF ( defined( 'MBRADMIN' ) AND MBRADMIN ) :
			return $block_content;
		ENDIF;

		$attributes = $this->get_mbr_block_attributes( $block );

		IF ( ! empty( $attributes ) ) :
			IF ( ! $this->match_block_content( $attributes ) ) :
				return '';
			ENDIF;
		ENDIF;

		return $block_content;
	}

	








	public function get_mbr_block_attributes( $attributes )
	{
		IF ( empty( $attributes['attrs'] ) ) :
			return [];
		ENDIF;

		$attributes                                 = $attributes['attrs'];

		$settings                                   = [];

		IF ( ! empty( $attributes['mbr_mode'] ) AND 'conditional' == $attributes['mbr_mode'] ) :
			$settings['mbr_mode']                     = 'conditional';

			IF ( ! empty( $attributes['mbr_conditional_eval'] ) ) :
				$settings['mbr_conditional_eval']       = $attributes['mbr_conditional_eval'];
			ELSE:
				
				$settings['mbr_conditional_eval']       = 'true';
			ENDIF;

			IF ( ! empty( $attributes['mbr_conditional_id'] ) ) :
				$settings['mbr_conditional_id']         = $attributes['mbr_conditional_id'];
			ELSE:
				$settings['mbr_conditional_id']         = 0;
			ENDIF;
		ELSE:
			$settings['mbr_mode']                     = 'individual';

			IF ( ! empty( $attributes['mbr_pos_tags'] ) ) :
				$settings['mbr_pos_tags']               = [];
				FOREACH ( $attributes['mbr_pos_tags'] AS $key => $array ) :
					$settings['mbr_pos_tags'][]           = $array['value'];
				ENDFOREACH;
			ENDIF;

			IF ( ! empty( $attributes['mbr_neg_tags'] ) ) :
				$settings['mbr_neg_tags']               = [];
				FOREACH ( $attributes['mbr_neg_tags'] AS $key => $array ) :
					$settings['mbr_neg_tags'][]           = $array['value'];
				ENDFOREACH;
			ENDIF;

			IF ( empty( $attributes['mbr_display_if'] ) ) :
				$settings['mbr_display_if']             =  'always';
			ELSE:
				$settings['mbr_display_if']             =  $attributes['mbr_display_if'];
			ENDIF;

			IF ( ! empty( $attributes['mbr_compare_field'] ) ) :
				$settings['mbr_compare_field']          =  $attributes['mbr_compare_field'];
			ENDIF;

			IF ( ! empty( $attributes['mbr_compare_field_operator'] ) ) :
				$settings['mbr_compare_field_operator'] =  $attributes['mbr_compare_field_operator'];
			ENDIF;

			IF ( ! empty( $attributes['mbr_compare_field_value'] ) ) :
				$settings['mbr_compare_field_value']    =  $attributes['mbr_compare_field_value'];
			ENDIF;

			IF ( ! empty( $attributes['mbr_php_statement'] ) ) :
				$settings['mbr_php_statement']          =  $attributes['mbr_php_statement'];
			ENDIF;
		ENDIF;

		return $settings;
	}
	








	private function match_block_content( $settings )
	{
		IF ( 'conditional' == $settings['mbr_mode'] ) :
			$conditional_eval     = $settings['mbr_conditional_eval'];
			$conditional_id       = $settings['mbr_conditional_id'];
			IF ( ! empty( $conditional_id ) AND ! empty( $conditional_eval ) ) :
				$match = apply_filters( 'mbr/conditionals/conditional/check', NULL, $conditional_id );
				IF ( 'true' == $conditional_eval AND FALSE === $match ) :
					return FALSE;
				ELSEIF ( 'false' == $conditional_eval AND FALSE !== $match ) :
					return FALSE;
				ENDIF;
			ENDIF;
		ELSE:
			IF ( 'always' <> $settings['mbr_display_if'] ) :
				IF ( 'never' == $settings['mbr_display_if'] ) :
					return FALSE;
				ENDIF;
				IF ( 'is_logged_in' == $settings['mbr_display_if'] AND ! is_user_logged_in() ) :
					return FALSE;
				ENDIF;
				IF ( 'is_logged_out' == $settings['mbr_display_if'] AND is_user_logged_in() ) :
					return FALSE;
				ENDIF;
			ENDIF;

			IF ( ! empty( $settings['mbr_pos_tags'] ) AND is_array( $settings['mbr_pos_tags'] ) ) :
				IF ( ! mbr_has_tags( $settings['mbr_pos_tags'] ) ) :
					return FALSE;
				ENDIF;
			ENDIF;

			IF ( ! empty( $settings['mbr_neg_tags'] ) AND is_array( $settings['mbr_neg_tags'] ) ) :
				IF ( mbr_has_tags( $settings['mbr_neg_tags'] ) ) :
					return FALSE;
				ENDIF;
			ENDIF;

			$operator      = $settings['mbr_compare_field_operator'];
			$field         = strtolower( $settings['mbr_compare_field'] );
			$compare_value = $settings['mbr_compare_field_value'];
			IF ( ! empty( $operator ) AND ! empty( $field ) ) :
				$remote_logged_in = apply_filters( 'mbr/contact_id', NULL );
				IF ( empty( $remote_logged_in ) ) :
					return FALSE;
				ENDIF;

				$field_value = apply_filters( 'mbr/get_contact_field', $field );
				IF ( 'equals' == $operator ) :
					$match = ( $field_value == $compare_value ? TRUE : FALSE );
				ELSEIF ( 'not_equal' == $operator ) :
					$match = ( $field_value <> $compare_value ? TRUE : FALSE );
				ELSEIF ( 'less_than' == $operator ) :
					$match = ( $field_value <  $compare_value ? TRUE : FALSE );
				ELSEIF ( 'greater_than' == $operator ) :
					$match = ( $field_value >  $compare_value ? TRUE : FALSE );
				ELSEIF ( 'greater_or_equal' == $operator ) :
					$match = ( $field_value >= $compare_value ? TRUE : FALSE );
				ELSEIF ( 'less_or_equal' == $operator ) :
					$match = ( $field_value <= $compare_value ? TRUE : FALSE );
				ELSEIF ( 'begins_with' == $operator ) :
					$match = ( substr( $field_value,0, strlen( $compare_value ) ) == $compare_value ? TRUE : FALSE );
				ELSEIF ( 'ends_with' == $operator ) :
					$match = ( substr( $field_value,strlen( $compare_value ) * -1 ) == $compare_value ? TRUE : FALSE);
				ELSEIF ( 'contains' == $operator ) :
					$match = ( FALSE !== stripos( $field_value, $compare_value ) ? TRUE : FALSE );
				ELSEIF ( 'not_contains' == $operator ) :
					$match = ( FALSE !== stripos( $field_value, $compare_value ) ? FALSE : TRUE );
				ELSE :
					$match = FALSE;
				ENDIF;
				IF ( empty( $match ) ) :
					return FALSE;
				ENDIF;
			ENDIF;

			IF ( ! empty( $settings['mbr_php_statement'] ) ) :
				$php_statement = trim( $settings['mbr_php_statement'] );
				$php_statement = ( stristr( $php_statement,  'return' ) ) ? $php_statement : 'return (' . $php_statement . ');';
				$php_statement = stripcslashes( $php_statement );
				IF ( ! eval( $php_statement ) ) :
					return FALSE;
				ENDIF;
			ENDIF;

		ENDIF;

		return TRUE;
	}

}




global $wp_version;
IF ( version_compare( $wp_version, '5.0', '>=' ) ) :
	$GLOBALS['mbr_gutenberg'] = mbr_gutenberg::getInstance();
ENDIF;