<?php
class mbr_lifterlms
{
	use TRAIT__getInstance;

	public function _load()
	{
		function MBRLIFTERLMS()
		{
			IF ( empty( $GLOBALS['mbrlifterlms'] ) ) :
				$GLOBALS['mbrlifterlms'] = mbr_lifterlms::getInstance();
			ENDIF;

			return $GLOBALS['mbrlifterlms'];
		}

		global $pagenow;
		IF ( is_admin() ) :
			
			IF ( in_array( $pagenow, [ 'post.php', 'post-new.php' ] ) ) :
				add_action( "load-{$pagenow}",         [ $this, 'init_metaboxes' ] );
			ENDIF;
			add_action( 'mbr/quick_edit/protection/box', [ $this, 'init_quick_edit' ], 0 );
		ENDIF;

		
		add_filter( 'mbr/protectable_post_types/built_in',    [ $this, 'add_protectable_post_types' ],      10, 1 );

		
































	}

	public function add_protectable_post_types( $arr_protectable_post_types = [] )
	{
		array_push( $arr_protectable_post_types, 'course', 'lesson', 'llms_quiz' );
		return $arr_protectable_post_types;
	}

	public function init_metaboxes( $_post_type = FALSE, $_post = FALSE )
	{
		global $pagenow, $typenow;

		IF ( in_array( $typenow, [ 'course', 'lesson', 'llms_quiz' ] ) ) :
			IF ( "load-{$pagenow}" == current_filter() ) :
				add_action( 'add_meta_boxes', [ $this, __FUNCTION__ ], 10, 2 );
				




			ELSEIF ( 'add_meta_boxes' == current_filter() ) :
				do_action( 'mbr/add_meta_box', $_post, [ $this, "render_meta_boxes_protection_{$_post_type}" ], NULL );
			ENDIF;
		ENDIF;
	}

	public function init_quick_edit( $_post )
	{
		IF ( 'course' == $_post->post_type ) :
			$this->render_meta_boxes_protection_course( $_post, 'quick-protection' );
		ELSEIF ( 'lesson' == $_post->post_type ) :
			$this->render_meta_boxes_protection_lesson( $_post, 'quick-protection' );
		ELSEIF ( 'llms_quiz' == $_post->post_type ) :
			$this->render_meta_boxes_protection_lesson( $_post, 'quick-protection' );
		ENDIF;
	}

	public function add_meta_boxes_completion_course( $_post_type, $_post )
	{
		global $wp_post_types;
		$help     = apply_filters( 'mbr/format_help_abbr', _x( 'Define which actions to carry out when the course has been completed.', 'wp_admin', 'activemember360' ) );
		$doc_type = ucfirst( $wp_post_types[ $_post_type ]->labels->singular_name );
		$box_id   = "completion_{$_post_type}";

		do_action( 'mbr/force_render_meta_box', $_post, $box_id );

		add_meta_box(
				$box_id
			, apply_filters( 'mbr/meta_box_header', _x( 'Course Completion Actions', 'wp_admin', 'activemember360' ), FALSE )
			, [ $this, 'render_meta_boxes_completion_course' ]
			, $_post_type
			, 'side'
			, 'high'
		);
		//do_action( 'mbr/add_meta_box', $_post, [ $this, 'render_meta_boxes_completion_course' ], NULL );
	}

	function render_meta_boxes_protection_course( $_post, $box )
	{
		$settings = apply_filters( 'mbr/get_meta_box_protection_settings', $_post );

		do_action( 'mbr/render_metabox_css_helper', $box );

		IF ( empty( $settings['membership_levels'] ) ) :
			echo "<p style='color:" . apply_filters( 'mbr/plugin_color', NULL ) . ";font-size:10px;'>" . sprintf( _x( 'You have not yet defined which memberships you want to use on this site. Please do so in <a href="' . admin_url( "admin.php?page=ActiveMember360&mbrtab=memberships" ) . '">%s.</a>', 'wp_admin', 'activemember360' ), "'Memberships'" ) . "</p>";
			return;
		ENDIF;

		do_action( 'mbr/render_meta_boxes_protection_generic',            $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_memberships',        $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_filters',            $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_addtl_tags',         $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_comment_automation', $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_redirect',           $_post, $settings );
	}

	function render_meta_boxes_protection_lesson( $_post, $box )
	{
		$settings = apply_filters( 'mbr/get_meta_box_protection_settings', $_post );

		do_action( 'mbr/render_metabox_css_helper', $box );

		IF ( empty( $settings['membership_levels'] ) ) :
			echo "<p style='color:" . apply_filters( 'mbr/plugin_color', NULL ) . ";font-size:10px;'>" . sprintf( _x( 'You have not yet defined which memberships you want to use on this site. Please do so in <a href="' . admin_url( "admin.php?page=ActiveMember360&mbrtab=memberships" ) . '">%s.</a>', 'wp_admin', 'activemember360' ), "'Memberships'" ) . "</p>";
			return;
		ENDIF;

		do_action( 'mbr/render_meta_boxes_protection_addtl_tags', $_post, $settings );
	}

	function render_meta_boxes_protection_llms_quiz( $_post, $box )
	{
		$settings = apply_filters( 'mbr/get_meta_box_protection_settings', $_post );

		do_action( 'mbr/render_metabox_css_helper', $box );

		IF ( empty( $settings['membership_levels'] ) ) :
			echo "<p style='color:" . apply_filters( 'mbr/plugin_color', NULL ) . ";font-size:10px;'>" . sprintf( _x( 'You have not yet defined which memberships you want to use on this site. Please do so in <a href=\'" . admin_url(\'admin.php?page=ActiveMember360&mbrtab=memberships\') . "\'>%s.</a>' ), "'Memberships'") . "</p>";
			return;
		ENDIF;

		do_action( 'mbr/render_meta_boxes_protection_addtl_tags', $_post, $settings );
	}

	public function render_meta_boxes_completion_course( $_post, $settings )
	{
		$settings = apply_filters( 'mbr/get_meta_box_protection_settings', $_post );

		FOREACH ( $settings['membership_levels'] AS $thisID => $thisLEVEL ) :

			IF ( trim( $thisLEVEL['name'] ) == '' ) :
				$thisLEVEL['name'] = $settings['site_tags'][ $thisID ];
			ENDIF;

			$checked = ( in_array( $thisID, $settings['setGROUPS'] ) ) ? "checked='checked'" : "";

			$help    = apply_filters( 'mbr/format_help_abbr', sprintf( _x( 'Checking this box will grant access to this %s to anyone who is logged in and has tag %s ("%s")', 'wp_admin', 'activemember360' ), $settings['post_type_name'], $thisID, $thisLEVEL['name'] ) );

			echo "<label style='height:11px;line-height:11px;font-size:0.95em;'><input style='vertical-align:middle;' type='checkbox' name='group_access[$thisID]' value='$thisID' $checked />{$help}&nbsp;" . $thisLEVEL['name'] . "</label>";
			echo "<br />";

		ENDFOREACH;

		echo "<div style='margin-top:3px;margin-bottom:4px;height:1px;border-bottom:solid 1px #ccc;'></div>";
	}

}
$GLOBALS['mbrlifterlms'] = mbr_lifterlms::getInstance();
