<?php
class mbr_memberoni
{
	use TRAIT__getInstance;

	public function _load()
	{

		function MBRMEMBERONI()
		{
			IF ( empty( $GLOBALS['mbrmemberoni'] ) ) :
				$GLOBALS['mbrmemberoni'] = mbr_memberoni::getInstance();
			ENDIF;

			return $GLOBALS['mbrmemberoni'];
		}

		$this->memberoni_assign_automations_key = '_mbr_memberoni_assign_automations';
		$this->memberoni_remove_automations_key = '_mbr_memberoni_remove_automations';
		$this->memberoni_assign_tags_key        = '_mbr_memberoni_assign_tags';
		$this->memberoni_remove_tags_key        = '_mbr_memberoni_remove_tags';
		$this->memberoni_subscribe_lists_key    = '_mbr_memberoni_subscribe_lists';
		$this->memberoni_unsubscribe_lists_key  = '_mbr_memberoni_unsubscribe_lists';

		global $pagenow;

		IF ( is_admin() ) :
			
			IF ( in_array( $pagenow, [ 'post.php', 'post-new.php' ] ) ) :
				add_action( "load-{$pagenow}",            [ $this, 'init_metaboxes' ] );
			ENDIF;
			add_action( 'mbr/quick_edit/protection/box', [ $this, 'init_quick_edit' ], 0 );
			add_action( 'wp_insert_post',                [ $this, 'wp_insert_post_memberoni_course' ],  999, 3 );
		ENDIF;

		
		add_filter( 'mbr/protectable_post_types/built_in', [ $this, 'add_protectable_post_types' ], 10, 1 );

		
		IF ( ! empty( $_GET['mc'] ) AND $_GET['mc'] == 'y' ) :
			add_action( 'template_redirect',       [ $this, 'template_redirect_memberoni_course_completion' ], 0 );
		ENDIF;
	}

	public function init_metaboxes( $_post_type = FALSE, $_post = FALSE )
	{
		global $pagenow, $typenow;

		IF ( 'memberoni_course' == $typenow ) :
			$current_filter = current_filter();
			IF ( "load-{$pagenow}" == $current_filter ) :
				add_action( 'add_meta_boxes',   [ $this, __FUNCTION__ ], 10, 2 );
			ELSEIF ( 'add_meta_boxes' == $current_filter ) :
				do_action( 'mbr/add_meta_box', $_post, [ $this, 'render_meta_boxes_protection_memberoni_course' ], NULL );
				$this->add_meta_boxes_memberoni_course_completion( $_post );
			ENDIF;
		ENDIF;
	}

	public function init_quick_edit( $_post )
	{
		IF ( 'memberoni_course' == $_post->post_type ) :
			$this->render_meta_boxes_protection_memberoni_course( $_post, 'quick-protection' );
		ENDIF;
	}

	public function render_meta_boxes_protection_memberoni_course( $_post, $box )
	{
		$settings = apply_filters( 'mbr/get_meta_box_protection_settings', $_post );

		do_action( 'mbr/render_metabox_css_helper', $box );

		IF ( empty( $settings['membership_levels'] ) ) :
			echo "<p style='color:" . apply_filters( 'mbr/plugin_color', NULL ) . ";font-size:10px;'>" . sprintf( _x( 'You have not yet defined which memberships you want to use on this site. Please do so in <a href="' . admin_url( "admin.php?page=ActiveMember360&mbrtab=memberships" ) . '">%s.</a>', 'wp_admin', 'activemember360' ), "'Memberships'" ) . "</p>";
			return;
		ENDIF;

		do_action( 'mbr/render_meta_boxes_protection_generic',             $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_memberships',         $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_filters',             $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_addtl_tags',          $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_comment_automations', $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_redirect',            $_post, $settings );
	}

	public function add_meta_boxes_memberoni_course_completion( $_post )
	{
		
		$course_page_type = get_post_meta( $_post->ID, 'course_page_type', TRUE );

		
		IF ( empty( $course_page_type ) OR $course_page_type == 'course' ) :

			add_meta_box(
				"memberoni_completion_{$_post->post_type}"
				, apply_filters( 'mbr/meta_box_header', _x( 'Course Completion Actions', 'wp_admin', 'activemember360' ), FALSE )
				, [ $this, 'render_meta_boxes_memberoni_course_completion' ]
				, $_post->post_type
				, 'side'
				, 'high'
			);

		ENDIF;
	}

	public function render_meta_boxes_memberoni_course_completion( $_post, $box )
	{
		$assign_automations = json_decode( get_post_meta( $_post->ID, $this->memberoni_assign_automations_key, TRUE ), TRUE );
		$remove_automations = json_decode( get_post_meta( $_post->ID, $this->memberoni_remove_automations_key, TRUE ), TRUE );
		$assign_tags        = json_decode( get_post_meta( $_post->ID, $this->memberoni_assign_tags_key,        TRUE ), TRUE );
		$remove_tags        = json_decode( get_post_meta( $_post->ID, $this->memberoni_remove_tags_key,        TRUE ), TRUE );
		$subscribe_lists    = json_decode( get_post_meta( $_post->ID, $this->memberoni_subscribe_lists_key,    TRUE ), TRUE );
		$unsubscribe_lists  = json_decode( get_post_meta( $_post->ID, $this->memberoni_unsubscribe_lists_key,  TRUE ), TRUE );

		do_action ( 'mbr/render_metabox_css_helper', $box );

		printf(
			_x( 'Specify actions to perform when a Memberoni course is completed', 'wp_admin', 'activemember360' ) . '<br />&nbsp;<br />
			<strong style="font-size:1.3em;">' . _x( 'Automations',             'wp_admin', 'activemember360' ) . '</strong>
			<fieldset><legend>'   . _x( 'Assign to automations',   'wp_admin', 'activemember360' ) . '</legend>%s</fieldset>
			<fieldset><legend>'   . _x( 'Remove from automations', 'wp_admin', 'activemember360' ) . '</legend>%s</fieldset>
			<strong style="font-size:1.3em;">' . _x( 'Tags',                    'wp_admin', 'activemember360' ) . '</strong>
			<fieldset><legend>'   . _x( 'Assign tags',             'wp_admin', 'activemember360' ) . '</legend>%s</fieldset>
			<fieldset><legend>'   . _x( 'Remove tags',             'wp_admin', 'activemember360' ) . '</legend>%s</fieldset>
			<strong style="font-size:1.3em;">' . _x( 'Lists',                   'wp_admin', 'activemember360' ) . '</strong>
			<fieldset><legend>'   . _x( 'Subscribe to lists',      'wp_admin', 'activemember360' ) . '</legend>%s</fieldset>
			<fieldset><legend>'   . _x( 'Unsubscribe from lists',  'wp_admin', 'activemember360' ) . '</legend>%s</fieldset>
			',
			apply_filters( 'mbr/select_box_helper', apply_filters( 'mbr/site_automations/get/active', NULL ), $assign_automations, 'mbr_memberoni_assign_automations', MBR_SELECTBOX_DO_DISPLAY_ID, MBR_SELECTBOX_DO_MULTIPLE, MBR_SELECTBOX_DO_SELECT2 ),
			apply_filters( 'mbr/select_box_helper', apply_filters( 'mbr/site_automations/get/active', NULL ), $remove_automations, 'mbr_memberoni_remove_automations', MBR_SELECTBOX_DO_DISPLAY_ID, MBR_SELECTBOX_DO_MULTIPLE, MBR_SELECTBOX_DO_SELECT2 ),
			apply_filters( 'mbr/select_box_helper', apply_filters( 'mbr/site_tags/get',               NULL ), $assign_tags,        'mbr_memberoni_assign_tags',        MBR_SELECTBOX_DO_DISPLAY_ID, MBR_SELECTBOX_DO_MULTIPLE, MBR_SELECTBOX_DO_SELECT2 ),
			apply_filters( 'mbr/select_box_helper', apply_filters( 'mbr/site_tags/get',               NULL ), $remove_tags,        'mbr_memberoni_remove_tags',        MBR_SELECTBOX_DO_DISPLAY_ID, MBR_SELECTBOX_DO_MULTIPLE, MBR_SELECTBOX_DO_SELECT2 ),
			apply_filters( 'mbr/select_box_helper', apply_filters( 'mbr/site_lists/get',              NULL ), $subscribe_lists,    'mbr_memberoni_subscribe_lists',    MBR_SELECTBOX_DO_DISPLAY_ID, MBR_SELECTBOX_DO_MULTIPLE, MBR_SELECTBOX_DO_SELECT2 ),
			apply_filters( 'mbr/select_box_helper', apply_filters( 'mbr/site_lists/get',              NULL ), $unsubscribe_lists,  'mbr_memberoni_unsubscribe_lists',  MBR_SELECTBOX_DO_DISPLAY_ID, MBR_SELECTBOX_DO_MULTIPLE, MBR_SELECTBOX_DO_SELECT2 )
		);
	}

	
	public function wp_insert_post_memberoni_course( $post_id = 0, $post = FALSE, $updating = '' )
	{
		IF ( empty( $post_id ) OR empty( $post ) OR $post->post_type <> 'memberoni_course') :
			return;
		ENDIF;

		
		IF ( empty( $_POST ) OR empty( $_POST['action'] ) OR $_POST['action'] <> 'editpost' ) :
			return;
		ENDIF;

		$mbr_memberoni_assign_automations   = NULL;
		$mbr_memberoni_remove_automations   = NULL;
		$mbr_memberoni_assign_tags          = NULL;
		$mbr_memberoni_remove_tags          = NULL;
		$mbr_memberoni_subscribe_lists      = NULL;
		$mbr_memberoni_unsubscribe_lists    = NULL;

		$course_page_type = get_post_meta( $post_id, 'course_page_type', TRUE );

		
		IF ( empty( $course_page_type ) OR $course_page_type == 'course') :
			$mbr_memberoni_assign_automations = empty( $_POST['mbr_memberoni_assign_automations'] ) ? NULL : $_POST['mbr_memberoni_assign_automations'];
			$mbr_memberoni_remove_automations = empty( $_POST['mbr_memberoni_remove_automations'] ) ? NULL : $_POST['mbr_memberoni_remove_automations'];
			$mbr_memberoni_assign_tags        = empty( $_POST['mbr_memberoni_assign_tags'] )        ? NULL : $_POST['mbr_memberoni_assign_tags'];
			$mbr_memberoni_remove_tags        = empty( $_POST['mbr_memberoni_remove_tags'] )        ? NULL : $_POST['mbr_memberoni_remove_tags'];
			$mbr_memberoni_subscribe_lists    = empty( $_POST['mbr_memberoni_subscribe_lists'] )    ? NULL : $_POST['mbr_memberoni_subscribe_lists'];
			$mbr_memberoni_unsubscribe_lists  = empty( $_POST['mbr_memberoni_unsubscribe_lists'] )  ? NULL : $_POST['mbr_memberoni_unsubscribe_lists'];
		ENDIF;

		IF ( empty( $mbr_memberoni_assign_automations ) ) :
			delete_post_meta( $post_id, $this->memberoni_assign_automations_key );
		ELSE :
			update_post_meta( $post_id, $this->memberoni_assign_automations_key, json_encode( $mbr_memberoni_assign_automations ) );
		ENDIF;

		IF ( empty( $mbr_memberoni_remove_automations ) ) :
			delete_post_meta( $post_id, $this->memberoni_remove_automations_key );
		ELSE :
			update_post_meta( $post_id, $this->memberoni_remove_automations_key, json_encode( $mbr_memberoni_remove_automations ) ) ;
		ENDIF;

		IF ( empty( $mbr_memberoni_assign_tags ) ) :
			delete_post_meta( $post_id, $this->memberoni_assign_tags_key );
		ELSE :
			update_post_meta( $post_id, $this->memberoni_assign_tags_key, json_encode( $mbr_memberoni_assign_tags ) );
		ENDIF;

		IF ( empty( $mbr_memberoni_remove_tags ) ) :
			delete_post_meta( $post_id, $this->memberoni_remove_tags_key );
		ELSE :
			update_post_meta( $post_id, $this->memberoni_remove_tags_key, json_encode( $mbr_memberoni_remove_tags ) );
		ENDIF;

		IF ( empty( $mbr_memberoni_subscribe_lists ) ) :
			delete_post_meta( $post_id, $this->memberoni_subscribe_lists_key );
		ELSE :
			update_post_meta( $post_id, $this->memberoni_subscribe_lists_key, json_encode( $mbr_memberoni_subscribe_lists ) );
		ENDIF;

		IF ( empty( $mbr_memberoni_unsubscribe_lists ) ) :
			delete_post_meta( $post_id, $this->memberoni_unsubscribe_lists_key );
		ELSE :
			update_post_meta( $post_id, $this->memberoni_unsubscribe_lists_key, json_encode( $mbr_memberoni_unsubscribe_lists ) );
		ENDIF;
	}

	public function template_redirect_memberoni_course_completion()
	{
		
		$_GET['mc'] = NULL;
		$post_id    = get_the_id();
		$user_id    = get_current_user_id();

		
		mark_course_complete($post_id, $user_id);

		IF ( ! apply_filters( 'mbr/contact_id', FALSE ) ) :
			return;
		ENDIF;

		$assign_automations = json_decode( get_post_meta( $post_id, $this->memberoni_assign_automations_key, TRUE ), TRUE );
		$remove_automations = json_decode( get_post_meta( $post_id, $this->memberoni_remove_automations_key, TRUE ), TRUE );
		$assign_tags        = json_decode( get_post_meta( $post_id, $this->memberoni_assign_tags_key,        TRUE ), TRUE );
		$remove_tags        = json_decode( get_post_meta( $post_id, $this->memberoni_remove_tags_key,        TRUE ), TRUE );
		$subscribe_lists    = json_decode( get_post_meta( $post_id, $this->memberoni_subscribe_lists_key,    TRUE ), TRUE );
		$unsubscribe_lists  = json_decode( get_post_meta( $post_id, $this->memberoni_unsubscribe_lists_key,  TRUE ), TRUE );

		$contact_data       = [ 'email' => mbr_get_contact_field( 'email' ) ];

		do_action(
			'mbr/api/sync_ctla',
			[
				'contact_data'       => $contact_data,
				'assign_automations' => $assign_automations,
				'remove_automations' => $remove_automations,
				'assign_tags'        => $assign_tags,
				'remove_tags'        => $remove_tags,
				'subscribe_lists'    => $subscribe_lists,
				'unsubscribe_lists'  => $unsubscribe_lists
			]
		);
	}

	function add_protectable_post_types( $arr_protectable_post_types = [] )
	{
		array_push( $arr_protectable_post_types, 'memberoni_course' );
		return $arr_protectable_post_types;
	}

}
$GLOBALS['mbrmemberoni'] = mbr_memberoni::getInstance();