<?php
class mbr_membership_menu
{
	use TRAIT__getInstance;

	public function _load()
	{

		function MBRMENU()
		{
			IF ( empty( $GLOBALS['mbrmembermenu'] ) ) :
				$GLOBALS['mbrmembermenu'] = mbr_membership_menu::getInstance();
			ENDIF;

			return $GLOBALS['mbrmembermenu'];
		}

		
		add_action( 'init',             [ $this, 'register_membership_menus' ], 999 );
		add_filter( 'wp_nav_menu_args', [ $this, 'render_membership_menus'] );
	}

	public function register_membership_menus()
	{
		$default_menus  = get_registered_nav_menus();
		$extra_menus    = [];

		FOREACH ( $default_menus AS $slug => $name ) :
			unregister_nav_menu( $slug );
			$extra_menus[ $slug ] = $name . ' [Default] ';

			FOREACH ( apply_filters( 'mbr/site_membership_levels/get', NULL ) AS $tag_id => $obj ) :
				$level_name = ! empty( $obj['name'] ) ? $obj['name'] : apply_filters( 'mbr/site_tag/get', $tag_id );
				$extra_menus[ $slug . '_mbr_level_' . trim( $tag_id ) ] = '&nbsp;&nbsp;&nbsp;-&nbsp;' . $name . ' [' . $level_name . ']';
			ENDFOREACH;

			$extra_menus[ $slug . '_mbr_members' ]  = '&nbsp;&nbsp;&nbsp;-&nbsp;' . $name . ' [' . __( 'Any Membership', 'activemember360' ) . ']';
			$extra_menus[ $slug . '_mbr_loggedin' ] = '&nbsp;&nbsp;&nbsp;-&nbsp;' . $name . ' [' . __( 'Logged in',      'activemember360' ) . ']';
		ENDFOREACH;

		register_nav_menus( $extra_menus );
	}

	
	public function render_membership_menus( $content )
	{
		IF ( empty( $content['theme_location'] ) OR ! is_user_logged_in() ) :
			return $content;
		ENDIF;

		$slug                  = $content['theme_location'];
		$theme_locations       = [];
		$theme_locations[]     = $slug . '_mbr_loggedin';
		$user_levels           = [];
		$contact_id            = apply_filters( 'mbr/contact_id', NULL );
		$site_levels           = apply_filters( 'mbr/site_membership_levels/get', NULL );

		IF ( ! empty( $contact_id ) ) :
			$user_levels         = apply_filters( 'mbr/contact/membership_levels', NULL );
			$theme_locations[]   = $slug . '_mbr_members';
			FOREACH ( $site_levels AS $tag_id => $obj ) :
				$tag_id            = trim( $tag_id );
				
				 
				$theme_locations[] = $slug . '_mbr_level_' . $tag_id;
			ENDFOREACH;
		ENDIF;

		$wp_menu_locations     = get_nav_menu_locations();

		FOREACH ( $theme_locations AS $k => $location ) :
			
			IF ( ! empty( $wp_menu_locations[ $location ] ) ) :
				
				IF ( ! empty( $contact_id ) AND ! empty( $user_levels ) ) :
					
					FOREACH ( $site_levels AS $tag_id => $obj ) :
						
						
						IF ( ! array_key_exists( $tag_id, $user_levels ) ) :
							continue;
						ENDIF;
						$level_location =  $slug . '_mbr_level_' . trim( $tag_id );
						IF ( ! empty( $wp_menu_locations[ $level_location ] ) ) :
							$content['theme_location'] = $level_location;
							return $content;
						ENDIF;
					ENDFOREACH;
					$level_location =  $slug . '_mbr_members';
					IF ( ! empty( $wp_menu_locations[ $level_location ] ) ) :
						$content['theme_location'] = $level_location;
						return $content;
					ENDIF;
				ENDIF;
				$level_location =  $slug . '_mbr_loggedin';
				IF ( ! empty( $wp_menu_locations[ $level_location ] ) ) :
					$content['theme_location'] = $level_location;
					return $content;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		return $content;
	}
}
$GLOBALS['mbrmembermenu'] = mbr_membership_menu::getInstance();
