<?php
final class mbr_activemember360_menu EXTENDS mbr_redux_base_class
{
	use TRAIT__getInstance;

	public $opt_name_menu_parent = 'mbr_activemember360_menu';
	public $page_slug_parent     = MBR_MENU_PARENT_PAGE;

	public function _load()
	{
		add_action( 'plugins_loaded',                                                    [ $this, 'init_admin_cpt_panels' ],             99998 );
		add_filter( "redux/{$this->opt_name_menu_parent}/panel/template/header.tpl.php", [ $this, 'alternate_header' ]                         );
		add_action( 'admin_menu',                                                        [ $this, 'admin_menu' ],                        99999 );
		add_filter( 'custom_menu_order',                                                 [ $this, 'reorder_submenu' ] );
	}

	public function admin_menu()
	{
		add_submenu_page( MBR_MENU_PARENT_PAGE, _x( 'Documentation', 'wp_admin', 'activemember360' ) ,  _x( 'Documentation', 'wp_admin', 'activemember360' ),  'activate_plugins', 'mbr360-documentation', [ MBR(), 'documentation_admin' ] );
	}

	public function reorder_submenu( $menu_order )
	{
		global $MBR_OPTIONS, $submenu;
		$subname     = strtolower( MBR_MENU_PARENT_PAGE );
		$prio        = 1;  
		$arr_license = apply_filters( 'mbr/license/status/get', NULL );

		IF ( empty( $submenu[ $subname ] ) ) :
			return $menu_order;
		ENDIF;

		IF ( $arr_license['status'] <> 'inactive' AND $MBR_OPTIONS['api_url'] AND $MBR_OPTIONS['api_key'] ) :
			$new_order = [
				'activemember360'                         => $prio++, 
				'mbr360-documentation'                    => $prio++,
				'mbr360-plugin-options'                   => $prio++,
				'mbr360-membership-levels'                => $prio++,
				'mbr360-extensions'                       => $prio++,
				'mbr360-utilities'                        => $prio++,
				'mbr360-contacts'                         => $prio++,
				'mbr360-bulk-editor'                      => $prio++,
				'mbr360-webhooks'                         => $prio++,
				'mbr360-role-tags-mapping'                => $prio++,
				'mbr360-templates'                        => $prio++,
				'edit.php?post_type=mbrcustsc'            => $prio++
			];

			FOREACH ( $submenu[ $subname ] AS $key => $item ) :
				IF ( $item[2] == 'activemember360' ) :
					$new_menu[0] = $item;
				ELSEIF ( array_key_exists( $item[2], $new_order ) ) :
					$new_menu[ $new_order[ $item[2] ] ] = $item;
				ELSEIF ( $item[0] == __( 'Options Object', 'redux-framework' ) ) :
					unset( $submenu[ $subname ][ $key ] );
				ELSE :
					$new_menu[ $prio++ ] = $item;
				ENDIF;
			ENDFOREACH;

			ksort($new_menu);
			$submenu[ $subname ] = $new_menu;
		ELSE :
			// If no valid license or missing API parameters, we shorten the menu to only 2 items
			$new_order = [
				'activemember360'      => $prio++,
				'mbr360-documentation' => $prio++,
			];
			FOREACH ( $submenu[ $subname ] AS $key => $item ) :
				IF ( $item[2] == 'activemember360' ) :
					$new_menu[0] = $item;
				ELSEIF ( array_key_exists( $item[2], $new_order ) ) :
					$new_menu[ $new_order[ $item[2] ] ] = $item;
				ELSEIF ( $item[0] == __( 'Options Object', 'redux-framework' ) ) :
					unset( $submenu[ $subname ][ $key ] );
				ENDIF;
			ENDFOREACH;
			$submenu[ $subname ] = $new_menu;
		ENDIF;

		
		return $menu_order;
	}

	public function init_admin_cpt_panels()
	{
		$admin_title           = _x( 'ActiveMember360', 'wp_admin', 'activemember360' );

		$arr_config            =  [
			'opt_name'           => $this->opt_name_menu_parent,
			'page_slug'          => $this->page_slug_parent,
			'admin_title'        => $admin_title,
			'menu_title'         => $admin_title,
			'menu_icon'          => apply_filters( 'mbr/plugin_favicon', NULL ),
			'page_priority'      => 2,
		];

		$arr_config            = array_merge( $this->arr_default_main_admin_panel_settings, $arr_config );

		Redux::setArgs( $this->opt_name_menu_parent, $arr_config );
	}

}
$GLOBALS['mbr_inst_admin_menu'] = mbr_activemember360_menu::getInstance();