<?php
class mbr_popup_maker {

	use TRAIT__getInstance;

	public function _load()
	{
		function MBRPUM()
		{
			IF (empty($GLOBALS['mbr_popup_maker'])) :
				$GLOBALS['mbr_popup_maker'] = mbr_popup_maker::getInstance();
			ENDIF;

			return $GLOBALS['mbr_popup_maker'];
		}

		add_action( 'init', [ $this, '_init' ], 11 );
	}

	public function _init()
	{
		IF ( ! class_exists( 'Popup_Maker' ) ) :
			return;
		ENDIF;

		add_filter( 'pum_get_conditions', [ $this, 'pum_get_conditions'], 9999, 1 );

		$this->arr_site_tags = apply_filters( 'mbr/site_tags/get', NULL );

		IF ( empty( $this->arr_site_tags ) OR ! is_array( $this->arr_site_tags ) ) :
			return;
		ENDIF;
	}


	public function pum_get_conditions( $conditions )
	{
		$conditions['mbr_pum_has_tags_selected'] = [
			'group'                   => _x( 'ActiveMember360', 'popup-maker', 'activemember360' ),
			'name'                    => _x( 'Has any Tag', 'popup-maker', 'activemember360' ),
			'callback'                => [ $this, 'pum_condition_has_tags_callback' ],
			'fields'                  => [
				'selected'              => [
					'placeholder'         => _x( 'Select Tag(s)', 'popup-maker', 'activemember360' ),
					'type'                => 'select',
					'multiple'            => TRUE,
					'select2'             => TRUE,
					'as_array'            => TRUE,
					'options'             => $this->arr_site_tags
				]
			]
		];

		$conditions['mbr_pum_not_has_tags_selected'] = [
			'group'                   => _x( 'ActiveMember360', 'popup-maker', 'activemember360' ),
			'name'                    => _x( 'Does not have any Tag', 'popup-maker', 'activemember360' ),
			'callback'                => [ $this, 'pum_condition_not_has_tags_callback' ],
			'fields'                  => [
				'selected'              => [
					'placeholder'         => _x( 'Select Tag(s)', 'popup-maker', 'activemember360' ),
					'type'                => 'select',
					'multiple'            => TRUE,
					'select2'             => TRUE,
					'as_array'            => TRUE,
					'options'             => $this->arr_site_tags
				]
			]
		];

		return $conditions;
	}

	public function pum_condition_has_tags_callback( $settings )
	{
		return mbr_has_tags( $settings['selected'] );
	}

	public function pum_condition_not_has_tags_callback( $settings )
	{
		IF ( mbr_has_tags( $settings['selected'] ) ) :
			return FALSE;
		ENDIF;

		return TRUE;
	}

}
$GLOBALS['mbr_popup_maker'] = mbr_popup_maker::getInstance();
