<?php








class mbr_privacy {

	use TRAIT__getInstance;

	






	public function _load()
	{
		add_filter( 'wp_privacy_personal_data_exporters', [ $this, 'register_personal_data_exporters' ], 10 );
		add_filter( 'wp_privacy_personal_data_erasers',   [ $this, 'register_personal_data_erasers' ],   10 );
	}

	






	public function register_personal_data_exporters( $exporters = [] )
	{
		$exporters['activemember360'] = [ 'exporter_friendly_name' => __( 'ActiveMember360 Personal Data', 'activemember360' ), 'callback' => [ $this, 'personal_data_exporter' ] ];

		return $exporters;
	}

	






	public function register_personal_data_erasers( $erasers = [] )
	{
		$erasers['activemember360']   = [ 'eraser_friendly_name'   => __( 'ActiveMember360 Personal Data', 'activemember360' ), 'callback' => [ $this, 'personal_data_eraser' ] ];

		return $erasers;
	}

	









	public function personal_data_exporter( $email_address, $page = 1 )
	{
		global $wpdb;

		$export_items         = [];

		IF ( ! empty( $email_address ) AND is_email( $email_address ) ) :
			IF ( $row = $wpdb->get_row( "SELECT * FROM {$wpdb->tbl_contact} WHERE email='{$email_address}' LIMIT 1" ) ) :

				$data             = [];

				$contact          = gz_decode( $row->data );
				IF ( is_array( $contact ) AND isset( $contact['id'] ) ) :
					FOREACH ( $contact AS $field => $value ) :
						IF ( '' == $value ) :
							continue;
						ENDIF;
						IF ( is_array( $value ) ) :
							$value      = json_encode( $value );
						ENDIF;
						$data[]       = [ 'name' => $field, 'value' => $value ];
					ENDFOREACH;
				ENDIF;

				IF ( ! empty( $row->last_active ) ) :
					$data[]         = [ 'name' => 'Last active',   'value' => $row->last_active ];
				ENDIF;
				IF ( ! empty( $row->last_updated ) ) :
					$data[]         = [ 'name' => 'Last updated',  'value' => $row->last_updated ];
				ENDIF;

				IF ( ! empty( $data ) AND is_array( $data ) ) :
					$export_items[] = [ 'group_id' => 'activemember360_cache', 'group_label' => 'ActiveMember360 Cache', 'item_id' => uniqid(), 'data' => $data ];
				ENDIF;

			ENDIF;
		ENDIF;

		$user                 = get_user_by( 'email', $email_address );
		IF ( ! empty( $user->ID ) ) :
			$data               = [];
			IF ( $mbr_login = get_user_meta( $user->ID, 'mbr_login', TRUE ) ) :
				$data[]           = [ 'name' => 'Login', 'value' => $mbr_login ];
			ENDIF;
			IF ( $mbr_last_ip = get_user_meta( $user->ID, 'user_last_ipnr', TRUE ) ) :
				$data[]           = [ 'name' => 'Last IP', 'value' => $mbr_last_ip ];
			ENDIF;
			IF ( $mbr_role_history = get_user_meta( $user->ID, 'mbr_role_tag_map_user_history', TRUE ) ) :
				$data[]           = [ 'name' => 'Role history', 'value' => json_encode( $mbr_role_history ) ];
			ENDIF;
			IF ( $mbr_tickets_updates = get_user_meta( $user->ID, 'mbr_tickets_updates', TRUE ) ) :
				$data[]           = [ 'name' => 'Ticket updates', 'value' => json_encode( $mbr_tickets_updates ) ];
			ENDIF;
			IF ( ! empty( $data ) AND is_array( $data ) ) :
				$export_items[]   = [ 'group_id' => 'activemember360_user_meta', 'group_label' => 'ActiveMember360 User Meta', 'item_id' => uniqid(), 'data' => $data ];
			ENDIF;
		ENDIF;

		return [ 'data' => $export_items, 'done' => TRUE ];
	}

	









	public function personal_data_eraser( $email_address, $page = 1 )
	{
		global $wpdb;

		$user = get_user_by( 'email', $email_address );
		IF ( ! empty( $user->ID ) ) :
			$wpdb->query( "DELETE FROM {$wpdb->tbl_contact} WHERE email='{$email_address}'" );
			delete_user_meta( $user->ID, 'mbr_user_id' );
			delete_user_meta( $user->ID, 'mbr_login' );
			delete_user_meta( $user->ID, 'user_last_ipnr' );
			delete_user_meta( $user->ID, 'mbr_role_tag_map_user_history' );
			delete_user_meta( $user->ID, 'mbr_tickets_updates' );
		ENDIF;

		return [ 'items_removed' => TRUE, 'items_retained' => FALSE, 'messages' => [], 'done' => TRUE ];
	}

}



$GLOBALS['mbr_privacy'] = mbr_privacy::getInstance();
