<?php
class mbr_remoteauth
{

	use TRAIT__getInstance;

	public function _load()
	{

		function MBRREMAUTH()
		{
			IF ( empty( $GLOBALS['mbrremoteauth'] ) ) :
				$GLOBALS['mbrremoteauth'] = mbr_remoteauth::getInstance();
			ENDIF;

			return $GLOBALS['mbrremoteauth'];
		}

		add_action( 'init', [ $this, 'remote_login_request' ], 12 );
	}

	public function remote_login_request()
	{
		IF ( ! empty( $_REQUEST['mbr_auth'] ) AND apply_filters( 'mbr/secodes/validate', $_REQUEST['mbr_auth'] ) ) :

			do_action( 'mbr/clear_ob' );

			IF ( ! empty( $_REQUEST['user'] ) AND ! empty( $_REQUEST['pass'] ) ) :
				$arrLOGIN = $this->remote_login();

				IF ( is_array( $arrLOGIN ) ) :
					IF ( isset( $_REQUEST['json'] ) ) :
						$login = json_encode( $arrLOGIN );
					ELSE :
						$login = serialize( $arrLOGIN );
					ENDIF;
				ELSE :
					$login = $arrLOGIN;
				ENDIF;
				 IF ( ! empty( $_REQUEST['base64'] ) ) :
					$login = base64_encode( $login );
				ENDIF;
				echo $login;
				exit;
			ENDIF;
		ENDIF;
	}

	public function remote_login() {
		$pUSER = trim( $_REQUEST['user'] );
		$pPASS = trim( $_REQUEST['pass'] );

		$passfield = apply_filters( 'mbr/passfield', NULL );

		IF ( is_email( $pUSER ) ) :
			IF ( $contact = apply_filters( 'mbr/fetch_contact', [ 'email' => $pUSER, 'local' => FALSE ], FALSE ) ) :
				


				IF ( $contact[ $passfield ] <> $pPASS ) :
					do_action( 'mbr/clear_ob' );
					die(0);
				ELSE:
					IF ( isset( $_REQUEST['required_tags'] ) ) :
						$arrUSERTAGS = array_flip( explode( ',', $contact['tag_ids'] ) );
						$arrTAGS     = apply_filters( 'mbr/tags/normalize/ids',  $_REQUEST['required_tags'], TRUE );
						$arrTAGS     = array_flip( $arrTAGS );

						FOREACH ( $arrTAGS AS $tag_id => $filler ) :
							IF ( ! array_key_exists( $tag_id, $arrUSERTAGS ) ) :
								do_action( 'mbr/clear_ob' );
								die(0);
							ENDIF;
						ENDFOREACH;

					ENDIF;

					IF ( isset( $_REQUEST['retfields'] ) AND trim( $_REQUEST['retfields'] ) <> '' ) :
						$arrRETFIELDS = array_filter( explode( ',', trim( $_REQUEST['retfields'] ) ) );
						FOREACH ( $contact AS $fieldname => $filler ) :
							IF ( ! in_array( $fieldname, $arrRETFIELDS ) ) :
								unset( $contact[ $fieldname ] );
							ENDIF;
						ENDFOREACH;
					ENDIF;

					unset( $contact[ $passfield ] );
					return $contact;
				ENDIF;
			ENDIF;
		ENDIF;

		do_action( 'mbr/clear_ob' );
		die(0);
	}

}
$GLOBALS['mbrremoteauth'] = mbr_remoteauth::getInstance();