<?php
class mbr_session
{
	public $contact   = [];

	public function __construct()
	{
		$this->contact = $this->load_session();
	}

	function load_session()
	{
		IF (!empty($_COOKIE[MBR_COOKIE_NAME])) :
			
			IF ($contact = apply_filters('mbr/contact/fetch', ['hash' => $_COOKIE[MBR_COOKIE_NAME]])) :
				return $contact;
			ENDIF;
		ENDIF;

		IF ( ! empty( wp_get_current_user()->user_email ) ) :
		  IF ( $contact = apply_filters( 'mbr/contact/fetch', [ 'email' => wp_get_current_user()->user_email ] ) ) :
				
				setcookie(MBR_COOKIE_NAME, $contact['hash'], time() + MBR_COOKIE_EXP, COOKIEPATH, COOKIE_DOMAIN);
				IF ( SITECOOKIEPATH <> COOKIEPATH ) :
					setcookie(MBR_COOKIE_NAME, $contact['hash'], time() + MBR_COOKIE_EXP, SITECOOKIEPATH, COOKIE_DOMAIN);
				ENDIF;
				return $contact;
			ENDIF;
		ENDIF;
		return [];
	}

	public function __get($field)
	{
		IF (array_key_exists($name, $this->contact)) :
			return $this->contact[$field];
		ENDIF;
		return null;
	}

	public function __set($field, $value)
	{
		$this->contact[$field] = $value;
	}

	public function __unset($field)
	{
		unset($this->contact[$field]);
	}

	function save_session($contact = false)
	{
		global $wpdb;

		IF ((defined('DOING_AJAX') AND DOING_AJAX) OR (defined('DOING_CRON') AND DOING_CRON) OR isset($_GET['doing_wp_cron'])) :
			return;
		ENDIF;

		IF ( $contact === FALSE ) :
			  $contact = apply_filters( 'mbr/session/get', [] );
		ENDIF;

		IF (!empty($contact['id'])) :
			$wpdb->query( $wpdb->prepare( "REPLACE INTO {$wpdb->tbl_contact} (contact_id, hash, email, data, last_active, last_updated) VALUES(%s,%s,%s,%s,UTC_TIMESTAMP(),UTC_TIMESTAMP()) ", $contact['id'], $contact['hash'], $contact['email'], 	gz_encode( $contact ) ) );
		ENDIF;
	}

}