<?php
class mbr_theme_switcher
{
	use TRAIT__getInstance;

	public function _load()
	{

		function mbrthemeswitch()
		{
			IF ( empty( $GLOBALS['mbrthemeswitch'] ) ) :
				$GLOBALS['mbrthemeswitch'] = mbr_theme_switcher::getInstance();
			ENDIF;

			return $GLOBALS['mbrthemeswitch'];
		}

		IF ( is_admin() ) :
			add_filter( 'mbr/theme_switch/add_theme_column',             [ $this, 'add_theme_column' ],            10, 3 );
			add_filter( 'mbr/theme_switch/add_theme_column/redux',       [ $this, 'add_theme_column_redux' ],      10, 0 );
		ELSE:
			add_filter( 'template',                                      [ $this, 'switch_template' ],             999 );
			add_filter( 'stylesheet',                                    [ $this, 'switch_stylesheet' ],           999 );
		ENDIF;
	}

	public function switch_template( $template = '' )
	{
		$thisTHEME = $this->getGroupTheme();
		$template  = $thisTHEME['Template'];

		return $template;
	}

	public function switch_stylesheet( $stylesheet = '' )
	{
		$thisTHEME  = $this->getGroupTheme( $stylesheet );
		$stylesheet = $thisTHEME['Stylesheet'];

		return $stylesheet;
	}

	public function getGroupTheme( $stylesheet = '' )
	{
		static $site_levels = NULL;

		IF ( is_null( $site_levels ) ) :
			$site_levels = apply_filters( 'mbr/site_membership_levels/get', NULL );
		ENDIF;

		$memberships   = apply_filters( 'mbr/contact/membership_levels', NULL );

		IF ( ! empty( $site_levels ) AND is_array( $site_levels ) ) :
			FOREACH ( $site_levels AS $tag_id => $level ) :
				IF ( ! empty( $memberships[ $tag_id ] ) ) :
					IF ( ! empty( $level['theme'] ) AND $level['theme'] <> 'Site Default' ) :
						return wp_get_theme( $level['theme'] );
					ENDIF;
				ENDIF;
			ENDFOREACH;
		ENDIF;

		return wp_get_theme( $stylesheet );
	}

	public function add_theme_column( $type, $thisTAG = NULL, $thisLEVEL = NULL )
	{
		IF ( $type == 'header' ) :
			return '<th>' . _x( 'Theme', 'wp_admin', 'activemember360' ) . '</th>';
		ENDIF;

		static $wp_themes = NULL;
		IF ( is_null( $wp_themes ) ) :
			$wp_themes      = wp_get_themes( [ 'allowed' => TRUE ] );
		ENDIF;

		static $title     = NULL;
		IF ( is_null( $title ) ) :
			$title          = _x('Select the theme you wish to use for members of this level.', 'wp_admin', 'activemember360' );
		ENDIF;

		static $default   = NULL;
		IF ( is_null( $default ) ) :
			$default        =  _x('Default Site Theme', 'wp_admin', 'activemember360' );
		ENDIF;

		$edit             = ( $type == 'edit' );
		$type_field       = $edit ? 'membership_levels' : 'membership_levels_new';
		$prefix           = $edit ? '' : 'n';
		$options          = '';
		FOREACH ( $wp_themes AS $themeNAME => $themeDATA ) :
			$selected       = ( $edit AND $themeNAME == $thisLEVEL['theme'] ) ? " selected='selected'" : '';
			$options       .= "<option value='{$themeNAME}'{$selected}>{$themeDATA['Name']}</option>";
		ENDFOREACH;

		return "<td><a name='imn{$prefix}{$thisTAG}' title='{$title}'></a><select name='{$type_field}[{$thisTAG}][theme]' class='form-control'><option value=''>{$default}</option>{$options}</select></td>";
	}

	public function add_theme_column_redux()
	{
		static $wp_themes = NULL;
		IF ( is_null( $wp_themes ) ) :
			$wp_themes      = wp_get_themes( [ 'allowed' => TRUE ] );
		ENDIF;

		$arr_themes = [];
		FOREACH ( $wp_themes AS $theme_name => $theme_data ) :
			$arr_themes[ $theme_name ] = $theme_data['Name'];
		ENDFOREACH;

		return $arr_themes;
	}

}
$GLOBALS['mbrthemeswitch'] = mbr_theme_switcher::getInstance();