<?php
class WP_Widget_Login2 extends WP_Widget
{
  function __construct()
  {
	parent::__construct('mbr_login2', '&nbsp;ActiveMember360 Login', ['classname' => 'widget_login2', 'description' => 'ActiveMember360 Login Widget'], ['width' => 330, 'height' => 100]);
  }

  function widget( $args, $instance )
  {
	global $user, $current_user, $post, $redirect_to, $user_identity;
	extract($args);
	$title         = $instance['title'];
	$title_after   = $instance['title_after'];
	$divfloat      = isset($instance['divfloat']) ? $instance['divfloat'] : 'left';
	$hide_after    = $instance['hide_after']   ? 1 : 0;
	$addusername   = $instance['addusername']  ? 1 : 0;
	$register      = $instance['register']     ? 1 : 0;
	$rememberme    = $instance['rememberme']   ? 1 : 0;
	$lostpassword  = $instance['lostpassword'] ? 1 : 0;
	$automation_id = isset($instance['automation_id']) ? $instance['automation_id'] : 0;
	$nobreak       = $instance['nobreak']      ? 1 : 0;
	$inputwidth    = $instance['inputwidth'];
	$submt         = esc_attr($instance['submt']);
	$wtext         = $instance['wtext'];
	$stext         = $instance['stext'];

	IF ((!empty($_POST['mbrlogin2']))) :
	  $user = mbr_login_helper($_POST['log'], $_POST['pwd'], 'mbrlogin2');
	  IF (!is_wp_error($user)) :
		$current_user = $user;
	  ELSE:
		$login_failed_message = $user->get_error_message();
	  ENDIF;
	ENDIF;

	$inputwidth = trim($inputwidth);
	IF (trim($inputwidth) == '') :
	  $inputwidth = '150px';
	ELSE :
	  IF (substr($inputwidth,-1) <> '%') :
		$inputwidth .= 'px';
	  ENDIF;
	ENDIF;

	IF (!is_user_logged_in() OR !$hide_after) :
	  echo $before_widget;
	ENDIF;

	IF (isset($_GET['action']) AND $_GET['action'] == 'sendpassword2') :
	  $parms = ['user_login' => $_POST['send_user_login'], 'fromaddr' => '', 'fromname' => '', 'automation_id' => $automation_id];
	  $result = mbr_send_password($parms);
	  echo "<script>alert('" . htmlentities($result[1]) . "');</script>";
	ENDIF;

	IF (isset($_GET['action']) AND $_GET['action'] == 'lostpassword') :
	  echo $before_title . __('Lost Password', 'activemember360') . $after_title;
	  echo "<div align='{$divfloat}'>";
	  echo "<form name='mbr_lost_login_password' action='?action=sendpassword2' method='post'>";
	  echo "<input type='hidden' name='mbr_send_login_password' value='true' />";
	  echo __('Please enter your email address.', 'activemember360');
	  echo "<br /><label for='user_login'><input name='send_user_login' value='' class='mid' id='user_login' type='text' style='width:{$inputwidth}' /></label>";
	  echo "<br /><input type='submit' class='mbr_lost_login_password' name='wp-submit' id='wp-submit' value='" . __('Send password', 'activemember360') . "' />";
	  echo "</form>";
	  echo "</div>";
	ELSEIF (is_user_logged_in() AND $hide_after) :
	  
	ELSE :
	  IF (is_user_logged_in()) :
		IF (trim($title_after) == '') :
		  IF (trim($title)) :
			$title = 'Logged in';
		  ENDIF;
		ELSE :
		  $title = $title_after;
		ENDIF;
		IF ($addusername) :
		  IF (isset($user_identity) AND trim($user_identity) <> '') :
			$display_name = $user_identity;
		  ELSEIF (isset($current_user->display_name) AND trim($current_user->display_name) <> '') :
			$display_name = $current_user->display_name;
		  ELSE :
			$display_name = '';
		  ENDIF;
		  IF ($display_name) :
			$title .= (trim($title)=='' ? '' : ": ") . $display_name;
		  ENDIF;
		ENDIF;
	  ELSE :
		IF (trim($title) == '') :
		  $title = 'Login';
		ENDIF;
	  ENDIF;
	  $title = apply_filters('widget_title', $title, $instance, $this->id_base);
	  IF (trim($submt) == '') :
		$submt = 'Login';
	  ENDIF;
	  IF (!empty($title)) :
		echo $before_title . $title . $after_title;
	  ENDIF;
	  echo "<div align='{$divfloat}'>";
	  echo "<div class='widget_login2'>";
	  IF (!is_user_logged_in()) :
		echo apply_filters('widget_text', $wtext) . "<br />";
		IF (isset($_POST['mbrlogin2'])) :
		  $errTXT = $login_failed_message;
		  IF (isset($_COOKIE['tmp_login_message'])):
			$errTXT = $_COOKIE['tmp_login_message'];
			mbr_delete_cookie('tmp_login_message');
		  ENDIF;
		  echo "<strong style='color:darkred'>{$errTXT}</strong><br />";
		ENDIF;
		echo "<form name='widget_login2' action='' method='post'>";
		echo "<input type='hidden' name='mbrlogin2'   value='1' />";
		echo "<input type='hidden' name='autologin'   value='yes' />";
		echo "<input type='hidden' name='testcookie'  value='1' />";
		echo "<input type='hidden' name='redirect_to' value='_use_level_redir_' />";
		IF (!$rememberme) :
		  echo "<input type='hidden' name='rememberme' value='forever' />";
		ENDIF;
		IF ($nobreak) :
		  echo "<table style='border:0px'>";
		  echo "<tr>";
		  echo "<td><label for='user_login'>" . __('Email: ', 'activemember360') . "</label></td>";
		  echo "<td><input name='log' value='" . (isset($_POST['log']) ? $_POST['log'] : '') . "' class='mid' id='user_login' type='text' style='width:{$inputwidth}' /></td>";
		  echo "</tr>";
		  echo "<tr>";
		  echo "<td><label for='user_pass'>" . __('Password: ', 'activemember360') . "</label></td>";
		  echo "<td><input name='pwd' value='' class='mid' id='user_pass' type='password' style='width:{$inputwidth}' /></td>";
		  echo "</tr>";
		  echo "<tr>";
		  echo "<td colspan='2' style='width:100%;text-align:center'><input class='mbr_widget_login2_submit' style='min-width:50%;' type='submit' name='mbr_widget_login2_submit' id='mbr_widget_login2_submit' value='{$submt}'  /></td>";
		  echo "</tr>";
		  IF ($rememberme OR $lostpassword) :
			echo "<tr>";
			echo "<td colspan='2'>";
			IF ($rememberme) :
			  echo "<label for='lg_rememberme'><input name='rememberme' class='checkbox' id='lg_rememberme' value='forever' type='checkbox' checked='checked' />" . __('Remember me ', 'activemember360') . "</label>";
			  IF ($lostpassword) :
				echo "<br />";
			  ENDIF;
			ENDIF;
			IF ($lostpassword) :
			  echo "<a href='?action=lostpassword'>" . __('Lost your password?', 'activemember360') . "</a>";
			  IF ($register) :
				echo "<br />";
			  ENDIF;
			ENDIF;
			IF ($register) :
			  IF (mbr_regpage_url()) :
				echo "<a href='" . mbr_regpage_url() . "'>" . __('Not a member? Sign up here.', 'activemember360') . "</a>";
			  ELSEIF (mbr_regpage()) :
				echo "<a href='" . get_permalink(mbr_regpage()) . "'>" . __('Not a member? Sign up here.', 'activemember360') . "</a>.";
			  ELSE :
				IF (blog_get_option('users_can_register')) :
				  echo "<a href='" . site_url('wp-login.php?action=register') . "'>" . __('Not a member? Sign up here.', 'activemember360') . "</a>.";
				ENDIF;
			  ENDIF;
			ENDIF;
			echo "</td>";
			echo "</tr>";
		  ENDIF;
		  echo "</table>";
		ELSE :
		  echo "<label for='user_login'>" . __('Email: ', 'activemember360') . "<br /><input name='log' value='" . (isset($_POST['log'])?$_POST['log']:'') . "' class='mid' id='user_login' type='text' style='width:{$inputwidth}' /></label>";
		  echo "<br /><label for='user_pass'>" . __('Password: ', 'activemember360') . "<br /><input name='pwd' value='' class='mid' id='user_pass' type='password' style='width:{$inputwidth}' /></label>";
		  echo "<br /><input class='mbr_widget_login2_submit' type='submit' name='mbr_widget_login2_submit' id='mbr_widget_login2_submit' value='{$submt}' />";
		  IF ($rememberme) :
			echo "<br /><label for='lg_rememberme'><input name='rememberme' class='checkbox' id='lg_rememberme' value='forever' type='checkbox' checked='checked' />" . __('Remember me ', 'activemember360') . "</label>";
		  ENDIF;
		  IF ($lostpassword) :
			echo "<br /><a href='?action=lostpassword'>" . __('Lost your password?', 'activemember360') . "</a>";
		  ENDIF;
		  IF ($register) :
			IF (mbr_regpage_url()) :
			  echo "<br /><a href='" . mbr_regpage_url() . "'>" . __('Not a member? Sign up here.', 'activemember360') . "</a>";
			ELSEIF (mbr_regpage()) :
			  echo "<br /><a href='" . get_permalink(mbr_regpage()) . "'>" . __('Not a member? Sign up here.', 'activemember360') . "</a>.";
			ELSE :
			  echo "<br /><a href='" . site_url('wp-login.php?action=register') . "'>" . __('Not a member? Sign up here.', 'activemember360') . "</a>.";
			ENDIF;
		  ENDIF;
		ENDIF;
		echo "</form>";
		echo "</div>";
		echo "</div>";
	  ELSE :
		echo apply_filters('widget_text', $stext) . "<br />";
		IF (mbr_get_contact_payment_failed_tags()) :
		  echo "<span><a href='#' onclick='payf_popup()' style='font-weight:bold;color:red;'>" . __('There is a problem with your account.<br />Click here for more information.', 'activemember360') . "</a></span>";
		ENDIF;
		$thisREDIR = mbr_redir_logout();
		IF (isset($post) AND trim($thisREDIR) == '') :
		  $thisREDIR = get_permalink($post->ID);
		ENDIF;
		echo "<ul><li><a href='" . wp_logout_url($thisREDIR) . "'>" . __('Log out', 'activemember360') . "</a></li></ul>";
		echo "</div>";
		echo "</div>";
	  ENDIF;
	ENDIF;
	IF (!is_user_logged_in() OR !$hide_after) :
	  echo $after_widget;
	ENDIF;
  }

  function update($new_instance, $old_instance) {
	$new_instance['title']           = strip_tags($new_instance['title']);
	$new_instance['title_after']     = strip_tags($new_instance['title_after']);
	$new_instance['divfloat']        = isset($new_instance['divfloat']) ? $new_instance['divfloat'] : 'left';
	$new_instance['hide_after']      = $new_instance['hide_after']  ? 1 : 0;
	$new_instance['addusername']     = $new_instance['addusername'] ? 1 : 0;
	$new_instance['register']        = $new_instance['register']    ? 1 : 0;
	$new_instance['rememberme']      = $new_instance['rememberme']  ? 1 : 0;
	$new_instance['lostpassword']    = $new_instance['lostpassword']? 1 : 0;
	$new_instance['automation_id']   = isset($new_instance['automation_id']) ? $new_instance['automation_id'] : 0;
	$new_instance['nobreak']         = $new_instance['nobreak']     ? 1 : 0;
	$new_instance['inputwidth']      = $new_instance['inputwidth'];
	$new_instance['submt']           = strip_tags($new_instance['submt']);
	$new_instance['wtext']           = $new_instance['wtext'];
	$new_instance['stext']           = $new_instance['stext'];
	return $new_instance;
  }

  function form($instance) {
	$instance        = wp_parse_args( (array) $instance, ['title' => '', 'title_after' => '', 'divfloat' => 'left', 'hide_after' => 0, 'addusername' => 1, 'register' => 1, 'rememberme' => 1, 'lostpassword' => 1, 'automation_id' => 0, 'nobreak' => 0, 'inputwidth' => '150px', 'wtext' => '', 'stext' => '', 'submt' => '']);
	$title           = strip_tags($instance['title']);
	$title_after     = strip_tags($instance['title_after']);
	$divfloat        = esc_attr($instance['divfloat']);
	$hide_after      = esc_attr($instance['hide_after']);
	$addusername     = esc_attr($instance['addusername']);
	$register        = esc_attr($instance['register']);
	$rememberme      = esc_attr($instance['rememberme']);
	$lostpassword    = esc_attr($instance['lostpassword']);
	$automation_id   = (int)esc_attr($instance['automation_id']);
	$nobreak         = esc_attr($instance['nobreak']);
	$inputwidth      = esc_attr($instance['inputwidth']);
	$submt           = esc_attr($instance['submt']);
	$wtext           = $instance['wtext'];
	$stext           = $instance['stext'];
	?>
	<p>
	<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Title before login:' ); ?></label>
	<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
	</p>
	<p>
	<label for="<?php echo $this->get_field_id('title_after'); ?>"><?php _e( 'Title after login:' ); ?></label>
	<input class="widefat" id="<?php echo $this->get_field_id('title_after'); ?>" name="<?php echo $this->get_field_name('title_after'); ?>" type="text" value="<?php echo $title_after; ?>" />
	</p>
	<p>
	<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('hide_after');?>" name="<?php echo $this->get_field_name('hide_after');?>"<?php (isset($hide_after) ? checked($hide_after) : ''); ?> />
	<label for="<?php echo $this->get_field_id('hide_after'); ?>"><?php _e( 'Hide Widget after Login?' ); ?></label>
	</p>
	<p>
	<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('addusername');?>" name="<?php echo $this->get_field_name('addusername');?>"<?php (isset($addusername) ? checked($addusername) : ''); ?> />
	<label for="<?php echo $this->get_field_id('addusername'); ?>"><?php _e( 'Add User Name to Title after login?' ); ?></label>
	</p>
	<p>
	<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('register'); ?>" name="<?php echo $this->get_field_name('register'); ?>"<?php (isset($register) ? checked($register) : ''); ?> />
	<label for="<?php echo $this->get_field_id('register'); ?>"><?php _e( 'Include "Register" link?' ); ?></label>
	</p>
	<p>
	<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('rememberme');?>" name="<?php echo $this->get_field_name('rememberme');?>"<?php (isset($rememberme) ? checked($rememberme) : ''); ?> />
	<label for="<?php echo $this->get_field_id('rememberme'); ?>"><?php _e( 'Include "Remember Me" option?' ); ?></label>
	</p>
	<p>
	<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('lostpassword');?>" name="<?php echo $this->get_field_name('lostpassword');?>"<?php (isset($lostpassword) ? checked($lostpassword) : ''); ?> />
	<label for="<?php echo $this->get_field_id('lostpassword'); ?>"><?php _e( 'Include "Lost Password" link?' ); ?></label>
	</p>
	<p>
	<label for="<?php echo $this->get_field_id('automation_id'); ?>"><?php _e( 'Method to use for sending Password Email?' ); ?></label>
	<select name="<?php echo $this->get_field_name('automation_id'); ?>" style="width:100%;">
	  <?php
	  mbr_fetch_automations();
	  echo '<option value="">' . __('Send Password via WordPress ', 'activemember360') . '</option>';
	  FOREACH (mbr_get_site_automations() as $aid => $aname) :
		$status = mbr_site_automation_status($aid) <> 1 ? 'disabled="disabled"' : '';
		echo "<option value='$aid' " . selected($automation_id, $aid, false) . " " . $status . ">Run Automation #{$aid} $aname</option>";
	  ENDFOREACH;
	  ?>
	</select>
	</p>
	<p>
	<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('nobreak');?>" name="<?php echo $this->get_field_name('nobreak');?>"<?php (isset($nobreak) ? checked($nobreak) : ''); ?> />
	<label for="<?php echo $this->get_field_id('nobreak'); ?>"><?php _e( 'Omit line break after labels?' ); ?></label>
	</p>
	<p>
	<label for="<?php echo $this->get_field_id('divfloat'); ?>"><?php _e( 'Widget Alignment:' ); ?></label>&nbsp;&nbsp;
	<input type="radio" class="radio" value='left'   id="<?php echo $this->get_field_id('divfloat'); ?>" name="<?php echo $this->get_field_name('divfloat'); ?>"<?php echo ($divfloat=='left'   ? "checked='checked'" : ''); ?> />&nbsp;Left&nbsp;&nbsp;
	<input type="radio" class="radio" value='right'  id="<?php echo $this->get_field_id('divfloat'); ?>" name="<?php echo $this->get_field_name('divfloat'); ?>"<?php echo ($divfloat=='right'  ? "checked='checked'" : ''); ?> />&nbsp;Right&nbsp;&nbsp;
	<input type="radio" class="radio" value='center' id="<?php echo $this->get_field_id('divfloat'); ?>" name="<?php echo $this->get_field_name('divfloat'); ?>"<?php echo ($divfloat=='center' ? "checked='checked'" : ''); ?> />&nbsp;Center&nbsp;&nbsp;
	</p>
	<p>
	<label for="<?php echo $this->get_field_id('inputwidth'); ?>"><?php _e('Width of Input Fields:'); ?></label>
	<input type='text' class="text" size='8' id="<?php echo $this->get_field_id('inputwidth'); ?>" name="<?php echo $this->get_field_name('inputwidth'); ?>" value='<?php echo (isset($inputwidth) ? $inputwidth : '150px'); ?>' />&nbsp;
	</p>
	<p>
	<label for="<?php echo $this->get_field_id('submt'); ?>"><?php _e('Text on Submit Button:'); ?></label><br />
	<input type='text' class="widefat" id="<?php echo $this->get_field_id('submt'); ?>" name="<?php echo $this->get_field_name('submt'); ?>" value='<?php echo $submt; ?>' />
	</p>
	<p>
	<label for="<?php echo $this->get_field_id('wtext'); ?>"><?php _e('Pre-Login Message:'); ?></label><br />
	<textarea class="widefat" style='height:80px;' id="<?php echo $this->get_field_id('wtext'); ?>" name="<?php echo $this->get_field_name('wtext'); ?>"><?php echo $wtext; ?></textarea>
	</p>
	<p>
	<label for="<?php echo $this->get_field_id('stext'); ?>"><?php _e('Successful Login Message:'); ?></label><br />
	<textarea class="widefat" style='height:80px;' id="<?php echo $this->get_field_id('stext'); ?>" name="<?php echo $this->get_field_name('stext'); ?>"><?php echo $stext; ?></textarea>
	</p>
	<?php
  }
}
