<?php

class mbr_wpcw
{
	use TRAIT__getInstance;

	function plugins_loaded()
	{
		global $pagenow;

		
		IF ( !defined( 'WPCW_PLUGIN_ID' ) OR WPCW_PLUGIN_ID <> 'WPCW_wp_courseware' ) :
			return;
		ENDIF;

		
		add_filter( 'mbr/protectable_post_types/built_in', [ $this, 'add_protectable_post_types' ], 10, 1 );

		IF ( is_admin() ) :
			
			IF ( in_array( $pagenow, ['post.php', 'post-new.php'] ) ) :
				add_action( "load-{$pagenow}",             [ $this, 'init_metaboxes' ], 0 );
			ENDIF;

			add_action( 'mbr/quick_edit/protection/box', [ $this, 'init_quick_edit' ], 2 );
		ENDIF;

		






		








	}

	function add_protectable_post_types( $arr_protectable_post_types = [] )
	{
		array_push( $arr_protectable_post_types, 'course_unit' );
		return $arr_protectable_post_types;
	}

	function init_metaboxes( $_post_type = FALSE, $_post = FALSE )
	{
		global $pagenow, $typenow;

		IF ( 'course_unit' == $typenow ) :
			$current_filter = current_filter();
			IF ( "load-{$pagenow}" == $current_filter ) :
				add_action( 'add_meta_boxes',   [ $this, __FUNCTION__ ], 10, 2 );
			ELSEIF ( 'add_meta_boxes' == $current_filter ) :
				do_action( 'mbr/add_meta_box_protection/default', $_post );
			ENDIF;
		ENDIF;
	}

	public function init_quick_edit( $_post )
	{
		IF ( 'course_unit' == $_post->post_type ) :
			do_action( 'mbr/render_meta_boxes_protection_default', $_post, 'quick-protection' );
		ENDIF;
	}

}
mbr_wpcw::getInstance();
