(function( $ ) {

	// Listen for our change to our trigger type selectors
	$( '.requirements-list' ).on( 'change', '.select-trigger-type', function() {

		// Grab our selected trigger type
		let mbr_trigger                = false;
		let trigger_type               = $( this ).val();
		let mbr_contact_has_tag        = $( this ).siblings( '.select-mbr-gamipress-requirement-contact-has-tag' );
		let mbr_contact_has_tag_mode   = $( this ).siblings( '.select-mbr-gamipress-requirement-contact-has-tag-mode' );
		let mbr_contact_in_list        = $( this ).siblings( '.select-mbr-gamipress-requirement-contact-in-list' );
		let mbr_contact_in_list_mode   = $( this ).siblings( '.select-mbr-gamipress-requirement-contact-in-list-mode' );
		let mbr_contact_field_compare  = $( this ).siblings( '.select-mbr-gamipress-requirement-contact-field-compare' );
		let mbr_contact_field_operator = $( this ).siblings( '.select-mbr-gamipress-requirement-contact-field-operator' );
		let mbr_contact_field_value    = $( this ).siblings( '.input-mbr-gamipress-requirement-contact-field-value' );
		let mbr_points_earnings        = $( this ).siblings( 'div.requirement-awards' );

		mbr_contact_has_tag.hide();
		mbr_contact_has_tag.next( '.select2-container' ).hide();
		mbr_contact_has_tag_mode.hide();
		mbr_contact_in_list.hide();
		mbr_contact_in_list.next( '.select2-container' ).hide();
		mbr_contact_in_list_mode.hide();
		mbr_contact_field_compare.hide();
		mbr_contact_field_compare.next( '.select2-container' ).hide();
		mbr_contact_field_operator.hide();
		mbr_contact_field_value.hide();

		if ( 'mbr_gamipress_contact_has_tag' === trigger_type ) {
			mbr_contact_has_tag.show();
			mbr_contact_has_tag.select2( { containerCssClass : 'mbr-select2' } );
			mbr_contact_has_tag_mode.show();
			mbr_trigger = true;
		} else if ( 'mbr_gamipress_contact_in_list' === trigger_type ) {
			mbr_contact_in_list.show();
			mbr_contact_in_list.select2( { containerCssClass : 'mbr-select2' } );
			mbr_contact_in_list_mode.show();
			mbr_trigger = true;
		} else if ( 'mbr_gamipress_contact_field_compare' === trigger_type ) {
			mbr_contact_field_compare.show();
			mbr_contact_field_compare.select2( { containerCssClass : 'mbr-select2' } );
			mbr_contact_field_operator.show();
			mbr_contact_field_value.show();
			mbr_trigger = true;
		}

		if ( mbr_trigger ) {
			$( this ).siblings( '.count' ).hide();
			$( this ).siblings( '.count-text' ).hide();
			$( this ).siblings( '.limit-text' ).hide();
			$( this ).siblings( '.limit' ).hide();
			$( this ).siblings( '.limit-type' ).hide();

			mbr_points_earnings.find( '.maximum-earnings-text' ).hide();
			mbr_points_earnings.find( '.maximum-earnings' ).hide();
			mbr_points_earnings.find( '.requirement-maximum-earnings' ).hide();
			mbr_points_earnings.find( '.maximum-earnings-notice' ).hide();
		} else {
			mbr_points_earnings.find( '.maximum-earnings-text' ).show();
			mbr_points_earnings.find( '.maximum-earnings' ).show();
			mbr_points_earnings.find( '.requirement-maximum-earnings' ).show();
			mbr_points_earnings.find( '.maximum-earnings-notice' ).show();
		}

	} );

	// Loop requirement list items to show/hide inputs on initial load
	$( '.requirements-list li' ).each( function() {
		// Grab our selected trigger type
		let mbr_trigger                = false;
		let trigger_type               = $( this ).find( '.select-trigger-type' ).val();
		let mbr_contact_has_tag        = $( this ).find( '.select-mbr-gamipress-requirement-contact-has-tag' );
		let mbr_contact_has_tag_mode   = $( this ).find( '.select-mbr-gamipress-requirement-contact-has-tag-mode' );
		let mbr_contact_in_list        = $( this ).find( '.select-mbr-gamipress-requirement-contact-in-list' );
		let mbr_contact_in_list_mode   = $( this ).find( '.select-mbr-gamipress-requirement-contact-in-list-mode' );
		let mbr_contact_field_compare  = $( this ).find( '.select-mbr-gamipress-requirement-contact-field-compare' );
		let mbr_contact_field_operator = $( this ).find( '.select-mbr-gamipress-requirement-contact-field-operator' );
		let mbr_contact_field_value    = $( this ).find( '.input-mbr-gamipress-requirement-contact-field-value' );

		mbr_contact_has_tag.hide();
		mbr_contact_has_tag_mode.hide();
		mbr_contact_in_list.hide();
		mbr_contact_in_list_mode.hide();
		mbr_contact_field_compare.hide();
		mbr_contact_field_operator.hide();
		mbr_contact_field_value.hide();

		if ( 'mbr_gamipress_contact_has_tag' === trigger_type ) {
			mbr_contact_has_tag.show();
			mbr_contact_has_tag.select2( { containerCssClass : 'mbr-select2' } );
			mbr_contact_has_tag_mode.show();
			mbr_trigger = true;
		} else if ( 'mbr_gamipress_contact_in_list' === trigger_type ) {
			mbr_contact_in_list.show();
			mbr_contact_in_list.select2( { containerCssClass : 'mbr-select2' } );
			mbr_contact_in_list_mode.show();
			mbr_trigger = true;
		} else if ( 'mbr_gamipress_contact_field_compare' === trigger_type ) {
			mbr_contact_field_compare.show();
			mbr_contact_field_compare.select2( { containerCssClass : 'mbr-select2' } );
			mbr_contact_field_operator.show();
			mbr_contact_field_value.show();
			mbr_trigger = true;
		}

		if ( mbr_trigger ) {
			$( this ).find( '.count' ).hide();
			$( this ).find( '.count-text' ).hide();
			$( this ).find( '.limit-text' ).hide();
			$( this ).find( '.limit' ).hide();
			$( this ).find( '.limit-type' ).hide();
			$( this ).find( 'div.requirement-awards .maximum-earnings-text' ).hide();
			$( this ).find( 'div.requirement-awards .maximum-earnings' ).hide();
			$( this ).find( 'div.requirement-awards .requirement-maximum-earnings' ).hide();
			$( this ).find( 'div.requirement-awards .maximum-earnings-notice' ).hide();
		} else {
			$( this ).find( 'div.requirement-awards > .maximum-earnings-text' ).show();
			$( this ).find( 'div.requirement-awards > .maximum-earnings' ).show();
			$( this ).find( 'div.requirement-awards > .requirement-maximum-earnings' ).show();
			$( this ).find( 'div.requirement-awards > .maximum-earnings-notice' ).show();
		}

	} );

	$( '.requirements-list' ).on( 'gamipress_update_requirement_data', '.requirement-row', function( e, requirement_details, requirement ) {

		if ( 'mbr_gamipress_contact_has_tag' === requirement_details.trigger_type ) {
			requirement_details.mbr_gamipress_requirement_contact_has_tag        = requirement.find( '.select-mbr-gamipress-requirement-contact-has-tag' ).val();
			requirement_details.mbr_gamipress_requirement_contact_has_tag_mode   = requirement.find( '.select-mbr-gamipress-requirement-contact-has-tag-mode' ).val();
		} else if ( 'mbr_gamipress_contact_in_list' === requirement_details.trigger_type ) {
			requirement_details.mbr_gamipress_requirement_contact_in_list        = requirement.find( '.select-mbr-gamipress-requirement-contact-in-list' ).val();
			requirement_details.mbr_gamipress_requirement_contact_in_list_mode   = requirement.find( '.select-mbr-gamipress-requirement-contact-in-list-mode' ).val();
		} else if ( 'mbr_gamipress_contact_field_compare' === requirement_details.trigger_type ) {
			requirement_details.mbr_gamipress_requirement_contact_field_compare  = requirement.find( '.select-mbr-gamipress-requirement-contact-field-compare' ).val();
			requirement_details.mbr_gamipress_requirement_contact_field_operator = requirement.find( '.select-mbr-gamipress-requirement-contact-field-operator' ).val();
			requirement_details.mbr_gamipress_requirement_contact_field_value    = requirement.find( '.input-mbr-gamipress-requirement-contact-field-value' ).val();
		}

	} );

	$( '.mbr-gamipress-achievement-earned, .mbr-gamipress-achievement-earned-set-field, .mbr-gamipress-rank-earned, .mbr-gamipress-rank-earned-set-field, .mbr-gamipress-store-points-to-custom-field' ).each( function() {
		$( this ).select2( { containerCssClass : 'mbr-select2', placeholder : '---', allowClear : true } );
	} );

} )( jQuery );