function stripeResponseHandler(status, response) {
    if (response.error) {
        /* re-enable the submit button */
        jQuery('#mbr-payment-submit').removeAttr("disabled");
        /* show the errors on the form */
        //jQuery("#mbr-payment-stripe-error").html(response.error.message);
    } else {
        var form$ = jQuery("#mbr-payment-form");
        /* token contains id, last4, and card type */
        var token = response['id'];
        /* insert the token into the form so it gets submitted to the server */
        form$.append("<input type='hidden' name='mbr_stripe_token' value='" + token + "' />");
        /* and submit */
        form$.get(0).submit();
    }
}
jQuery(document).ready(function() {
    jQuery("#mbr-payment-form").submit(function(event) {
        /* disable the submit button to prevent repeated clicks */
        jQuery('#mbr-payment-submit').attr("disabled", "disabled");
        /* createToken returns immediately - the supplied callback submits the form if there are no errors */
        Stripe.createToken({
            number: jQuery('#mbr_card_number').val(),
            cvc: jQuery('#mbr_card_cvc').val(),
            exp_month: jQuery('#mbr_card_exp_month').val(),
            exp_year: jQuery('#mbr_card_exp_year').val()
        }, stripeResponseHandler);
        return false; /* submit from callback */
    });
});
