<?php require_once(MBR_DIR . '/templates/inc/processing.php'); ?>
<!DOCTYPE html>
<html>
<head>
  <title><?php echo ucwords( $product->post_title ); ?></title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0">
  <link rel="stylesheet" href="<?php echo plugins_url( '/templates/assets/css/font-awesome.css', MBRNAME ); ?>" />
  <link rel="stylesheet" href="<?php echo plugins_url( '/templates/assets/css/checkout-1.css',   MBRNAME ); ?>" />
  <?php require_once( MBR_DIR . '/templates/inc/header.php' ); ?>
</head>

<body class="">
  <div class="body">
    <form action="" method="post" id="mbr-payment-form" class="me-form">
      <input type="hidden" name="action" value="stripe" />
      <input type="hidden" name="product_id" value="<?php echo $product->ID; ?>" />
      <input type="hidden" name="stripe_nonce" value="<?php echo wp_create_nonce( 'stripe-nonce' ); ?>" />
      <header><?php echo ucwords( $product->post_title ); ?></header>
      <?php
      require_once( MBR_DIR . '/templates/inc/error_success_handler.php' );
      /* skipping created in the error_success_handler.php */
      IF ( $skipping ) :
        GOTO SKIP_POINT;
      ENDIF;

      $p_desc  = FALSE;
      $p_image = FALSE;
      $product_description = trim( $product->post_content );
      IF ( ! empty($product_description ) ) :
        $p_desc  = TRUE;
      ENDIF;

      $product_image = get_the_post_thumbnail_url( $product->ID, 'thumbnail' );
      IF ( ! empty($product_image ) ) :
        $p_image  = TRUE;
      ENDIF;

      $col_img    = '';
      $col_desc   = '';
      IF ( $p_desc AND $p_image ) :
        $col_img  = ' class="col col-4"';
        $col_desc = ' class="col col-8"';
      ENDIF;

      IF ( $p_desc OR $p_image ) :
        echo '<fieldset><div class="row">';
        IF ( $p_image ) :
          echo '<section' . $col_img . '><img class="imgborder" src="' . $product_image . '" width="100%" /></section>';
        ENDIF;
        IF ( $p_desc ) :
          echo '<section' . $col_desc . '>' . $product_description . '</section>';
        ENDIF;
        echo '</div></fieldset>';
      ENDIF;

      $contact    = [];
      IF ( apply_filters( 'mbr/contact_id', NULL )) :
        $contact  =  apply_filters( 'mbr/session/get', NULL );
      ENDIF;
      ?>
      <fieldset>
        <div class="row">
          <section class="col col-6">
            <label class="input">
              <i class="icon-prepend fa fa-user"></i>
              <input type="text" name="first_name" id="mbr_first_name" placeholder="<?php _ex( 'First Name', 'checkout-form', 'activemember360' ); ?>" value="<?php echo ( ! empty( $contact['first_name'] ) ? $contact['first_name'] : '' ); ?>" data-validation="required" />
            </label>
          </section>
          <section class="col col-6">
            <label class="input">
              <i class="icon-prepend fa fa-user"></i>
              <input type="text" name="last_name" id="mbr_last_name" placeholder="<?php _ex( 'Last Name', 'checkout-form', 'activemember360' ); ?>" value="<?php echo ( ! empty( $contact['last_name'] ) ? $contact['last_name'] : '' ); ?>" data-validation="required" />
            </label>
          </section>
        </div>
        <div class="row">
          <?php
          IF ( ! empty( $contact['email'] ) ) :
            ?>
            <input type="hidden" name="email" value="<?php echo $contact['email']; ?>" />
            <?php
          ELSE:
            ?>
            <section class="col col-6">
              <label class="input">
                <i class="icon-prepend fa fa-envelope"></i>
                <input type="text" name="email" id="mbr_email" placeholder="<?php _ex( 'Email', 'checkout-form', 'activemember360' ); ?>" value="<?php echo ( ! empty( $contact['email'] ) ? $contact['email'] : '' ); ?>" data-validation="email" />
              </label>
            </section>
            <?php
          ENDIF;
          IF ( ! empty( $cmeta['_mbr_checkout_display_phone_number'] ) ) :
            ?>
            <section class="col col-6">
              <label class="input">
                <i class="icon-prepend fa fa-phone"></i>
                <input type="tel" name="phone" id="mbr_phone" placeholder="<?php _ex( 'Phone', 'checkout-form', 'activemember360' ); ?>" value="<?php echo ( ! empty( $contact['phone'] ) ? $contact['phone'] : '' ); ?>" data-validation="required" />
              </label>
            </section>
            <?php
          ENDIF;
          ?>
        </div>
        <section>
          <label class="input">
            <i class="icon-prepend fa fa-bars"></i>
            <input type="text" name="billing_company" id="mbr_billing_company" placeholder="<?php _ex( 'Company', 'checkout-form', 'activemember360' ); ?>" value="<?php echo ( ! empty( $contact['billing_company'] ) ? $contact['billing_company'] : '' ); ?>" />
          </label>
        </section>
      </fieldset>
      <fieldset <?php echo ( empty( $cmeta['_mbr_checkout_display_billing_fields'] ) ? 'style="display:none;"' : '' ); ?>>
        <section>
          <label class="input">
            <input type="text" name="billing_address_1" id="mbr_billing_address_1" placeholder="<?php _ex( 'Street Address', 'checkout-form', 'activemember360' );?>" value="<?php echo ( ! empty( $contact['billing_address_1'] ) ? $contact['billing_address_1'] : '' ); ?>" data-validation="required" />
          </label>
        </section>
        <section>
          <label class="input">
            <input type="text" name="billing_address_2" id="mbr_billing_address_2" placeholder="<?php _ex( 'Street Address 2', 'checkout-form', 'activemember360' );?>" value="<?php echo ( ! empty( $contact['billing_address_2'] ) ? $contact['billing_address_2'] : '' ); ?>" />
          </label>
        </section>
        <div class="row">
          <section class="col col-6">
            <label class="select">
              <select name="billing_country" id="mbr_billing_country" data-validation="required">
                <option value="" selected disabled><?php _ex( 'Country', 'checkout-form', 'activemember360' ); ?></option>
                <?php
                FOREACH ( apply_filters( 'mbr/payments/countries/get', NULL ) AS $code => $country ) :
                  $selected     = '';
                  IF ( ! empty( $contact['billing_country'] ) ) :
                    IF ( $contact['billing_country'] == $code ) :
                      $selected = 'selected="selected"';
                    ENDIF;
                  ENDIF;
                  echo '<option value="' . $code . '" ' . $selected . '>' . $country . '</option>';
                ENDFOREACH;
                ?>
              </select>
              <i></i>
            </label>
          </section>
          <section class="col col-6">
            <label class="select">
              <select name="billing_state" id="mbr_billing_state" data-validation="required">
                <option value="" selected disabled><?php _ex( 'State', 'checkout-form', 'activemember360' ); ?></option>
                <?php
                FOREACH ( apply_filters( 'mbr/payments/states/us/get', NULL ) AS $code => $state ) :
                  $selected     = '';
                  IF ( ! empty( $contact['billing_state'] ) ) :
                    IF ( $contact['billing_state'] == $code ) :
                      $selected = 'selected="selected"';
                    ENDIF;
                  ENDIF;
                  echo '<option value="' . $code . '" ' . $selected . '>' . $state . '</option>';
                ENDFOREACH;
                ?>
              </select>
              <i></i>
            </label>
          </section>
        </div>
        <div class="row">
          <section class="col col-8">
            <label class="input">
              <input type="text" name="billing_city" id="mbr_billing_city" placeholder="<?php _ex( 'City', 'checkout-form', 'activemember360' ); ?>" value="<?php echo ( ! empty( $contact['billing_city'] ) ? $contact['billing_city'] : '' ); ?>" data-validation="required" />
            </label>
          </section>
          <section class="col col-4">
            <label class="input">
              <input type="text" name="billing_postcode" id="mbr_billing_postcode" placeholder="<?php _ex( 'Postal Code', 'checkout-form', 'activemember360' ); ?>" value="<?php echo ( ! empty( $contact['billing_postcode'] ) ? $contact['billing_postcode'] : '' ); ?>" data-validation="required" />
            </label>
          </section>
        </div>
      </fieldset>
      <?php
      IF ( ! empty( $cmeta['_mbr_checkout_trust_bar']['url'] ) ) :
        ?>
        <section class="col col-12">
          <div class="me-secureimg">
            <img src="<?php echo $cmeta['_mbr_checkout_trust_bar']['url']; ?>" alt="" />
          </div>
        </section>
        <?php
      ENDIF;
      ?>
      <fieldset>
        <section>
          <label class="input">
            <input type="text" id="mbr_card_number" placeholder="<?php _ex( 'Card Number', 'checkout-form', 'activemember360' ); ?>" maxlength="16" data-validation="number length" data-validation-length="min13" />
          </label>
        </section>
        <div class="row">
          <section class="col col-4">
            <label class="input">
              <input type="text" id="mbr_card_cvc" placeholder="<?php _ex( 'CVC', 'checkout-form', 'activemember360' ); ?>" maxlength="4" data-validation="number length" data-validation-length="min3" />
            </label>
          </section>
          <section class="col col-4">
            <label class="select">
              <select id="mbr_card_exp_month" data-validation="required">
                <option value=""><?php _ex( 'Month',       'checkout-form', 'activemember360' ); ?></option>
                <option value="01"><?php _ex( 'January',   'checkout-form', 'activemember360' ); ?></option>
                <option value="02"><?php _ex( 'February',  'checkout-form', 'activemember360' ); ?></option>
                <option value="03"><?php _ex( 'March',     'checkout-form', 'activemember360' ); ?></option>
                <option value="04"><?php _ex( 'April',     'checkout-form', 'activemember360' ); ?></option>
                <option value="05"><?php _ex( 'May',       'checkout-form', 'activemember360' ); ?></option>
                <option value="06"><?php _ex( 'June',      'checkout-form', 'activemember360' ); ?></option>
                <option value="07"><?php _ex( 'July',      'checkout-form', 'activemember360' ); ?></option>
                <option value="08"><?php _ex( 'August',    'checkout-form', 'activemember360' ); ?></option>
                <option value="09"><?php _ex( 'September', 'checkout-form', 'activemember360' ); ?></option>
                <option value="10"><?php _ex( 'October',   'checkout-form', 'activemember360' ); ?></option>
                <option value="11"><?php _ex( 'November',  'checkout-form', 'activemember360' ); ?></option>
                <option value="12"><?php _ex( 'December',  'checkout-form', 'activemember360' ); ?></option>
              </select>
              <i></i>
            </label>
          </section>
          <section class="col col-4">
            <label class="select">
              <select id="mbr_card_exp_year" data-validation="required">
                <option value=""><?php _ex( 'Year', 'checkout-form', 'activemember360' ); ?></option>
                <?php
                FOR ( $x = date( 'Y' ); $x <= date( 'Y' ) + 25; $x++ ) :
                  echo '<option value="' . $x . '">' . $x . '</option>';
                ENDFOR;
                ?>
              </select>
              <i></i>
            </label>
          </section>
        </div>
      </fieldset>
      <fieldset>
        <section id="mbr-payment-checkout"></section>
      </fieldset>
      <?php
      IF ( ! empty( $cmeta['_mbr_checkout_display_term_condition_checkbox'] ) AND ! empty( $cmeta['_mbr_checkout_terms_and_condition_text'] ) ) :
        ?>
        <fieldset>
          <div class="terms-conditions"><input type="checkbox" name="" value="1" data-validation="required" data-validation-error-msg="<?php _ex( '(Please agree to the terms and conditions before proceeding)', 'checkout-form', 'activemember360' ); ?>" /> <?php echo $cmeta['_mbr_checkout_terms_and_condition_text']; ?></div>
        </fieldset>
        <?php
      ENDIF;
      ?>
      <footer>
        <input type="submit" id="mbr-payment-submit" class="button" name="" value="<?php echo $cmeta['_mbr_checkout_button_text']; ?>" />
      </footer>
    </form>
  </div>
  <?php require_once( MBR_DIR . '/templates/inc/footer.php' ); ?>
</body>
</html>
<?php
SKIP_POINT:
IF ( $skipping ) :
  ?><footer></footer></form></div></body></html><?php
ENDIF;