<?php
/**
 * The template for the main panel container.
 * Override this template by specifying the path where it is stored (templates_path) in your Redux config.
 *
 * @author        Redux Framework
 * @package       ReduxFramework/Templates
 * @version: 3.5.7.8
 */


$expanded = ( $this->parent->args['open_expanded'] ) ? ' fully-expanded' : '' . ( ! empty( $this->parent->args['class'] ) ? ' ' . esc_attr( $this->parent->args['class'] ) : '' );
$nonce    = wp_create_nonce( "redux_ajax_nonce" . $this->parent->args['opt_name'] );
?>
<style>
	#mbr_api_url, #mbr_api_key { width:550px; }
</style>

<script>
  function mbr_re_check_license() {
    jQuery( '#mbr_re_check_license_loading' ).html( '<div style="width:100%;height:61px;padding-top:5px;padding-bottom:5px;background-color:#f3f3f3;border:solid 1px #ccc;text-align:center;">Please wait. Checking license.<br /><img src="<?php echo plugin_dir_url( __DIR__ ) . 'img/ajax-loader.gif'; ?>" style="margin-top:5px" /></div>' );
    jQuery.post(
      ajaxurl, {
        'action' : 'mbr_re_check_license',
      },
      function( response ) {
        location.reload();
      }
    );
  }

  jQuery( document ).ready( function() {
		jQuery('#mbr_api_key').click( function() {toggle_api_key();});
		jQuery( '#mbr_re_check_license' ).click( function () {
      mbr_re_check_license()
      return false;
    } );

    jQuery( 'li.mbr_api_section_api_settings a'  ).click( function () {
      jQuery('input[name=redux_save]').prop('disabled', false);
    } );

    jQuery( 'li.mbr_api_section_license_status a'  ).click( function () {
      jQuery('input[name=redux_save]').prop('disabled', true);
    } );
  } );

	function toggle_api_key() {
		var x = document.getElementById("mbr_api_key");
		if (x.type === "password") {
			x.type = "text";
		} else {
			x.type = "password";
		}
	}

</script>

<div class="redux-container<?php echo esc_attr( $expanded ); ?>">
  <?php $action = ( $this->parent->args['database'] == "network" && $this->parent->args['network_admin'] && is_network_admin() ? './edit.php?action=redux_' . $this->parent->args['opt_name'] : './options.php' ) ?>
  <form method="post"
        action="<?php echo esc_attr($action); ?>"
        data-nonce="<?php echo esc_attr($nonce); ?>"
        enctype="multipart/form-data"
        id="redux-form-wrapper">
    <?php // $this->parent->args['opt_name'] is sanitized in the Framework class, no need to re-sanitize it. ?>
    <input type="hidden" id="redux-compiler-hook"
           name="<?php echo $this->parent->args['opt_name']; ?>[compiler]"
           value=""/>
    <?php // $this->parent->args['opt_name'] is sanitized in the Framework class, no need to re-sanitize it. ?>
    <input type="hidden" id="currentSection"
           name="<?php echo $this->parent->args['opt_name']; ?>[redux-section]"
           value=""/>
    <?php // $this->parent->args['opt_name'] is sanitized in the Framework class, no need to re-sanitize it. ?>
    <?php if ( ! empty( $this->parent->no_panel ) ) { ?>
      <input type="hidden"
             name="<?php echo $this->parent->args['opt_name']; ?>[redux-no_panel]"
             value="<?php echo esc_attr(implode( '|', $this->parent->no_panel )); ?>"
      />
    <?php } ?>
    <?php
    // Must run or the page won't redirect properly
    $this->init_settings_fields();

    // Last tab?
    $this->parent->options['last_tab'] = ( isset( $_GET['tab'] ) && ! isset( $this->parent->transients['last_save_mode'] ) ) ? esc_attr( $_GET['tab'] ) : '';
    ?>
    <?php // $this->parent->args['opt_name'] is sanitized in the Framework class, no need to re-sanitize it. ?>
    <input type="hidden"
           id="last_tab"
           name="<?php echo $this->parent->args['opt_name']; ?>[last_tab]"
           value="<?php echo esc_attr( $this->parent->options['last_tab'] ); ?>"
    />

    <?php $this->get_template( 'content.tpl.php' ); ?>

  </form>
</div>

<?php if ( isset( $this->parent->args['footer_text'] ) ) { ?>
  <div id="redux-sub-footer"><?php echo wp_kses_post( $this->parent->args['footer_text'] ); ?></div>
<?php } ?>
