<?php
/**
 * The template for the main panel container.
 * Override this template by specifying the path where it is stored (templates_path) in your Redux config.
 *
 * @author        Redux Framework
 * @package       ReduxFramework/Templates
 * @version: 3.5.7.8
 */


$expanded = ( $this->parent->args['open_expanded'] ) ? ' fully-expanded' : '' . ( ! empty( $this->parent->args['class'] ) ? ' ' . esc_attr( $this->parent->args['class'] ) : '' );
$nonce    = wp_create_nonce( "redux_ajax_nonce" . $this->parent->args['opt_name'] );
?>
<style>
  .mbr-redux-listing td {
    padding:10px !important;
    vertical-align: top;
    text-align:left;
  }
  .mbr-col-75 td:first-child {
    width: 75px;
  }
  .mbr-col-300 td:first-child {
    width: 300px;
  }
  .redux-container-sorter ul {
     width:46%;
  }
</style>

<script>

  function mbr_send_be_ajax( action, post_type, response_container, message_container, message ) {
    jQuery( response_container ).html( '<div style="width:100%;height:41px;padding-top:5px;padding-bottom:5px;background-color:#f3f3f3;border:solid 1px #ccc;text-align:center;"><img src="<?php echo plugin_dir_url( __DIR__ ) . 'img/ajax-loader.gif'; ?>" style="margin-top:5px" /></div>' );
      jQuery.post(
         ajaxurl, {
        'action'           : action,
        'mbr_be_post_type' : post_type
      },
      function( response ) {
        jQuery( response_container ).html( response );
        if ( message_container && message ) {
          jQuery( message_container ).html( message );
        }
      }
    );
  }

  jQuery( document ).ready( function() {
    if ( ! jQuery.cookie( 'redux_current_tab' ) || jQuery.cookie( 'redux_current_tab' ) > 1 ) {
      jQuery('input[name=redux_save]').prop('disabled', true);
    } else {
      jQuery('input[name=redux_save]').prop('disabled', false);
    }

    jQuery( 'li.mbr_be_section_bulk_enable_post_type a'  ).click( function () {
      jQuery('input[name=redux_save]').prop('disabled', false);
    } );
    jQuery( 'li.mbr_be_section_bulk_edit_post_type a'  ).click( function () {
      jQuery('input[name=redux_save]').prop('disabled', true);
    } );
  } );
</script>

<div class="redux-container<?php echo esc_attr( $expanded ); ?>">
  <?php $action = ( $this->parent->args['database'] == "network" && $this->parent->args['network_admin'] && is_network_admin() ? './edit.php?action=redux_' . $this->parent->args['opt_name'] : './options.php' ) ?>
    <form method="post"
          action="<?php echo esc_attr($action); ?>"
          data-nonce="<?php echo esc_attr($nonce); ?>"
          enctype="multipart/form-data"
          id="redux-form-wrapper">
      <?php // $this->parent->args['opt_name'] is sanitized in the Framework class, no need to re-sanitize it. ?>
        <input type="hidden" id="redux-compiler-hook"
               name="<?php echo $this->parent->args['opt_name']; ?>[compiler]"
               value=""/>
      <?php // $this->parent->args['opt_name'] is sanitized in the Framework class, no need to re-sanitize it. ?>
        <input type="hidden" id="currentSection"
               name="<?php echo $this->parent->args['opt_name']; ?>[redux-section]"
               value=""/>
      <?php // $this->parent->args['opt_name'] is sanitized in the Framework class, no need to re-sanitize it. ?>
      <?php if ( ! empty( $this->parent->no_panel ) ) { ?>
          <input type="hidden"
                 name="<?php echo $this->parent->args['opt_name']; ?>[redux-no_panel]"
                 value="<?php echo esc_attr(implode( '|', $this->parent->no_panel )); ?>"
          />
      <?php } ?>
      <?php
      // Must run or the page won't redirect properly
      $this->init_settings_fields();

      // Last tab?
      $this->parent->options['last_tab'] = ( isset( $_GET['tab'] ) && ! isset( $this->parent->transients['last_save_mode'] ) ) ? esc_attr( $_GET['tab'] ) : '';
      ?>
      <?php // $this->parent->args['opt_name'] is sanitized in the Framework class, no need to re-sanitize it. ?>
        <input type="hidden"
               id="last_tab"
               name="<?php echo $this->parent->args['opt_name']; ?>[last_tab]"
               value="<?php echo esc_attr( $this->parent->options['last_tab'] ); ?>"
        />

      <?php $this->get_template( 'content.tpl.php' ); ?>

    </form>
</div>

<?php if ( isset( $this->parent->args['footer_text'] ) ) { ?>
    <div id="redux-sub-footer"><?php echo wp_kses_post( $this->parent->args['footer_text'] ); ?></div>
<?php } ?>
