<?php
/**
 * The template for the main panel container.
 * Override this template by specifying the path where it is stored (templates_path) in your Redux config.
 *
 * @author        Redux Framework
 * @package       ReduxFramework/Templates
 * @version: 3.5.7.8
 */


$expanded = ( $this->parent->args['open_expanded'] ) ? ' fully-expanded' : '' . ( ! empty( $this->parent->args['class'] ) ? ' ' . esc_attr( $this->parent->args['class'] ) : '' );
$nonce    = wp_create_nonce( "redux_ajax_nonce" . $this->parent->args['opt_name'] );
?>
<style>
  .mbr-redux-listing td {
    padding:10px !important;
  }
  .mbr-col-75 td:first-child {
    width: 75px;
  }
  .mbr-col-300 td:first-child {
    width: 300px;
  }
</style>
<script>
  function mbr_send_utl_ajax( action, response_container ) {
    if ( jQuery( response_container ).html() != '' ) {
      return;
    }
    jQuery( response_container ).html( '<div style="width:100%;height:41px;padding-top:5px;padding-bottom:5px;background-color:#f3f3f3;border:solid 1px #ccc;text-align:center;"><img src="<?php echo plugin_dir_url( __DIR__ ) . 'img/ajax-loader.gif'; ?>" style="margin-top:5px" /></div>' );
    jQuery.post(
      ajaxurl, {
        'action' : action,
      },
      function( response ){
        jQuery( response_container ).html( response );
      }
    );
  }

  jQuery( document ).ready( function() {
    if ( ! jQuery.cookie( 'redux_current_tab' ) || jQuery.cookie( 'redux_current_tab' ) > 13 ) {
      mbr_send_utl_ajax( 'mbr_utl_get_api_log', '#mbr_utl_api_log_container' )
    }

    /* Utilities Automations */
    jQuery( 'li.mbr_utl_section_automations a'  ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_automations', '#mbr_utl_automations_container' )
      return false;
    } );

    /* Utilities Custom Fields */
    jQuery( 'li.mbr_utl_section_custom_fields a'  ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_custom_fields', '#mbr_utl_custom_fields_container' )
      return false;
    } );

    /* Utilities Forms */
    jQuery( 'li.mbr_utl_section_forms a'  ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_forms', '#mbr_utl_forms_container' )
      return false;
    } );

    /* Utilities Lists */
    jQuery( 'li.mbr_utl_section_lists a'  ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_lists', '#mbr_utl_lists_container' )
      return false;
    } );

    /* Utilities Mail Templates */
    jQuery( 'li.mbr_utl_section_mail_templates a'  ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_mail_templates', '#mbr_utl_mail_templates_container' )
      return false;
    } );

    /* Utilities Tags */
    jQuery( 'li.mbr_utl_section_tags a'  ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_tags', '#mbr_utl_tags_container' )
      return false;
    } );

    /* Utilities Webhooks */
    jQuery( 'li.mbr_utl_section_webhooks a'  ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_webhooks', '#mbr_utl_webhooks_container' )
      return false;
    } );

    /* Utilities API Log */
    jQuery( 'li.mbr_utl_section_api_log a'  ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_api_log', '#mbr_utl_api_log_container' )
      return false;
    } );

    /* Utilities Database */
    jQuery( 'li.mbr_utl_section_database a'  ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_database', '#mbr_utl_database_container' )
      return false;
    } );

    /* Utilities Environment */
    jQuery( 'li.mbr_utl_section_environment a' ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_environment', '#mbr_utl_environment_container' )
      return false;
    } );

    /* Utilities PHP INFO */
    jQuery( 'li.mbr_utl_section_php_info a' ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_php_info', '#mbr_utl_php_info_container' )
      return false;
    } );

    /* Utilities Cache Refresh Display*/
    jQuery( 'li.mbr_utl_section_cache_refresh a' ).click( function () {
      mbr_send_utl_ajax( 'mbr_utl_get_cache_refresh', '#mbr_utl_cache_refresh_container' )
      return false;
    } );

  } );
</script>
<div class="redux-container<?php echo esc_attr( $expanded ); ?>">
  <?php
  // Must run or the page won't redirect properly
  $this->init_settings_fields();

  // Last tab?
  $this->parent->options['last_tab'] = ( isset( $_GET['tab'] ) && ! isset( $this->parent->transients['last_save_mode'] ) ) ? esc_attr( $_GET['tab'] ) : '';

  $this->get_template( 'content.tpl.php' );
  ?>

</div>

<?php if ( isset( $this->parent->args['footer_text'] ) ) { ?>
  <div id="redux-sub-footer"><?php echo wp_kses_post( $this->parent->args['footer_text'] ); ?></div>
<?php } ?>
