<?php
global $post, $wp_query;

IF ( empty( $post ) ) :
  wp_redirect( home_url() );
ENDIF;

$mbr_payments_settings = apply_filters( 'mbr/payments/payment/settings/get', NULL );

IF ( ! $mbr_payments_settings['stripe_status'] ) :
  return __( 'Stripe Payment is not active', 'activemember360' );
ENDIF;

$product = $post;

IF ( empty( $product->ID ) ) :
  return __( 'No product ID provided', 'activemember360' );
ENDIF;

IF ( empty( $product ) OR $product->post_type <> MBRCUSTPRODUCTS AND $product->post_type <> MBRCUSTSUBSCRIPTIONS ) :
  return __( 'Product does not exist.', 'activemember360' );
ENDIF;

IF ( $product->post_type == MBRCUSTPRODUCTS ) :
  $settings_key  = MBR_PRODUCT_SETTINGS;
ELSE:
  $settings_key  = MBR_SUBSCRIPTION_SETTINGS;
ENDIF;

$pmeta           = redux_post_meta( $settings_key, $product->ID );

/* 0 => inactive 1 => live 2 => test */
$product_status  = $pmeta['_mbr_oitem_status'];
$publishable_key = FALSE;

IF ( empty( $product_status ) ) :
  wp_redirect( home_url() );
ELSEIF ( $product_status == 1 ) :
  $publishable_key = $mbr_payments_settings['stripe_live_publishable'];
ELSEIF ( $product_status == 2 ) :
  $publishable_key = $mbr_payments_settings['stripe_test_publishable'];
ENDIF;

IF ( empty( $publishable_key ) ) :
  wp_redirect( home_url() );
ENDIF;

$checkout_tpl_id_org       = $pmeta['_mbr_oitem_checkout_template'];
$checkout_tpl_id_alt       = ! empty( $wp_query->query_vars['page'] ) ? $wp_query->query_vars['page'] : '';

$cmeta                     = FALSE;
IF ( ! empty( $checkout_tpl_id_alt ) ) :
  $checkout_tpl_alt        = get_post( $checkout_tpl_id_alt );
  IF ( ! empty($checkout_tpl_alt->ID ) AND $checkout_tpl_alt->post_type == MBRCUSTCHECKOUTTPL ) :
    $cmeta                 = redux_post_meta( MBR_CHECKOUTTPL_SETTINGS, $checkout_tpl_id_alt );
  ENDIF;
ENDIF;

IF ( empty( $cmeta ) ) :
  $checkout_tpl_org       = get_post( $checkout_tpl_id_org );
  IF ( ! empty( $checkout_tpl_org->ID ) AND $checkout_tpl_org->post_type == MBRCUSTCHECKOUTTPL ) :
    $cmeta                = redux_post_meta( MBR_CHECKOUTTPL_SETTINGS, $checkout_tpl_id_org );
  ENDIF;
ENDIF;

do_action( 'mbr/payments/stripe/process/payment/regular', [ 'billing' => $cmeta['_mbr_checkout_display_billing_fields'], 'phone' => $cmeta['_mbr_checkout_display_phone_number'] ] );
