( function ( $ ) {
	list = {

		display: function () {
			$.ajax( {
				url      : ajaxurl,
				dataType : 'json',
				data     : {
					action : mbr_table.display_action
				},
				success  : function ( response ) {

					$( '#' + mbr_table.history_id ).html( response.display );

					$( 'input[name=order]' ).val( mbr_table.order );
					$( 'input[name=orderby]' ).val( mbr_table.orderby );
					$( 'input[name=post_status]' ).val( mbr_table.post_status );

					$( 'tbody' ).on( 'click', '.toggle-row', function ( e ) {
						e.preventDefault();
						$( this ).closest( 'tr' ).toggleClass( 'is-expanded' )
					} );

					list.init();
				}
			} );
		},

		init: function () {
			var timer;
			var delay              = 500;

			if ( $( '.search-box' ).length == 0 ) {
				$( '#mbr-wp-list-table-search-box' ).html( '<p class="search-box"><input type="search" name="s" value="" style="display:none;" /></p>' );
			}

			$( '#' + $( 'input[name=post_status]' ).val() ).addClass( 'current' );
			$( '.tablenav-pages' ).removeClass( 'no-pages' );

			total_pages = $( '.tablenav-pages .total-pages').html();
			if ( total_pages == 0 ) {
				$( '.tablenav-pages' ).hide();
			} else {
				$( '.tablenav-pages' ).show();
			}

			$( '#mbr-wp-table-search-results' ).remove();
			if ( $( 'input[name=s]' ).val() != '' && typeof $( 'input[name=s]' ).val() != 'undefined' ) {
				$( '.wrap h1' ).after( '<span id="mbr-wp-table-search-results">' + mbr_table.search_results_label + '&#8220;' + $( 'input[name=s]' ).val() + '&#8221</span>' );
			}

			$( '#search-submit, #mbr-wp-table-filter' ).on( 'click', function ( e ) {
				e.preventDefault();

				var data = {
					paged       : '1',
					order       : $( 'input[name=order]' ).val()       || mbr_table.order,
					orderby     : $( 'input[name=orderby]' ).val()     || mbr_table.orderby,
					post_status : $( 'input[name=post_status]' ).val() || mbr_table.post_status,
					filter      : $( 'select[name=filter]' ).val()     || '',
					s           : $( 'input[name=s]' ).val()           || ''
				};

				list.update( data );

			} );

			$( '.mbr-list-post-status' ).on( 'click', function ( e ) {
				e.preventDefault()

				var data = {
					paged       : '1',
					order       : mbr_table.order,
					orderby     : mbr_table.orderby,
					s           : '',
					filter      : '',
					post_status : e.target.id
				};

				list.update( data );
			} );

			$( '.tablenav-pages a, .manage-column.sortable a, .manage-column.sorted a' ).on( 'click', function ( e ) {
				e.preventDefault();

				var query = this.search.substring(1);

				tmp_search_string = list.__query(query, 's');

				if ( typeof tmp_search_string == 'undefined' ) {
					search_str = '';
				} else if ( list.__query( query, 's' ) != '' ) {
					search_str = decodeURIComponent( list.__query( query, 's' ) );
				} else {
					search_str = '';
				}

				var data  = {
					paged       : list.__query( query, 'paged' )       || '1',
					order       : list.__query( query, 'order' )       || mbr_table.order,
					orderby     : list.__query( query, 'orderby' )     || mbr_table.orderby,
					post_status : list.__query( query, 'post_status' ) || mbr_table.post_status,
					filter      : $( 'select[name=filter]' ).val()     || '',
					s           : search_str
				};

				list.update( data );
			} );

			$( 'input[name=paged]' ).on( 'keyup', function ( e ) {
				if ( 13 == e.which ) {
					e.preventDefault();
				}

				var data = {
					paged       : parseInt( $( 'input[name=paged]' ).val()) || '1',
					order       : $( 'input[name=order]' ).val()            || mbr_table.order,
					orderby     : $( 'input[name=orderby]' ).val()          || mbr_table.orderby,
					post_status : $( 'input[name=post_status]' ).val()      || mbr_table.post_status,
					filter      : $( 'select[name=filter]' ).val()          || '',
					s           : $( 'input[name=s]' ).val()                || ''
				};

				window.clearTimeout( timer );
				timer = window.setTimeout( function () {
					list.update( data );
				}, delay );

			});

			$( '#' + mbr_table.form_id ).on( 'submit', function ( e ) {
				e.preventDefault();
			} );
		},

		update: function ( data ) {

			colspan = $( 'th', $( '.wp-list-table' ).find( 'thead' ) ).length;
			$( '#the-list' ).html( '<tr><td colspan="' + colspan + '" class="mbr-wp-list-table-loading-bg">&nbsp;</td></tr>' );

			$.ajax( {
				url                         : ajaxurl,
				dataType                    : 'json',
				data                        : $.extend(
					{
						mbr_wp_list_table_nonce : $( '#mbr_wp_list_table_nonce' ).val(),
						action                  : mbr_table.history_action
					},
					data
				),
				success: function ( response ) {
					if ( response.rows.length ) {
						$( '#the-list' ).html( response.rows );
					}
					if ( response.column_headers.length ) {
						$( 'thead tr, tfoot tr' ).html( response.column_headers );
					}
					if ( response.pagination.bottom.length ) {
						$( '.tablenav.top .tablenav-pages' ).html( $( response.pagination.top ).html() );
					}
					if ( response.pagination.top.length ) {
						$( '.tablenav.bottom .tablenav-pages' ).html( $( response.pagination.bottom ).html() );
					}

					$( '#mbr-wp-list-table-status-filter' ).html( response.status_filter );
					if ( $( '#mbr-wp-table-filter-box' ).length ) {
						$( '#mbr-wp-table-filter-box' ).html( $( '#mbr-wp-table-filter-box' ).html() );
					}

					$( '#mbr-wp-list-table-search-box' ).html( response.search_box );

					$( 'input[name=order]' ).val( data.order );
					$( 'input[name=orderby]' ).val( data.orderby );
					$( 'select[name=filter]' ).val( data.filter );
					$( 'input[name=s]' ).val( data.s );
					$( 'input[name=post_status]' ).val( data.post_status );

					list.init();
				}
			});
		},

		__query: function ( query, variable ) {
			var vars    = query.split( '&' );
			for ( var i = 0; i < vars.length; i++ ) {
				var pair  = vars[ i ].split( '=' );
				if ( pair[0] == variable ) {
					return pair[1];
				}
			}
			return false;
		}

	};

	list.display();

} ) ( jQuery );