(function( $ ){
	$( document ).on( 'heartbeat-send', function( e, data ) {
		data['mbr_tickets_check']         = 'true';// should be lat modified, ov
		data['mbr_tickets_last_modified'] = mbr_tickets.last_modified;
		data['mbr_tickets_reply_check']   = 'true';
	});

	$( document ).on( 'heartbeat-tick', function( e, data ) {
		if ( data['mbr_tickets_refresh']['tickets']['refresh'] == true ) {
			$( '#mbr-tickets-notifications-container' ).hide().html( data['mbr_tickets_refresh']['tickets']['display'] ).fadeIn( 'slow' );
		}

		if ( typeof data['mbr_tickets_refresh']['tickets']['last_modified'] !== 'undefined' && data['mbr_tickets_refresh']['tickets']['last_modified'] != '' ) {
			mbr_tickets.last_modified = data['mbr_tickets_refresh']['tickets']['last_modified'];
		}

		if ( data['mbr_tickets_refresh']['single_ticket']['refresh'] == true ) {
			if ( data['mbr_tickets_refresh']['single_ticket']['details']['display'] != ' ') {
				$( '#mbr-ticket-details-container' ).html( data['mbr_tickets_refresh']['single_ticket']['details']['display'] ).fadeIn( 'slow' );
			}
			if ( data['mbr_tickets_refresh']['single_ticket']['replies']['display'] != '' ) {
				mbr_tickets_old_replies = $( '.mbr-tickets-reply-container' ).length;

				$( '#mbr-ticket-replies-container' ).html( data['mbr_tickets_refresh']['single_ticket']['replies']['display'] ).fadeIn( 'slow' );
				mbr_tickets_new_replies = $( '.mbr-tickets-reply-container' ).length;
				if( mbr_tickets_old_replies !== mbr_tickets_new_replies ) {
					if ( mbr_tickets.audio_notifications ) {
						$( '#mbr-tickets-audio-notification' ).remove();
						$( '<audio id="mbr-tickets-audio-notification"><source src="' + mbr_tickets.audio_dir + 'notify.ogg" type="audio/ogg"><source src="' + mbr_tickets.audio_dir + 'notify.mp3" type="audio/mpeg"><source src="' + mbr_tickets.audio_dir + 'notify.way" type="audio/wav"></audio>' ).appendTo( 'body' );
						$( '#mbr-tickets-audio-notification' )[0].play();
					}
				}
			}
		}
	});
}(jQuery));

jQuery( document ).ready( function( $ ) {
	if ( $( '.wp-header-end' ).length ) {
		$( '.wp-header-end' ).before( '<div id="mbr-tickets-notifications-container"></div>' );
	} else {
		$( '.wrap h1' ).after( '<div id="mbr-tickets-notifications-container"></div>' );
	}

	if ( mbr_tickets.push_notifications ) {
		Notification.requestPermission( function(){} );
	}

	$( '<div id="major-publishing-actions"><div id="publishing-action"><span class="spinner"></span><a href="#" id="mbr-tickets-save-ticket-tags" class="button button-primary button-large">' + mbr_tickets.save_ticket_tags_label + '</a></div><div class="clear"></div></div>').appendTo( '#tagsdiv-mbr_ticket_tag' );

	var mbr_ticket_prevent_action = false;

	$( '#mbr-tickets-save-ticket-tags' ).on( 'click', function ( e ) {
		e.preventDefault();

		if ( mbr_ticket_prevent_action == true ) {
			return;
		}

		mbr_ticket_prevent_action = true;

		$( '#mbr-tickets-notifications-container' ).hide();
		$( '#publishing-action .spinner' ).addClass( 'is-active' );
		$( '#mbr-tickets-save-ticket-tags' ).prop( 'disabled', true );

		$.post( {
			url         : ajaxurl,
			dataType    : 'json',
			data        : {
				action    : 'mbr_ajax_ticket_set_tags',
				tags      : $( '#tax-input-mbr_ticket_tag' ).val(),
				ticket_id : $( '#mbr-ticket-id' ).html()
			},
			success     : function ( response ) {
				$( '#publishing-action .spinner' ).removeClass( 'is-active' );
				$( '#mbr-tickets-save-ticket-tags' ).prop( 'disabled', false );
				$( '#mbr-tickets-notifications-container' ).html( response.notification ).fadeIn( 'slow' );
				mbr_ticket_prevent_action = false;
			}
		} );
	} );

	$( '#mbr-ticket-mark-as-answered-button, #mbr-ticket-mark-as-closed-button' ).on( 'click', function ( e ) {
		e.preventDefault();

		if ( mbr_ticket_prevent_action == true ) {
			return;
		}

		mbr_ticket_prevent_action = true;

		$( '.mbr-tickets-loading-bar' ).show();
		$( '#mbr-tickets-notifications-container' ).hide();
		$( '#mbr-ticket-details-container' ).hide();
		$( '#mbr-ticket-replies-container' ).hide();
		$( '#mbr-ticket-reply-textarea' ).prop( 'disabled', true );

		if ( $( e.target ).is( '#mbr-ticket-mark-as-answered-button' ) ) {
			ticket_status = 'mbr_ticket_answered'
		} else {
			ticket_status = 'mbr_ticket_closed'
		}

		$.post( {
			url         : ajaxurl,
			dataType    : 'json',
			data        : {
				action    : 'mbr_ajax_ticket_status_change',
				status    : ticket_status,
				ticket_id : $( '#mbr-ticket-id' ).html()
			},
			success     : function ( response ) {
				$( '.mbr-tickets-loading-bar' ).hide();
				$( '#mbr-tickets-notifications-container' ).html( response.notification ).fadeIn( 'slow' );
				$( '#mbr-ticket-reply-textarea').prop('disabled', false);
				if ( response.status == 1 ) {
					$( '#mbr-ticket-details-container' ).html( response.details ).fadeIn( 'slow' );
				} else {
					$( '#mbr-ticket-details-container' ).fadeIn( 'slow' );
				}
				$( '#mbr-ticket-replies-container' ).fadeIn( 'slow' );
				mbr_ticket_prevent_action = false;
			}
		} );

	} );

	$( '#mbr-ticket-reply-button' ).on( 'click', function ( e ) {
		e.preventDefault();

		if ( mbr_ticket_prevent_action == true ) {
			return;
		}

		mbr_ticket_prevent_action = true;

		$( '.mbr-tickets-loading-bar' ).show();
		$( '#mbr-tickets-notifications-container' ).hide();
		$( '#mbr-ticket-details-container' ).hide();
		$( '#mbr-ticket-replies-container' ).hide();
		$( '#mbr-ticket-reply-textarea' ).prop( 'disabled', true );

		$.post( {
			url         : ajaxurl,
			dataType    : 'json',
			data        : {
				action    : 'mbr_ajax_ticket_reply',
				ticket_id : $( '#mbr-ticket-id' ).html(),
				message   : $( '#mbr-ticket-reply-textarea' ).val()
			},
			success     : function ( response ) {
				$( '.mbr-tickets-loading-bar' ).hide();
				$( '#mbr-tickets-notifications-container' ).html( response.notification ).fadeIn( 'slow' );
				if ( response.status == 1 ) {
					$( '#mbr-ticket-reply-textarea' ).val( '' );
					$( '#mbr-ticket-reply-textarea' ).prop( 'disabled', false );
					$( '#mbr-ticket-details-container' ).html( response.details ).fadeIn( 'slow' );
					$( '#mbr-ticket-replies-container' ).html( response.replies ).fadeIn( 'slow' );
				} else {
					$( '#mbr-ticket-details-container' ).fadeIn( 'slow' );
					$( '#mbr-ticket-replies-container' ).fadeIn( 'slow' );
				}
				mbr_ticket_prevent_action = false;
			}
		} );

	} );

} );
