jQuery( document ).ready( function( $ ) {

	if ( typeof mbr_tickets.is_endpoint !== 'undefined' ) {
		if ( mbr_tickets.push_notifications_enabled ) {
			Notification.requestPermission( function(){} );
		}

		history.pushState( null, '', location.href.split('?')[0] );

		if ( mbr_tickets.replies_refresh &&  mbr_tickets.replies_refresh_interval ) {
			mbr_current_ticket_do_ajax_interval = true;

			mbr_current_ticket_reply_timer      = setInterval( function () {
				if ( mbr_current_ticket_do_ajax_interval ) {
					mbr_current_ticket_do_ajax_interval = false;

					$.ajax({
						url                 : mbr_tickets.ajax_url,
						dataType            : 'json',
						data: {
							action            : 'mbr_ajax_frontend_ticket_refresh_replies',
							mbr_ticket_id     : mbr_tickets.current_ticket_id,
							mbr_last_reply_id : mbr_tickets.current_ticket_last_reply_id,
							mbr_last_modified : mbr_tickets.current_ticket_last_modified
						},
						method              : 'POST',
						success             : function ( response ) {
							mbr_tickets.current_ticket_last_reply_id = response.last_reply_id;
							mbr_tickets.current_ticket_last_modified = response.last_modified;

							if ( typeof response.newest_replies !== 'undefined' && response.newest_replies != '' ) {
								$( response.newest_replies ).insertAfter( '#mbr-tickets-replies' );
								$( '#mbr-tickets-no-replies-yet').remove();
								if ( mbr_tickets.audio_notification_enabled ) {
									$( '#mbr-tickets-audio-notification' ).remove();
									$( '<audio id="mbr-tickets-audio-notification"><source src="' + mbr_tickets.audio_files_directory + 'notify.ogg" type="audio/ogg"><source src="' + mbr_tickets.audio_files_directory + 'notify.mp3" type="audio/mpeg"><source src="' + mbr_tickets.audio_files_directory + 'notify.way" type="audio/wav"></audio>' ).appendTo( 'body' );
									$( '#mbr-tickets-audio-notification' )[0].play();
								}
								if (  mbr_tickets.push_notifications_enabled ) {
									mbr_push_send( mbr_tickets.push_reply_title.replace( /%s/g, mbr_tickets.current_ticket_id ) , mbr_tickets.push_reply_body, mbr_tickets.push_icon_url );
								}
							}
							if ( typeof response.ticket_details !== 'undefined' && response.ticket_details != '' ) {
								$( '#mbr-tickets-ticket-details' ).html( response.ticket_details );
							}

							mbr_current_ticket_do_ajax_interval = true;
						}
					})
				}
			}, mbr_tickets.replies_refresh_interval );

			$( '#mbr-tickets-submit-reply' ).on( 'click', function (e) {
				clearInterval( mbr_current_ticket_reply_timer );
				mbr_current_ticket_reply_timer = null;
			});

		}

		if ( mbr_tickets.tickets_overview_refresh && mbr_tickets.tickets_overview_refresh_interval ) {
			mbr_tickets_do_ajax_interval = true;

			mbr_tickets_overview_timer   = setInterval( function () {
				if ( mbr_tickets_do_ajax_interval ) {
					mbr_tickets_do_ajax_interval = false;
					$.ajax({
						url                 : mbr_tickets.ajax_url,
						dataType            : 'json',
						data: {
							action            : 'mbr_ajax_frontend_ticket_refresh_overview',
							mbr_tickets_overview_last_modified : mbr_tickets.tickets_overview_last_modified,
						},
						method              : 'POST',
						success             : function ( response ) {

							if ( typeof response.last_modified !== 'undefined' && response.last_modified != '' ) {
								if (mbr_tickets.tickets_overview_last_modified != response.last_modified) {
									$( '<div class="notification is-info">' + mbr_tickets.tickets_overview_refresh_notification + '</div>').insertBefore( '.container h1.title' ).hide().fadeIn( 'slow' );
									if ( mbr_tickets.audio_notification_enabled ) {
										$( '#mbr-tickets-audio-notification' ).remove();
										$( '<audio id="mbr-tickets-audio-notification"><source src="' + mbr_tickets.audio_files_directory + 'notify.ogg" type="audio/ogg"><source src="' + mbr_tickets.audio_files_directory + 'notify.mp3" type="audio/mpeg"><source src="' + mbr_tickets.audio_files_directory + 'notify.way" type="audio/wav"></audio>' ).appendTo( 'body' );
										$( '#mbr-tickets-audio-notification' )[0].play();
									}
									if (  mbr_tickets.push_notifications_enabled ) {
										mbr_push_send( mbr_tickets.push_overview_title , mbr_tickets.push_overview_body, mbr_tickets.push_icon_url );
									}
									clearInterval( mbr_tickets_overview_timer );
									mbr_tickets_overview_timer = null;
								}
							}

							mbr_tickets_do_ajax_interval = true;
						}
					})
				}
			}, mbr_tickets.tickets_overview_refresh_interval );

		}

		$( '.navbar-item' ).each( function( e ) {
			$( this ).click( function() {
				if ( $( '#navbar-burger-id' ).hasClass( 'is-active' ) ) {
					$( '#navbar-burger-id' ).removeClass( 'is-active' );
					$( '#navbar-menu-id' ).removeClass( 'is-active' );
				}
			});
		});

		$( '#navbar-burger-id' ).click( function () {
			if( $( '#navbar-burger-id' ).hasClass( 'is-active' ) ) {
				$( '#navbar-burger-id' ).removeClass( 'is-active' );
				$( '#navbar-menu-id' ).removeClass( 'is-active' );
			}else {
				$( '#navbar-burger-id' ).addClass( 'is-active' );
				$( '#navbar-menu-id' ).addClass( 'is-active' );
			}
		});

		$( '#mbr-tickets-reply-form-toggle').on( 'click', function () {
			if( $( '#mbr-tickets-reply-form' ).hasClass( 'is-hidden' ) ) {
				$( '#mbr-tickets-reply-form' ).removeClass( 'is-hidden' );
				$( '#mbr-tickets-reply-form-toggle-icon' ).html( 'Cancel' );
				$( '#mbr-tickets-reply-form-toggle' ).removeClass( 'is-link' );
				$( '#mbr-tickets-reply-form-toggle' ).addClass( 'is-danger' );
			}else {
				$( '#mbr-tickets-reply-form' ).addClass( 'is-hidden' );
				$( '#mbr-tickets-reply-form-toggle-icon' ).html( 'Reply' );
				$( '#mbr-tickets-reply-form-toggle' ).addClass( 'is-link' );
				$( '#mbr-tickets-reply-form-toggle' ).removeClass( 'is-danger' );
			}
		});

		$( '.delete' ).on( 'click', function ( e ) {
			target = e.target.closest( '.notification' );
			target.remove();
		});

		$( '#mbr-tickets-create-form' ).on( 'submit', function ( e ) {
			error = false;

			if ( $( 'input[name=mbr_tickets_subject]' ).val() == '' ) {
				error = true;
				$( 'input[name=mbr_tickets_subject]' ).addClass( 'is-danger' );
				$( '.mbr-tickets-subject-help' ).removeClass( 'is-hidden' );
			} else {
				$( 'input[name=mbr_tickets_subject]' ).removeClass('is-danger');
				$( '.mbr-tickets-subject-help' ).addClass( 'is-hidden' );
			}

			if ( $( 'textarea[name=mbr_tickets_description]' ).val() == '' ) {
				error = true;
				$( 'textarea[name=mbr_tickets_description]' ).addClass( 'is-danger' );
				$( '.mbr-tickets-description-help' ).removeClass( 'is-hidden' );
			} else {
				$( 'textarea[name=mbr_tickets_description]' ).removeClass( 'is-danger' );
				$( '.mbr-tickets-description-help' ).addClass( 'is-hidden' );
			}

			if ( error == false ) {
				return true;
			}

			return false;
		});

		$( '#mbr-tickets-reply-form' ).on( 'submit', function ( e ) {
			error = false;

			if ( $( 'textarea[name=mbr_tickets_reply]' ).val() == '' ) {
				error = true;
				$( 'textarea[name=mbr_tickets_reply]' ).addClass( 'is-danger' );
				$( '#mbr-tickets-reply-help' ).removeClass( 'is-hidden' );
			} else {
				$( 'textarea[name=mbr_tickets_reply]' ).removeClass( 'is-danger' );
				$( '#mbr-tickets-reply-help' ).addClass( 'is-hidden' );
			}

			if ( error == false ) {
				return true;
			}

			return false;
		});

		$( '#mbr-tickets-login-form' ).on( 'submit', function ( e ) {
			error = false;

			if ( $( 'input[name=log]' ).val() == '' ) {
				error = true;
				$( 'input[name=log]' ).addClass( 'is-danger' );
				$( '.mbr-tickets-login-log-help' ).removeClass( 'is-hidden' );
			} else {
				$( 'input[name=log]' ).removeClass('is-danger');
				$( '.mbr-tickets-login-log-help' ).addClass( 'is-hidden' );
			}

			if ( $( 'input[name=pwd]' ).val() == '' ) {
				error = true;
				$( 'input[name=pwd]' ).addClass( 'is-danger' );
				$( '.mbr-tickets-login-pwd-help' ).removeClass( 'is-hidden' );
			} else {
				$( 'input[name=pwd]' ).removeClass( 'is-danger' );
				$( '.mbr-tickets-login-pwd-help' ).addClass( 'is-hidden' );
			}

			if ( error == false ) {
				return true;
			}

			return false;
		});
	} else {
		$( '.woocommerce-MyAccount-navigation-link--mbr-support' ).on( 'click', function (e) {
			e.preventDefault();

			if ( document.documentMode || /Edge/.test( navigator.userAgent ) ) {
				if ( typeof mbr_tickets_window != 'undefined' && mbr_tickets_window != '' ) {
					mbr_tickets_window.close();
				}
			}

			mbr_tickets_window = window.open( mbr_tickets.support_endpoint_main, 'mbr-support' );
			mbr_tickets_window.focus();
		});
	}
});