<?php
trait TRAIT__admin
{

	function _load_TRAIT__admin()
	{
		global $pagenow, $wp_version;

		IF ( is_admin() ) :
			
			IF ( in_array( $pagenow, [ 'post.php', 'post-new.php' ] ) ) :
				add_action( "load-{$pagenow}",             [ $this, 'init_metaboxes_main' ],                    0 );
				add_action( "load-{$pagenow}",             [ $this, 'init_metaboxes_tag_list' ],              999 );
			ENDIF;
			add_action( 'mbr/quick_edit/protection/box', [ $this, 'init_quick_edit_main' ], 0 );
		ENDIF;

		add_action( 'admin_init',                    [ $this, 'hide_dashboard' ],                       0 );

		add_filter( 'clean_url',                     [ $this, 'mbr_menu_clean_url' ],                 999, 3 );

		add_action( 'mbr/migration',                 [ $this, 'check_migration_status' ],               0, 0 );

		add_action( 'post_submitbox_misc_actions',   [ $this, 'post_submitbox_misc_actions' ] );

		add_action( 'admin_head',                    [ $this, 'quick_content_protection_popup' ],     9999 );
		add_filter( 'post_row_actions',              [ $this, 'page_post_row_actions' ],                10, 2 );
		add_filter( 'page_row_actions',              [ $this, 'page_post_row_actions' ],                10, 2 );

		add_action( 'current_screen',                [ $this, 'current_screen'] );

		IF ( !defined( 'MBR_MENUVISIBILITY_MODULE') OR MBR_MENUVISIBILITY_MODULE ) :
			add_action( 'wp_nav_menu_item_custom_fields', [ $this, 'menu_visibility' ],                10, 4 );
			add_filter( 'manage_nav-menus_columns',       [ $this, 'nav_menu_columns' ],             9999, 1 );
			IF ( version_compare( $wp_version, '5.4', '<' ) ) :
				add_filter( 'wp_edit_nav_menu_walker',      [ $this, 'menuvis_edit_nav_menu_walker' ], 9999, 1 );
			ENDIF;
			add_action( 'wp_update_nav_menu_item',        [ $this, 'menuvis_update_option' ],          10, 3 );
			add_action( 'delete_post',                    [ $this, 'menuvis_remove_visibility_meta' ],  1, 3 );
		ENDIF;

		add_action( 'export_wp',                     [ $this, 'export_wp' ],                             0 );
		add_action( 'import_end',                    [ $this, 'import_end' ],                            0 );
		add_filter( 'admin_memory_limit',            [ $this, 'admin_memory_limit' ] );

		add_action( 'post_comment_status_meta_box-options', [ $this, 'prvcmt_post_comment_status_meta_box_options' ], 10, 1 );
	}

	function documentation_admin()
	{
		global $MBR_OPTIONS;

		echo '<iframe src="https://activemember360.com/docs/" style="width:85vw;height:90vh"></iframe>';
	}

	function admin_memory_limit()
	{
		global $MBR_OPTIONS;

		return '1024M';
	}

	function current_screen()
	{
		$this->screen = get_current_screen();
	}

	function force_render_meta_box( $_post, $box )
	{
		$box_id = empty( $box['id'] ) ? $box : $box['id'];

		IF ($arrTEMP = get_user_meta( $this->current_user->ID, "metaboxhidden_{$_post->post_type}", true ) ) :
			FOREACH ( $arrTEMP as $k => $v ) :
				IF ( $v == $box_id ) :
					IF ( isset( $arrTEMP[$k] ) ) :
						unset( $arrTEMP[$k] );
					ENDIF;
				ENDIF;
			ENDFOREACH;
			update_user_meta( $this->current_user->ID, "metaboxhidden_{$_post->post_type}", $arrTEMP );
		ENDIF;

		IF ( $arrTEMP = get_user_meta( $this->current_user->ID, "closedpostboxes_{$_post->post_type}", true ) ) :
			FOREACH ( $arrTEMP as $k => $v ) :
				IF ( $v == $box_id ) :
					IF ( isset( $arrTEMP[$k] ) ) :
						unset( $arrTEMP[$k] );
					ENDIF;
				ENDIF;
			ENDFOREACH;
			update_user_meta( $this->current_user->ID, "closedpostboxes_{$_post->post_type}", $arrTEMP );
		ENDIF;
	}

	function init_metaboxes_main( $_post_type = FALSE, $_post = FALSE )
	{
		global $pagenow, $typenow;

		IF ( in_array( $typenow, [ 'attachment', 'page', 'post' ] ) ) :
			IF ( "load-{$pagenow}" == current_filter() ) :
				add_action( 'add_meta_boxes', [ $this, __FUNCTION__ ], 10, 2 );
			ELSEIF ( 'add_meta_boxes' == current_filter() ) :
				do_action( 'mbr/add_meta_box', $_post, [ $this, 'render_meta_boxes_protection' ], NULL );
				IF ( in_array( $_post_type, [ 'post', 'page' ] ) ) :
					do_action( 'mbr/meta_boxes_excerpt',  $_post );
				ENDIF;
			ENDIF;
		ENDIF;
	}

	public function init_quick_edit_main( $_post )
	{
		IF ( in_array( $_post->post_type, [ 'attachment', 'page', 'post' ] ) ) :
			$this->render_meta_boxes_protection( $_post, 'quick-protection' );
		ENDIF;
	}

	function add_metaboxes_3rd_parties( $_post, $box )
	{
		do_action( 'mbr/add_meta_box', $_post, [ $this, 'render_meta_boxes_protection' ], NULL );
	}

	function init_metaboxes_tag_list()
	{
		add_action( 'add_meta_boxes', [$this, 'add_meta_boxes_tag_list'], 99, 1 );
	}

	function add_meta_boxes_tag_list( $_post )
	{
		$help = $this->format_help_abbr( _x( "Search for tags by entering parts of the tag name or tag ID&#039;s you have created in ActiveCampaign", 'wp_admin', 'activemember360' ) );
		$this->force_render_meta_box( $_post, 'tag_list_search' );
		add_meta_box(
			"tag_list_search_{$_post->post_type}"
			, $this->meta_box_header( _x( 'Tag Search', 'wp_admin', 'activemember360' ), false )
			, [ $this, 'render_meta_boxes_tag_list' ]
			, $_post->post_type
			, 'side'
			, 'high'
		);
	}

	function add_meta_boxes_protection( $_post )
	{
		$this->add_meta_box( $_post, [ $this, 'render_meta_boxes_protection' ] );
	}

	function add_meta_box( $_post, $callback = null, $header = null )
	{
		IF ( ! current_user_can( 'publish_pages' ) ) :
			return;
		ENDIF;

		IF ( is_null( $callback ) ) :
			$callback = [ $this, 'render_meta_boxes_protection' ];
		ENDIF;

		IF ( is_array( $callback ) ) :

			IF ( empty( $callback[0] ) OR empty( $callback[1] ) ) :
				return;
		  ENDIF;

			IF ( ! method_exists( $callback[0], $callback[1] ) ) :
				return;
			ENDIF;

		ELSE :

			IF ( empty( $callback ) OR ! function_exists( $callback ) ) :
				return;
			ENDIF;

		ENDIF;

		$meta_box_id = 'group_access_' . $_post->post_type;

		$this->force_render_meta_box( $_post, $meta_box_id );

		add_meta_box(
			$meta_box_id
			, is_null($header) ? $this->meta_box_header($_post->post_type) : $this->meta_box_header($header, false)
			, $callback
			, $_post->post_type
			, 'side'
			, 'high'
		);
	}

	function meta_box_header( $_post_type, $generate = true )
	{
		global $wp_post_types;
		IF ( $generate ) :
			$headline = ucfirst( $wp_post_types[$_post_type]->labels->singular_name ) . ' ' . __( 'Protection', 'activemember360' );
		ELSE :
			$headline = $_post_type;
		ENDIF;
		return "<div style='background:url({$this->admin_header_icon_url}) no-repeat left top;background-size:16px 16px;margin-top:5px;padding-left:20px;font-weight:bold;color:{$this->plugcolor};'>{$headline}</div>";
	}

	function get_meta_box_protection_settings( $_post )
	{
		global $MBR_OPTIONS;

		$settings                     = [];
		$settings['setGROUPS']        = '';
		$settings['setPUBLIC']        = 0;
		$settings['setHIDEMENU']      = 0;
		$settings['setIGNOREEXCERPT'] = 0;
		$settings['tag_pos_list']     = '';
		$settings['tag_neg_list']     = '';
		$settings['automation_list']  = '';

		$perms = apply_filters( 'mbr/permissions/get', NULL, $_post->ID );

		IF ( isset( $perms->group_access ) ) :
			$settings['setGROUPS'] = explode( ',', lower_trim( $perms->group_access) ) ;
		ENDIF;

		IF ( isset( $perms->public_only ) ) :
			$settings['setPUBLIC'] = $perms->public_only;
		ENDIF;

		IF ( isset( $perms->hide_menu ) ) :
			$settings['setHIDEMENU'] = $perms->hide_menu;
		ENDIF;

		IF ( isset( $perms->ignore_excerpt ) ) :
			$settings['setIGNOREEXCERPT'] = $perms->ignore_excerpt;
		ENDIF;

		IF ( isset( $perms->tag_pos_list ) ) :
			$settings['tag_pos_list'] = explode( ',', $perms->tag_pos_list );
		ENDIF;

		IF ( isset( $perms->tag_neg_list ) ) :
			$settings['tag_neg_list'] = explode( ',', $perms->tag_neg_list );
		ENDIF;

		IF ( isset( $perms->automation_list ) ) :
			$settings['automation_list'] = $perms->automation_list;
		ENDIF;

		$settings['redirect_no_access']     = (int) get_post_meta( $_post->ID, $this->postmeta_no_access_redirect_key, true );
		$settings['redirect_no_access_url'] = get_post_meta( $_post->ID, $this->postmeta_no_access_redirect_url_key, true );

		IF ($settings['redirect_no_access'] == -1 AND !trim( $settings['redirect_no_access_url'] ) ) :
			$settings['redirect_no_access'] = 0;
			update_post_meta( $_post->ID, $this->postmeta_no_access_redirect_key, $settings['redirect_no_access'] );
		ENDIF;

		IF ($settings['redirect_no_access'] >= 0) :
			$settings['redirect_no_access_url'] = '';
			update_post_meta( $_post->ID, $this->postmeta_no_access_redirect_url_key, $settings['redirect_no_access_url'] );
		ENDIF;

		$settings['post_type_object']       = $GLOBALS['wp_post_types'];
		$settings['post_type_name']         = strtolower( $settings['post_type_object'][$_post->post_type]->labels->singular_name );
		$settings['post_show_in_nav_menus'] = $settings['post_type_object'][$_post->post_type]->show_in_nav_menus;

		$this->fetch_automations();
		$settings['site_automations']       = $this->site_automations;
		$settings['site_automation_status'] = $this->site_automation_status;

		$settings['plugcolor']              = $this->plugcolor;
		$settings['membership_levels']      = $MBR_OPTIONS['membership_levels'];
		$settings['site_tags']              = $this->site_tags;
		$settings['site_pages']             = $this->get_pages();

		return $settings;
	}

	function render_meta_boxes_protection_generic($_post, $settings)
	{
		extract($settings);

		IF (is_post_type_hierarchical($_post->post_type)) :
			$checked = in_array(-3, $setGROUPS) ? "checked='checked'" : "";
			$help    = $this->format_help_abbr("Checking this box will allow access to anyone who meets the access requirements for this {$post_type_name}&#039;s parent {$post_type_name}.");
			echo "<label style='height:11px;line-height:11px;font-size:0.95em;'><input style='vertical-align:middle;' type='checkbox' name='group_access[-3]' value='-3' " . $checked . " />{$help}&nbspInherit from parent</label>";
			echo '<br />';
		ENDIF;

		$checked = in_array(-2, $setGROUPS) ? "checked='checked'" : "";
		$help    = $this->format_help_abbr("Checking this box will allow everyone access to this {$post_type_name} at all times, even if \"Forced Login\" is required.");

		echo "<label style='height:11px;line-height:11px;font-size:0.95em;'><input style='vertical-align:middle;' type='checkbox' name='group_access[-2]' value='-2' " . $checked . " />{$help}&nbspAnyone at any time</label>";
		echo '<br />';

		$checked = in_array(-1, $setGROUPS) ? "checked='checked'" : "";
		$help    = $this->format_help_abbr("Checking this box will grant access to this {$post_type_name} to anyone who is logged in, regardless of membership.");

		echo "<label style='height:11px;line-height:11px;font-size:0.95em;'><input style='vertical-align:middle;' type='checkbox' name='group_access[-1]' value='-1' " . $checked . " />{$help}&nbsp;Any logged in user</label>";
		echo '<br />';
	}

	function render_meta_boxes_protection_memberships($_post, $settings)
	{
		extract($settings);

		FOREACH ($membership_levels as $thisID => $thisLEVEL) :

			IF ( trim( $thisLEVEL['name'] ) == '' ) :
				$thisLEVEL['name'] = $site_tags[$thisID];
			ENDIF;

			$checked = (in_array($thisID, $setGROUPS)) ? "checked='checked'" : "";
			$help    = $this->format_help_abbr("Checking this box will grant access to this {$post_type_name} to anyone who is logged in and has tag {$thisID} (\"{$thisLEVEL['name']}\").");

			echo "<label style='height:11px;line-height:11px;font-size:0.95em;'><input style='vertical-align:middle;' type='checkbox' name='group_access[$thisID]' value='$thisID' $checked />{$help}&nbsp;" . $thisLEVEL['name'] . "</label>";
			echo "<br />";

		ENDFOREACH;

		echo "<div style='margin-top:3px;margin-bottom:4px;height:1px;border-bottom:solid 1px #ccc;'></div>";
	}

	function render_meta_boxes_protection_filters($_post, $settings)
	{
		extract($settings);

		IF ($_post->post_type == 'page' OR post_type_supports($_post->post_type, 'excerpt')) :
			$help = $this->format_help_abbr("Checking this option will result in excerpts being ignored when determining this {$post_type_name}&#39;s visibility to a user unless a user first meets all permissions requirements. It means that an excerpt will only be displayed to users who fulfill all permissions requirements. Users who do not will see neither the full content nor the excerpt, if one exists.");
			echo "<label style='font-size:0.95em;'><input style='vertical-align:middle;' type='checkbox' name='ignore_excerpt' value='0' " . checked($setIGNOREEXCERPT, 1, false) . " />{$help}&nbsp;<strong style='color:{$plugcolor}'>Excerpt only with permissions</strong></label>";
			echo '<br />';
		ENDIF;

		IF ($post_show_in_nav_menus) :
			$help = $this->format_help_abbr("Checking this option will prevent this {$post_type_name} from appearing in the menu. It will not prevent access to the {$post_type_name} itself.");
			echo "<label style='font-size:0.95em;'><input style='vertical-align:middle;' type='checkbox' name='hide_menu' value='0' " . checked($setHIDEMENU, 1, false) . " />{$help}&nbsp;<strong style='color:{$plugcolor}'>Hide from menu only</strong></label>";
			echo '<br />';
		ENDIF;

		$checked = (in_array('0', $setGROUPS)) ? "checked='checked'" : "";
		$help    = $this->format_help_abbr("Checking this option will prevent this {$post_type_name} from appearing in the menu as well deny access to anyone other than administrators.");
		echo "<label style='font-size:0.95em;'><input style='vertical-align:middle;' type='checkbox' name='group_access[0]' value='0' $checked />{$help}&nbsp;<strong style='color:{$plugcolor}'>Hide completely (incl. excerpt)</strong></label>";

		echo '<br />';
		$checked = ($setPUBLIC == 1) ? "checked='checked'" : "";
		$help    = $this->format_help_abbr("Checking this option will deny access to this {$post_type_name} to anyone who is logged in. It will only be made available to visitors who are NOT logged in.");
		echo "<label style='font-size:0.95em;'><input style='vertical-align:middle;' type='checkbox' name='public_only' value='0' $checked />{$help}&nbsp;<strong style='color:{$plugcolor}'>Show only to public visitors</strong></label>";

		echo "<div style='margin-top:3px;margin-bottom:4px;height:1px;border-bottom:solid 1px #ccc;'></div>";
	}

	function render_meta_boxes_protection_addtl_tags($_post, $settings)
	{
		IF (in_array($_post->post_type, [$this->bbtopic, $this->bbreply])) :
			return;
		ENDIF;
		extract($settings);
		$help = $this->format_help_abbr("This is used to define additional tag criteria beyond basic membership tags.\n\nExample:\n-> membership1,membership2,not membership3,not membership4\n -> Anyone who has either tag membership1 OR membership2 and has not membership3 OR membership4.");
		echo "{$help}&nbsp;<strong style='font-size:0.95em;'>Only/Not these Tags</strong>";
		echo '<select multiple="multiple" name="tag_list[]" class="mbr-select2">';
		FOREACH ($site_tags AS $tid => $tname) :
			$selected = (in_array($tid, $tag_pos_list)) ? 'selected="selected"' : '';
			echo "<option value='{$tid}' $selected>$tid - $tname</option>";
		ENDFOREACH;
		FOREACH ($site_tags AS $tid => $tname) :
			$selected = (in_array($tid, $tag_neg_list)) ? 'selected="selected"' : '';
			echo "<option value='-{$tid}' $selected>not $tid - $tname</option>";
		ENDFOREACH;
		echo '</select>';
	}

	function render_meta_boxes_protection_comment_automations($_post, $settings)
	{
		IF (in_array($_post->post_type, [$this->bbtopic, $this->bbreply])) :
			return;
		ENDIF;
		extract($settings);
		echo '<br />';
		$help = $this->format_help_abbr("When a logged in contact submits a comment, assign the contact to the automation specified below. This option is only available when comments are enabled for this {$post_type_name}.");
		echo "{$help}&nbsp;<strong style='font-size:0.95em;'>Run automation on comment</strong>";
		IF ('attachment' <> $_post->post_type  AND 'open' == $_post->comment_status) :
			echo "<select name='automation_list' style='width:100%;'>";
			echo '<option value="">' . _x('Do not run an automation', 'wp_admin', 'activemember360') . '</option>';
			FOREACH ($site_automations as $automationid => $automationname) :
				$status = $site_automation_status[$automationid] <> 1 ? 'disabled="disabled"' : '';
				echo "<option value='$automationid' " . selected($automation_list, $automationid, false) . " " . $status . ">$automationname</option>";
			ENDFOREACH;
			echo "</select>";
		ELSE :
			echo "<div style='width:100%;text-align:center;'>Comments are currently disabled.</div>";
			echo "<input type='hidden' name='automation_list' value='' />";
		ENDIF;
	}

	function render_meta_boxes_protection_redirect($_post, $settings)
	{
		extract($settings);

		$help = $this->format_help_abbr("Choose a location to which to redirect a contact/visitor who has no permissions to see this {$post_type_name}. Please note that the existence of any excerpt will not trigger a redirect unless the &#039;Excerpt only with permissions&#039; setting above has been set.");
		echo "{$help}&nbsp;<strong style='font-size:0.95em;'>When forbidden, redirect to</strong> ";
		echo '<select id="mbr_forbidden" name="forbidden_redirect" style="width:100%;">';
		echo '<option value="0">Default site 404 handler</option>';
		echo '<option value="-1" ' . selected($redirect_no_access, '-1', false) . '>Custom URL</option>';
		echo '<option value="-2" ' . selected($redirect_no_access, '-2', false) . '>Front Page</option>';
		FOREACH ($site_pages AS $page) :
			echo "<option value='{$page->ID}' " . selected($redirect_no_access, $page->ID, false) . ">{$page->post_title}</option>";
		ENDFOREACH;
		echo '</select>';
		echo "<input id='mbr_forbidden_url' style='display:none;width:100%;' type='text' name='forbidden_redirect_url' placeholder='Custom URL / Location' value='{$redirect_no_access_url}' />";
		echo "<script>jQuery(document).ready(function() {if (jQuery('#mbr_forbidden').val() == '-1') {jQuery('#mbr_forbidden_url').show();}});jQuery('#mbr_forbidden').change(function() {if (jQuery('#mbr_forbidden').val() == '-1') {jQuery('#mbr_forbidden_url').show();} else {jQuery('#mbr_forbidden_url').hide();}});</script>";
	}

	function render_meta_boxes_protection( $_post, $box )
	{
		$settings = apply_filters( 'mbr/get_meta_box_protection_settings', $_post );

		do_action( 'mbr/render_metabox_css_helper', $box );

		IF ( empty( $settings['membership_levels'] ) ) :
			echo "<p style='color:" . apply_filters( 'mbr/plugin_color', NULL ) . ";font-size:10px;'>You have not yet defined which memberships you want to use on this site. Please do so in <a href='" . admin_url('admin.php?page=activemember360&mbrtab=memberships') . "'>'Memberships'</a>.</p>";
			return;
		ENDIF;

		do_action( 'mbr/render_meta_boxes_protection_generic',            $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_memberships',        $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_filters',            $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_addtl_tags',         $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_comment_automation', $_post, $settings );
		do_action( 'mbr/render_meta_boxes_protection_redirect',           $_post, $settings );
	}

	function add_meta_boxes_completion_tag_list($post)
	{
		$help = $this->format_help_abbr("Search for tags by entering parts of the tag name or tag ID&#039;s you have created in ActiveCampaign");
		$this->force_render_meta_box($post, 'tag_list_search');
		add_meta_box(
				"tag_list_search_{$post->post_type}"
			, $this->meta_box_header('Tag Search', false)
			, [$this, 'render_meta_boxes_tag_list']
			, $post->post_type
			, 'side'
			, 'high'
		);
	}

	function render_meta_boxes_tag_list($post, $box)
	{
		$this->render_metabox_css_helper($box);

		echo '<select multiple="multiple" class="mbr-clear-select2">';

		FOREACH ( $this->site_tags AS $tid => $tname ) :
			echo "<option value='{$tid}'>$tid - $tname</option>";
		ENDFOREACH;

		echo '</select>';
	}

	function add_meta_boxes_excerpt( $_post)
	{
		global $wp_post_types;

		$this->force_render_meta_box( $_post, 'postexcerpt' );

		$help = $this->format_help_abbr("If you manually add a {$_post->post_type} excerpt, it will be used as &#039;teaser&#039; text when a user does not have the permissions required to access this {$_post->post_type}.\n\nAn excerpt is not required. If a user lacks the necessary permissions and an excerpt is not available, a &#039;Page not found&#039; will be returned, using your theme templates.");

		add_meta_box(
				'postexcerpt'
			, $this->meta_box_header(ucfirst($wp_post_types[$post->post_type]->labels->singular_name) . ' Excerpt', false)
			, [$this, 'render_meta_boxes_excerpt']
			, $_post->post_type
			, 'normal'
			, 'high'
		);
	}

	function render_meta_boxes_excerpt( $_post, $box )
	{
		do_action( 'mbr/render_metabox_css_helper', $box );

		$thisEXCERPT = isset( $_post->post_excerpt ) ? rtrim( $_post->post_excerpt ) : '';

		wp_editor( htmlspecialchars_decode( stripslashes( $thisEXCERPT ) ), 'excerpt', [ 'media_buttons' => false, 'text_area_rows' => 6 ] );
	}

	function render_metabox_css_helper( $box )
	{
		
		$box_id = empty($box['id']) ? $box : $box['id'];
		echo "<style>#{$box_id} {background-color:{$this->metabox_bg_color};} fieldset.metabox-prefs div[style] {display: inline; background:none !important; color:#555 !important; font-size:13px !important; margin: 0 !important; padding: 0!important; font-weight: normal !important;}</style>";
	}

	function post_submitbox_misc_actions($post)
	{
		IF (!in_array($post->post_type, ['attachment', 'nav_menu_item'])) :
			$help = $this->format_help_abbr("Check this box to turn off WordPress&#039; automatic paragraph feature if your {$post->post_type} format is being broken.");
			echo "<div class='misc-pub-section mbr-wpautop'>{$help} <span>Turn wpautop off:</span> <input type='checkbox' name='_mbr_disable_wpautop' id='_mbr_disable_wpautop' " . checked(get_post_meta($post->ID, '_mbr_disable_wpautop', true), true, false) . "' /></div>";
		ENDIF;
	}

	public function page_post_row_actions( $actions, $post )
	{
		global $pagenow;

		IF ( $pagenow == 'edit.php' OR $_POST['action'] == 'inline-save' ) :
			$arr_protectable_post_types = apply_filters( 'mbr/protectable_post_types/built_in', [] );
			IF ( in_array( $post->post_type, $arr_protectable_post_types ) ) :
				$post_type_name  = ucwords( get_post_type_object( $post->post_type )->labels->singular_name );
				$actions['mbr-quick-protection'] = '<a title="' . $post->post_title . ' (Post ID #' . $post->ID .')" href="' . admin_url() . '?mbr_quick_protection=' . $post->ID .'&TB_iframe=true&width=400&height=600" class="thickbox">AM360 ' . $post_type_name . ' Protection</a>';
			ENDIF;
		ENDIF;

		return $actions;
	}

	public function quick_content_protection_popup()
	{
		IF ( is_admin() AND MBRADMIN AND ! empty( $_GET['mbr_quick_protection'] ) ) :
			echo '</head><body>';
			$post_id  = $_GET['mbr_quick_protection'];
			$post     = get_post( $post_id );
			$obj_name = ucwords( get_post_type_object( $post->post_type )->labels->singular_name );

			IF ( isset( $_POST['mbr-quick-protection-submit'] ) ) :
				$this->save_permissions( $post_id, $post );
				$post = get_post( $post_id );
				echo '<div id="message" class="updated notice notice-success is-dismissible"><p>' . _x( 'Permissions saved.', 'wp_admin', 'activemember360' ) . '</p></div>';
			ENDIF;

			echo '<div style="padding:0 20px 20px 20px;">';
			echo "<h2> <img src='{$this->favicon}' /> {$obj_name} " . _x( 'Protection', 'wp_admin', 'activemember360' ) . "</h2>";
			echo '<form method="post" action="">';

			do_action( 'mbr/quick_edit/protection/box', $post );

			echo "<input type='hidden' name='post_parent' value='{$post->post_parent}' />";
			echo "<p><input type='submit' name='mbr-quick-protection-submit' value='Update' /></p>";
			echo "</form>";
			echo "</div>";
			echo '</body></html>';
			exit;
		ENDIF;
	}

	function select_box_helper($arrOPTIONS, $current_options, $identifier, $display_id=true, $multiple=true, $select2=true)
	{
		$select_multiple   = '';
		$select_name       = $identifier;
		$select_class      = '';
		IF ($multiple) :
			$select_multiple = 'multiple="multiple"';
			$select_name     = $identifier . '[]';
			IF ($select2) :
				$select_class  = 'class="mbr-select2"';
			ENDIF;
		ENDIF;
		$select_box        = '<select id="' . $identifier . '" ' . $select_multiple . ' name="' . $select_name . '" ' . $select_class . '>';
		FOREACH ($arrOPTIONS AS $id => $name) :
			IF (is_array($current_options)) :
				$selected      = in_array($id, $current_options) ? 'selected="selected"' : '';
			ELSE:
				$selected      = selected($id, $current_options, false);
			ENDIF;
			$select_box     .= "<option value='{$id}' $selected>" . ($display_id ? $id . ' - ': '') . "$name</option>";
		ENDFOREACH;
		$select_box       .= '</select>';
		return $select_box;
	}

	function convert_user_login()
	{
		IF (!MBRADMIN) :
			wp_die( _x( 'You must be an administrator to perform this task', 'wp_admin', 'activemember360' ) );
		ENDIF;

		IF ($rows = $this->wpdb->get_results("SELECT ID, user_login, user_email FROM {$this->wpdb->users} WHERE user_login <> user_email ORDER BY ID")) :
			add_filter('send_password_change_email', '__return_false');
			echo "<style>table {border:1px solid black;border-collapse:collapse} tr:nth-child(even) {background-color:#eee;} table#t01 tr:nth-child(odd) {background-color: #fff;border-right:1px solid black;} td {padding:5px;border-top:1px solid black;border-right:1px solid black;font-size:x-large;}</style>";
			echo "<table>";
			echo "<caption style='font-size:x-large;'>List of users - if any - that will be converted for Activemember360</caption>";
			echo "<tr style='background-color:lightyellow;'><td>User ID</td><td>User Login</td><td>User Email</td></tr>";
			FOREACH ($rows AS $k => $row) :
				$conv_user  = new WP_User($row->ID);
				
				IF (!$conv_user->roles OR !is_array($conv_user->roles) OR in_array('subscriber', $conv_user->roles)) :
					
					$subscriber = true;
				ELSE :
					$subscriber = false;
				ENDIF;
				
				IF ($subscriber) :
					echo "<tr style='='1'><td>{$row->ID}</td><td>{$row->user_login}</td><td>{$row->user_email}</td></tr>";
					
					IF ('convert' == lower_trim($_GET['mbr_convertuserlogin'])) :
						
						update_user_meta($row->ID, 'mbr_old_user_login', $row->user_login);
						
						$this->wpdb->update($this->wpdb->users, ['user_login' => $row->user_email], ['ID' => $row->ID]);
					ENDIF;
				ENDIF;
			ENDFOREACH;
			echo '</table>';
		ELSE :
			wp_die(_x('There were no users found that needed to be converted.', 'wp_admin', 'activemember360'));
		ENDIF;
		exit;
	}

	function show_user_wp_roles()
	{
		IF ($roles = get_editable_roles()) :
			FOREACH ($roles AS $slug => $obj) :
				echo '<hr>';
				echo '<strong>' . $slug . '</strong><br/>';
				echo '&nbsp;&nbsp;&nbsp;&nbsp;' . $obj['name'] . '<br/>';
			ENDFOREACH;
		ENDIF;
		//mbr_die($roles);
		exit;
	}

}
