<?php
trait TRAIT__helpers
{
	function _load_TRAIT__helpers()
	{

		
		add_filter( 'mbr_filter_page_list',           [ $this, 'cpts_to_page_list' ],                   0, 1 );


		add_filter( 'mbr/redux/module_name',                               [ $this, 'redux_header_module_name' ],                 10, 2 );

		add_filter( 'mbr/site/domain/get',                                 [ $this, 'get_domain' ] );

		add_filter( 'mbr/site_tags/get',                                   [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/site_tag/get',                                    [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/site_lists/get',                                  [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/site_automations/get',                            [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/site_automations/get/status',                     [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/site_automations/get/active',                     [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/site_membership_levels/get',                      [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/metabox_bg_color',                                [ $this, '_return__site_vars' ] );

		add_filter( 'mbr/tags/normalize/ids',                              [ $this, 'normalize_tag_ids'],                         10, 2 );
		add_filter( 'mbr/tags/normalize/names',                            [ $this, 'normalize_tag_names'],                       10, 2 );

		add_action( 'mbr/site_tags/fetch',                                 [ $this, 'fetch_tags' ] );
		add_action( 'mbr/site_lists/fetch',                                [ $this, 'fetch_lists' ] );
		add_action( 'mbr/site_automations/fetch',                          [ $this, 'fetch_automations' ] );
		add_action( 'mbr/site_custom_fields/fetch',                        [ $this, 'fetch_custom_fields' ] );
		add_action( 'mbr/site_custom_fields/sync',                         [ $this, 'sync_custom_fields' ] );
		add_filter( 'mbr/site_forms/fetch',                                [ $this, 'fetch_forms' ] );
		add_filter( 'mbr/site_messages/templates/fetch',                   [ $this, 'fetch_site_message_template_list' ] );
		add_filter( 'mbr/webhooks/fetch',                                  [ $GLOBALS['mbr_inst_webhooks'], 'fetch_webhooks' ], 10, 0 );
		add_filter( 'mbr/webhooks/events/get',                             [ $this, '_return__webhook_vars' ] );
		add_filter( 'mbr/webhooks/triggers/get',                           [ $this, '_return__webhook_vars' ] );
		add_action( 'mbr/webhooks/delete/local/all',                       [ $GLOBALS['mbr_inst_webhooks'], 'delete_all_site_webhooks' ] );

		add_filter( 'mbr/site_regular_fields/get',                         [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/site_contact_std_fields/get',                     [ $this, '_return__site_vars'] );
		add_filter( 'mbr/site_custom_fields/get',                          [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/site_messages/templates/get',                     [ $this, 'get_site_message_template_list' ] );

		add_filter( 'mbr/plugin_name',                                     [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/plugin_color',                                    [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/plugin_favicon',                                  [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/contact_id',                                      [ $this, '_return__contact_id' ] );
		add_filter( 'mbr/password_perstag',                                [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/password/char_base',                              'mbr_get_password_base');
		add_filter( 'mbr/passfield',                                       [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/passfield/id',                                    [ $this, '_return__site_vars' ] );
		add_action( 'mbr/password/lostpassword_post_form_process',         [ $GLOBALS['mbr_passwords'], 'lostpassword_post_form_process' ] );
		add_filter( 'mbr/password/generate',                               [ $GLOBALS['mbr_passwords'], 'generate_password' ] );
		add_filter( 'mbr/url',                                             [ $this, 'url' ] );
		add_filter( 'mbr/url_to_post_id',                                  [ $this, 'url_to_postid' ] );

		add_filter( 'mbr/match_user_content',                              [ $this, 'match_user_content'], 10, 2 );

		add_filter( 'mbr/fetch_remote_contact/by_id',                      [ $this, '_return__fetch_remote_contact_by_id' ] );

		add_filter( 'mbr/fetch_contact',                                   [ $this, 'fetch_contact' ],                            10, 2 );
		add_filter( 'mbr/fetch_contact/local',                             [ $this, 'fetch_contact_local' ],                      10, 1 );
		add_filter( 'mbr/get_contact',                                     [ $this, 'fetch_contact' ],                            10, 1 );

		add_filter( 'mbr/is_contact',                                      [ $this, 'is_contact' ],                               10, 1 );

		add_filter( 'mbr/get_remote_contact/by_id',                        [ $this, 'fetch_contact' ],                            10, 2 );
		add_filter( 'mbr/get_remote_contact/by_email',                     [ $this, 'fetch_contact' ],                            10, 2 );
		add_filter( 'mbr/get_remote_contact/by_hash',                      [ $this, 'fetch_contact' ],                            10, 2 );

		add_filter( 'mbr/get_contact_field',                               [ $this, '_return__get_contact_field' ],               10, 1 );
		add_filter( 'mbr/save_contact_fields',                             [ $this, '_return__save_contact_fields' ] );

		add_filter( 'mbr/api',                                             [ $this, 'api' ],                                      10, 2 );
		add_filter( 'mbr/api/sync_ctla',                                   [ $this, 'sync_automations_tags_lists' ],              10, 1 );
		add_filter( 'mbr/api/init',                                        [ $this, 'api_init' ] );
		add_filter( 'mbr/api_account/check',                               [ $this, 'api_check_account'] );

		add_filter( 'mbr/secodes/get',                                     [ $this, '_return__get_sec_codes' ] );
		add_filter( 'mbr/secodes/validate',                                [ $this, 'validate_sec_code' ],                        10, 1 );
		add_action( 'mbr/clear_ob',                                        [ $this, 'clear_ob' ] );

		add_filter( 'mbr/process_tags',                                    [ $this, 'process_tag' ],                              10, 2 );

		add_filter( 'mbr/contact/tags',                                    [ $this, '_return__contact_vars' ] );
		add_filter( 'mbr/contact/membership_levels',                       [ $this, '_return__contact_vars' ] );
		add_filter( 'mbr/contact/payf_tags',                               [ $this, '_return__contact_vars' ] );
		add_filter( 'mbr/contact/lists',                                   [ $this, '_return__contact_vars' ] );
		add_filter( 'mbr/contact/has_tag',                                 'mbr_contact_has_tag',                                 10, 1 );
		add_filter( 'mbr/contact/has_tags',                                'mbr_has_tags',                                        10, 2 );

		add_action( 'mbr/options/save',                                    'mbr_save_site_options' );
		add_action( 'mbr/options/load',                                    'mbr_load_site_options' );
		add_filter( 'mbr/pages/get',                                       [ $this, 'get_pages' ] );

		add_filter( 'mbr/session/get',                                     [ $this, '_return__session_data' ] );
		add_action( 'mbr/session/update',                                  [ $this, '_action__session_data_update' ] );

		add_action( 'mbr/track/log/event',                                 [ $GLOBALS['mbr_tracking'], 'log_event' ],             10, 3 );
		add_action( 'mbr/track/create/event',                              [ $GLOBALS['mbr_tracking'], 'log_event' ],             10, 3 );

		add_action( 'mbr/render_metabox_css_helper',                       [ $this, 'render_metabox_css_helper' ],                10, 1 );

		add_filter( 'mbr/select_box_helper',                               [ $this, 'select_box_helper' ],                        10, 6 );

		add_action( 'mbr/update_cookie',                                   [ $this, 'update_cookie' ],                            10, 2 );
		add_action( 'mbr/delete_cookie',                                   [ $this, 'delete_cookie' ],                            10, 1 );
		add_action( 'mbr/create_user_cookie',                              [ $this, 'create_user_cookie' ],                       10, 1 );

		add_filter( 'mbr/get_meta_box_protection_settings',                [ $this, 'get_meta_box_protection_settings' ],         10, 1 );

		add_action( 'mbr/meta_boxes_tag_list',                             [ $this, 'add_meta_boxes_tag_list' ],                   0, 1 );
		add_action( 'mbr/meta_boxes_excerpt',                              [ $this, 'add_meta_boxes_excerpt' ],                    0, 1 );

		add_action( 'mbr/render_meta_boxes_protection_default',            [ $this, 'render_meta_boxes_protection' ],             10, 2 );
		add_action( 'mbr/render_meta_boxes_protection_generic',            [ $this, 'render_meta_boxes_protection_generic' ],     10, 2 );
		add_action( 'mbr/render_meta_boxes_protection_memberships',        [ $this, 'render_meta_boxes_protection_memberships' ], 10, 2 );
		add_action( 'mbr/render_meta_boxes_protection_filters',            [ $this, 'render_meta_boxes_protection_filters' ],     10, 2 );
		add_action( 'mbr/render_meta_boxes_protection_redirect',           [ $this, 'render_meta_boxes_protection_redirect' ],    10, 2 );
		add_action( 'mbr/render_meta_boxes_protection_addtl_tags',         [ $this, 'render_meta_boxes_protection_addtl_tags' ],  10, 2 );
		add_action( 'mbr/render_meta_boxes_protection_comment_automation', [ $this, 'render_meta_boxes_protection_comment_automations' ], 10, 2 );

		add_action( 'mbr/add_meta_box',                                    [ $this, 'add_meta_box' ],                               10, 3 );
		add_action( 'mbr/add_meta_box_protection/default',                 [ $this, 'add_meta_boxes_protection' ],                  10, 1 );
		add_filter( 'mbr/meta_box_header',                                 [ $this, 'meta_box_header' ],                            10, 2 );
		add_filter( 'mbr/format_help_abbr',                                [ $this, 'format_help_abbr' ],                           10, 2 );
		add_filter( 'mbr/shortcodes/atts',                                 [ $this, 'shortcode_atts' ],                             10, 3 ) ;
		add_action( 'mbr/force_render_meta_box',                           [ $this, 'force_render_meta_box' ],                      10, 2 );

		add_action( 'mbr/ac_account/fetch',                                [ $this, 'fetch_ac_account_info' ] );
		add_filter( 'mbr/ac_account/get',                                  [ $this, '_return__ac_account_info' ] );

		add_action( 'mbr/redirect',                                        [ $this, 'redirect' ] );
		add_action( 'mbr/redirect/no_access',                              [ $this, 'redirect_no_access' ] );
		add_action( 'mbr/redirect/op_sn',                                  [ $this, 'redirect_op_sn' ] );

		add_filter( 'mbr/excerpt/trim',                                    [ $this, 'wp_trim_excerpt' ], 10, 3 );
		add_action( 'mbr/filter/remove/the_content',                       [ $this, 'remove_filter_the_content' ], 10, 0 );
		add_filter( 'mbr/sign_up/link',                                    [ $this, 'sc_signup_link' ], 10, 3 );

		add_filter( 'mbr/datetime/convert',                                'mbr_convert_datetime', 10, 2 );

		add_filter( 'mbr/payments/order/details/template',                 [ $GLOBALS['mbrpayment'], 'order_details_template' ], 10, 1 );
		add_action( 'mbr/payments/stripe/process/payment/regular',         [ $GLOBALS['mbrpayment'], 'stripe_process_payment_regular' ], 10, 1 );
		add_filter( 'mbr/payments/payment/settings/get',                   [ $GLOBALS['mbrpayment'], 'get_payment_settings' ] );
		add_filter( 'mbr/payments/redux/section/box/actions',              'mbr_make_actions_box_section', 10, 1 );
		add_action( 'mbr/payments/stripe/api_key/set',                     [ $GLOBALS['mbrpayment'], 'stripe_set_api_key' ],   10, 1 );
		add_filter( 'mbr/payments/stripe/plans/all/get',                   [ $GLOBALS['mbrpayment'], 'stripe_get_all_plans' ] );
		add_filter( 'mbr/payments/countries/get',                          'mbr_get_countries' );
		add_filter( 'mbr/payments/states/us/get',                          'mbr_get_us_states' );
		add_filter( 'mbr/payments/stripe/convert_amount',                  'stripe_convert_amount', 10, 1 );
		add_filter( 'mbr/payments/currency/symbol/get',                    'mbr_get_currency_symbol', 10, 1 );

		add_filter( 'mbr/license/status/get',                              [ $this, '_return__license_status' ] );
		add_filter( 'mbr/license/check',                                   [ $this, 'get_license_status' ] );
		add_filter( 'mbr/memory/limit/get',                                [ $this, '_return__init_memory_limit' ] );
		add_filter( 'mbr/memory/limit/admin/get',                          [ $this, 'admin_memory_limit' ] );

		add_action( 'mbr/cache/refresh',                                   [ $this, 'refresh_site_data' ],   10, 0 );
		add_filter( 'mbr/cpt/integration/get',                             [ $this, 'get_integration_cpt' ], 10, 0 );

		add_filter( 'mbr/templates/email/new_user_reg/default',            [ $this, 'generate_wp_new_user_notification_template' ], 10, 0 );
		add_filter( 'mbr/templates/email/login_credentials/default',       [ $this, 'generate_login_credentials_notification_template' ], 10, 0 );
		add_filter( 'mbr/templates/email/login_credentials/send',          [ $this, 'send_login_credentials_template' ], 10, 2 );
		add_filter( 'mbr/templates/email/password_reminder/default',       [ $GLOBALS['mbr_passwords'], 'generate_site_password_reminder_email_template' ], 10, 0 );

		add_filter( 'mbr/post_types/default',                              [ $this, 'default_post_types' ], 0, 1 );
		add_filter( 'mbr/permissions/postmeta/key',                        [ $this, '_return__site_vars' ] );
		add_filter( 'mbr/permissions/get',                                 [ $this, 'get_permissions' ], 0, 2 );
		add_action( 'mbr/permissions/load',                                [ $this, 'load_permissions' ], 999, 0 );

		add_filter( 'mbr/options/key/license_status',                      [ $this, '_return__option_keys' ] );
		add_filter( 'mbr/options/key/license_status_md5',                  [ $this, '_return__option_keys' ] );
		add_filter( 'mbr/options/key/ac_account',                          [ $this, '_return__option_keys' ] );
		add_filter( 'mbr/options/key/standard_fields_list',                [ $this, '_return__option_keys' ] );
		add_filter( 'mbr/options/key/webhook_fields_list',                 [ $this, '_return__option_keys' ] );
		add_filter( 'mbr/options/key/custom_fields_list',                  [ $this, '_return__option_keys' ] );
		add_filter( 'mbr/options/key/automations_list',                    [ $this, '_return__option_keys' ] );
		add_filter( 'mbr/options/key/tags_list',                           [ $this, '_return__option_keys' ] );
	}

	
	function _return__contact_vars()
	{
		SWITCH ( current_filter() ) :
			CASE 'mbr/contact/membership_levels' :
				return $this->MBRMEMB;
			CASE 'mbr/contact/payf_tags' :
				return $this->MBRPAYF;
			CASE 'mbr/contact/lists' :
				return $this->MBRLISTS;
			DEFAULT:
				return $this->MBRTAGS;
		ENDSWITCH;
	}

	
	function _return__get_contact_field( $field = false )
	{
		IF ( is_user_logged_in() AND !empty( $field ) ) :
			IF ( isset( $this->SESSION[$field] ) ) :
				return $this->SESSION[$field];
			ENDIF;
		ENDIF;
		return '';
	}

	function _return__save_contact_fields($fields)
	{
		$obj = $this->api('contact_edit?overwrite=0', $fields);
		IF ($obj->result_code == 0) :
			return false;
		ENDIF;

		return true;
	}

	function _return__session_data()
	{
		return $this->SESSION;
	}

	function _action__session_data_update( $session = [])
	{
		IF ( !empty( $session ) ) :
			$this->SESSION = $session;
		ENDIF;
	}

	function _return__fetch_remote_contact_by_id( $id = false )
	{
		IF ( !empty( $id ) ) :
			return $this->fetch_contact( ['id' => $id, 'local' => false, 'sync' => false], false );
		ENDIF;

		return FALSE;
	}

	function _return__contact_id()
	{
		return $this->CONTACTID;
	}

	function _return__site_vars( $parm )
	{
		SWITCH ( current_filter() ) :
			CASE 'mbr/site_tags/get' :
				return $this->site_tags;
			CASE 'mbr/site_tag/get' :
				return ! empty( $this->site_tags[ $parm ] ) ? $this->site_tags[ $parm ] : FALSE;
			CASE 'mbr/site_lists/get' :
				return $this->site_lists;
			CASE 'mbr/site_automations/get' :
				return $this->site_automations;
			CASE 'mbr/site_automations/get/status' :
				return $this->site_automation_status;
			CASE 'mbr/site_automations/get/active' :
				return $this->filter_active_automations();
			CASE 'mbr/site_membership_levels/get' :
				return $GLOBALS['MBR_OPTIONS']['membership_levels'];
			CASE 'mbr/site_custom_fields/get' :
				return $this->site_cust_fields;
			CASE 'mbr/site_regular_fields/get' :
				return $this->site_regular_fields;
			CASE 'mbr/site_contact_std_fields/get' :
				return $this->contact_std_fields;
			CASE 'mbr/plugin_name' :
				return $this->plugname;
			CASE 'mbr/plugin_color' :
				return $this->plugcolor;
			CASE 'mbr/plugin_favicon' :
				return $this->favicon;
			CASE 'mbr/password_perstag' :
				return $this->password_perstag;
			CASE 'mbr/passfield' :
				return $this->passfield;
			CASE 'mbr/passfield/id' :
				return $this->get_passfield_id();
			CASE 'mbr/metabox_bg_color' :
				return $this->metabox_bg_color;
			CASE 'mbr/permissions/postmeta/key' :
				return $this->postmeta_permissions_key;
			DEFAULT:
				return FALSE;
		ENDSWITCH;
	}

	function redux_header_module_name( $return = '', $opt_name = '' )
	{
		global $MBR_REDUX_HEADER_MODULE_NAMES;

		IF ( empty( $opt_name ) OR empty( $MBR_REDUX_HEADER_MODULE_NAMES[ $opt_name ] ) ) :
			return $return;
		ENDIF;

		return $MBR_REDUX_HEADER_MODULE_NAMES[ $opt_name ];
	}

	function _return__ac_account_info()
	{
		$arr_account_info =
		[
			'account'    => $this->ac_account_info->account,
			'track_id'   => $this->ac_account_info->trackid,
			'event_key'  => $this->ac_account_info->eventkey,
			'script_url' => $this->ac_tracking_code_url
		];

		return $arr_account_info;
	}

	function remove_filter_the_content()
	{
		remove_filter( 'the_content', [ $this, 'filter_the_content' ], 8 );
	}

	function _return__get_sec_codes()
	{
		global $MBR_OPTIONS;
		IF ( ! empty( $MBR_OPTIONS['security_codes'] ) ) :
			return array_filter( array_map( 'trim', unserialize( $MBR_OPTIONS['security_codes'] ) ) );
		ENDIF;

		return FALSE;
	}

	function _return__license_status()
	{
		$this->check_license();
		return [ 'status' => $this->license_type, 'level' => $this->license_level ];
	}

	function _return__init_memory_limit()
	{
		return $this->init_memory_limit;
	}

	function _return__webhook_vars()
	{
		SWITCH ( current_filter() ) :
			CASE 'mbr/webhooks/events/get' :
				return $GLOBALS['mbr_inst_webhooks']->webhooks_events;
			CASE 'mbr/webhooks/triggers/get' :
				return $GLOBALS['mbr_inst_webhooks']->webhooks_triggers;
			DEFAULT:
				return FALSE;
		ENDSWITCH;
	}

	function _return__option_keys()
	{
		SWITCH ( current_filter() ) :
			CASE 'mbr/options/key/license_status' :
				return $this->site_license_status_key;
			CASE 'mbr/options/key/license_status_md5' :
				return $this->license_status_md5;
			CASE 'mbr/options/key/ac_account' :
				return $this->ac_account_key;
			CASE 'mbr/options/key/standard_fields_list' :
				return $this->site_standard_fields_key;
			CASE 'mbr/options/key/webhook_fields_list' :
				return $this->site_webhook_fields_key;
			CASE 'mbr/options/key/custom_fields_list' :
				return $this->site_cust_fields_key;
			CASE 'mbr/options/key/automations_list' :
				return $this->site_automations_key;
			CASE 'mbr/options/key/tags_list' :
				return $this->site_tags_list_key;
			DEFAULT:
				return FALSE;
		ENDSWITCH;
	}

	function get_current_post_type() {
		global $post, $typenow, $current_screen;
	
		
		IF ( $post AND $post->post_type ) :
			return $post->post_type;
		ENDIF;

		
		IF ( $typenow ) :
			return $typenow;
		ENDIF;
	
		
		IF ( $current_screen AND $current_screen->post_type ) :
			return $current_screen->post_type;
		ENDIF;
	
		
		IF ( isset( $_REQUEST['post_type'] ) ) :
			return sanitize_key( $_REQUEST['post_type'] );
		ENDIF;
	
		
		IF ( isset( $_REQUEST['post'] ) ) :
			return get_post_type( $_REQUEST['post'] );
		ENDIF;
	
		
		return NULL;
	}

}
