<?php
trait TRAIT__custom_shortcodes
{
  function init_hooks_TRAIT__custom_shortcodes()
  {
	IF (is_admin()) :
		global $pagenow;
	  
	  add_action( 'mbr/shortcodes/init',                [ $this, 'cpt_custom_shortcodes' ] );

	  add_filter( 'mbr_reorder_menu_items',             [ $this, 'reorder_menu_item_custom_shortcodes' ] );

	  
	  add_filter( 'esc_html',                           [ $this, 'esc_html_custom_shortcodes_page_title' ] );
	  add_filter( 'user_can_richedit',                  [ $this, 'disable_visual_editor_for_cpt' ] );
	  add_filter( 'post_row_actions',                   [ $this, 'remove_quick_edit' ], 10, 2 );
	  add_filter( 'post_updated_messages',              [ $this, 'set_messages' ] );
	  add_action( 'admin_head-post.php',                [ $this, 'custom_shortcodes_hide_publishing_actions' ] );
	  add_action( 'admin_head-post-new.php',            [ $this, 'custom_shortcodes_hide_publishing_actions' ] );
	  add_filter( 'wp_unique_post_slug',                [ $this, 'unique_mbrcustsc_slug' ], 10, 6 );
	  
		IF ( in_array( $pagenow, [ 'post.php', 'post-new.php' ] ) ) :
			add_action( "load-{$pagenow}",                  [ $this, 'init_metaboxes_custom_shortcodes' ] );
		ENDIF;

	ENDIF;
  }

  function init_metaboxes_custom_shortcodes( $_post_type = FALSE, $_post = FALSE )
  {
  	global $pagenow, $typenow;

		IF ( MBRCUSTSC == $typenow ) :
			$current_filter = current_filter();
			IF ( "load-{$pagenow}" == $current_filter ) :
				add_action( 'add_meta_boxes', [ $this, 'add_meta_boxes_mbrcustsc_slug' ],    10, 1 );
				add_action( 'add_meta_boxes', [ $this, 'add_meta_boxes_mbrcustsc_excerpt' ], 10, 1 );
			ENDIF;
		ENDIF;
  }

  function reorder_menu_item_custom_shortcodes($arrITEMS)
  {
	
	$arrITEMS[] = 'custom shortcodes';
	return $arrITEMS;
  }

  function cpt_custom_shortcodes()
  {
	global $MBR_OPTIONS;
	IF (empty($this->licenseOK)  OR empty($MBR_OPTIONS['api_url']) OR empty($MBR_OPTIONS['api_key'])) :
	  return;
	ENDIF;

	$args = [
		'labels'  => [
		  'name'                => 'Custom Shortcodes'
		 ,'singular_name'       => 'Custom Shortcode'
		 ,'add_new_item'        => 'Add a new custom shortcode'
		 ,'edit_item'           => 'Edit custom shortcode'
		 ,'new_item'            => 'New custom shortcode'
		 ,'view'                => false
		 ,'view_item'           => 'View custom shortcode'
		 ,'search_items'        => 'Search custom shortcodes'
		 ,'not_found'           => 'No matching custom shortcodes found'
		 ,'not_found_in_trash'  => 'No custom shortcodes found in trash'
		]
	 ,'description'         => 'Custom shortcodes for ' . $this->plugname
	 ,'public'              => FALSE
	 ,'exclude_from_search' => TRUE
	 ,'publicly_queryable'  => FALSE
	 ,'show_ui'             => current_user_can('activate_plugins')
	 ,'show_in_nav_menus'   => FALSE
	 ,'show_in_menu'        => MBR_MENU_PARENT_PAGE  
	 ,'show_in_admin_bar'   => current_user_can('activate_plugins')
	 ,'menu_position'       => '4.0'
	 ,'menu_icon'           => $this->favicon
	 ,'capability_type'     => 'post'
	 ,'can_export'          => TRUE
	 ,'supports'            => ['title', 'editor', 'revisions']
	];
	register_post_type(MBRCUSTSC, $args);
  }

  function add_meta_boxes_mbrcustsc_slug( $post_type )
  {
	IF (!current_user_can('publish_pages')) :
	  return;
	ENDIF;

	global $current_user;

	$metabox_name  = 'scname';
  $metabox_title = $this->plugname . ' ' . _x('Custom SC Name', 'wp_admin', 'activemember360');

	remove_meta_box('slugdiv', $post_type, 'normal');

	IF ($arrTEMP = get_user_meta($current_user->ID, "metaboxhidden_mbrcustsc", true)) :
	  FOREACH ($arrTEMP as $k => $v) :
		IF ($v == $metabox_name) :
		  unset($arrTEMP[$k]);
		ENDIF;
	  ENDFOREACH;
	  update_user_meta($current_user->ID, "metaboxhidden_mbrcustsc", $arrTEMP);
	ENDIF;

	IF ($arrTEMP = get_user_meta($current_user->ID, "closedpostboxes_mbrcustsc", true)) :
	  FOREACH ($arrTEMP as $k => $v) :
		IF ($v == $metabox_name) :
		  unset($arrTEMP[$k]);
		ENDIF;
	  ENDFOREACH;
	  update_user_meta($current_user->ID, "closedpostboxes_mbrcustsc", $arrTEMP);
	ENDIF;

	add_meta_box(
		$metabox_name
	  , $this->meta_box_header($metabox_title, false)
	  , [$this, 'mbrcustsc_render_slug_meta_box']
	  , 'mbrcustsc'
	  , 'side'
	  , 'high'
	);
  }

  function add_meta_boxes_mbrcustsc_excerpt( $post_type )
  {
	  IF (!current_user_can('publish_pages')) :
		  return;
	  ENDIF;

	  global $current_user;

	  $metabox_name  = 'postexcerpt_mbrcustsc';
	  $metabox_title = $this->plugname . ' ' . _x('Notes', 'wp_admin', 'activemember360');

		IF ($arrTEMP = get_user_meta($current_user->ID, 'metaboxhidden_mbrcustsc', true)) :
			FOREACH ($arrTEMP as $k => $v) :
			IF ($v == $metabox_name) :
				unset($arrTEMP[$k]);
			ENDIF;
			ENDFOREACH;
			update_user_meta($current_user->ID, 'metaboxhidden_mbrcustsc', $arrTEMP);
		ENDIF;

		IF ($arrTEMP = get_user_meta($current_user->ID, 'closedpostboxes_mbrcustsc', true)) :
			FOREACH ($arrTEMP as $k => $v) :
			IF ($v == $metabox_name) :
				unset($arrTEMP[$k]);
			ENDIF;
			ENDFOREACH;
			update_user_meta($current_user->ID, 'closedpostboxes_mbrcustsc', $arrTEMP);
		ENDIF;

		$help = $this->format_help_abbr(_x('You can use this area to record any notes or comments you want to remember or share with others on your team.', 'wp_admin', 'activemember360'));

		add_meta_box(
			$metabox_name
			, '<div style="float:right;display:inline;">' . $help . '</div>' . $this->meta_box_header($metabox_title, false)
			, [$this, 'mbrcustsc_post_excerpt_meta_box']
			, 'mbrcustsc'
			, 'side'
			, 'low'
		);
  }

  function mbrcustsc_post_excerpt_meta_box($post, $box)
  {
	echo "<style>#{$box['id']} {background-color:{$this->metabox_bg_color}}</style>";
	$thisEXCERPT = isset($post->post_excerpt) ? rtrim($post->post_excerpt) : '';
	$thisEXCERPT = htmlspecialchars_decode(stripslashes($thisEXCERPT), ENT_QUOTES);
	echo "<label class='hidden' for='excerpt'>Excerpt</label><textarea class='mbr_excerpt' name='excerpt' tabindex='6' id='excerpt' style='width:100%;height:200px'>{$thisEXCERPT}</textarea>";
  }

  function mbrcustsc_render_slug_meta_box($post, $box)
  {
	echo "<style>#{$box['id']} {background-color:{$this->metabox_bg_color};}</style>";
	echo "<input type='text' name='post_name' style='height:2.2em;width:100%;' value='{$post->post_name}' />";
  }

  function esc_html_custom_shortcodes_page_title($safe_text='', $text='')
  {
	IF ( (!empty($_GET['post_type']) AND $_GET['post_type'] == MBRCUSTSC) OR (!empty($_GET['action']) AND $_GET['action']=='edit' AND !empty($_GET['post']) AND get_post_type($_GET['post']) == MBRCUSTSC) ) :
	  $lower_safe_text = strtolower($safe_text);
	  IF (in_array($lower_safe_text, ['custom shortcodes', 'edit custom shortcode', 'add a new custom shortcode'])) :
		add_action('admin_head', [$this, 'make_current_menu_item_mbrcustsc']);
	  ENDIF;
	ENDIF;
	return $safe_text;
  }

  function make_current_menu_item_mbrcustsc()
  {
	?><script>jQuery(document).ready(function(){jQuery(".wp-first-item").removeClass("current");jQuery('li').find('a[href$="<?php echo MBRCUSTSC; ?>"]').parent().addClass('current');});</script><?php
  }

  function disable_visual_editor_for_cpt($default)
  {
	global $post, $wp_filter;
	IF (empty($post->post_type) OR $post->post_type <> MBRCUSTSC) :
	  
	  return $default;
	ENDIF;
	
	FOREACH ($wp_filter['media_buttons'] as $priority => $filters) :
	  FOREACH ($filters as $filter_name => $filter_content) :
		IF (stripos(serialize($filter_content), 'optimizepress')) :
		  IF (isset($wp_filter['media_buttons'][$priority][$filter_name])) :
			unset($wp_filter['media_buttons'][$priority][$filter_name]);
		  ENDIF;
		ENDIF;
	  ENDFOREACH;
	ENDFOREACH;
	return false;
  }

  function remove_quick_edit($actions)
  {
	global $post;
	IF (!empty($post->post_type) AND $post->post_type == MBRCUSTSC) :
	  IF (isset($actions['inline hide-if-no-js'])) :
		unset($actions['inline hide-if-no-js']);
	  ENDIF;
	ENDIF;
	return $actions;
  }

  function custom_shortcodes_hide_publishing_actions()
  {
	global $post;
	IF (!empty($post->post_type) AND $post->post_type == MBRCUSTSC) :
	  echo '<style type="text/css">#misc-publishing-actions{display:none;}</style>';
	ENDIF;
  }

  
  function unique_mbrcustsc_slug($slug, $post_ID, $post_status, $post_type, $post_parent, $original_slug)
  {
	IF (!empty($post_type) AND $post_type == MBRCUSTSC) :
	  IF (substr($slug, 0, 4) <> 'mbr_') :
		$slug = 'mbr_' . $slug;
	  ENDIF;
	  $slug = str_replace([' ', '-'], '_', $slug);
	  $check_name = $slug;
	  $sequencer  = 1;
	  WHILE (true) :
		IF (!$check_result = $this->wpdb->get_var("SELECT post_name FROM {$this->wpdb->posts} WHERE ID<>'{$post_ID}' AND post_type='{$post_type}' AND post_name='{$check_name}' LIMIT 1")) :
		  IF (!array_key_exists($check_name, $this->SHORTCODES)) :
			$slug = $check_name;
			break;
		  ENDIF;
		ENDIF;
		$check_name = $slug . '_' . $sequencer++;
	  ENDWHILE;
	ENDIF;
	return $slug;
  }

  function set_messages($messages)
  {
	IF (!empty($GLOBALS['post_ID']) AND $post_type = get_post_type($GLOBALS['post_ID'])) :
	  IF (!empty($post_type) AND $post_type == MBRCUSTSC) :
		$messages[$post_type] = [
		  0 => '', // Unused. Messages start at index 1.
		  1 => __('Custom shortcode was updated.'),
		  2 => '',
		  3 => '',
		  4 => __('Custom shortcode was updated.'),
		  5 => isset($_GET['revision']) ? sprintf( __('Custom shortcode was restored to revision from %s'), wp_post_revision_title((int)$_GET['revision'], false)) : false,
		  6 => __('Custom shortcode was published.'),
		  7 => __('Custom shortcode was saved.'),
		  8 => __('Custom shortcode was submitted.'),
		  9 => '',
		  10 => ''
		];
	  ENDIF;
	ENDIF;
	return $messages;
  }
}
