<?php
trait TRAIT__geoip
{
	function _load_TRAIT__geoip()
	{
		
		//add_action( 'init',  [ $this, 'get_geo_data' ] );
	}

	function get_geo_data()
	{
		IF ( defined( 'MBR_IPADDR' ) ) :
			$ipaddress   = MBR_IPADDR;
			IF ( empty( $ipaddress ) ) :
				$ipaddress = $this->fetch_client_ip();
			ENDIF;
		ELSE:
			$ipaddress   = $this->fetch_client_ip();
			define( 'MBR_IPADDR', $ipaddress );
		ENDIF;

		IF ( ! empty( $ipaddress ) ) :
			$addr    = explode( '.', $ipaddress );
			$addr[3] = 0;
			define( 'MBR_C24MASK', join( '.', $addr ) );
		ELSE :
			define( 'MBR_C24MASK', 0 );
		ENDIF;

		$this->GEOIP = get_transient( 'mbr_geo_ip_' . MBR_C24MASK );

		IF ( empty( $this->GEOIP ) OR ! is_array( $this->GEOIP ) ) :

			$this->GEOIP     = [
				'IP'           => '',
				'COUNTRY'      => '',
				'COUNTRY_CODE' => '',
				'REGION'       => '',
				'REGION_CODE'  => '',
				'CITY'         => '',
				'ZIP_CODE'     => '',
				'METRO_CODE'   => '',
				'TIME_ZONE'    => '',
				'LATITUDE'     => '',
				'LONGITUDE'    => ''
			];

			$data = json_decode( file_get_contents( 'https://www.freegeoip.net/json/' . MBR_C24MASK ), true );

			$tmp  = MBR_C24MASK;
			IF ( ! empty( $tmp ) ) :
				$this->GEOIP['IP'] = $data['ip'];
			ENDIF;

			IF ( ! empty( $data['country_name'] ) ) :
				$this->GEOIP['COUNTRY'] = $data['country_name'];
			ENDIF;

			IF ( ! empty( $data['country_code'] ) ) :
				$this->GEOIP['COUNTRY_CODE'] = $data['country_code'];
			ENDIF;

			IF ( ! empty( $data['region_name'] ) ) :
				$this->GEOIP['REGION'] = $data['region_name'];
			ENDIF;

			IF ( ! empty( $data['region_code'] ) ) :
				$this->GEOIP['REGION_CODE'] = $data['region_code'];
			ENDIF;

			IF ( ! empty( $data['city'] ) ) :
				$this->GEOIP['CITY'] = $data['city'];
			ENDIF;

			IF ( ! empty( $data['zip_code'] ) ) :
				$this->GEOIP['ZIP_CODE'] = $data['zip_code'];
			ENDIF;

			IF ( ! empty( $data['metro_code'] ) ) :
				$this->GEOIP['METRO_CODE'] = $data['metro_code'];
			ENDIF;

			IF ( ! empty( $data['time_zone'] ) ) :
				$this->GEOIP['TIME_ZONE'] = $data['time_zone'];
			ENDIF;

			IF ( ! empty( $data['latitude'] ) ) :
				$this->GEOIP['LATITUDE'] = $data['latitude'];
			ENDIF;

			IF ( ! empty( $data['longitude'] ) ) :
				$this->GEOIP['LONGITUDE'] = $data['longitude'];
			ENDIF;

			IF ( isset( $this->GEOIP['REGIONNAME'] ) ):
				unset( $this->GEOIP['REGIONNAME'] );
			ENDIF;

			IF ( isset( $this->GEOIP['COUNTRYNAME'] ) ):
				unset( $this->GEOIP['COUNTRYNAME'] );
			ENDIF;

			set_transient('mbr_geo_ip__' . MBR_C24MASK, $this->GEOIP, WEEK_IN_SECONDS );

		ENDIF;
	}

	function fetch_client_ip()
	{
		IF ( ! empty( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ) :
			return trim( $_SERVER['HTTP_X_FORWARDED_FOR'] );
		ELSEIF ( ! empty( $_SERVER['HTTP_CLIENT_IP'] ) ) :
			return trim( $_SERVER['HTTP_CLIENT_IP'] );
		ELSEIF ( ! empty( $_SERVER['REMOTE_ADDR'] ) ) :
			return trim( $_SERVER['REMOTE_ADDR'] );
		ENDIF;

		return 0;
	}

}
