<?php
trait TRAIT__mailtemplates
{
	public $site_message_template_list_key     = 'site_message_template_list';
	public $site_message_template_list_expires = 86400;
	public $site_message_template_list         = [];

	function init_hooks_TRAIT__mailtemplates()
	{
		add_action('init',                     [$this, 'load_site_message_template_list'],    0);
	}

	function fetch_site_message_template_list()
	{
		$messages = [];
		$objects  = mbr_api( 'message_template_list?ids=all' );
		IF ( $objects->result_code <> 0 ) :
			FOREACH ( $objects AS $k => $obj ) :
				IF ( is_object( $obj ) ) :
					$messages[ $obj->id ] = $obj;
				ENDIF;
			ENDFOREACH;
			asort( $messages );
		ENDIF;
		$this->save_site_message_template_list( $messages );

		return $messages;
	}

	function save_site_message_template_list($messages = [])
	{
		set_transient( $this->site_message_template_list_key, $messages, $this->site_message_template_list_expires );
	}

	function get_site_message_template_list()
	{
		return $this->site_message_template_list;
	}

	function load_site_message_template_list()
	{
		$this->site_message_template_list = get_transient( $this->site_message_template_list_key );
		IF ( FALSE === $this->site_message_template_list ) :
			$this->site_message_template_list = $this->fetch_site_message_template_list();
		ENDIF;
	}

}