<?php
trait TRAIT__plugin_loader
{
	public $licpre = '#fcc9bc';
	public $licsuf = '#fcc8fd';

	
	public $site_license_status_key = 'site_license_status';   
	public $site_license_expire_in  = [86400, 90];
	public $license_type            = 'active';
	public $license_level           = 'free';

	public $license_start           = null;

	function init_hooks_TRAIT__plugin_loader()
	{
		
		$this->license_status_md5 = $this->jquery_library_version;
		$this->license_hook_name  = str_replace( '.', '_', $this->jquery_library_version );
		add_action( 'mbr_license_check',                    [$this, 'perform_license_check'] );
		add_action( "mbr_{$this->license_hook_name}_event", [$this, 'get_license_status'] );
		add_action( 'admin_notices',                        [$this, 'admin_notice_license'] );
	}

	function perform_license_check()
	{
		global $MBR_OPTIONS;

		IF (empty($MBR_OPTIONS['api_url']) OR empty($MBR_OPTIONS['api_key'])) :
			$this->license_type  = 'pending';
			$this->license_level = 'free';
			$this->licenseOK     = 1;
			return 1;
		ELSEIF ( ( defined('DOING_AJAX' ) AND DOING_AJAX ) OR ( defined( 'DOING_CRON' ) AND DOING_CRON ) OR isset( $_GET['doing_wp_cron'] ) ) :
			$this->licenseOK     = 1;
			$this->license_level = 'free';
		ELSE :
			$this->licenseOK = $this->check_license();   
		ENDIF;
	}

	function admin_notice_license()
	{
		SWITCH ($this->license_type) :
			CASE 'pending' :
				echo '<div class="notice notice-info">';
				echo '<p><a href="' . admin_url('admin.php?page=activemember360') . '">' . __('Please click here to enter your ActiveMember360 API settings.', 'activemember360') . '</a></p>';
				echo '</div>';
				break;
			CASE 'trial' :
				$objSITESTATUS = get_gz_option($this->site_license_status_key);
				IF (!empty($objSITESTATUS['end'])) :
					$exp_date = date('Y-m-d', strtotime($objSITESTATUS['end']));
				ELSEIF (!empty($objSITESTATUS['start'])) :
					$exp_date = date('Y-m-d', strtotime($objSITESTATUS['start']) + (86400 * 45));
				ELSE :
					$exp_date = '';
				ENDIF;
				echo '<div class="notice notice-warning is-dismissible"><p>';
				IF ($exp_date) :
					echo __('You are using an ActiveMember360 trial license due to expire on', 'activemember360') . ': <strong>' . $exp_date . '</strong>. <a href="' . $this->activemember_order_url . '" target="_blank">' . __('Click here to upgrade', 'activemember360') . '</a> | <a href="' . admin_url('admin.php?page=activemember360') . '">' . __('Re-check your license', 'activemember360') . '</a>';
				ELSE :
					echo __('You are using an ActiveMember360 trial license', 'activemember360') . '. <a href="' . $this->activemember_order_url . '" target="_blank">' . __('Click here to upgrade', 'activemember360') . '</a> | <a href="' . admin_url('admin.php?page=activemember360') . '">' . __('Re-check your license', 'activemember360') . '</a>';
				ENDIF;
				echo '</p></div>';
				break;
			CASE 'inactive' :
				$objSITESTATUS = get_gz_option($this->site_license_status_key);
				echo '<div class="notice notice-error"><p>';
				echo __('Your ActiveMember360 license is inactive', 'activemember360') . '. <a href="' . $this->activemember_order_url . '" target="_blank">' . __('Click here to upgrade', 'activemember360') . '</a> | <a href="' . admin_url('admin.php?page=activemember360') . '">' . __('Re-check your license', 'activemember360') . '</a>';
				echo '</p></div>';
				break;
		ENDSWITCH;
	}

	function check_license($check_only=false)
	{
		global $MBR_OPTIONS;

		IF (!$MBR_OPTIONS['api_url'] OR !$MBR_OPTIONS['api_key']) :
			$this->license_type  = 'pending';
			$this->license_level = 'free';
			return 1;
		ENDIF;

		$objSITESTATUS     = get_gz_option($this->site_license_status_key);
		$site_status_md5   = get_gz_option($this->license_status_md5);

		IF (!$objSITESTATUS OR !$site_status_md5) :
			return $this->get_license_status();
		
		ELSEIF ($site_status_md5 <> md5(strrev($this->licpre . $objSITESTATUS['status'] . $objSITESTATUS['level'] . $objSITESTATUS['account'] . $this->licsuf))):
			$this->license_type  = $objSITESTATUS['status'];
			$this->license_level = $objSITESTATUS['level'];
			return $this->get_license_status();
		ELSEIF ($site_status_md5 == md5(strrev($this->licpre . 'active' . $objSITESTATUS['level'] . $objSITESTATUS['account'] . $this->licsuf))) :
			$this->license_type  = 'active';
			$this->license_level = $objSITESTATUS['level'];
			return 1;
		ELSEIF ($site_status_md5 == md5(strrev($this->licpre . 'trial'  . $objSITESTATUS['level'] . $objSITESTATUS['account'] . $this->licsuf))) :
			$this->license_type  = 'trial';
			$this->license_level = $objSITESTATUS['level'];
			return 1;
		ELSE :
			$retVAL          = 0;
			$bad_license_key = md5('bad_license_key');
			IF (FALSE === get_transient($bad_license_key)) :
				IF (!$retVAL = $this->get_license_status()) :
					set_transient($bad_license_key, '1', $this->site_license_expire_in[1]);
				ENDIF;
			ENDIF;
			IF ($retVAL == 0) :
				$this->license_type  = 'inactive';
				$this->license_level = $objSITESTATUS['level'];
			ENDIF;
			return $retVAL;
		ENDIF;
	}

	function get_license_status()
	{
		global $MBR_OPTIONS;

		IF (!$MBR_OPTIONS['api_url'] OR !$MBR_OPTIONS['api_key']) :
			$this->license_type  = 'pending';
			$this->license_level = 'free';
			return 1;
		ENDIF;
		IF (!isset($this->ac_account_info) OR !$this->ac_account_info) :
			$this->fetch_ac_account_info();
			$this->ac_account_info();
		ENDIF;
		IF (!isset($this->ac_account_info) OR !$this->ac_account_info) :
			$this->license_type  = 'pending';
			$this->license_level = 'free';
			return 1;
		ENDIF;
		$postDATA = ['timeout'  => $this->license_check_timeout, 'sslverify'  => false, 'body' => ['account' => $this->ac_account_info, 'version' => MBRVERSION]];
		IF ($retSTATUS = post_file_contents($this->license_server_url, $postDATA)) :
			$objRETURN = json_decode($retSTATUS);
			update_gz_option($this->site_license_status_key, $objRETURN->account);
			update_gz_option($this->license_status_md5,      $objRETURN->license);
			IF ($objRETURN->account->status == 'active') :
				$this->license_type  = 'active';
				$this->license_level = $objRETURN->account->level;
				return 1;
			ELSEIF ($objRETURN->account->status == 'trial') :
				$this->license_type  = 'trial';
				$this->license_level = $objRETURN->account->level;
				return 1;
			ENDIF;
		ENDIF;
		$this->license_type  = 'inactive';
		$this->license_level = $objRETURN->account->level;
		return 0;
	}
}