<?php
trait TRAIT__shortcodes
{
	public $scPREFIX = 'mbr';

	function init_hooks_TRAIT__shortcodes()
	{

		
		
		IF ( isset( $_GET['action'] ) AND $_GET['action'] == 'ajax_update_memberdir' ) :
			IF (defined('DOING_AJAX') AND DOING_AJAX) :
				$_POST['action']         = $_GET['action'];
				$_POST['formats']        = $_GET['formats'];
				$_POST['edit_fields']    = $_GET['edit_fields'];
				$_POST['only_self_edit'] = $_GET['only_self_edit'];
			ENDIF;
		ENDIF;

		IF (!is_admin()) :
			add_action( 'init',                             [ $this, 'inject_shortcode' ] );
		ENDIF;

		add_action('wp_ajax_ajax_update_memberdir',                     [$this, 'ajax_memberdir_row_update']);
		add_action('wp_ajax_nopriv_ajax_update_memberdir',              [$this, 'ajax_memberdir_row_update']);
		add_action( 'mbr/shortcodes/init', [ $this, 'init_shortcodes' ] );
		add_filter( 'do_shortcode_tag',    [ $this, 'post_do_shortcode_tag' ], 0, 4 );
	}

	function init_shortcodes()
	{
		$this->SHORTCODES = [];

		IF ( function_exists( 'op3_is_admin' ) ) :
			IF ( op3_is_admin() ) :
				return;
			ENDIF;
		ENDIF;

		IF ($arrSKIP = json_decode(get_transient('visualeditors'))) :
			FOREACH ($arrSKIP as $k => $v) :
				IF (isset($_GET[$k]) AND ($_GET[$k] == $v OR $v == '~^~')) :
					return;
				ENDIF;
			ENDFOREACH;
		ENDIF;

		IF (defined('DOING_AUTOSAVE') AND DOING_AUTOSAVE) :
			return;
		ENDIF;

		$scMAX = 20;

		$SHORT['form']                  = ['sc_form', 0];
		$SHORT['automation']            = ['sc_automation', 0];
		$SHORT['tag']                   = ['sc_tag', 0];
		$SHORT['list']                  = ['sc_list', 0];
		$SHORT['is_in_list']            = ['sc_is_in_list', 1];
		$SHORT['not_in_list']           = ['sc_is_in_list', 1];
		$SHORT['populate']              = ['sc_populate', 0];

		$SHORT['ac_account']            = ['sc_ac_account', 0];  
		$SHORT['author']                = ['sc_author', 0];      
		$SHORT['avatar']                = ['sc_avatar', 0];
		$SHORT['site']                  = ['sc_site', 0];

		$SHORT['contact']               = ['sc_contact', 0];

		$SHORT['user_agent']            = ['sc_user_agent', 0];
		$SHORT['is_user_agent']         = ['sc_is_user_agent', 0];
		$SHORT['not_user_agent']        = ['sc_is_user_agent', 0];

		$SHORT['is_first_login']        = ['sc_is_first_login', 0];
		$SHORT['not_first_login']       = ['sc_not_first_login', 0];
		$SHORT['s3_link']               = ['sc_s3_link', 0];
		$SHORT['texpand']               = ['sc_texpand', 0];

		
		$SHORT['if_get']                = ['sc_is_var', 1];
		$SHORT['if_post']               = ['sc_is_var', 1];
		$SHORT['if_request']            = ['sc_is_var', 1];
		$SHORT['if_cookie']             = ['sc_is_var', 1];
		$SHORT['if_session']            = ['sc_is_var', 1];

		
		$SHORT['is_http_get']           = ['sc_is_var', 1];
		$SHORT['is_http_post']          = ['sc_is_var', 1];
		$SHORT['is_http_request']       = ['sc_is_var', 1];
		$SHORT['is_cookie']             = ['sc_is_var', 1];
		$SHORT['is_session']            = ['sc_is_var', 1];

		$SHORT['http_get']              = ['sc_http_get', 0];
		$SHORT['http_post']             = ['sc_http_post', 0];
		$SHORT['http_request']          = ['sc_http_request', 0];
		$SHORT['cookie']                = ['sc_cookie', 0];
		$SHORT['session']               = ['sc_session', 0];

		$SHORT['page']                  = ['sc_get_post_info', 0];
		$SHORT['post']                  = ['sc_get_post_info', 0];

		$SHORT['is_logged_in']          = ['sc_is_logged_in', 0];
		$SHORT['not_logged_in']         = ['sc_not_logged_in', 0];

		$SHORT['include']               = ['sc_include', 0];
		$SHORT['include_once']          = ['sc_include', 0];

		$SHORT['compare']               = ['sc_compare', 1];
		$SHORT['forloop']               = ['sc_forloop', 0];
		$SHORT['foreach']               = ['sc_foreach', 0];
		$SHORT['date']                  = ['sc_date', 0];
		$SHORT['datediff']              = ['sc_datediff', 0];
		$SHORT['contact_count']         = ['sc_contact_count', 0];

		$SHORT['is_admin']              = ['sc_is_admin', 0];
		$SHORT['is_contact']            = ['sc_is_contact', 0];
		$SHORT['is_member']             = ['sc_is_member', 0];

		$SHORT['is_for']                = ['sc_onlyfor', 1];
		$SHORT['not_for']               = ['sc_onlyfor', 1];
		$SHORT['onlyfor']               = ['sc_onlyfor', 1];
		$SHORT['hidefrom']              = ['sc_onlyfor', 1];

		$SHORT['jdelay']                = ['sc_jdelay', 0];
		$SHORT['exec']                  = ['sc_exec', 0];

		$SHORT['themedir']              = ['sc_themedir', 0];
		$SHORT['randint']               = ['sc_randint', 0];

		$SHORT['geoip']                 = ['sc_geoip', 0];
		$SHORT['geoip_city']            = ['sc_geoip', 0];
		$SHORT['geoip_region']          = ['sc_geoip', 0];
		$SHORT['geoip_country']         = ['sc_geoip', 0];
		$SHORT['geoip_latitude']        = ['sc_geoip', 0];
		$SHORT['geoip_longitude']       = ['sc_geoip', 0];

		$SHORT['update']                = ['sc_update_contact', 0];
		$SHORT['update_contact']        = ['sc_update_contact', 0];

		$SHORT['is_failed_payment']     = ['sc_is_failed_payment', 0];

		$SHORT['is_email_unconfirmed']  = ['sc_is_email_unconfirmed', 0];
		$SHORT['is_email_active']       = ['sc_is_email_active', 0];
		$SHORT['is_email_unsubscribed'] = ['sc_is_email_unsubscribed', 0];
		$SHORT['is_email_bounced']      = ['sc_is_email_bounced', 0];
		$SHORT['email_status']          = ['sc_email_status', 0];

		$SHORT['popup_page']            = ['sc_popup_page', 0];
		$SHORT['popup_inline']          = ['sc_popup_inline', 0];
		$SHORT['popup_inliner']         = ['sc_popup_inline_responsive', 0];

		$SHORT['isset']                 = ['sc_isset', 0];

		$SHORT['list_pages']            = ['sc_page_list', 0];
		$SHORT['page_list']             = ['sc_page_list', 0];

		$SHORT['is_bot']                = ['sc_is_bot', 0];

		$SHORT['post_id']               = ['sc_get_post_info', 0];
		$SHORT['post_title']            = ['sc_get_post_info', 0];
		$SHORT['post_date']             = ['sc_get_post_info', 0];
		$SHORT['post_time']             = ['sc_get_post_info', 0];

		$SHORT['permalink']             = ['sc_permalink', 0];
		$SHORT['logout_link']           = ['sc_logout_link', 0];
		$SHORT['logout_url']            = ['sc_logout_url', 0];
		$SHORT['signup_link']           = ['sc_signup_link', 0];

		$SHORT['menu_loginout_label']   = ['sc_menu_loginout_label', 0];
		$SHORT['menu_loginout_url']     = ['sc_menu_loginout_url', 0];

		$SHORT['casetag']               = ['sc_casetag', 0];
		$SHORT['redirect']			        = ['sc_redirect', 0];
		$SHORT['related_posts']         = ['sc_related_posts', 0];

		$SHORT['is_allowed_access']     = ['sc_is_allowed_access', 0];
		$SHORT['not_allowed_access']    = ['sc_is_allowed_access', 0];

		$SHORT['login_form']            = ['sc_login_form', 0];
		$SHORT['password_send']         = ['sc_password_send', 0];
		$SHORT['password_change']       = ['sc_password_change', 0];
		$SHORT['email_change']          = ['sc_email_change', 0];

		$SHORT['show_after']            = ['sc_show_before_or_after', 1];
		$SHORT['show_before']           = ['sc_show_before_or_after', 1];
		$SHORT['show_between']          = ['sc_show_between', 1];

		$SHORT['member_dir_editable']   = ['sc_member_dir', 0];
		$SHORT['member_dir']            = ['sc_member_dir', 0];

		$SHORT['math']                  = ['sc_math', 0];
		$SHORT['my_account']            = ['sc_my_account', 0];
		$SHORT['progress_tags']         = ['sc_progress_tags',  0];
		$SHORT['progress_bar']          = ['sc_progress_bar',   0];
		$SHORT['progress_meter']        = ['sc_progress_meter', 0];
		


		

















		$SHORT = apply_filters( 'mbr/shortcodes/extend', $SHORT );

		FOREACH ( $SHORT AS $sc => $arr ) :
			$scname = $this->scPREFIX . '_' . $sc;

			IF ( !$this->licenseOK ) :
				$method = '__return_null';
			ELSEIF ( !is_array( $arr[0] ) ) :
				$method = [$this, $arr[0]];
			ELSE :
				$method = $arr[0];
			ENDIF;

			$this->SHORTCODES[$scname] = $method;
			IF ( !empty( $arr[1] ) ) :
				FOR ( $x = 1; $x < $this->scMAX; $x++ ) :
					$this->SHORTCODES[$scname . $x] = $method;
				ENDFOR;
			ENDIF;
		ENDFOREACH;

		$method = $this->licenseOK ? [ $this, 'sc_db_field' ] : '__return_null';

		FOREACH ( $this->contact_std_fields AS $k => $field ) :
			$this->SHORTCODES[$this->scPREFIX . '_db_' . lower_trim( $field )] = $method;
		ENDFOREACH;

		FOREACH ( $this->site_cust_fields AS $k => $cust_field ) :
			$this->SHORTCODES[$this->scPREFIX . '_db_' . lower_trim( $cust_field['perstag'] )] = $method;
		ENDFOREACH;

		IF ( !is_admin() ) :
			global $shortcode_tags;
			$shortcode_tags = array_merge( $this->SHORTCODES, $shortcode_tags );
		ENDIF;
	}

	function shortcode_atts( $defaults = [], $parm = [], $scname = false )
	{
		$out             = apply_filters( "mbr/shortcodes/{$scname}/defaults", $defaults );
		$out['mbr_hash'] = $this->array_hash($parm);

		IF ($parm) :
			FOREACH ($parm as $name => $value) :
				$name = strtolower(trim($name));
				IF ($name == 'cid') :
					$value = (int) $value ? (int) $value : (int) $this->CONTACTID;
				ELSEIF (!is_bool($value) AND !is_numeric($value)) :
					$value = trim($value);
					$value = str_ireplace(['(|', '|)'], ['[', ']'], $value);
					IF (stripos($value, '[' . $this->scPREFIX) !== FALSE AND stripos($value, ']') !== FALSE) :
						$value = $this->shortcode($value);
					ENDIF;
				ENDIF;
				$out[$name] = $value;
			ENDFOREACH;
		ENDIF;

		




		IF (array_key_exists('cid', $out) AND (is_null($out['cid']) OR !$out['cid'])) :
			$out['cid'] = $this->CONTACTID;
		ENDIF;

		IF ($scname) :
			$out = apply_filters("shortcode_atts_{$scname}", $out, $defaults, $parm);
		ENDIF;

		return $out;
	}

	function post_do_shortcode_tag($output, $scname, $attr, $m)
	{
		$filter = "mbr/shortcodes/{$scname}/return";
		IF (has_filter($filter)) :
			$output = apply_filters($filter, $output, $scname, $attr, m);
		ENDIF;
		return $output;
	}

	function split_else_content($content, $calling_func, $index=0)
	{
		




		static $sc_prefix_len = null;
		IF (is_null($sc_prefix_len)) :
			$sc_prefix_len = strlen($this->scPREFIX) + 1;
		ENDIF;

		IF ($index === TRUE) :
			$index = 0;
		ELSEIF ($index === FALSE) :
			$index = 1;
		ENDIF;
		$arrCONTENT = preg_split('#\[ELSE_' . substr($calling_func, $sc_prefix_len) . '\]#si', $content);
		IF (isset($arrCONTENT[$index])) :
			return do_shortcode($this->shortcode(trim($arrCONTENT[$index])));
		ENDIF;
		return '<!--#remove#-->';
	}

	function array_hash($arrPARM=[])
	{
		$base = '';
		IF ($arrPARM) :
			FOREACH ($arrPARM as $k => $v) :
				$base .= (string)$k . '|' . (string)$v . '|';
			ENDFOREACH;
		ENDIF;
		return md5($base);
	}

	function ajax_memberdir_row_update()
	{
		ob_end_clean();
		$data                 = array_filter($_POST['data']);
		$formats              = json_decode(stripslashes($_POST['formats']), true);
		$edit_fields          = stripslashes($_POST['edit_fields']);
		$edit_fields          = explode(',', $edit_fields);
		$rowid                = key($data);
		$arrVAL               = $data[$rowid];
		$cid                  = substr($rowid,4);
		IF (!$cid) :
			echo 'error';
			exit;
		ENDIF;
		IF ($_POST['only_self_edit'] == 'yes') :
			IF ($cid <> $this->CONTACTID) :
				echo 'Error';
				exit;
			ENDIF;
		ENDIF;
		$arrUpdate            = ['id' => $cid];
		$arrData['DT_RowId']  = $rowid;
		FOREACH ($arrVAL AS $field => $val) :
			IF ($field == 'runautomation') :
				$runau                    = $arrVAL['runautomation'];
				$arrData['runautomation'] = '';
			ELSEIF (in_array($field, ['avatar', 'gravatar', 'Id', 'id', 'Password', 'password'])) :
				$arrData[$field]          = stripslashes($val);
			ELSE :
				IF (in_array($field, $edit_fields)) :
					IF (array_key_exists($field, $this->site_regular_fields)) :
						$updfield = $field;
					ELSE:
						$updfield = 'field[%' . strtoupper(trim($field)) . '%]';
					ENDIF;
					IF (array_key_exists(strtolower($field), $formats) AND $val) :
						$val = str_ireplace(['August', 'th','st','nd','rd'], ['Aug','','','',''], $val);
						$arrUpdate[$updfield] = date('Ymd\TH:i:s', strtotime($val));
						$val = date($formats[$field], strtotime($val));
					ELSE:
						$arrUpdate[$updfield] = stripslashes($val);
					ENDIF;
				ENDIF;
				$arrData[$field]          = stripslashes($val);
			ENDIF;
		ENDFOREACH;

		IF (isset($runau) AND $runau > 0) :
			$this->api("automation_contact_add", ['contact_id' => $cid, 'automation' => $runau]);
		ENDIF;

		$this->save_contact_fields($arrUpdate);

		$wp_user_id = $this->wpdb->get_var("SELECT user_id FROM {$this->wpdb->usermeta} WHERE meta_key = 'mbr_user_id' AND meta_value = {$cid} LIMIT 1");
		IF ($wp_user_id) :
			$update_wp_user      = false;
			$update_display_name = false;
			$arrWPUSERUPDATE     = [];
			IF (isset($arrVAL['first_name'])) :
				$update_display_name           = true;
				$arrWPUSERUPDATE['first_name'] = $arrVAL['first_name'];
				$arrWPUSERUPDATE['nickname']   = $arrVAL['first_name'];
			ENDIF;
			IF (isset($arrVAL['last_name'])) :
				$update_display_name           = true;
				$arrWPUSERUPDATE['last_name']  = $arrVAL['last_name'];
			ENDIF;
			IF (isset($arrVAL['email'])) :
				$update_wp_user                = true;
				$this->wpdb->update($this->wpdb->users, ['user_login' => $arrVAL['email'], 'user_email' => $arrVAL['email']], ['ID' => $wp_user_id]);
				$user_cookie = get_user_meta($wp_user_id, 'mbr_login', true);
				$arrCOOKIE   = array_filter(explode('|', $user_cookie));
				$new_cookie  = $arrVAL['email'] . '|' . $arrCOOKIE[1];
				update_user_meta($wp_user_id, 'mbr_login', $new_cookie);
				IF ($this->CONTACTID == $cid) :
					$this->update_cookie($wp_user_id, $new_cookie);
					wp_cache_delete($wp_user_id, 'users');
					wp_clear_auth_cookie();
					wp_set_current_user ($wp_user_id);
					wp_set_auth_cookie($wp_user_id, 'forever', is_ssl());
				ENDIF;
			ENDIF;
			IF ($update_display_name) :
				$update_wp_user = true;
				$firstname     = (isset($arrVAL['first_name']) ? $arrVAL['first_name'] : get_user_meta($wp_user_id, 'first_name', true));
				$lastname      = (isset($arrVAL['last_name'])  ? $arrVAL['last_name']  : get_user_meta($wp_user_id, 'last_name', true));
				$display_name  = $firstname . ' ' . $last_name;
				$display_name  = apply_filters('mbr_display_name', $display_name, $firstname, $lastname, $arrVAL);
				$arrWPUSERUPDATE['display_name'] = $display_name;
				$user_nicename = str_ireplace(' ', '-', strtolower($firstname . ' ' . $lastname));
				$user_nicename = apply_filters('mbr_nicename', $user_nicename, $firstname, $lastname, $arrVAL);
				$arrWPUSERUPDATE['user_nicename'] = $user_nicename;
				IF ($this->CONTACTID == $cid) :
				ENDIF;
			ENDIF;
			IF ($update_wp_user) :
				$arrWPUSERUPDATE['ID'] = $wp_user_id;
				wp_update_user($arrWPUSERUPDATE);
			ENDIF;
		ENDIF;
		$response = '{"data": [' . json_encode($arrData). ']}';
		echo $response;
		exit;
	}

	function sc_populate($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['cid' => null], $parm));

		IF (!$cid) :
			return null;
		ENDIF;

		static $cached = [];
		IF ($this->CONTACTID == $cid) :
			$contact = $this->SESSION;
		ELSEIF (isset($cached[$cid])) :
			$contact = $cached[$cid];
		ELSE :
			$contact = $cached[$cid] = $this->fetch_contact(['id' => $cid, 'sync' => false], false);
		ENDIF;

		IF (isset($contact['id'])) :
			preg_match_all("/%%(.*?)%%/s", $content, $arrMATCH);
			IF ($arrMATCH = array_map('strtolower', $arrMATCH[1])) :
				$arrOLD = $arrNEW = [];
				FOREACH ($arrMATCH AS $filler => $field) :
					$arrOLD[] = '%%' . $field . '%%';
					IF ($regfield = array_search($field, $this->site_regular_fields)) :
						$field = $regfield;
					ENDIF;
					$arrNEW[] = isset($contact[$field]) ? $contact[$field] : '';
				ENDFOREACH;
				$content = str_ireplace($arrOLD, $arrNEW, $content);
			ENDIF;
		ENDIF;

		return $content;
	}

	





	function sc_is_in_list($parm='', $content=null, $scname='')
	{
		$parm = $this->shortcode_atts(['list_id' => false, 'status' => 'active', 'segment_id' => false], $parm);

		IF (!$this->CONTACTID OR !$parm['list_id']) :
			
			return null;
		ENDIF;

		IF ($parm['status'] == 'any') :
			$status             = 'any';
		ELSEIF (array_key_exists($parm['status'], $this->arr_optstatus_names)) :
			$status             = $parm['status'];
		ELSEIF (in_array(strtolower($parm['status']), $this->arr_optstatus_names)) :
			$arr_optstatus_flip = array_flip($this->arr_optstatus_names);
			$status             = $arr_optstatus_flip[strtolower($parm['status'])];
		ELSE:
			return;
		ENDIF;

		$match = 1;

		IF (isset($this->MBRLISTS[$parm['list_id']])) :
			IF ($status == 'any') :
				$match = 0;
			ELSE:
				IF ($this->MBRLISTS[$parm['list_id']] == $status) :
					$match = 0;
				ELSE:
					
					IF ($status == 0 OR $status == 3) :
						$list_opt_status = $this->get_list_optstatus($this->CONTACTID, $parm['list_id']);
						IF ($list_opt_status == $status) :
							$match = 0;
							$this->MBRLISTS[$parm['list_id']] = $status;
						ENDIF;
					ENDIF;
				ENDIF;
			ENDIF;
		ENDIF;

		IF (stripos($scname, '_not_in')) :
			$match = $match ? 0 : 1;
		ENDIF;

		return $this->split_else_content($content, $scname, $match);
	}

	function sc_list($parm='', $content=null, $scname='')
	{
		$parm = $this->shortcode_atts(['autorun' => null, 'cid' => null, 'subscribe' => null, 'unsubscribe' => null, 'unsubscribe_reason' => __('Contact unsubscribed on site', 'activemember360') . ' ' . home_url(), 'link_text' => __('Click here to submit', 'activemember360'), 'link_style' => '', 'link_id' => '', 'link_class' => '', 'button_text' => '', 'button_image' => '', 'button_style' => '', 'button_id' => '', 'button_class' => '', 'redirect' => '', 'redirect_popup' => '', 'after_text' => __('Your request was processed', 'activemember360'), 'scname' => $scname], $parm);

		IF (!$parm['cid']) :
			return null;
		ENDIF;

		IF (!$parm['subscribe'] AND !$parm['unsubscribe']) :
			return null;
		ENDIF;

		IF ($parm['autorun'] == 'yes') :
			return $this->auto_list($parm);
		ELSE :
			return $this->click_list($parm);
		ENDIF;
	}

	function auto_list($parm=[])
	{
		extract($parm);

		$arrASSIGNLISTS  = array_filter( array_unique( explode( ',', $parm['subscribe'] ) ) );
		$arrREMOVELISTS  = array_filter( array_unique( explode( ',', $parm['unsubscribe'] ) ) );

		IF (!empty( $arrASSIGNLISTS ) ) :
			FOREACH ($arrASSIGNLISTS AS $filler => $list_id) :
				$arrFIELDS["p[{$list_id}]"]      = $list_id;
				$arrFIELDS["status[{$list_id}]"] = 1;
			ENDFOREACH;
		ENDIF;

		IF (!empty( $arrREMOVELISTS ) ) :
			FOREACH ($arrREMOVELISTS AS $filler => $list_id) :
				$arrFIELDS["p[{$list_id}]"]           = $list_id;
				$arrFIELDS["status[{$list_id}]"]      = 2;
				$arrFIELDS["unsubreason[{$list_id}]"] = $parm['unsubscribe_reason'];
			ENDFOREACH;
		ENDIF;

		IF ($arrFIELDS) :
			$arrFIELDS['id'] = $cid;
			$success         = $this->save_contact_fields($arrFIELDS);
		ENDIF;

		return null;
	}

	function click_list($parm=[])
	{
		extract($parm);

		IF (isset($_POST['mbr_hash']) AND $_POST['mbr_hash'] == $mbr_hash) :
			$this->auto_list(['cid' => $cid, 'subscribe' => $subscribe, 'unsubscribe' => $unsubscribe, 'unsubscribe_reason' => $unsubscribe_reason]);
			IF ($redirect) :
				IF ($redirect == '#reload#') :
					$redirect = $_SERVER['REQUEST_URI'];
				ENDIF;
				IF ($redirect_popup == 'yes') :
					echo "<script>window.open('$redirect','_blank');</script>";
				ELSE :
					$this->redirect($redirect);
				ENDIF;
			ENDIF;
			return "<span class='mbr_list_after_text'>{$after_text}</span>";
		ENDIF;

		$retCODE = '';
		IF ($subscribe OR $unsubscribe) :
			$randkey   = uniqid();
			$retCODE  .= "<span id='{$randkey}' style='display:none'></span>";
			$retCODE  .= "<script>
											jQuery('#{$randkey}').append('<form name=\"{$randkey}\"  action=\"\" method=\"post\">');
											jQuery('#{$randkey} form').append('<input type=\"hidden\" name=\"list_post\"   value=\"{$randkey}\" />');
											jQuery('#{$randkey} form').append('<input type=\"hidden\" name=\"mbr_hash\"    value=\"{$mbr_hash}\" />');
										</script>";
			$retCODE .= "<span class='{$randkey}'>";
			IF ($button_text OR $button_image) :
				$button_css = $button_style ? "style='{$button_style}'" : '';
				$button_id  = $button_id    ? "id='{$button_id}'"       : '';
				IF ($button_image) :
					$retCODE .= "<input onclick=\"document.forms['{$randkey}'].submit();\" type='image' {$button_id} class='{$button_class} {$scname}_btn' name='{$scname}[btn]' src='{$button_image}' alt='" . __('Click here to submit', 'activemember360') . "' {$button_css} />";
				ELSE :
					$retCODE .= "<input onclick=\"document.forms['{$randkey}'].submit();\" type='submit' {$button_id} class='{$button_class} {$scname}_btn' name='{$scname}[btn]' value='{$button_text}' {$button_css} />";
				ENDIF;
			ELSE :
				$link_id   = $link_id    ? "id='{$link_id}'"       : '';
				$link_text = $link_text ? $link_text : __('Click here to submit', 'activemember360');
				$link_css  = $link_style ? "style='{$link_style}'" : '';
				$retCODE  .= "<a href='#' onclick=\"document.forms['{$randkey}'].submit();\" {$link_id} class='{$link_class} {$scname}_link' {$link_css}>{$link_text}</a>";
			ENDIF;
			$retCODE .= '</span>';
		ENDIF;
		return $retCODE;
	}

	function sc_update_contact($parm='', $content=null, $scname='')
	{
		












		extract($this->shortcode_atts(['assign_tags' => '', 'remove_tags' => '', 'assign_automations' => '', 'remove_automations' => '', 'subscribe_lists' => '', 'unsubscribe_lists' => '', 'unsubscribe_reason' => __('Contact unsubscribed on site', 'activemember360') . ' ' . home_url(), 'autocreate_tags' => 'yes'], $parm));

		IF (!$this->CONTACTID) :
			return null;
		ENDIF;

		$email_changed      = false;
		$first_name_changed = false;
		$last_name_changed  = false;

		FOREACH ($parm as $field => $value) :

			IF (in_array($field, ['assign_tags', 'remove_tags', 'subscribe_lists', 'unsubscribe_lists', 'assign_automations', 'remove_automations'])) :
				continue;
			ENDIF;

			$field = trim($field, '%');

			IF (array_key_exists($field, $this->site_regular_fields)) :
				IF (strtolower($field) == 'email' AND trim($value)) :
					$foundUSER = email_exists($value);
					IF ($foundUSER <> $this->current_user->ID) :
						$email_changed = true;
						$new_email     = lower_trim($value);
					ELSE:
						continue;
					ENDIF;
				ENDIF;
				IF (strtolower($field) == 'first_name') :
					$first_name_changed = true;
					$new_first_name     = $value;
				ENDIF;
				IF (strtolower($field) == 'last_name') :
					$last_name_changed  = true;
					$new_last_name     = $value;
				ENDIF;
			ELSE :
				FOREACH ($this->site_cust_fields AS $k => $cust_field) :
					IF ($field == lower_trim($cust_field['perstag'])) :
						$field = 'field[%' . upper_trim($field) . '%]';
						break;
					ENDIF;
				ENDFOREACH;
			ENDIF;
			$arrFIELDS[$field] = $value;
		ENDFOREACH;

		IF ($arrFIELDS) :
			$arrFIELDS['id'] = $this->CONTACTID;
			$success         = $this->save_contact_fields($arrFIELDS);
		ENDIF;

		IF ($email_changed AND $success AND @$this->wpdb->update($this->wpdb->users, ['user_login' => $new_email, 'user_email' => $new_email], ['ID' => $this->current_user->ID])) :
			$arrCOOKIE = array_filter(explode('|', $_COOKIE['mbr_login']));
			$new_cookie = $new_email . '|' . $arrCOOKIE[1];
			$this->update_cookie($this->current_user->ID, $new_cookie);
			$this->fetch_contact(['id' => $this->CONTACTID, 'local' => false, 'sync' => false]);
			$this->delete_cookie(MBR_COOKIE_NAME);
			$this->create_user_cookie($this->SESSION['hash']);
			wp_cache_delete($this->current_user->ID, 'users');
			wp_clear_auth_cookie();
			wp_set_current_user ($this->current_user->ID);
			wp_set_auth_cookie($this->current_user->ID, 'forever', is_ssl());
		ENDIF;

		IF ($first_name_changed OR $last_name_changed) :
			$first_name      = $new_first_name ? $new_first_name : $this->SESSION['first_name'];
			$last_name       = $new_last_name  ? $new_last_name  : $this->SESSION['last_name'];
			$display_name    = $this->SESSION['name'];
			$user_nicename   = str_ireplace(' ', '-', strtolower($display_name));
			$nickname        = $this->SESSION['first_name'];
			$arrUSER         = ['ID' => $this->current_user->ID, 'first_name' => $this->SESSION['first_name'], 'last_name' => $this->SESSION['last_name'], 'user_nicename' => $user_nicename, 'display_name' => $display_name, 'nickname' => $nickname];
			wp_update_user($arrUSER);
		ENDIF;

		IF ($assign_tags OR $remove_tags) :
			$this->sc_tag(['autorun' => 'yes', 'cid' => $this->CONTACTID, 'assign' => $assign_tags, 'remove' => $remove_tags,  'autocreate_tags' => $autocreate_tags]);
		ENDIF;

		IF ($assign_automations OR $remove_automations) :
			$this->sc_automation(['autorun' => 'yes', 'cid' => $this->CONTACTID, 'assign' => $assign_automations, 'remove' => $remove_automations]);
		ENDIF;

		IF ($subscribe_lists OR $unsubscribe_lists) :
			$this->sc_list(['autorun' => 'yes', 'cid' => $this->CONTACTID, 'subscribe' => $subscribe_lists, 'unsubscribe' => $unsubscribe_lists, 'unsubscribe_reason' => $unsubscribe_reason]);
		ENDIF;
	}

	function sc_themedir($parm='', $content=null, $scname='')
	{
		return get_template_directory_uri() . "/";
	}

	function sc_randint($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['min' => '0', 'max' => PHP_INT_MAX], $parm));
		return mt_rand($min, $max);
	}

	function sc_casetag($parm='', $content=null, $scname='')
	{
		global $post;
		extract($this->shortcode_atts(['limit_else' => 'no'], $parm ));

		IF ($limit_else == 'yes' AND (!is_user_logged_in() OR !$this->MBRMEMB)) :
			return null;
		ENDIF;

		IF (!$this->MBRMEMB) :
			return null;
		ENDIF;

		$content = ltrim($content, '<br />');
		$content = ltrim($content, '<br/>');
		$content = ltrim($content, '<br>');
		$arrSEARCH    = ['not_tag:', 'not_any_tags:', 'not_all_tags:', 'all_tags:', 'else:', 'any_tags:', 'tag:'];
		$content      = str_ireplace($arrSEARCH, $arrSEARCH, $content);

		$content      = $this->ncr2ent($content);
		$arrCONTAINER = [];
		$arrPARMS     = explode("\n", trim($content));
		$arrKEY       = 0;
		$elseKEY      = false;

		FOREACH ($arrPARMS as $thisLINE) :
			$thisLINE = trim($thisLINE);
			IF (stripos($thisLINE,'not_tag:') !== FALSE OR stripos($thisLINE,'not_any_tags:') !== FALSE) :
				$thisLINE = str_ireplace(['<br />','<br/>','<br>', '<p>', '</p>', '\r'], '', $thisLINE);
				IF (stripos($thisLINE,'not_tag:') !== FALSE) :
					$arrPARM = explode('not_tag:', $thisLINE, 2);
				ELSE :
					$arrPARM = explode('not_any_tags:', $thisLINE, 2);
				ENDIF;
				IF (count($arrPARM) == 2) :
					$arrCONTAINER[++$arrKEY] = ['tagids' => explode(',',trim($arrPARM[1])), 'type' => 'anynot', 'content' => ''];
				ENDIF;
				continue;
			ENDIF;

			IF (stripos($thisLINE,'not_all_tags:') !== FALSE) :
				$thisLINE = str_ireplace(['<br />','<br/>','<br>', '<p>', '</p>', '\r'], '', $thisLINE);
				$arrPARM = explode('not_all_tags:', $thisLINE, 2);
				IF (count($arrPARM) == 2) :
					$arrCONTAINER[++$arrKEY] = ['tagids' => explode(',',trim($arrPARM[1])), 'type' => 'allnot', 'content' => ''];
				ENDIF;
				continue;
			ENDIF;

			IF (stripos($thisLINE,'all_tags:') !== FALSE) :
				$thisLINE = str_ireplace(['<br />','<br/>','<br>', '<p>', '</p>', '\r'], '', $thisLINE);
				$arrPARM = explode('all_tags:', $thisLINE, 2);
				IF (count($arrPARM) == 2) :
					$arrCONTAINER[++$arrKEY] = ['tagids' => explode(',',trim($arrPARM[1])), 'type' => 'all', 'content' => ''];
				ENDIF;
				continue;
			ENDIF;

			IF (stripos($thisLINE,'tag:') !== FALSE OR stripos($thisLINE,'any_tags:') !== FALSE) :
				$thisLINE = str_ireplace(['<br />','<br/>','<br>', '<p>', '</p>', '\r'], '', $thisLINE);
				IF (stripos($thisLINE,'tag:') !== FALSE) :
					$arrPARM = explode('tag:', $thisLINE, 2);
				ELSE :
					$arrPARM = explode('any_tags:', $thisLINE, 2);
				ENDIF;
				IF (count($arrPARM) == 2) :
					$arrCONTAINER[++$arrKEY] = ['tagids' => explode(',',trim($arrPARM[1])), 'type' => 'any', 'content' => ''];
				ENDIF;
				continue;
			ENDIF;

			IF (stripos($thisLINE,'else:') !== FALSE) :
				$thisLINE = str_ireplace(['<br />','<br/>','<br>', '<p>', '</p>', '\r'], '', $thisLINE);
				$arrCONTAINER[++$arrKEY] = ['ELSE' => 'ELSE', 'content' => ''];
				$elseKEY = $arrKEY;
				continue;
			ENDIF;
			IF (isset($arrKEY)) :
				IF (isset($arrCONTAINER[$arrKEY]['content'])) :
					$arrCONTAINER[$arrKEY]['content'] .= $thisLINE;
				ELSE :
					$arrCONTAINER[$arrKEY]['content']  = $thisLINE;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$matched = false;

		FOREACH ($arrCONTAINER as $arrKEY => $arrCASE) :
			$arrCASE['tagids'] = $this->normalize_tag_ids(implode(',',$arrCASE['tagids']), true);

			IF ($arrCASE['type'] == 'any') :
				FOREACH ($arrCASE['tagids'] as $k => $tag) :
					IF (array_key_exists($tag, $this->MBRTAGS)) :
						$matched = $arrKEY;
						break 2;
					ENDIF;
				ENDFOREACH;
			ENDIF;

			IF ($arrCASE['type'] == 'all') :
				$matched = $arrKEY;
				FOREACH ($arrCASE['tagids'] as $k => $tag) :
					IF (!array_key_exists($tag, $this->MBRTAGS)) :
						$matched = false;
						break;
					ENDIF;
				ENDFOREACH;
				IF ($matched) :
					break;
				ENDIF;
			ENDIF;

			IF ($arrCASE['type'] == 'allnot') :
				$anythingLEFT = $arrCASE['tagids'];
				FOREACH ($arrCASE['tagids'] as $k => $tag) :
					IF (!array_key_exists($tag, $this->MBRTAGS)) :
						IF (isset($anythingLEFT[$k])) :
							unset($anythingLEFT[$k]);
						ENDIF;
					ENDIF;
				ENDFOREACH;
				IF (count($anythingLEFT) < 1) :
					$matched = $arrKEY;
					break;
				ENDIF;
			ENDIF;

			IF ($arrCASE['type'] == 'anynot') :
				$matched = $arrKEY;
				FOREACH ($arrCASE['tagids'] as $k => $tag) :
					IF (array_key_exists($tag, $this->MBRTAGS)) :
						$matched = false;
						break;
					ENDIF;
				ENDFOREACH;
				IF ($matched) :
					break;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		IF (!$matched AND $elseKEY) :
			$matched = $elseKEY;
		ENDIF;

		$retVAL = null;

		IF ($matched) :
			$retVAL = $arrCONTAINER[$matched]['content'];
			IF (stripos($retVAL,'<br') !== FALSE) :
				$thisLINE = $retVAL;
				IF (substr(strtolower($thisLINE), -6) == '<br />') :
					$thisLINE = substr($thisLINE, 0, -6);
				ELSEIF (substr(strtolower($thisLINE), -5) == '<br/>') :
					$thisLINE = substr($thisLINE, 0, -5);
				ELSEIF (substr(strtolower($thisLINE), -4) == '<br>') :
					$thisLINE = substr($thisLINE, 0, -4);
				ENDIF;
				$retVAL = $thisLINE;
			ENDIF;
		ENDIF;
		return $retVAL;
	}

	function sc_geoip($parm='', $content=null, $scname='')
	{
		$scname = strtolower($scname);
		IF (substr($scname, -4) == 'city') :
			$field = 'city';
		ELSEIF (substr($scname, -5) == 'state') :
			$field = 'region';
		ELSEIF (substr($scname, -6) == 'region') :
			$field = 'region';
		ELSEIF (substr($scname, -7) == 'county') :
			$field = 'country';
		ELSEIF (substr($scname, -8) == 'latitude') :
			$field = 'latitude';
		ELSEIF (substr($scname, -9) == 'longitude') :
			$field = 'longitude';
		ELSE :
			extract($this->shortcode_atts(['field' => ''], $parm));
		ENDIF;

		$field = strtoupper($field);
		IF (array_key_exists($field, $this->GEOIP)) :
			return $this->GEOIP[$field];
		ENDIF;
		return null;
	}

	function sc_db_field($parm='', $content=null, $scname='')
	{
		$field = trim(substr($scname, strlen($this->scPREFIX) + 4));
		IF (!empty($this->SESSION[$field])) :
			return $this->SESSION[$field];
		ENDIF;
		return null;
	}

	function sc_generic_contact($matches=[])
	{
		$var = strtolower($matches[1]);
		IF (isset($this->SESSION[$var])) :
			return $this->SESSION[$var];
		ENDIF;
		return null;
	}

	function sc_ac_account($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['field' => null], $parm));
		$field = lower_trim($field);
		IF (!$field) :
			return null;
		ENDIF;
		IF (!isset($this->ac_account_info) OR !$this->ac_account_info) :
			$this->ac_account_info();
		ENDIF;
		$response =& $this->ac_account_info;
		IF ($response->result_code == 1 AND $response->result_message == $this->api_success_msg) :
			IF (isset($response->$field) AND $response->$field) :
				return $response->$field;
			ENDIF;
		ENDIF;
		return null;
	}

	function sc_author($parm='', $content=null, $scname='')
	{
		global $post;
		extract($this->shortcode_atts(['field' => null], $parm));

		$field            = lower_trim($field);
		$forbidden_fields = ['user_pass', $this->wpdb->prefix . 'capabilities',  $this->wpdb->prefix . 'level'];

		IF (!$field OR in_array($field, $forbidden_fields)) :
			return null;
		ENDIF;

		static $arrAUTHOR = [];

		$field_map = ['email' => 'user_email', 'nicename' => 'user_nicename', 'url' => 'user_url'];
		IF (array_key_exists($field, $field_map)) :
			$field = $field_map[$field];
		ENDIF;

		$author_id = $GLOBALS['post']->post_author;
		IF (!isset($arrAUTHOR[$author_id])) :
			$author_data = $this->fetch_wp_user_data($author_id);
			$arrAUTHOR[$author_id] = $author_data;
		ENDIF;

		IF (isset($arrAUTHOR[$author_id]->$field)) :
			return $arrAUTHOR[$author_id]->$field;
		ENDIF;
		return null;
	}

	function sc_avatar($parm='', $content=null, $scname='')
	{
		global $MBR_OPTIONS;

		extract($this->shortcode_atts(['email' => '', 'size' => $MBR_OPTIONS['avatar_size'], 'suppress_empty' => 'no'], $parm));

		IF (!$email = lower_trim($email)) :
			$email = lower_trim($GLOBALS['current_user']->user_email);
		ENDIF;

		static $arrGRAVATAR = [];
		IF (!isset($arrGRAVATAR[$email][$size])) :
			IF (checktrue($suppress_empty)) :
				$hash = md5(lower_trim($email));
				$uri = 'https://www.gravatar.com/avatar/' . $hash . '?d=404';
				$headers = @get_headers($uri);
				IF (!preg_match("|200|", $headers[0])) :
					return null;
				ENDIF;
			ENDIF;
			$arrGRAVATAR[$email][$size] = get_avatar($email, $size);
		ENDIF;

		return $arrGRAVATAR[$email][$size];
	}

	function sc_site($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['field' => ''], $parm ));
		$field_map = ['desc' => 'description', 'email' => 'admin_email'];

		IF (array_key_exists($field, $field_map)) :
			$field = $field_map[$field];
		ENDIF;

		IF ($field = lower_trim($field)) :
			return get_bloginfo($field);
		ENDIF;

		return null;
	}

	function sc_is_user_agent($parm='', $content=null, $scname='')
	{
		global $is_lynx, $is_gecko, $is_winIE, $is_macIE, $is_opera, $is_NS4, $is_safari, $is_chrome, $is_iphone, $is_IE, $is_apache, $is_IIS, $is_iis7, $is_edge;
		extract($this->shortcode_atts(['name'=>''], $parm));
		$names = lower_trim($name);
		$match = 1;
		$arrUA = array_map('trim', explode(',', $names));
		FOREACH ($arrUA as $filler => $agent) :
			IF     ($agent == 'lynx'       AND $is_lynx) :
				$match = 0;
			ELSEIF ($agent == 'gecko'      AND $is_gecko) :
				$match = 0;
			ELSEIF ($agent == 'winie'      AND $is_winIE) :
				$match = 0;
			ELSEIF ($agent == 'macie'      AND $is_macIE) :
				$match = 0;
			ELSEIF ($agent == 'opera'      AND $is_opera) :
				$match = 0;
			ELSEIF ($agent == 'ns4'        AND $is_NS4) :
				$match = 0;
			ELSEIF ($agent == 'safari'     AND $is_safari) :
				$match = 0;
			ELSEIF ($agent == 'chrome'     AND $is_chrome) :
				$match = 0;
			ELSEIF ($agent == 'iphone'     AND $is_iphone) :
				$match = 0;
			ELSEIF ($agent == 'edge'       AND $is_edge) :
				$match = 0;
			ELSEIF ($agent == 'ie'         AND $is_IE) :
				$match = 0;
			ELSEIF ($agent == 'apache'     AND $is_apache) :
				$match = 0;
			ELSEIF ($agent == 'iis'        AND $is_IIS) :
				$match = 0;
			ELSEIF ($agent == 'iis7'       AND $is_iis7) :
				$match = 0;
			ELSEIF ($agent == 'mobile'     AND wp_is_mobile()) :
				$match = 0;
			ELSEIF ($agent == 'ipad'       AND preg_match('/(ipad)/i', $_SERVER['HTTP_USER_AGENT'])) :
				$match = 0;
			ELSEIF ($agent == 'ipod'       AND preg_match('/(ipod)/i', $_SERVER['HTTP_USER_AGENT'])) :
				$match = 0;
			ELSEIF ($agent == 'operamini'  AND stripos($_SERVER['HTTP_USER_AGENT'], 'Opera Mini') !== false) :
				$match = 0;
			ELSEIF ($agent == 'operamobi'  AND stripos($_SERVER['HTTP_USER_AGENT'], 'Opera Mobi') !== false) :
				$match = 0;
			ELSEIF ($agent == 'android'    AND stripos($_SERVER['HTTP_USER_AGENT'], 'Android') !== false) :
				$match = 0;
			ELSEIF ($agent == 'winff'      AND stripos($_SERVER['HTTP_USER_AGENT'], 'FireFox') !== false AND stripos($_SERVER['HTTP_USER_AGENT'], 'Win') !== false ) :
				$match = 0;
			ELSEIF ($agent == 'macff'      AND stripos($_SERVER['HTTP_USER_AGENT'], 'FireFox') !== false AND stripos($_SERVER['HTTP_USER_AGENT'], 'Mac') !== false ) :
				$match = 0;
			ELSEIF ($agent == 'ff'         AND stripos($_SERVER['HTTP_USER_AGENT'], 'Firefox') !== false) :
				$match = 0;
			ELSEIF ($agent == 'firefox'    AND stripos($_SERVER['HTTP_USER_AGENT'], 'Firefox') !== false) :
				$match = 0;
			ELSEIF ($agent == 'silk'       AND stripos($_SERVER['HTTP_USER_AGENT'], 'Silk/') !== false) :
				$match = 0;
			ELSEIF ($agent == 'kindle'     AND stripos($_SERVER['HTTP_USER_AGENT'], 'Kindle') !== false) :
				$match = 0;
			ELSEIF ($agent == 'blackberry' AND stripos($_SERVER['HTTP_USER_AGENT'], 'Blackberry') !== false) :
				$match = 0;
			ELSEIF ($agent <> ''           AND stripos($_SERVER['HTTP_USER_AGENT'], $agent) !== false) :
				$match = 0;
			ENDIF;
			IF ($match == 0) :
				break;
			ENDIF;
		ENDFOREACH;

		IF ($scname <> $this->scPREFIX . '_is_user_agent') :
			$match = $match ? 0 : 1;
		ENDIF;

		return $this->split_else_content($content, $scname, $match);
	}

	function sc_user_agent($parm='', $content=null, $scname='')
	{
		IF (isset($_SERVER['HTTP_USER_AGENT'])) :
			return $_SERVER['HTTP_USER_AGENT'];
		ENDIF;
		return null;
	}

	function sc_is_first_login($parm='', $content=null, $scname='')
	{
		$match = ( isset( $_COOKIE['mbr_first_login_session'] ) AND $_COOKIE['mbr_first_login_session'] == 'yes' ) ? 0 : 1;
		return $this->split_else_content($content, $scname, $match);
	}

	function sc_not_first_login($parm='', $content=null, $scname='')
	{
		$match = ( ! isset( $_COOKIE['mbr_first_login_session'] ) OR $_COOKIE['mbr_first_login_session'] <> 'yes' ) ? 0 : 1;
		return $this->split_else_content($content, $scname, $match);
	}

	function sc_s3_link($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['s3key'=>'', 's3secret'=>'', 'object'=>'', 'host'=>'', 'bucket'=>'', 'expire'=>'', 'protocol'=>'https'], $parm));
		return $this->s3link($object, $s3key, $s3secret, $host, $bucket, $expire, $protocol);
	}

	function s3link($object='', $s3key='', $s3secret='', $host='', $bucket='', $expire='', $protocol='https')
	{
		global $MBR_OPTIONS;

		IF ($object == '') :
			return null;
		ENDIF;
		IF ($s3key == '') :
			$s3key = $MBR_OPTIONS['mbr_s3_key'];
			IF (trim($s3key) == '') :
				return null;
			ENDIF;
		ENDIF;
		IF ($s3secret == '') :
			$s3secret = $MBR_OPTIONS['mbr_s3_secret'];
			IF (trim($s3secret) == '') :
				return null;
			ENDIF;
		ENDIF;
		IF ($host == '') :
			$host = $MBR_OPTIONS['mbr_s3_host'];
			IF (trim($host) == '') :
				return null;
			ENDIF;
		ENDIF;
		IF ($bucket == '') :
			$bucket = $MBR_OPTIONS['mbr_s3_bucket'];
			IF (trim($bucket) == '') :
				return null;
			ENDIF;
		ENDIF;
		IF ($expire == '') :
			$expire = $MBR_OPTIONS['mbr_s3_expire'];
			IF ($expire == '') :
				$expire = 300;
			ENDIF;
		ENDIF;
		$arrOBJ  = explode('/', trim($object));
		FOREACH ($arrOBJ as $k => $v) :
			$arrOBJ[$k] = urlencode($v);
		ENDFOREACH;
		$object = join('/', $arrOBJ);
		$timestamp = time() + $expire;
		$strtosign = "GET\n\n\n$timestamp\n/$bucket/$object";
		$signature = urlencode(base64_encode(hash_hmac("sha1", $this->encode($strtosign), $s3secret, true)));
		IF ($protocol <> '') :
			$protocol .= '://';
		ENDIF;
		return "{$protocol}{$bucket}.{$host}/{$object}?AWSAccessKeyId={$s3key}&amp;Expires={$timestamp}&amp;Signature={$signature}";
	}

	function sc_texpand($parm='', $content=null, $scname='')
	{
		static $enqueued = 0;
		IF ( !$enqueued++ ) :
			echo '<script>function expand(param){param.style.display=(param.style.display=="none") ? "" : "none";}</script>';
		ENDIF;

		extract($this->shortcode_atts(['header'=>'Click here to expand'], $parm));

		IF (trim($header == '')) :
			$header = join(' ', $parm);
		ENDIF;

		$header = trim($header);
		$rnum   = uniqid();

		return "<a style='display:none;' id='mbrtexpandlink{$rnum}' href='javascript:expand(document.getElementById(\"mbrtexpand{$rnum}\"))'>{$header}</a><div class='mbrtexpand_div' id='mbrtexpand{$rnum}'><script>expand(document.getElementById('mbrtexpand{$rnum}'));expand(document.getElementById('mbrtexpandlink{$rnum}'))</script>{$content}</div><br />";
	}

	function sc_is_var($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['var' => '', 'val' => FALSE], $parm ));
		IF (!$var) :
			return null;
		ENDIF;
		IF ($val === FALSE AND (isset($parm['val']) AND $parm['val'] == '')) :
			$val = '';
		ENDIF;
		$scname = strtolower($scname);

		IF     (stripos($scname, 'if_get')      OR stripos($scname, 'is_http_get')) :
			$target =& $_GET;
		ELSEIF (stripos($scname, 'if_post')     OR stripos($scname, 'is_http_post')) :
			$target =& $_POST;
		ELSEIF (stripos($scname, 'if_cookie')   OR stripos($scname, 'is_cookie')) :
			$target =& $_COOKIE;
		ELSEIF (stripos($scname, 'if_request')  OR stripos($scname, 'is_http_request')) :
			$target =& $_REQUEST;
		ELSEIF ((stripos($scname, 'if_session') OR stripos($scname, 'is_session')) AND (isset($this->SESSION[$var]) OR isset($this->SESSION[strtolower($var)]))) :
			$target =& $this->SESSION;
		ELSEIF ((stripos($scname, 'if_session') OR stripos($scname, 'is_session')) AND (isset($this->SESSION[$var]) OR isset($this->SESSION[strtolower($var)]))) :
			$target =& $this->SESSION;
		ELSEIF ((stripos($scname, 'if_session') OR stripos($scname, 'is_session')) AND (isset($this->SESSION['SESSVARS'][$var]) OR isset($this->SESSION['SESSVARS'][strtolower($var)]))) :
			$target =& $this->SESSION['SESSVARS'];
		ELSEIF ((stripos($scname, 'if_session') OR stripos($scname, 'is_session')) AND (isset($_SESSION[$var]) OR isset($_SESSION[strtolower($var)]))) :
			$target =& $_SESSION;
		ELSE :
			return null;
		ENDIF;

		FOREACH ([1,2] AS $loop) :
			FOREACH ($target as $k => $v) :
				IF (is_array($v) OR is_object($v)) :
					continue;
				ENDIF;
				IF ( ($loop == 1 AND $k == $var) OR ($loop == 2 AND strtolower($k) == strtolower($var)) ) :  
					IF ($val === FALSE) :
						return $this->split_else_content($content, $scname, 0);
					ENDIF;
					IF ($val == urldecode($v)) :
						return $this->split_else_content($content, $scname, 0);
					ENDIF;
				ENDIF;
			ENDFOREACH;
		ENDFOREACH;

		return $this->split_else_content($content, $scname, 1);
	}

	function sc_get_post_info($parm='', $content=null, $scname='')
	{
		IF ($scname == $this->scPREFIX . '_post_time') :
			global $post;
			extract($this->shortcode_atts(['format' => 'h:i a'], $parm ));
			IF (!empty($post->post_date)) :
				return date($format, strtotime($post->post_date));
			ENDIF;
			return null;
		ELSEIF ($scname == $this->scPREFIX . '_post_date') :
			global $post;
			extract($this->shortcode_atts(['format' => 'F jS, Y'], $parm ));
			IF (!empty($post->post_date)) :
				return date($format, strtotime($post->post_date));
			ENDIF;
			return null;
		ELSEIF ($scname == $this->scPREFIX . '_post_id') :
			IF (isset($GLOBALS['post']->ID)) :
				return $GLOBALS['post']->ID;
			ENDIF;
			return null;
		ELSEIF ($scname == $this->scPREFIX . '_post_title') :
			return get_the_title();
		ENDIF;

		#* meta fields */
		extract($this->shortcode_atts(['id' => $GLOBALS['post']->ID, 'field' => 'post_content',  'status' => '*', 'excerpt_fb' => 0], $parm));
		$status     = lower_trim($status);
		$field      = lower_trim($field);
		$meta_field = lower_trim($field);
		$post_id    = (int)$id;

		IF (!$post_id OR !$field) :
			return null;
		ENDIF;

		IF ($post_id == $GLOBALS['post']->ID AND $field == 'post_content') :
			return null;
		ENDIF;

		
		static $arrPOST= [];

		IF (empty($arrPOST[$post_id])) :
			IF ($arrRES = $this->wpdb->get_results("SELECT * FROM {$this->wpdb->posts} WHERE ID='{$post_id}' LIMIT 1")) :
				IF (count($arrRES) == 1) :
					IF ($arrRES[0]->ID == $post_id) :
						$arrPOST[$post_id] = $arrRES[0];
					ENDIF;
				ENDIF;
			ENDIF;
		ENDIF;

		IF (empty($arrPOST[$post_id])) :
			return null;
		ENDIF;

		IF (empty($arrPOST[$post_id]->$field)) :
			
			$arrPOST[$post_id]->$field = get_post_meta($post_id, $field, true);
		ENDIF;

		IF (empty($arrPOST[$post_id]->$field)) :
			
			$arrPOST[$post_id]->$field = get_post_meta($post_id, '_' . $field, true);
		ENDIF;

		IF (empty($arrPOST[$post_id]->$field)) :
			return null;
		ENDIF;

		IF ($status == '*' OR $status == strtolower($arrPOST[$post_id]->post_status) ) :
			return $arrPOST[$post_id]->$field;
		ENDIF;

		IF ($excerpt_fb AND $field == 'post_content') :
			IF (!empty($arrPOST[$post_id]->post_excerpt)) :
				return $arrPOST[$post_id]->post_excerpt;
			ENDIF;
			IF ($tmpCONTENT = $this->wp_trim_excerpt($arrPOST[$post_id], false)) :
				return $tmpCONTENT;
			ENDIF;
		ENDIF;
		return null;
	}

	function sc_is_admin($parm='', $content=null, $scname='')
	{
		return $this->split_else_content($content, $scname, (MBRADMIN ? 0 : 1));
	}

	function sc_is_logged_in($parm='', $content=null, $scname='')
	{
		return $this->split_else_content($content, $scname, (is_user_logged_in() ? 0 : 1));
	}

	function sc_not_logged_in($parm='', $content=null, $scname='')
	{
		return $this->split_else_content($content, $scname, (is_user_logged_in() ? 1 : 0));
	}

	function sc_include($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['file' => ''], $parm));
		IF ($file == '') :
			return "<!-- $scname failed: File not specified. -->";
		ENDIF;
		IF (file_exists($file)):
			IF ( strpos( $scname, 'include_once' ) ) :
				@include_once($file);
			ELSE :
				@include($file);
			ENDIF;
		ENDIF;
	}

	function sc_compare($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['sc' => $scname, 'value1' => '', 'cmp' => '', 'value2' => ''], $parm));

		$cmp = lower_trim($cmp);

		IF (!in_array($cmp, ['==', '>', '<', '>=', '<=', '<>', 'eq', 'gt', 'lt', 'ge', 'le', 'ne', '~=', '=~', 'bw', 'ew', '~~', 'contains'])) :
			return null;
		ENDIF;

		IF ($cmp == '=='     OR $cmp == 'eq') :
			$match = ($value1 == $value2 ? true : false);
		ELSEIF ($cmp == '<'  OR $cmp == 'lt') :
			$match = ($value1 <  $value2 ? true : false);
		ELSEIF ($cmp == '>'  OR $cmp == 'gt') :
			$match = ($value1 >  $value2 ? true : false);
		ELSEIF ($cmp == '>=' OR $cmp == 'ge') :
			$match = ($value1 >= $value2 ? true : false);
		ELSEIF ($cmp == '<=' OR $cmp == 'le') :
			$match = ($value1 <= $value2 ? true : false);
		ELSEIF ($cmp == '<>' OR $cmp == 'ne') :
			$match = ($value1 <> $value2 ? true : false);
		ELSEIF ($cmp == '~=' OR $cmp == 'bw') :
			$match = (substr($value1,0,strlen($value2)) == $value2 ? true : false);
		ELSEIF ($cmp == '=~' OR $cmp == 'ew') :
			$match = (substr($value1,strlen($value2)*-1) == $value2 ? true : false);
		ELSEIF ($cmp == '~~' OR $cmp == 'contains') :
			$match = (stripos($value1,$value2) !== false ? true : false);
		ELSE :
			$match = false;
		ENDIF;
		$match = $match ? 0 : 1;
		return $this->split_else_content($content, $scname, $match);
	}

	function sc_forloop($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['times' => ''], $parm));
		$loopCOUNT = (int)$times;
		IF (count($loopCOUNT) < 1) :
			return null;
		ENDIF;
		$thisCONTENT = '';
		FOR ($v = 0; $v < $loopCOUNT; $v++) :
			$thisCONTENT .= str_ireplace('<:forloop:>', ($v+1), $content);
		ENDFOR;
		return trim($thisCONTENT);
	}

	function sc_foreach($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['set' => '', 'separator' => ',', arrayseparator=> '|'], $parm));
		$set = trim($set);
		IF (empty($set)) :
			return null;
		ENDIF;

		$arrLOOP = explode($separator, $set);
		IF (empty($arrLOOP)) :
			return null;
		ENDIF;

		$thisCONTENT = '';
		FOREACH ($arrLOOP as $k => $v) :
			IF ($v = trim($v)) :
				$thisCONTENT .= str_ireplace('<:foreach:>', $v, $content);
			ENDIF;
		ENDFOREACH;
		return trim($thisCONTENT);
	}

	function sc_date($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['date' => '', 'operation' => '', 'format' => 'F jS, Y'], $parm ));
		$date = trim($date);

		IF ($date=='' OR !$date = strtotime($date)) :
			$date = current_time('timestamp');
		ENDIF;

		$operation = trim($operation);

		IF ($operation == '') :
			return date($format, $date);
		ENDIF;

		IF ($date2 = strtotime($operation, $date)):
			return date($format, $date2);
		ENDIF;

		return null;
	}

	function sc_datediff($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['from_date' => '', 'to_date' => '', 'format' => 'd'], $parm));

		$to_date   = trim($to_date)   == '' ? current_time('timestamp') : strtotime($to_date);
		$from_date = trim($from_date) == '' ? current_time('timestamp') : strtotime($from_date);
		$format   = trim($format);
		IF ($from_date == '#registered#') :
			$from_date = strtotime($GLOBALS['current_user']->user_registered);
		ELSEIF (substr($from_date,0, 7) == '#field#') :
			IF (substr($from_date,-1) == '#') :
				$from_date = substr($from_date,7,-1);
			ELSE :
				$from_date = substr($from_date,7);
			ENDIF;
			$from_date = strtotime($this->SESSION[strtolower($from_date)]);
		ENDIF;

		$dateDIFF      = $to_date - $from_date;
		$calendar_diff = date('Y:m:d', $dateDIFF);
		$arrCAL        = explode(':', $calendar_diff);

		IF ($format == 'd') :
			return intval($dateDIFF/DAY_IN_SECONDS) . ' days';
		ELSEIF ($format == 'md') :
			$years  = $arrCAL[0] - 1970;
			$months = ($years * 12) + ($arrCAL[1] - 1);
			$days   = $arrCAL[2] - 1;
			IF ($months < 1) :
				return "$days days";
			ELSEIF ($months == 1) :
				return "1 month and $days days";
			ELSEIF ($months > 1) :
				return "$months months and $days days";
			ELSE :
				return "$days days";
			ENDIF;
		ELSEIF ($format == 'm') :
			$years  = $arrCAL[0] - 1970;
			$months = ($years * 12) + ($arrCAL[1] - 1);
			return "$months months";
		ELSEIF ($format == 'ymd') :
			$years  = $arrCAL[0] - 1970;
			$months = $arrCAL[1] - 1;
			$days   = $arrCAL[2] - 1;
			IF ($years < 1) :
				IF ($months < 1) :
					return "$days days";
				ELSEIF ($months == 1) :
					return "1 month and $days days";
				ELSEIF ($months > 1) :
					return "$months months and $days days";
				ENDIF;
			ELSEIF ($years == 1) :
				IF ($months < 1) :
					return "1 year and $days days";
				ELSEIF ($months == 1) :
					return "1 year 1 month and $days days";
				ELSEIF ($months > 1) :
					return "1 year $months months and $days days";
				ENDIF;
			ELSEIF ($years > 1) :
				IF ($months < 1) :
					return "$years years and $days days";
				ELSEIF ($months == 1) :
					return "$years years 1 month and $days days";
				ELSEIF ($months > 1) :
					return "$years years $months months and $days days";
				ENDIF;
			ENDIF;
		ELSE :
			return date($format, $dateDIFF);
		ENDIF;
	}

	function sc_contact_count($parm, $content=null, $scname='')
	{
		extract($this->shortcode_atts(['tag_id' => 0, 'tag_name' => '', 'thousands_sep' => ''], $parm));
		$counter = $this->fetch_tags_live_count([$tag_id, $tag_name]);
		$thousands_sep = trim($thousands_sep);
		return ($thousands_sep) ? number_format($counter, 0, '.', $thousands_sep) : $counter;
	}

	function sc_is_allowed_access($parm='', $content=null, $scname='')
	{
		global $post;
		extract($this->shortcode_atts(['post_id' => '', 'limit_else' => 'no'], $parm));
		IF ((int)$post_id) :
			$thisPOST = get_post((int)$post_id);
		ELSEIF (isset($post->ID)) :
			$thisPOST = $post;
		ELSE :
			return null;
		ENDIF;
		IF ($limit_else == 'yes') :
			IF (!is_user_logged_in() OR !$this->MBRMEMB) :
				return null;
			ENDIF;
		ENDIF;
		$match = $this->match_user_content($thisPOST, MBR_IGNORE_EXCERPT) ? 0 : 1;
		IF (stripos($scname, 'not_allowed_access')) :
			$match = $match ? 0 : 1;
		ENDIF;
		return $this->split_else_content($content, $scname, $match);
	}

	function sc_is_member($parm='', $content=null, $scname='')
	{
		return $this->split_else_content($content, $scname, $this->MBRMEMB ? 0 : 1);
	}

	function sc_onlyfor($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['only_cid' => '', 'exclude_cid' => '', 'tags' => '', 'exclude_tags' => '', 'require_all_tags' => 'no', 'limit_else' => 'no'], $parm ));

		$matchONLYFOR   = true;

		IF (MBRADMIN) :
			goto EXIT_POINT;
		ENDIF;

		IF ($limit_else == 'yes' AND (!is_user_logged_in() OR !$this->MBRMEMB)) :
			return null;
		ENDIF;

		IF (!is_user_logged_in()) :
			$matchONLYFOR = false;
			goto EXIT_POINT;
		ENDIF;

		$arrTAGS      = array_flip($this->normalize_tag_ids($tags, true));
		$arrNOTTAGIDS = $this->normalize_tag_ids($exclude_tags, true);

		IF ($exclude_cid) :
			IF ($arrNOTCONTACTIDS = array_filter(explode(',', $exclude_cid))) :
				IF (in_array($this->CONTACTID, $arrNOTCONTACTIDS)) :
					$matchONLYFOR = false;
					goto EXIT_POINT;
				ENDIF;
			ENDIF;
		ENDIF;

		IF ($only_cid) :
			IF ($arrCONTACTIDS = array_filter(explode(',', $only_cid))) :
				IF (!in_array($this->CONTACTID, $arrCONTACTIDS)) :
					$matchONLYFOR = false;
					goto EXIT_POINT;
				ENDIF;
			ENDIF;
		ENDIF;

		IF ($arrNOTTAGIDS) :
			FOREACH ($arrNOTTAGIDS as $k => $thisTAGID) :
				IF (array_key_exists($thisTAGID, $this->MBRTAGS)) :
					$matchONLYFOR = false;
					goto EXIT_POINT;
				ENDIF;
			ENDFOREACH;
		ENDIF;

		IF ($arrTAGS) :
			$mustALLTAGS  = $require_all_tags == 'yes' ? true : false;
			$matchONLYFOR = $this->check_member_tags($arrTAGS, $mustALLTAGS);
		ELSE :
			$matchONLYFOR = false;
		ENDIF;

		EXIT_POINT:

		IF (stripos($scname, '_hidefrom') OR stripos($scname, '_not_for')) :
			$reverse = true;
		ELSE:
			$reverse = false;
		ENDIF;
		IF ($matchONLYFOR) :
			$match = $reverse ? 1 : 0;
		ELSE :
			$match = $reverse ? 0 : 1;
		ENDIF;
		return $this->split_else_content($content, $scname, $match);
	}

	function sc_jdelay($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['id' => '', 'fade_out' => 0, 'delay_show' => 0.001, 'fade_show' => 0, 'delay_hide' => 0, 'fade_hide' => 0], $parm));

		$id = trim($id);

		IF (($content == null OR trim($content) == '') AND $id == '') :
			return null;
		ENDIF;

		$retVAL        = '';
		$retVAL_prefix = '';
		$retVAL_suffix = '';

		IF ($id == '') :
			$id = uniqid('mbr_jdelay_');
			$retVAL_prefix = "<div id='$id' style='display:none;'>";
			$retVAL_suffix = "</div>";
		ENDIF;

		$delay_show = (int)$delay_show;

		IF ($delay_show < 0) :
			return null;
		ELSEIF ($delay_show == 0) :
			$delay_show = 0.001;
		ENDIF;

		$fade_show = (int)$fade_show;
		IF ($fade_show <= 0) :
			$fade_show = 0.0001;
		ENDIF;

		$delay_show = $delay_show * 1000;
		IF ($fade_show)  :
			$fade_show  = min(2147483647, $fade_show  * 1000);
		ENDIF;

		$fade_out   = min(2147483647, $fade_out   * 1000);
		IF ($delay_hide)  :
			$delay_hide = min(2147483647, $delay_hide * 1000);
		ENDIF;

		$fade_hide  = min(2147483647, $fade_hide  * 1000);

		$retVAL .= $retVAL_prefix . trim($content) . $retVAL_suffix;

		IF (trim($content) <> '') :
			$pfx = uniqid();
			$jQretVAL = "jQuery('#$id').fadeOut($fade_out).delay(t{$pfx})" . ($fade_show ? ".fadeIn($fade_show)" : '') . ($delay_hide ? ".delay($delay_hide).fadeOut($fade_hide)" : '') . ';';
			$retVAL .= "<script>function f{$pfx}(t{$pfx}){ if (t{$pfx}<2147483647){ $jQretVAL }else{ setTimeout(function(){f{$pfx}(t{$pfx}-2147483647);},2147483647); } } f{$pfx}( $delay_show );</script>";
		ENDIF;

		return $retVAL;
	}

	function sc_exec($parm='', $content=null, $scname='')
	{
		$content = str_ireplace([chr(13),"<br />\n","<br/>\n","<br>\n"], "\n", $content);
		$content = str_ireplace(["<p>","</p>",chr(10)], "", $content);
		$content = $this->ncr2ent($content);
		$content = $this->shortcode($content);
		$content = "\n" . 'global $post, $redirect_to, $user_first_login, $mbr_autopopup;' . "\n" . $content;
		ob_start();
		eval($content);
		$output = ob_get_clean();
		return $output;
	}

	function sc_is_contact($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['id' => ''], $parm));
		IF (!empty($id)) :
			$match = ($id == $this->CONTACTID) ? 0 : 1;
		ELSE :
			$match = $this->CONTACTID ? 0 : 1;
		ENDIF;
		return $this->split_else_content($content, $scname, $match);
	}

	function sc_contact($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['field' => '', 'type' => 'string', 'format' => '', 'default' => '', 'callback' => '', 'decimals' => 0, 'dec_point' => '.', 'thousands_sep' => ',', 'locale' => ''], $parm));
		$field = strtolower($field);

		IF (empty($field)) :
			return null;
		ELSEIF (!$this->CONTACTID) :
			$value = $default;
		ELSEIF (!isset($this->SESSION[$field])) :
			$value = $default;
		ELSE :
			$value = $this->SESSION[$field];
		ENDIF;

		IF ($type == 'date') :
			IF ($value == '') :
				$value = null;
			ELSE :
				$value = strtotime($value);
				IF ($format) :
					$value = strftime($format, $value);
				ENDIF;
			ENDIF;
		ELSEIF ($type == 'number') :
			$value = number_format($value, $decimals, $dec_point, $thousands_sep);
		ELSEIF ($type == 'currency') :
			$lc_monetary = setlocale(LC_MONETARY, '0');
			IF ($locale == '') :
				$locale = $GLOBALS['locale'];
			ENDIF;
			setlocale(LC_MONETARY, $locale);
			$value = money_format($format, $value);
			setlocale(LC_MONETARY, $lc_monetary);
		ELSEIF ($type == 'string') :
			IF ($format) :
				$callback = $format;
			ENDIF;
		ENDIF;

		IF ($callback) :
			$args = [$value];
			$call_method = FALSE;
			IF ( method_exists( $this, $callback ) ) :
				$call_method = [$this, $callback];
			ELSEIF ( function_exists( $callback ) ) :
				$call_method = $callback;
			ENDIF;
			IF (!empty($call_method)) :
				FOR ($x = 1; $x < 10; $x++) :
					$p = $p . $x;
					$args[$x] = isset($$p) ? $$p : null;
				ENDFOR;
				$value = call_user_func_array($call_method, $args);
			ENDIF;
		ENDIF;
		return $value;
	}

	function sc_automation($parm='', $content=null, $scname='')
	{
		$parm = $this->shortcode_atts(['autorun' => null, 'cid' => null, 'assign' => null, 'remove' => null, 'link_text' => __('Click here to submit', 'activemember360'), 'link_style' => '', 'button_text' => '', 'button_image' => '', 'button_style' => '', 'redirect' => '', 'redirect_popup' => '', 'after_text' => __('Your request was processed', 'activemember360'), 'scname' => $scname], $parm);

		IF (!$parm['cid']) :
			return null;
		ENDIF;

		IF (!$parm['assign'] AND !$parm['remove']) :
			return null;
		ENDIF;

		IF ($parm['autorun'] == 'yes') :
			return $this->auto_automation($parm);
		ELSE :
			return $this->click_automation($parm);
		ENDIF;
	}

	function auto_automation($parm=[])
	{
		extract($parm);

		IF ($assignAUTOMATION = array_filter(array_map('intval', explode(',', $assign)))) :
			IF ($strASSIGN = trim(join(',', $assignAUTOMATION), ',')) :  
				$response = $this->api("automation_contact_add", ['contact_id' => $cid, 'automation' => $strASSIGN]);
			ENDIF;
		ENDIF;

		IF ($removeAUTOMATION = array_filter(array_map('intval', explode(',', $remove)))) :
			FOREACH ($removeAUTOMATION as $k => $automation) :
				$response = $this->api("automation_contact_remove", ['contact_id' => $cid, 'automation' => $automation]);
			ENDFOREACH;
		ENDIF;
		return null;
	}

	function click_automation($parm=[])
	{
		extract($parm);

		IF (isset($_POST['mbr_hash']) AND $_POST['mbr_hash'] == $mbr_hash) :
			$assignAUTOMATION = array_filter(array_map('intval', explode(',', $assign)));
			IF ($assignAUTOMATION) :
				$strASSIGN = trim(join(',', $assignAUTOMATION), ',');  
				IF ($strASSIGN) :
					$response = $this->api("automation_contact_add", ['contact_id' => $cid, 'automation' => $strASSIGN]);
				ENDIF;
			ENDIF;
			$removeAUTOMATION = array_filter(array_map('intval', explode(',', $remove)));
			IF ($removeAUTOMATION) :
				FOREACH ($removeAUTOMATION as $k => $automation) :
					$response = $this->api("automation_contact_remove", ['contact_id' => $cid, 'automation' => $automation]);
				ENDFOREACH;
			ENDIF;
			IF ($redirect) :
				IF ($redirect== '#reload#') :
					$redirect = $_SERVER['REQUEST_URI'];
				ENDIF;
				IF ($redirect_popup == 'yes') :
					echo "<script>window.open('{$redirect}', '_blank');</script>";
				ELSE :
					$this->redirect($redirect);
				ENDIF;
			ENDIF;
			return "<span class='mbr_automation_after_text'>{$after_text}</span>";
		ENDIF;

		$retCODE  = '';
		IF ($assign OR $remove) :
			$randkey   = uniqid();
			$retCODE  .= "<span id='{$randkey}' style='display:none'></span>";
			$retCODE  .= "<script>
											jQuery('#{$randkey}').append('<form name=\"{$randkey}\"  action=\"\" method=\"post\">');
											jQuery('#{$randkey} form').append('<input type=\"hidden\" name=\"automation_post\" value=\"{$randkey}\" />');
											jQuery('#{$randkey} form').append('<input type=\"hidden\" name=\"mbr_hash\"        value=\"{$mbr_hash}\" />');
										</script>";
			$retCODE .= "<span class='{$randkey}'>";
			IF ($button_text OR $button_image) :
				$button_css = $button_style ? "style='{$button_style}'" : '';
				IF ($button_image) :
					$retCODE .= "<input onclick=\"document.forms['{$randkey}'].submit();\" type='image'  class='{$scname}_btn' name='{$scname}[btn]' src='{$button_image}' alt='" . __('Click here to submit', 'activemember360') . "' {$button_css} />";
				ELSE :
					$retCODE .= "<input onclick=\"document.forms['{$randkey}'].submit();\" type='submit' class='{$scname}_btn' name='{$scname}[btn]' value='{$button_text}' {$button_css} />";
				ENDIF;
			ELSE :
				$link_text = $link_text ? $link_text : __('Click here to submit', 'activemember360');
				$link_css  = $link_style ? "style='{$link_style}'" : '';
				$retCODE  .= "<a href='#' onclick=\"document.forms['{$randkey}'].submit();\" class='{$scname}_link' {$link_css}>{$link_text}</a>";
			ENDIF;
			$retCODE .= '</span>';
		ENDIF;
		return $retCODE;
	}

	function sc_tag($parm='', $content=null, $scname='')
	{
		$parm = $this->shortcode_atts(['autorun' => null, 'cid' => null, 'assign' => null, 'remove' => null, 'link_text' => __('Click here to submit', 'activemember360'), 'link_style' => '', 'button_text' => '', 'button_image' => '', 'button_style' => '', 'redirect' => '', 'redirect_popup' => '', 'after_text' => __('Your request was processed', 'activemember360'), 'autocreate_tags' => 'yes', 'scname' => $scname], $parm);

		$assign = apply_filters('mbr_sanitize_tag_names', $parm['assign']);
		$remove = apply_filters('mbr_sanitize_tag_names', $parm['remove']);

		IF (!$parm['cid']) :
			return null;
		ENDIF;

		IF (!$parm['assign'] AND !$parm['remove']) :
			return null;
		ENDIF;

		IF ($parm['autorun'] == 'yes') :
			return $this->auto_tag($parm);
		ELSE :
			return $this->click_tag($parm);
		ENDIF;
	}

	function auto_tag($parm=[])
	{
		

		extract($parm);
		$autocreate = $autocreate_tags == 'yes' ? true : false;
		IF ($strASSIGN = $this->normalize_tag_names($assign, $autocreate)) :
			$response = $this->api("contact_tag_add",    ['id' => $cid, 'tags' => $strASSIGN]);
		ENDIF;
		IF ($strREMOVE = $this->normalize_tag_names($remove)) :
			$response = $this->api("contact_tag_remove", ['id' => $cid, 'tags' => explode(',', $strREMOVE)]);
		ENDIF;

		IF ($redirect) :
			IF ($redirect == '#reload#') :
				$redirect = $_SERVER['REQUEST_URI'];
			ENDIF;
			$this->redirect($redirect);
		ENDIF;

		return null;
	}

	function click_tag($parm=[])
	{
		extract($parm);

		IF (isset($_POST['mbr_hash']) AND $_POST['mbr_hash'] == $mbr_hash) :
			IF ($strASSIGN = $this->normalize_tag_names($assign, $autocreate_tags)) :
				$response = $this->api("contact_tag_add",    ['id' => $cid, 'tags' => $strASSIGN]);
			ENDIF;
			IF ($strREMOVE = $this->normalize_tag_names($remove)) :
				$response = $this->api("contact_tag_remove", ['id' => $cid, 'tags' => explode(',', $strREMOVE)]);
			ENDIF;

			IF ($redirect) :
				IF ($redirect == '#reload#') :
					$redirect = $_SERVER['REQUEST_URI'];
				ENDIF;
				IF ($redirect_popup == 'yes') :
					echo "<script>window.open('$redirect','_blank');</script>";
				ELSE :
					$this->redirect($redirect);
				ENDIF;
			ENDIF;
			return "<span class='mbr_tag_after_text'>{$after_text}</span>";
		ENDIF;

		$retCODE = '';
		IF ($assign OR $remove) :
			$randkey   = uniqid();
			$retCODE  .= "<span id='{$randkey}' style='display:none'></span>";
			$retCODE  .= "<script>
											jQuery('#{$randkey}').append('<form name=\"{$randkey}\"  action=\"\" method=\"post\">');
											jQuery('#{$randkey} form').append('<input type=\"hidden\" name=\"tag_post\"   value=\"{$randkey}\" />');
											jQuery('#{$randkey} form').append('<input type=\"hidden\" name=\"mbr_hash\"   value=\"{$mbr_hash}\" />');
										</script>";
			$retCODE .= "<span class='{$randkey}'>";
			IF ($button_text OR $button_image) :
				$button_css = empty($button_style) ? '' : "style='{$button_style}'";
				IF ($button_image) :
					$retCODE .= "<input onclick=\"document.forms['{$randkey}'].submit();\" type='image'  class='{$scname}_btn' name='{$scname}[btn]' src='{$button_image}' alt='" . __('Click here to submit', 'activemember360') . "' {$button_css} />";
				ELSE :
					$retCODE .= "<input onclick=\"document.forms['{$randkey}'].submit();\" type='submit' class='{$scname}_btn' name='{$scname}[btn]' value='{$button_text}' {$button_css} />";
				ENDIF;
			ELSE :
				$link_text = $link_text ? $link_text : __('Click here to submit', 'activemember360');
				$link_css  = $link_style ? "style='{$link_style}'" : '';
				$retCODE  .= "<a href='#' onclick=\"document.forms['{$randkey}'].submit();\" class='{$scname}_link' {$link_css}>{$link_text}</a>";
			ENDIF;
			$retCODE .= '</span>';
		ENDIF;
		return $retCODE;
	}

	function sc_is_failed_payment($parm='', $content=null, $scname='')
	{
		IF ($this->CONTACTID AND $this->MBRPAYF) :
			$match = 0;
		ELSE :
			$match = 1;
		ENDIF;
		return $this->split_else_content($content, $scname, $match);
	}

	





	function sc_email_status($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['list_id' => ''], $parm ));

		IF (empty($list_id)) :
			return null;
		ENDIF;

		IF ($this->CONTACTID) :
			$list_opt_status = $this->get_list_optstatus($this->CONTACTID, $list_id);
			IF (isset($this->arr_optstatus_names[$list_opt_status])) :
				return $this->arr_optstatus_names[$list_opt_status];
			ELSE:
				IF (is_numeric($list_opt_status)) :
					return __('Unknown optstatus: ', 'activemember360') . $list_opt_status;
				ELSE:
					return $list_opt_status;
				ENDIF;
			ENDIF;
		ENDIF;
		return null;
	}

	function sc_is_email_active($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['list_id' => ''], $parm ));

		IF (empty($list_id)) :
			return null;
		ENDIF;

		$match = 1;

		IF ($this->CONTACTID) :
			IF (isset($this->MBRLISTS[$list_id]) AND $this->MBRLISTS[$list_id] == '1') :
				$match = 0;
			ENDIF;
		ENDIF;

		return $this->split_else_content($content, $scname, $match);
	}

	function sc_is_email_unconfirmed($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['list_id' => ''], $parm ));

		IF (empty($list_id)):
			return null;
		ENDIF;

		$match = 1;

		IF ($this->CONTACTID) :
			IF (isset($this->MBRLISTS[$list_id])) :
				IF ($this->MBRLISTS[$list_id] == 0) :
					$match = 0;
				ELSE:
					
					$list_opt_status = $this->get_list_optstatus($this->CONTACTID, $list_id);
					IF ($list_opt_status == 0) :
						$match = 0;
						$this->MBRLISTS[$list_id] = 0;
					ENDIF;
				ENDIF;
			ENDIF;
		ENDIF;

		return $this->split_else_content($content, $scname, $match);
	}

	function sc_is_email_unsubscribed($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['list_id' => ''], $parm ));

		IF (empty($list_id)) :
			return null;
		ENDIF;

		$match = 1;

		IF ($this->CONTACTID) :
			IF (isset($this->MBRLISTS[$list_id]) AND $this->MBRLISTS[$list_id] == '2') :
				$match = 0;
			ENDIF;
		ENDIF;

		return $this->split_else_content($content, $scname, $match);
	}

	function sc_is_email_bounced($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['list_id' => ''], $parm));

		IF (empty($list_id)) :
			return null;
		ENDIF;

		$match = 1;

		IF ($this->CONTACTID) :
			IF (isset($this->MBRLISTS[$list_id])) :
				IF ($this->MBRLISTS[$list_id] == 3) :
					$match = 0;
				ELSE:
					
					$list_opt_status = $this->get_list_optstatus($this->CONTACTID, $list_id);
					IF ($list_opt_status == 3) :
						$match = 0;
						$this->MBRLISTS[$list_id] = 3;
					ENDIF;
				ENDIF;
			ENDIF;
		ENDIF;
		return $this->split_else_content($content, $scname, $match);
	}

	function sc_http_get($parm='', $content=null, $scname='')
	{
		
		extract($this->shortcode_atts(['var' => '', 'index' => '', 'default' => null], $parm));

		$var = trim($var);

		IF ($var == '') :
			return null;
		ENDIF;

		$index = trim($index, " \t\n\r\0\x0B|");

		IF ($index == '') :
			return urldecode($_GET[$var]);
		ENDIF;

		$index = explode('|', $index);

		IF (empty($index) OR !is_array($index)) :
			return $null;
		ENDIF;

		$GET = $_GET[$var];

		FOREACH ($index as $elem) :
			IF (!isset($GET[$elem])) :
				return null;
			ENDIF;
			$GET = $GET[$elem];
		ENDFOREACH;

		return urldecode($GET);
	}

	function sc_http_post($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['var' => null], $parm ));

		$var = trim($var);

		IF (isset($_POST[$var])) :
			return trim($_POST[$var]);
		ENDIF;

		return null;
	}

	function sc_http_request($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['var' => null], $parm ));

		$var = trim($var);

		IF (isset($_REQUEST[$var])) :
			return trim($_REQUEST[$var]);
		ENDIF;

		return null;
	}

	function sc_cookie($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['var' => null], $parm ));

		$var = trim($var);

		IF (isset($_COOKIE[$var])) :
			return trim($_COOKIE[$var]);
		ENDIF;

		IF (isset($HTTP_COOKIE_VARS[$var])) :
			return $HTTP_COOKIE_VARS[$var];
		ENDIF;

		return null;
	}

	function sc_session($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['var' => null], $parm));
		IF ($var) :
			IF (!empty($this->SESSION[$var])) :
				return $this->SESSION[$var];
			ELSEIF (!empty($this->SESSION[$var])) :
				return $this->SESSION[$var];
			ELSEIF (!empty($_SESSION[$var])) :
				return $_SESSION[$var];
			ENDIF;
		ENDIF;
		return null;
	}

	function sc_related_posts($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['cat' => '', 'limit' => '5', 'display'=>'title', 'excerpt_len'=>0], $parm));

		IF ($cat == '') :
			return '';
		ENDIF;

		$limit = (int)$limit;

		IF ($limit < 1) :
			$limit = 5;
		ENDIF;

		$arrCAT  = explode(',', $cat);
		$r       = new WP_Query( ['category__in' => $arrCAT, 'posts_per_page' => $limit] );
		$retVAL  = "<div class='mbr_related_posts_div'>";
		$retVAL .= "<ul class='mbr_related_posts_ul'>";

		WHILE ($r->have_posts()) :
			$r->next_post();
			$retVAL .= '<li class="mbr_related_posts_li">';
			$retVAL .= '<a class="mbr_related_posts_href" href="' . get_permalink($r->post->ID) . '">' . get_the_title($r->post->ID) . '</a>';
			IF ($display == 'title_excerpt') :
				$retVAL .= '<p class="mbr_related_posts_p">' . $this->wp_trim_excerpt($r->post, false, $excerpt_len) . '</p>';
			ENDIF;
			$retVAL .= '</li>';
		ENDWHILE;

		$retVAL .= "</ul>";
		$retVAL .= "</div>";

		return $retVAL;
	}

	function sc_page_list($parm='', $content=null, $scname='')
	{
		$defaults = [
			'authors'      => '',
			'child_of'     => 0,
			'date_format'  => get_option('date_format'),
			'depth'        => 0,
			'exclude'      => '',
			'include'      => '',
			'link_after'   => '',
			'link_before'  => '',
			'post_type'    => 'page',
			'post_status'  => 'publish',
			'show_date'    => '',
			'sort_column'  => 'menu_order, post_title',
			'sort_order'   => '',
			'title_li'     => '',
		];

		$arg2 = $this->shortcode_atts($defaults, $parm);
		
		$arg2['echo'] = 0;
		$retVAL = wp_list_pages($arg2);

		return $retVAL;
	}

	function sc_is_bot($parm='', $content=null, $scname='')
	{
		IF ($this->bot_visit(TRUE)) :
			return $content;
		ENDIF;

		return null;
	}

	function sc_popup_page($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['title' => '', 'url' => '', 'modal' => 'false', 'w' => 500, 'h' => 750], $parm));

		IF (stripos($url, '?') === FALSE) :
			$join = '?';
		ELSE :
			$join = '&';
		ENDIF;

		IF (empty($content)) :
			$content = empty($title) ? __('Click here', 'acitvemember360') : $title;
		ENDIF;

		return "<a href='{$url}{$join}placeValuesBeforeTB_=savedValues&amp;TB_iframe=true&amp;height={$h}&amp;width={$w}' title='{$title}' class='thickbox'>{$content}</a>";
	}

	function sc_popup_inline($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['title' => '', 'delay' => '0', 'autopopup' => 'false', 'modal_reload_after' => 'true', 'close_link' => 'Close', 'modal' => 'false', 'link_text' => '', 'h' => 400, 'w' => 550], $parm));
		$modparm     = '';
		$modalreload = 'false';
		$closebtn    = '';
		IF (strtolower($modal) == 'true') :
			$modparm = 'modal=true&amp;';
			IF (lower_trim($modal_reload_after) == 'true') :
				$modalreload = 'true';
			ENDIF;
			IF (strtolower($close_link) <> 'false') :
				IF (lower_trim($autopopup) == 'true') :
					$modalreload = 'false';
				ENDIF;
				$closebtn = "<div align='center'><a href='' style='line-height:10px;' onclick='tb_remove();return {$modalreload};'>{$close_link}</a></div>";
			ENDIF;
		ENDIF;
		$divNAME = uniqid('tbpop');
		IF (lower_trim($autopopup) == 'true') :
			global $mbr_autopopup;
			$modalreload = 'false';
			$mbr_autopopup = ['divNAME' => $divNAME, 'title' => $title, 'delay' => (int)$delay, 'parm' => "#TB_inline?{$modparm}height={$h}&amp;width={$w}&amp;inlineId={$divNAME}", 'content' => $content, 'closebtn' =>$closebtn];
			add_action('wp_footer', 'mbr_inline_pop_foot', 500);
			return null;
		ELSE :
			$retVAL  = "<div id='{$divNAME}' name='{$divNAME}' style='display:none'><p>{$content}{$closebtn}</p></div>";
			$retVAL .= "<script>function mbr_{$divNAME}(){tb_show('{$title}','#TB_inline?{$modparm}height={$h}&amp;width={$w}&amp;inlineId={$divNAME}');}</script>";
			$retVAL .= "<a href='#' onClick='mbr_{$divNAME}();return false;'>{$link_text}</a>";
			return $this->shortcode($retVAL);
		ENDIF;
	}

	function sc_popup_inline_responsive($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['title'=>'', 'delay'=>'0', 'autopopup'=>'false', 'modal_reload_after'=>'true', 'close_link'=>'Close', 'modal'=>'false', 'link_text'=>'Click here', 'h'=> '', 'w'=> '', 'header' => 'true', 'footer' => 'true'], $parm ));

		$div_id     = 'mbr_modal_' . uniqid();
		$link_id    = 'mbr_link_' . uniqid();

		IF (trim($delay)) :
			$delay  = (int)$delay * 1000;
			IF ($delay > 2147483647) :
				$delay = 2147483647;
			ENDIF;
		ENDIF;

		$w = trim($w);
		IF ($w <> '') :
			$w_unit_1 = substr($w, -2);
			$w_unit_2 = substr($w, -1);
			IF (in_array($w_unit_1, ['px', 'vw']) OR $w_unit_2 == '%') :
				$width  = $w;
			ELSE :
				$width  = $w . 'px';
			ENDIF;
		ENDIF;

		$h = trim($h);
		IF ($h <> '') :
			$h_unit_1 = substr($h, -2);
			$h_unit_2 = substr($h, -1);
			IF (in_array($h_unit_1, ['px', 'vh']) OR $h_unit_2 == '%') :
				$height = $h;
			ELSE :
				$height = $h . 'px';
			ENDIF;
		ENDIF;

		$modal_style     = '';
		IF (!empty($width)) :
			$modal_style  .= "width:{$width};";
		ENDIF;
		IF (!empty($height)) :
			$modal_style .= "height:{$height};";
		ENDIF;

		IF (!empty($modal_style)) :
			$modal_style  = 'style="' . $modal_style . '"';
		ENDIF;

		$ret      = '';
		$ret     .= '<div id="' . $div_id . '" class="mbr-popup-modal ' . $div_id . '">';
		$ret     .= '<div class="mbr-popup-modal-content" ' . $modal_style . '>';
		$ret     .= '<a href="#close" class="mbr-popup-close">' . $close_link . '</a>';
		IF (strtolower($header) == 'true') :
			$ret   .= '<h1>' . $title . '</h1>';
		ELSEIF (!empty($title)) :
			$ret   .= $title;
		ENDIF;
		$ret     .= '<p>' . $content . '</p>';
		IF (strtolower($footer) == 'true') :
			$ret   .= '<a href="#close" class="mbr-popup-button">' . $close_link . '</a>';
		ENDIF;
		$ret     .= '</div>';
		$ret     .= '</div>';

		
		IF (strtolower($autopopup) == 'true') :
			$ret   .= "<a id='{$link_id}' href='#{$div_id}' style='display:none;'>{$link_text}</a>";
			IF (empty($delay)) :
				$ret .= "<script>jQuery(document).ready(function() {window.location = jQuery('#{$link_id}').attr('href');});</script>";
			ELSE:
				$ret .= "<script>jQuery(document).ready(function() {setTimeout(function(){window.location = jQuery('#{$link_id}').attr('href')}, {$delay});});</script>";
			ENDIF;
		ELSE:
			$style  = absint($delay) ? "style='display:none;'" : "";
			$ret   .= "<a id='{$link_id}' href='#{$div_id}' {$style}>{$link_text}</a>";
			IF (!empty($delay)) :
				$ret .= "<script>";
				$ret .= "jQuery('#{$link_id}').hide();";
				$ret .= "setTimeout(function(){jQuery('#{$link_id}').show();}, {$delay});";
				$ret .= "</script>";
			ENDIF;
		ENDIF;

		IF (strtolower($modal_reload_after) == 'true' AND $autopopup <> 'true') :
			$ret .= "<script>jQuery('#{$div_id} .mbr-popup-button, #{$div_id} .mbr-popup-close').on('click', function () {location.reload();})</script>";
		ENDIF;
		IF (strtolower($modal) <> 'true') :
			$ret .= "<script>jQuery('body').click(function() {hash = location.hash.replace('#','');location.hash = '';});</script>";
		ENDIF;

		$ret   .= "<script>jQuery('#{$div_id}').show();</script>";

		return $ret;
	}

	function OLD_BOOTSTRAP_sc_popup_inline_responsive($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['title'=>'', 'delay'=>'0', 'autopopup'=>'false', 'modal_reload_after'=>'true', 'close_link'=>'Close', 'modal'=>'false', 'link_text'=>'Click here', 'h'=> '', 'w'=> '', 'header' => 'true', 'footer' => 'true'], $parm ));

		$modal_rules   = '';
		IF (strtolower($modal) == 'true') :
			$modal_rules = 'data-keyboard="false" data-backdrop="static"';
		ENDIF;

		$div_id     = 'mbr_modal_' . uniqid();
		$link_id    = 'mbr_link_' . uniqid();

		IF (trim($delay)) :
			$delay  = (int)$delay * 1000;
			IF ($delay > 2147483647) :
				$delay = 2147483647;
			ENDIF;
		ENDIF;

		$ret = '';
		IF (strtolower($autopopup) <> 'true') :
			$style = absint($delay) ? "style='display:none;'" : "style='cursor:pointer;'";
			$ret .= "<a id='{$link_id}' data-toggle='modal' data-target='#{$div_id}' {$style}>{$link_text}</a>";
		ENDIF;

		$w = trim($w);
		IF ($w <> '') :
			$w_unit_1 = substr($w, -2);
			$w_unit_2 = substr($w, -1);
			IF (in_array($w_unit_1, ['px', 'vw']) OR $w_unit_2 == '%') :
				$width  = $w;
			ELSE :
				$width  = $w . 'px';
			ENDIF;
		ENDIF;

		$h = trim($h);
		IF ($h <> '') :
			$h_unit_1 = substr($h, -2);
			$h_unit_2 = substr($h, -1);
			IF (in_array($h_unit_1, ['px', 'vh']) OR $h_unit_2 == '%') :
				$height = $h;
			ELSE :
				$height = $h . 'px';
			ENDIF;
		ENDIF;
		$swidth     = '';
		$sheight    = '';

		IF (!empty($width)) :
			$swidth  .= "style='width:{$width};'";
		ENDIF;
		IF (!empty($height)) :
			$sheight .= "style='height:{$height};'";
		ENDIF;

		$ret     .= "<div id='{$div_id}' class='mbr-modal mbr-fade' role='dialog' {$modal_rules} style='display:none;'>";
		$ret     .= "<div class='mbr-modal-dialog' {$swidth}>";
		$ret     .= "<div class='mbr-modal-content' {$sheight}>";

		IF (strtolower($header) == 'true') :
			$ret   .= "<div class='mbr-modal-header'><button type='button' class='mbr-close' data-dismiss='modal'>&times;</button>{$title}</div>";
		ELSEIF (!empty($title)) :
			$ret   .= $title;
		ENDIF;

		$ret     .= "<div class='mbr-modal-body'>{$content}</div>";

		IF (strtolower($footer) == 'true') :
			$ret   .= "<div class='mbr-modal-footer'><button type='button' data-dismiss='modal'>{$close_link}</button></div>";
		ENDIF;

		$ret     .= '</div>';
		$ret     .= '</div>';
		$ret     .= '</div>';

		IF (strtolower($autopopup) == 'true') :
			$options = "{show:true";
			IF (strtolower($modal) == 'true') :
				$options .= ",keyboard:false";
				$options .= ",backdrop:'static'";
			ENDIF;
			$options .= "}";

			$afunc  = "jQuery('#{$div_id}').modal({$options});";
			$ret   .= "<script>";
			IF ($delay > 0) :
				$ret .= "setTimeout(function(){{$afunc}}, {$delay});";
			ELSE:
				$ret .= "jQuery(window).load(function(){{$afunc}});";
			ENDIF;
			$ret   .= "</script>";
		ELSE:
			IF ($delay) :
				$ret .= "<script>";
				$ret .= "jQuery('#{$link_id}').hide();";
				$ret .= "setTimeout(function(){jQuery('#{$link_id}').show();}, {$delay});";
				$ret .= "</script>";
			ENDIF;
		ENDIF;
		IF (strtolower($modal_reload_after) == 'true' AND $autopopup <> 'true') :
			$ret .= "<script>jQuery('#{$div_id}').on('hidden.bs.modal', function () {location.reload();})</script>";
		ENDIF;
		return $ret;
	}

	function sc_isset($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['var' => ''], $parm));
		$var = trim($var);
		IF (isset($var) AND trim($var) <> '') :
			$match = 0;
		ELSE :
			$match = 1;
		ENDIF;
		return $this->split_else_content($content, $scname, $match);
	}

	function sc_permalink($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['post_id' => ''], $parm ));
		$post_id = (int)$post_id;
		IF ($post_id) :
			$retVAL = get_permalink($post_id);
		ELSE :
			$retVAL = get_permalink();
		ENDIF;
		return $retVAL;
	}

	function sc_logout_link($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['redirect' => '', 'text'=>__('Log out', 'activemember360'), 'class'=>'mbr_logout_link'], $parm));
		return sprintf("<a href='%s' title='%s' class='%s'>%s</a>", wp_logout_url($redirect), __('Log out', 'activemember360'), $class, $text);
	}

	function sc_logout_url($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['redirect' => ''], $parm));
		$redirect = trim($redirect);
		IF ($redirect == '') :
			$redirect = $this->redir_logout();
		ENDIF;
		return wp_logout_url($redirect);
	}

	function sc_menu_loginout_label($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['login' => __('Login', 'activemember360'), 'logout' => __('Log out', 'activemember360')], $parm));
		return is_user_logged_in() ? $logout : $login;
	}

	function sc_menu_loginout_url($parm='', $content=null, $scname='')
	{
		global $MBR_OPTIONS;

		extract($this->shortcode_atts(['logout_redir' => ''], $parm));
		IF (is_user_logged_in()) :
			$logout_redir = trim($logout_redir);
			IF ($logout_redir == '') :
				$logout_redir = $this->redir_logout();
			ENDIF;
			return wp_logout_url($logout_redir);
		ENDIF;
		IF ($MBR_OPTIONS['login_page'] == 0) :
			return wp_login_url();
		ENDIF;
		return get_permalink($MBR_OPTIONS['login_page']);
	}

	function sc_redirect($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['url' => '', 'autorun' => 'no', 'new_window' => 'no', 'button_text' => __('Go there now...', 'activemember360'), 'button_image' => '', 'button_style' => ''], $parm ));
		$randkey = uniqid('mbr_sc_redirect_');
		$target  = checktrue($new_window) ? "target='_blank'" : '';
		IF (checktrue($autorun)) :
			IF (checktrue($new_window)) :
				$retCODE  = "<form name='{$randkey}' id='{$randkey}' action='{$url}' {$target} method='post'><input type='hidden' name='action'  value='{$randkey}' /></form><script>jQuery('document').ready(function(){document.forms['{$randkey}'].submit();});</script>";
				return $retCODE;
			ELSE :
				$this->redirect($url);
			ENDIF;
		ENDIF;
		$retCODE     = "<form name='{$randkey}' id='{$randkey}' action='{$url}' {$target} method='post'>";
		$button_css  = ($button_style <> '') ? "style='$button_style'" : '';
		IF ($button_image == '') :
			$retCODE .= "<input type='submit' class='mbr_sc_redirect_btn' name='mbr_sc_redirect_btn[{$randkey}]' value='{$button_text}' alt='Click here to submit' {$button_css} />";
		ELSE :
			$retCODE .= "<input type='image'  class='mbr_sc_redirect_btn' name='mbr_sc_redirect_btn[{$randkey}]' src='{$button_image}'  alt='Click here to submit' {$button_css} />";
		ENDIF;
		$retCODE .= "</form>";
		return $content . $retCODE;
	}

	function sc_signup_link($parm='', $content='', $scname='')
	{
		global $MBR_OPTIONS;

		$signup_url = false;
		IF ($MBR_OPTIONS['registration_static']) :
			$signup_url = $MBR_OPTIONS['registration_static'];
		ELSEIF ($MBR_OPTIONS['registration_page']) :
			$signup_url = get_permalink($MBR_OPTIONS['registration_page']);
		ELSE :
			$signup_url = wp_registration_url();
		ENDIF;
		extract($this->shortcode_atts(['text' => 'Click here to register'], $parm ));
		return "<a href='{$signup_url}'>{$text}</a>";
	}

	function cb_cookie_set($m)
	{
		$parm = shortcode_parse_atts($m[2]);
		IF (!$parm) :
			return null;
		ENDIF;

		$expires = 3600;
		IF (isset($parm['expires'])) :
			$expires = (int) $parm['expires'];
			unset($parm['expires']);
		ENDIF;

		$retCODE = '';
		FOREACH ($parm as $k => $v) :
			$retCODE .= '(<:=' . $this->scPREFIX . "_cookie_set1 name='{$k}' value='{$v}' expires='{$expires}'" . '=:>)' . "\n";
		ENDFOREACH;

		return $retCODE;
	}

	function resolveSESSION($content='')
	{
		$content = preg_replace_callback('#\[' . $this->scPREFIX . '_db_([^]]*)\]#i',          [$this, 'sc_generic_contact'], $content);
		$content = preg_replace_callback('#\[(' . $this->scPREFIX . '_cookie_set)([^]]*)\]#i', [$this, 'cb_cookie_set'],      $content);
		return $content;
	}

	function shortcode($content='')
	{
		global $shortcode_tags, $post;

		IF ($content == '') :
			return $content;
		ENDIF;

		IF (empty($this->SESSION)) :
			$this->SESSION = [];
		ENDIF;

		IF (empty($this->SESSVARS)) :
			$this->SESSVARS = [];
		ENDIF;

		IF (empty($this->CUSTSC)) :
			$this->CUSTSC = [];
		ENDIF;

		static $custom_shortcode_regex = '';
		IF ($custom_shortcode_regex == '') :
			IF ($rows = $this->wpdb->get_results("SELECT post_name FROM {$this->wpdb->posts} WHERE post_type='" . MBRCUSTSC . "' AND post_status='publish' ORDER BY 1 DESC")) :
				$regex = wp_list_pluck($rows, 'post_name');
				$custom_shortcode_regex = join($regex, '|');
				unset($rows);
			ENDIF;
			$custom_shortcode_regex = $this->scPREFIX . '_select' . '|' . $custom_shortcode_regex;
			$custom_shortcode_regex = trim($custom_shortcode_regex, '|');
		ENDIF;

		$saveSHORTAGS   = $shortcode_tags; // Shortcode tags are saved as "mbr_post_id" nad not as "[mbr_post_id"
		$shortcode_tags = $this->SHORTCODES;
		$content        = $this->resolveSESSION($content);

		
		$loop = 0;
		WHILE ($loop++ < 100 AND preg_match_all( '@\[([^<>&/\[\]\x00-\x20=]++)@', $content, $matches) AND array_intersect( array_keys($shortcode_tags), $matches[1] )) :
			$content = do_shortcode($content);
		ENDWHILE;

		$sc_pattern = '[' . $this->scPREFIX . '_';
		$loop       = 0;

		WHILE ($loop++ < 10000 AND preg_match('/\[(' . $custom_shortcode_regex . ')\b((?:[\'"][^\'"]*[\'"]|.)*?)(?:(\/))?\](?:(.+?)\[\/\2\])?/i', $content, $arrSCALL)) :

			$sc_name   = trim($arrSCALL[1]);
			$sc_code   = '';
			$sc_params = '';
			$sc_atts   = [];

			IF (isset($arrSCALL[2])) :
				$sc_params = trim($arrSCALL[2]);
				$sc_atts   = shortcode_parse_atts($sc_params);
				IF ( ! empty( $sc_atts ) AND is_array( $sc_atts ) ) :
					$sc_atts = array_map( 'trim', $sc_atts );
				ENDIF;
			ENDIF;

			DO {

				IF ($sc_name == $this->scPREFIX . '_select') :
					$content = str_ireplace($arrSCALL[0], $this->sc_select($sc_params), $content);
					break;
				ENDIF;

				IF (!isset($this->CUSTSC[$sc_name])) :
					$sc_code = $this->wpdb->get_var("SELECT post_content FROM {$this->wpdb->posts} WHERE post_type='" . MBRCUSTSC . "' AND post_name='{$sc_name}' LIMIT 1");
					IF ($sc_code) :
						$this->CUSTSC[$sc_name] = $sc_code;
					ENDIF;
				ENDIF;

				IF (isset($this->CUSTSC[$sc_name])) :
					$sc_code = $this->CUSTSC[$sc_name];
				ENDIF;

				WHILE (preg_match('/\%\%(.*?)\%\%/i', $sc_code, $pregATTS)) :
					IF (isset($sc_atts[strtolower($pregATTS[1])]) AND $sc_atts[$pregATTS[1]]) :
						$replacer = $sc_atts[strtolower($pregATTS[1])];
					ELSE :
						$replacer = '<!--#remove#-->';
					ENDIF;
					$sc_code = str_ireplace($pregATTS[0], $replacer, trim($sc_code));
				ENDWHILE;

			} WHILE (false);

			IF (!empty($sc_code) AND !empty($arrSCALL[0])) :
				$content = str_ireplace($arrSCALL[0], $sc_code, $content);
			ENDIF;

			$content = shortcode_unautop($content);
			$content = $this->resolveSESSION($content);
			$content = do_shortcode($content);

			IF (stripos($content, $sc_pattern) !== FALSE) :
				FOR ($xx=1; $xx<15; $xx++) :
					IF (stripos($content, $sc_pattern) === FALSE) :
						break;
					ENDIF;
					$content = do_shortcode($content);
				ENDFOR;
			ENDIF;

		ENDWHILE;

		
		$shortcode_tags = $saveSHORTAGS;
		return trim($content);
	}

	function sc_select($parm='')
	{
		$parm = trim($parm);
		IF ($parm == '') :
			return null;
		ENDIF;
		$arrVAR = explode('|',substr($parm,6,-1));
		$switch = $this->shortcode($arrVAR[0]);
		IF (isset($arrVAR[0])) :
			unset($arrVAR[0]);
		ENDIF;
		FOREACH ($arrVAR as $k => $v) :
			$v = trim($v);
			IF (is_numeric($switch)) :
				IF ($switch == $k) :
					return $v;
				ENDIF;
			ELSEIF (lower_trim($v) == lower_trim($switch)) :
				return $this->shortcode($k);
			ENDIF;
		ENDFOREACH;
		return null;
	}

	function sc_login_form($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(
			[ 'form_id'        => 'loginform',
				'label_login'    => __( 'Log In',            'activemember360'),
				'label_username' => __( 'Username or Email', 'activemember360'),
				'label_password' => __( 'Password',          'activemember360'),
				'label_remember' => __( 'Remember Me',       'activemember360'),
				'redirect'       => '#use_level_redir#',
				'force_display'  => 'no',
				'min_width'      => '',
				'max_width'      => '',
				'label'          => 'top'
			], $parm));

		IF ( ! empty( $placeholder ) ) :
			$placeholder = lower_trim(substr($placeholder,0,1));
			IF ($placeholder = in_array($placeholder, ['t','y','1'])) :
				$label = 'placeholder';
			ENDIF;
		ENDIF;

		IF (!empty($_POST['wp-submit'])) :
			$user = $this->login_helper($_POST['log'], $_POST['pwd']);
		ENDIF;

		IF (is_user_logged_in()) :
			$force_display = lower_trim(substr($force_display,0,1));
			IF (!$force_display = in_array($force_display, ['t','y','1'])) :
				return;
			ENDIF;
		ENDIF;

		IF ($label == 'placeholder') :
			$form_class           = 'mbr-placeholder-form';
			$placeholder_or_label = 'placeholder';
		ELSEIF ($label == 'left') :
			$form_class           = 'mbr-label-left';
			$placeholder_or_label = 'label';
		ELSE :
			$form_class           = 'mbr-label-above';
			$placeholder_or_label = 'label';
		ENDIF;

		$arrFORM                = [];
		$arrFORM['before']      = '';
		$arrFORM['after']       = '';
		$arrFORM['min_width']   = !empty($min_width) ? $min_width : '';
		$arrFORM['max_width']   = !empty($max_width) ? $max_width : '';

		$arrFORM['form']        = ['method' => 'post',   'name'  => 'loginform', 'action' => '', 'class' => 'mbr-forms ' . $form_class];
		$arrFORM['redirect_to'] = ['type'   => 'hidden', 'value' => $redirect];

		$arrFORM['log'] = [
			'type'                => 'text',
			'value'               => '',
			$placeholder_or_label => $label_username,
			'size'                => isset($size_email_1)         ? $size_email_1         : '20',
			'maxlength'           => isset($maxlength_email_1)    ? $maxlength_email_1    : '255',
			'before'              => isset($before_email_1)       ? $before_email_1       : '',
			'after'               => isset($after_email_1)        ? $after_email_1        : '',
			'style'               => isset($style_email_1)        ? $style_email_1        : '',
			'class'               => isset($class_email_1)        ? $class_email_1        : '',
			'id'                  => 'user_login'
		];

		$arrFORM['pwd'] = [
			'type'                => 'password',
			'value'               => '',
			$placeholder_or_label => $label_password,
			'size'                => isset($size_email_2)         ? $size_email_2         : '20',
			'maxlength'           => isset($maxlength_email_2)    ? $maxlength_email_2    : '255',
			'before'              => isset($before_email_2)       ? $before_email_2       : '',
			'after'               => isset($after_email_2)        ? $after_email_2        : '',
			'style'               => isset($style_email_2)        ? $style_email_2        : '',
			'class'               => isset($class_email_2)        ? $class_email_2        : '',
			'id'                  => 'user_pass',
		];

		









		$arrFORM['rememberme'] = [
			'id'                  => 'rememberme',
			'before'              => '<div class="mbr-input-field mbr-check"><label for="rememberme">',
			'after'               => "&nbsp;{$label_remember}</label></div>",
			'type'                => 'checkbox',
			'value'               => 'forever'
		];

		$arrFORM['wp-submit']  = [
			'type'                => 'submit',
			'value'               => $label_login,
			'before'              => isset($before_submit_button) ? $before_submit_button : '',
			'after'               => isset($after_submit_button)  ? $after_submit_button  : '',
			'style'               => isset($style_submit_button)  ? $style_submit_button  : '',
			'class'               => isset($class_submit_button)  ? $class_submit_button  : 'mbr-submit',
			'id'                  => isset($id_submit_button)     ? $id_submit_button     : 'wp-submit'
		];

		$retCODE = $this->build_form($arrFORM);

		IF (isset($user) AND is_wp_error($user)) :
			$message = $user->get_error_message();
			$retCODE = '<p class="mbr-login-error">' . $message . '</p>' . $retCODE;
		ENDIF;
		return $content . $retCODE;
	}

	function sc_password_send($parm='', $content=null, $scname='')
	{
		IF ($this->prevent_shortcodes_in_head()) :
			return null;
		ENDIF;
		IF ((defined('DOING_AJAX') AND DOING_AJAX) OR (defined('DOING_CRON') AND DOING_CRON)) :
			return;
		ENDIF;
		static $has_run_password_send;
		IF ($has_run_password_send) :
			return null;
		ELSE :
			$has_run_password_send = true;
		ENDIF;

		extract($this->shortcode_atts(
			['button_image'  => '',
				'automation_id' => 0,
				'email'         => 'Email:',
				'button_style'  => '',
				'button_text'   => __('Send password', 'activemember360'),
				'from_addr'     => '',
				'from_name'     => '',
				'label'         => 'top',
				'min_width'     => '',
				'max_width'     => ''
			], $parm ));

		$retVAL   = '';

		IF (!empty($placeholder)) :
			$placeholder = substr(lower_trim($placeholder),0,1);
			IF ($placeholder = in_array($placeholder, ['t','y','1'])) :
				$label = 'placeholder';
			ENDIF;
		ENDIF;

		IF (isset($_POST['mbr-password-send-submit'])) :
			$parm  = ['user_login' => $_POST['send_user_login'], 'fromaddr' => $from_addr, 'fromname' => $from_name, 'automation_id' => $automation_id];
			$result = mbr_send_password($parm);
			IF ($result[0]) :
				$retVAL = "<div class='mbr-password-send-success'>" . $result[1] . "</div>";
			ELSE :
				$retVAL = "<div class='mbr-password-send-error'>"   . $result[1] . "</div>";
			ENDIF;
		ENDIF;

		IF (!isset($_POST['mbr-password-send-submit']) OR empty($result[0])) :

			IF ($label == 'placeholder') :
				$form_class           = 'mbr-placeholder-form';
				$placeholder_or_label = 'placeholder';
			ELSEIF ($label == 'left') :
				$form_class           = 'mbr-label-left';
				$placeholder_or_label = 'label';
			ELSE :
				$form_class           = 'mbr-label-above';
				$placeholder_or_label = 'label';
			ENDIF;

			$arrFORM                    = [];
			$arrFORM['min_width']       = !empty($min_width) ? $min_width : '';
			$arrFORM['max_width']       = !empty($max_width) ? $max_width : '';
			$arrFORM['form']            = ['name' => 'sendpasswordform', 'id' => 'sendpasswordform', 'action' => '', 'method' => 'post', 'class' => 'mbr-forms ' . $form_class, 'onsubmit' => 'return checkSendPasswordForm()'];

			$arrFORM['send_user_login'] = [
				'type'                    => 'text',
				'value'                   => ($this->CONTACT_ID && $this->SESSION['email']) ? $this->SESSION['email'] : '',
				$placeholder_or_label     => $email,
				'size'                    => isset($size_email)           ? $size_email           : '20',
				'maxlength'               => isset($maxlength_email)      ? $maxlength_email      : '',
				'before'                  => isset($before_email)         ? $before_email         : '',
				'after'                   => isset($after_email)          ? $after_email          : '',
				'style'                   => isset($style_email)          ? $style_email          : '',
				'class'                   => isset($class_email)          ? $class_email          : '',
				'id'                      => 'send_user_login'
			];

			$arrFORM['mbr-password-send-submit']  = [
				'before'                  => isset($before_submit_button) ? $before_submit_button : '',
				'after'                   => isset($after_submit_button)  ? $after_submit_button  : '',
				'style'                   => isset($button_style)         ? $button_style         : '',
				'class'                   => isset($class_submit_button)  ? $class_submit_button  : 'mbr-submit',
				'id'                      => isset($id_submit_button)     ? $id_submit_button     : 'mbr-submit'
			];

			IF (isset($button_image) AND trim($button_image) <> '') :
				$button_type = 'image';
				$arrFORM['mbr-password-send-submit']['type']  = 'image';
				$arrFORM['mbr-password-send-submit']['src']   = $button_image;
				$arrFORM['mbr-password-send-submit']['alt']   = $button_text;
			ELSE :
				$arrFORM['mbr-password-send-submit']['type']  = 'submit';
				$arrFORM['mbr-password-send-submit']['value'] = $button_text;
			ENDIF;

			$retVAL .= $this->build_form($arrFORM);

		ENDIF;
		$retVAL = "<script>function checkSendPasswordForm() {if(document.sendpasswordform.send_user_login.value==''){alert('" . __('Please enter your email address.', 'activemember360') . "');return false;}}</script>" . $retVAL;

		return $content . $retVAL;
	}

	function sc_password_change($parm='', $content=null, $scname='')
	{
		global $MBR_OPTIONS;

		IF ($this->prevent_shortcodes_in_head()) :
			return null;
		ENDIF;
		IF ((defined('DOING_AJAX') AND DOING_AJAX) OR (defined('DOING_CRON') AND DOING_CRON)) :
			return null;
		ENDIF;
		IF (!$this->CONTACTID) :
			return null;
		ENDIF;
		static $has_run_password_change;
		IF ($has_run_password_change) :
			return null;
		ELSE :
			$has_run_password_change = true;
		ENDIF;
		extract($this->shortcode_atts([
			'button_image'  => '',
			'button_style'  => '',
			'pass_1'        => __('New Password', 'activemember360'),
			'pass_2'        => __('Repeat Password', 'activemember360'),
			'label'         => 'top',
			'min_width'     => '',
			'max_width'     => '',
			'lead_text'     => '',
			'button_text'   => __('Change Password', 'activemember360'),
			'redirect'      => '',
			'automation_id' => 0
		], $parm ));

		IF (!empty($placeholder)) :
			$placeholder = substr(lower_trim($placeholder),0,1);
			IF ($placeholder = in_array($placeholder, ['t','y','1'])) :
				$label = 'placeholder';
			ENDIF;
		ENDIF;

		$retVAL = '';
		
		IF (!empty($_COOKIE['changepasswordcode'])) :
			$retVAL .= ($_COOKIE['changepasswordcode']['status'] == 'true' ? '<div class="mbr-password-change-success">' : '<div class="mbr-password-change-error">') . '<p>' . $_COOKIE['changepasswordcode']['message'] . '</p>' . '</div>';
			
			setcookie('changepasswordcode[status]');
			setcookie('changepasswordcode[message]');
			
			IF ($_COOKIE['changepasswordcode']['status'] == 'true' AND $automation_id) :
				$this->api("automation_contact_add", ['contact_id' => $this->CONTACTID, 'automation' => $automation_id]);
			ENDIF;
		ENDIF;
		$retVAL .= "<div class='mbr-password-change-notice'><p>" . __('To change your password, please enter your new password twice in the fields below.', 'activemember360') . "</p></div>";
		$password_base = mbr_get_password_base();
		$retVAL .= "
		<script>
		function checkChangePasswordForm() {
			if(document.changepasswordform.mbr_new_password1.value == '' || document.changepasswordform.mbr_new_password2.value == ''){
				alert('" . __('Please enter your new password twice.', 'activemember360') . "');
				return false;
			}
			if(document.changepasswordform.mbr_new_password1.value != document.changepasswordform.mbr_new_password2.value){
				alert('" . __('Please enter the same password in both input fields.', 'activemember360') . "');
				return false;
			}

			password = document.changepasswordform.mbr_new_password1.value;

			min_pass_len = " . $MBR_OPTIONS['min_passlen'] . ";
			if (password.length < min_pass_len) {
				alert('" . sprintf(__('Your password is too short. It should be at least %s characters long.', 'activemember360'), $MBR_OPTIONS['min_passlen']) . "');
				return false;
			}

			max_pass_len = " . $MBR_OPTIONS['max_passlen'] . ";
			if (password.length > max_pass_len) {
				alert('" . sprintf(__('Your password is too long. It should not be more than %s characters long.', 'activemember360'), $MBR_OPTIONS['max_passlen']) . "');
				return false;
			}

			charbase = '" . $password_base . "';
			if (charbase.length > 0) {
				for(i = 0; i < password.length; i++) {
					if (charbase.indexOf(password.charAt(i)) == -1) {
						alert('" . __('Your password includes characters that are not allowed.\nOnly the following characters may be used:\n','activemember360') . $password_base . "');
						return false;
					}
				}
			}
		}
		</script>
		";

		IF ($label == 'placeholder') :
			$form_class           = 'mbr-placeholder-form';
			$placeholder_or_label = 'placeholder';
		ELSEIF ($label == 'left') :
			$form_class           = 'mbr-label-left';
			$placeholder_or_label = 'label';
		ELSE :
			$form_class           = 'mbr-label-above';
			$placeholder_or_label = 'label';
		ENDIF;

		$arrFORM                   = [];
		$arrFORM['before']         = $lead_text;
		$arrFORM['form']           = ['name' => 'changepasswordform', 'id' => 'changepasswordform', 'action' => '', 'method' => 'post', 'class' => 'mbr-forms ' . $form_class, 'onsubmit' => 'return checkChangePasswordForm()'];
		$arrFORM['min_width']      = !empty($min_width) ? $min_width : '';
		$arrFORM['max_width']      = !empty($max_width) ? $max_width : '';

		$arrFORM['mbr_action']     = ['type' => 'hidden', 'value' => 'mbr_changepassword'];
		IF ( ! empty( $redirect ) ) :
			$arrFORM['mbr_redirect'] = ['type' => 'hidden', 'value' => base64_encode( $redirect ) ];
		ENDIF;

		$arrFORM['mbr_new_password1'] = [
			'type'                   => 'password',
			'value'                  => '',
			$placeholder_or_label    => $pass_1,
			'size'                   => isset($size_pass_1)            ? $size_pass_1            : '20',
			'maxlength'              => isset($maxlength_pass_1)       ? $maxlength_pass_1       : '',
			'before'                 => isset($before_pass_1)          ? $before_pass_1          : '',
			'after'                  => isset($after_pass_1)           ? $after_pass_1           : '',
			'style'                  => isset($style_pass_1)           ? $style_pass_1           : '',
			'class'                  => isset($class_pass_1)           ? $class_pass_1           : '',
			'id'                     => 'mbr_new_password1'
		];

		$arrFORM['mbr_new_password2'] = [
			'type'                   => 'password',
			'value'                  => '',
			$placeholder_or_label    => $pass_2,
			'size'                   => isset($size_pass_2)            ? $size_pass_2            : '20',
			'maxlength'              => isset($maxlength_pass_2)       ? $maxlength_pass_2       : '',
			'before'                 => isset($before_pass_2)          ? $before_pass_2          : '',
			'after'                  => isset($after_pass_2)           ? $after_pass_2           : '',
			'style'                  => isset($style_pass_2)           ? $style_pass_2           : '',
			'class'                  => isset($class_pass_2)           ? $class_pass_2           : '',
			'id'                     => 'mbr_new_password2'
		];

		$arrFORM['mbr_password_change_submit']  = [
			'before'                 => isset($before_submit_button)   ? $before_submit_button   : '',
			'after'                  => isset($after_submit_button)    ? $after_submit_button    : '',
			'style'                  => isset($button_style)           ? $button_style           : '',
			'class'                  => isset($class_submit_button)    ? $class_submit_button    : 'mbr-submit',
			'id'                     => isset($id_submit_button)       ? $id_submit_button       : ''
		];

		IF (isset($button_image) AND trim($button_image) <> '') :
			$button_type = 'image';
			$arrFORM['mbr_password_change_submit']['type']  = 'image';
			$arrFORM['mbr_password_change_submit']['src']   = $button_image;
			$arrFORM['mbr_password_change_submit']['alt']   = $button_text;
		ELSE :
			$arrFORM['mbr_password_change_submit']['type']  = 'submit';
			$arrFORM['mbr_password_change_submit']['value'] = $button_text;
		ENDIF;
		$retVAL .= $this->build_form($arrFORM);
		return $content . $retVAL;
	}

	function change_password()
	{
		global $MBR_OPTIONS;

		
		
		IF (!$this->CONTACTID OR 'POST' !== strtoupper($_SERVER['REQUEST_METHOD']) OR empty($_POST['mbr_action']) OR $_POST['mbr_action'] <> 'mbr_changepassword') :
			return;
		ENDIF;
		
		$cookie_expiration = time() + 15;
		
		IF (empty($_POST['mbr_new_password1']) OR empty($_POST['mbr_new_password2']) OR trim($_POST['mbr_new_password1']) == '' OR trim($_POST['mbr_new_password2']) == '') :
			
			setcookie('changepasswordcode[status]', 'false', $cookie_expiration);
			setcookie('changepasswordcode[message]', __('You must enter your new password twice. Please try again.', 'activemember360'), $cookie_expiration);
		
		ELSEIF ($_POST['mbr_new_password1'] <> $_POST['mbr_new_password2']) :
			
			setcookie('changepasswordcode[status]', 'false', $cookie_expiration);
			setcookie('changepasswordcode[message]', __('Your passwords did not match. Please try again.', 'activemember360'), $cookie_expiration);
		ELSE :
			
			$update_local_password = TRUE;
			IF (!$MBR_OPTIONS['mbr_encrypted_passwords']) :
				IF (!$this->save_contact_fields(['id' => $this->CONTACTID, $this->password_perstag => $_POST['mbr_new_password1']])) :
					$update_local_password = FALSE;
				ENDIF;
			ENDIF;
			IF ($update_local_password) :
				
				$GLOBALS['current_user']->user_pass         = $_POST['mbr_new_password1'];
				wp_update_user($GLOBALS['current_user']);
				
				setcookie('changepasswordcode[status]', 'true', $cookie_expiration);
				setcookie('changepasswordcode[message]', __('Your password was changed successfully.', 'activemember360'), $cookie_expiration);
			ELSE :
				
				setcookie('changepasswordcode[status]', 'false', $cookie_expiration);
				setcookie('changepasswordcode[message]', __('An error occurred during the procedure. Please try again.', 'activemember360'), $cookie_expiration);
			ENDIF;
		ENDIF;
		
		
		IF ( ! empty( $_POST['mbr_redirect' ] ) ) :
			$redirect_url = base64_decode( $_POST['mbr_redirect'] ) ;
		ELSE:
			$redirect_url = home_url( add_query_arg( [], $GLOBALS['wp']->request ) );
		ENDIF;
		wp_safe_redirect( $redirect_url );
		
		exit;
	}

	function prevent_shortcodes_in_head()
	{
		return in_array('wp_head', $GLOBALS['wp_current_filter']);
	}

	function sc_email_change($parm='', $content=null, $scname='')
	{
		IF ($this->prevent_shortcodes_in_head()) :
			return null;
		ENDIF;
		IF ((defined('DOING_AJAX') AND DOING_AJAX) OR (defined('DOING_CRON') AND DOING_CRON)) :
			return null;
		ENDIF;
		static $has_run_email_change;
		IF ($has_run_email_change) :
			return null;
		ELSE :
			$has_run_email_change = true;
		ENDIF;
		IF (!$this->CONTACTID) :
			return null;
		ENDIF;
		extract($this->shortcode_atts([
			'automation_id' => 0,
			'email_1'     => __('New Email Address', 'activemember360'),
			'email_2'     => __('Repeat Email Address', 'activemember360'),
			'label'       => 'top',
			'placeholder' => 0,
			'min_width'   => '',
			'max_width'   => '',
			'button_text' => __('Process Change', 'activemember360')
		], $parm));

		IF (!empty($placeholder)) :
			$placeholder = substr(lower_trim($placeholder),0,1);
			IF ($placeholder = in_array($placeholder, ['t','y','1'])) :
				$label = 'placeholder';
			ENDIF;
		ENDIF;

		$retVAL = '';

		
		IF (!empty($_COOKIE['changeemailcode'])) :
			$retVAL .= ($_COOKIE['changeemailcode']['status'] == 'true' ? '<div class="mbr-email-change-success">' : '<div class="mbr-email-change-error">') . '<p>' . $_COOKIE['changeemailcode']['message'] . '</p>' . '</div>';
			
			setcookie('changeemailcode[status]');
			setcookie('changeemailcode[message]');
			
			IF ($_COOKIE['changeemailcode']['status'] == 'true' AND $automation_id) :
				$this->api("automation_contact_add", ['contact_id' => $this->CONTACTID, 'automation' => $automation_id]);
			ENDIF;
		ENDIF;
		$retVAL .= "<div class='mbr-email-change-success'><p>" . __('To change your email address, please enter your new email address twice in the fields below.', 'activemember360') . "</p></div>";

		IF ($label == 'placeholder') :
			$form_class           = 'mbr-placeholder-form';
			$placeholder_or_label = 'placeholder';
		ELSEIF ($label == 'left') :
			$form_class           = 'mbr-label-left';
			$placeholder_or_label = 'label';
		ELSE :
			$form_class           = 'mbr-label-above';
			$placeholder_or_label = 'label';
		ENDIF;

		$arrFORM                   = [];
		$arrFORM['after']          = '';
		$arrFORM['min_width']      = !empty($min_width) ? $min_width : '';
		$arrFORM['max_width']      = !empty($max_width) ? $max_width : '';
		$arrFORM['form']           = ['method' => 'post',   'name'  => 'mbr_change_user_email', 'action' => '', 'class' => 'mbr-forms ' . $form_class, 'onsubmit' => 'return check_mbr_change_email_form()'];
		$arrFORM['mbr_action']     = ['type'   => 'hidden', 'value' => 'mbr_change_user_email'];

		$arrFORM['mbr_new_email1'] = [
			'type'                   => 'text',
			'value'                  => '',
			$placeholder_or_label    => $email_1,
			'size'                   => isset($size_email_1)         ? $size_email_1         : '60',
			'maxlength'              => isset($maxlength_email_1)    ? $maxlength_email_1    : '255',
			'before'                 => isset($before_email_1)       ? $before_email_1       : '',
			'after'                  => isset($after_email_1)        ? $after_email_1        : '',
			'style'                  => isset($style_email_1)        ? $style_email_1        : '',
			'class'                  => isset($class_email_1)        ? $class_email_1        : '',
			'id'                     => 'mbr_new_email1'
		];

		$arrFORM['mbr_new_email2'] = [
			'type'                   => 'text',
			'value'                  => '',
			$placeholder_or_label    => $email_2,
			'size'                   => isset($size_email_2)         ? $size_email_2         : '60',
			'maxlength'              => isset($maxlength_email_2)    ? $maxlength_email_2    : '255',
			'before'                 => isset($before_email_2)       ? $before_email_2       : '',
			'after'                  => isset($after_email_2)        ? $after_email_2        : '',
			'style'                  => isset($style_email_2)        ? $style_email_2        : '',
			'class'                  => isset($class_email_2)        ? $class_email_2        : '',
			'id'                     => 'mbr_new_email2',
		];

		$arrFORM['mbr_submit_new_email']  = [
			'type'                   => 'submit',
			'value'                  => $button_text,
			'before'                 => isset($before_submit_button) ? $before_submit_button : '',
			'after'                  => isset($after_submit_button)  ? $after_submit_button  : '',
			'style'                  => isset($style_submit_button)  ? $style_submit_button  : '',
			'class'                  => isset($class_submit_button)  ? $class_submit_button  : '',
			'id'                     => isset($id_submit_button)     ? $id_submit_button     : ''
		];

		$retVAL .= $this->build_form($arrFORM);
		$retVAL  = "<script>function check_mbr_change_email_form(){if(document.mbr_change_user_email.mbr_new_email1.value=='' || document.mbr_change_user_email.mbr_new_email2.value=='' || document.mbr_change_user_email.mbr_new_email1.value !== document.mbr_change_user_email.mbr_new_email2.value){alert('" . __('Please enter the same new email address in both input fields.', 'activemember360') . "');return false;}}</script>" . $retVAL;

		return $content . $retVAL;
	}

	function email_change()
	{
		
		
		IF (!$this->CONTACTID OR 'POST' !== strtoupper($_SERVER['REQUEST_METHOD']) OR empty($_POST['mbr_action']) OR $_POST['mbr_action'] <> 'mbr_change_user_email') :
			return;
		ENDIF;
		
		$cookie_expiration = time() + 15;

		$_POST['mbr_new_email1'] = lower_trim($_POST['mbr_new_email1']);
		$_POST['mbr_new_email2'] = lower_trim($_POST['mbr_new_email2']);
		IF (empty($_POST['mbr_new_email1']) OR empty($_POST['mbr_new_email2'])) :
			
			setcookie('changeemailcode[status]', 'false', $cookie_expiration);
			setcookie('changeemailcode[message]', __('You must enter your new email twice. Please try again.', 'activemember360'), $cookie_expiration);
		
		ELSEIF ($_POST['mbr_new_email1'] <> $_POST['mbr_new_email2']) :
			
			setcookie('changeemailcode[status]', 'false', $cookie_expiration);
			setcookie('changeemailcode[message]', __('Your emails did not match. Please try again.', 'activemember360'), $cookie_expiration);
		ELSE :
			$new_email = $_POST['mbr_new_email1'];
			IF ($foundUSER = email_exists($new_email)) :
				
				setcookie('changeemailcode[status]', 'false', $cookie_expiration);
				setcookie('changeemailcode[message]', __('The email address entered already exists. Please use a different one.', 'activemember360'), $cookie_expiration);
			ELSEIF ($objCONTACT = $this->api("contact_view_email?email={$new_email}") AND (int)$objCONTACT->result_code) :
				
				setcookie('changeemailcode[status]', 'false', $cookie_expiration);
				setcookie('changeemailcode[message]', __('The email address entered already exists. Please use a different one.', 'activemember360'), $cookie_expiration);
			ELSEIF ($this->save_contact_fields(['id' => $this->CONTACTID, 'email' => $new_email])) :
				$GLOBALS['current_user']->user_email = $new_email;
				wp_update_user($GLOBALS['current_user']);
				
				setcookie('changeemailcode[status]', 'true', $cookie_expiration);
				setcookie('changeemailcode[message]', __('Your email address was changed successfully.', 'activemember360'), $cookie_expiration);
				$this->update_cookie($GLOBALS['current_user']->ID, $new_email . '|' . date('YmdHis'));
				$this->fetch_contact(['id' => $this->CONTACTID, 'local' => false, 'sync' => false]);
				$this->delete_cookie(MBR_COOKIE_NAME);
				$this->create_user_cookie($this->SESSION['hash']);
				IF (is_email($GLOBALS['current_user']->user_login)) :
					$this->wpdb->update($this->wpdb->users, ['user_login' => $new_email], ['ID' => $GLOBALS['current_user']->ID]);
				ENDIF;
				$user = $GLOBALS['current_user'];
				wp_cache_delete($user->ID, 'users');
				wp_clear_auth_cookie();
				wp_set_current_user($user->ID);
				wp_set_auth_cookie($user->ID, 'forever', is_ssl());
			ELSE :
				
				setcookie('changeemailcode[status]', 'false', $cookie_expiration);
				setcookie('changeemailcode[message]', __('Your email address could not be changed. Please try again.', 'activemember360'), $cookie_expiration);
			ENDIF;
		ENDIF;
		
		
		$current_url = home_url( add_query_arg( [], $GLOBALS['wp']->request ) );
		wp_safe_redirect( $current_url );
		
		exit;
	}

	
	function sc_show_before_or_after($parm='', $content=null, $scname='')
	{
		DO
		{
			$match  = false;

			extract($this->shortcode_atts(['date' => '', 'adjust' => ''], $parm));

			$date   = trim($date);
			$adjust = trim($adjust);

			
			IF (empty($date)) :
				break; 
			ENDIF;

			$sc_now    = current_time('timestamp');
			$sc_adjust = empty($adjust) ? FALSE : trim($adjust);

			DO {

				
				IF ('#USER_REGISTERED#' == strtoupper($date)) :
					
					IF (!is_user_logged_in()) :
						break 2;
					ENDIF;
					
					$sc_date = $this->current_user->user_registered;
					break;
				ENDIF;

				
				IF ($field_name = preg_match('/\%(.*)\%/i', $date, $field_match) AND !empty($field_match[1])) :
					
					IF (!$this->CONTACTID) :
						break 2;
					ENDIF;
					$field_name = strtolower($field_match[1]);
					IF (!empty($this->SESSION[$field_name])) :
						
						$sc_date = $this->SESSION[$field_name];
					ENDIF;
					break;
				ENDIF;

				
				IF ($tmp_date = strtotime($date)) :
					$sc_date = $date;
					break;
				ENDIF;

			} WHILE (false);

			
			$sc_date = strtotime($sc_date);

			
			IF (FALSE === $sc_date) :
				break;
			ENDIF;

			$sc_adjust = ($adjust) ? strtotime($adjust, $sc_date) : $sc_date;

			
			IF (!$sc_adjust) :
				break;
			ENDIF;

			IF ($scname == "{$this->scPREFIX}_show_before") :
				IF ($sc_now < $sc_adjust) :
					$match = true;
				ENDIF;
			ELSE :
				IF ($sc_now > $sc_adjust) :
					$match = true;
				ENDIF;
			ENDIF;

		} WHILE (false);

		
		IF ($scname == "{$this->scPREFIX}_show_before") :
			$match == !$match;
		ENDIF;

		return $this->split_else_content($content, $scname, $match);
	}

	
	function sc_show_between($parm='', $content=null, $scname='')
	{
		$match = false;
		DO
		{
			extract($this->shortcode_atts(['date' => '', 'date2' => ''], $parm));
			$date     = trim($date);
			$date2    = trim($date2);
			$now_date = current_time('timestamp');

			
			IF (empty($date) OR empty($date2)) :
				break;
			ENDIF;

			DO
			{
				
				IF ('#USER_REGISTERED#' == strtoupper($date)) :
					IF (!is_user_logged_in() OR empty($this->current_user->user_registered)) :
						break 2;
					ENDIF;
					
					$tmp_date = strtotime($this->current_user->user_registered);
					
					IF (FALSE === $tmp_date) :
						break 2;
					ENDIF;
					
					$from_date = $this->normalize_timestamp($tmp_date);
					break;
				ENDIF;

				
				IF ($field_name = preg_match('/\%(.*)\%/i', $date, $field_match) AND !empty($field_match[1])) :
					
					IF (!$this->CONTACTID) :
						break 2;
					ENDIF;
					$field_name = strtolower($field_match[1]);
					IF (empty($this->SESSION[$field_name])) :
						break 2;
					ENDIF;
					
					$tmp_date = strtotime($this->SESSION[$field_name]);
					
					IF (FALSE === $tmp_date) :
						break 2;
					ENDIF;
					
					$from_date = $this->normalize_timestamp($tmp_date);
					break;
				ENDIF;

				
				$tmp_date = strtotime($date);

				
				IF (FALSE === $tmp_date) :
					break 2;
				ENDIF;

				
				$from_date = $this->normalize_timestamp($tmp_date);

			} WHILE (false);

			DO {

				
				IF ($field_name = preg_match('/\%(.*)\%/i', $date2, $field_match) AND !empty($field_match[1])) :
					
					IF (!$this->CONTACTID) :
						break 2;
					ENDIF;
					$field_name = strtolower($field_match[1]);
					IF (empty($this->SESSION[$field_name])) :
						break 2;
					ENDIF;
					
					$tmp_date = strtotime($this->SESSION[$field_name]);
					
					IF (FALSE === $tmp_date) :
						break 2;
					ENDIF;
					
					$to_date = $this->normalize_timestamp($tmp_date);
					break;
				ENDIF;

				
				IF (in_array(substr($date2, 0, 1), ['+', '-'])) :
					
					IF (FALSE === strtotime($date2)) :
						break2;
					ENDIF;
					$tmp_date = strtotime($from_date . ' ' . $date2);
					
					IF (FALSE === $tmp_date) :
						break 2;
					ENDIF;
					$to_date = $this->normalize_timestamp($tmp_date);
					break;
				ENDIF;

				$tmp_date = strtotime($date2);
				
				IF (FALSE === $tmp_date) :
					break 2;
				ENDIF;

				$to_date = $this->normalize_timestamp($tmp_date);

			} WHILE (false);

			
			IF (empty($from_date) OR empty($to_date)) :
				break;
			ENDIF;

			$from_date = strtotime($from_date);
			$to_date   = strtotime($to_date);

			IF (!$from_date OR !$to_date) :
				break;
			ENDIF;

			
			IF ($from_date > $to_date) :
				swap($from_date, $to_date);
			ENDIF;

			
			
			IF ($now_date >= $from_date AND $now_date <= $to_date) :
				$match = true;
			ENDIF;

		} WHILE (false);

		return $this->split_else_content($content, $scname, $match);
	}

	function sc_member_dir($parm='', $content=null, $scname='')
	{
		global $MBR_OPTIONS;

		$defaults = ['editable' =>'no', 'tag'=>false, 'list_id'=>false, 'fields'=>'', 'edit_fields' => false, 'edit_labels' => false, 'only_contact_id'=>'', 'headers'=>'yes', 'header_labels' => false, 'avatar_header' => '', 'avatar_field' => '', 'avatar_size' => $MBR_OPTIONS['avatar_size'], 'avatar_default' => 'mm', 'avatar_alt' => '', 'only_self_edit' => 'no', 'automations' => 'no', 'page_length' => 10];
		extract($this->shortcode_atts($defaults, $parm ));

		$tmp_formats    = array_diff_key($parm, $defaults);
		$formats        = [];
		FOREACH ($tmp_formats AS $perstag => $format) :
			$formats[lower_trim($perstag)] = $format;
		ENDFOREACH;
		$json_formats   = urlencode(json_encode($formats));

		$only_self_edit = strtolower($only_self_edit);

		IF ($only_self_edit == 'yes') :
			$automations = 'no';
		ENDIF;
		$automations = strtolower($automations);
		IF ($automations <> 'no') :
			$arrAUTOMATIONS = $this->site_automations; 
			IF ($automations <> 'yes') :
				IF ($tmpAU = array_flip(explode(',', $automations)) AND $tmpAU AND is_array($tmpAU)) :
					$newAU = array_intersect_key($arrAUTOMATIONS, $tmpAU);
					IF ($newAU AND is_array($newAU)) :
						$automations = 'yes';
						$arrAUTOMATIONS =& $newAU;
					ELSE :
						$automations = 'no';
					ENDIF;
				ELSE :
					$automations = 'no';
				ENDIF;
			ENDIF;
			IF ($automations <> 'no') :
				natcasesort($arrAUTOMATIONS);
				$auSTRING[] = "{label: 'Select an automation', value: '0'}";
				FOREACH ($arrAUTOMATIONS AS $auID => $auNAME) :
					$auSTRING[] = "{label: '" . addslashes($auNAME) . "', value: '{$auID}'}";
				ENDFOREACH;
				$auSTRING = implode(',', $auSTRING);
			ENDIF;
		ENDIF;

		$only_contact_id = (int)$only_contact_id;
		$page_length     = (int)$page_length;

		IF ($only_contact_id AND !in_array($this->CONTACTID, array_filter(explode(',', $only_contact_id))) AND !MBRADMIN) :
			return null;
		ENDIF;

		IF (!$fields) :
			return null;
		ENDIF;

		IF (!$tag AND !$list_id) :
			return null;
		ENDIF;

		IF ($page_length < 1) :
			$page_length  = 20;
		ENDIF;

		$SC_ID          = uniqid();
		$tag_id         = $this->normalize_tag_ids($tag);

		$arrFIELDS      = $fields ? array_filter(explode(",", $fields)) : [];
		$avatar_default = urlencode($avatar_default);
		$avatar_size    = (int)$avatar_size;
		$avatar_size    = ($avatar_size AND $avatar_size <= 128) ? $avatar_size : (int)$MBR_OPTIONS['avatar_size'];
		$avatar_found   = false;
		$arrHDRMAP      = $header_labels ? explode(',', $header_labels) : [];

		$arrTBLFIELDS = [];
		FOREACH ($arrFIELDS as $k => $v) :
			$v = trim($v);
			IF ($v AND isset($arrHDRMAP[$k])) :
				$arrTBLFIELDS[$arrFIELDS[$k]] = $arrHDRMAP[$k];
			ELSE:
				$arrTBLFIELDS[$arrFIELDS[$k]] = $v;
			ENDIF;
		ENDFOREACH;

		FOREACH ($arrTBLFIELDS AS $field => $label) :
			IF (in_array(strtolower($field), ['avatar', 'gravatar'])) :
				$avatar_found   = true;
				IF (isset($arrTBLFIELDS[$field])) :
					unset($arrTBLFIELDS[$field]);
				ENDIF;
				$tmp           = $avatar_header ? $avatar_header : $label;
				$arrTBLFIELDS  = array_merge(['avatar' => $tmp], $arrTBLFIELDS);
				break;
			ENDIF;
		ENDFOREACH;

		IF (!trim($edit_fields)) :
			$edit_fields = $fields;
			$edit_labels = $header_labels;
		ENDIF;

		$json_edit_fields = explode(',', $edit_fields);
		$json_edit_fields = array_flip($json_edit_fields);
		IF (isset($json_edit_fields['avatar'])) :
			unset($json_edit_fields['avatar']);
		ENDIF;
		$json_edit_fields = array_flip($json_edit_fields);
		$json_edit_fields = implode(',', $json_edit_fields);
		$json_edit_fields = urlencode($json_edit_fields);

		IF (!$edit_labels) :
			$edit_labels = $edit_fields;
		ENDIF;

		$tmp           = $edit_fields ? explode(',', $edit_fields) : [];
		$arrEDITLABELS = $edit_labels ? explode(',', $edit_labels) : [];
		$arrEDITFIELDS = [];
		FOREACH ($tmp as $k => $v) :
			$v = trim($v);
			IF ($v) :
				IF (isset($arrEDITLABELS[$k]) AND $arrEDITLABELS[$k]) :
					$arrEDITFIELDS[$v] = $arrEDITLABELS[$k];
				ELSE:
					$arrEDITFIELDS[$v] = $v;
				ENDIF;
			ENDIF;
		ENDFOREACH;

		$arrALLFIELDS = array_merge($arrTBLFIELDS,$arrEDITFIELDS);
		$dt_sorting   = "pageLength: $page_length, order: [[1, 'asc']]";
		IF ($editable == 'yes') :
			$last_field   = count($arrALLFIELDS);
			IF ($avatar_found) :
				$dt_sorting   .= ", columnDefs: [{targets: [0, $last_field], orderable: false}]";
			ELSE :
				$dt_sorting   .= ", columnDefs: [{targets: $last_field, orderable: false}]";
			ENDIF;
		ELSE :
			IF ($avatar_found) :
				$dt_sorting   .= ", columnDefs: [{targets: [0], orderable: false}]";
			ENDIF;
		ENDIF;

		$retFIELDS[] = 'id';
		FOREACH ($arrALLFIELDS AS $field => $label) :
			IF ($field == 'avatar') :
				$retFIELDS[] = 'email';
			ELSE :
				$retFIELDS[] = $field;
			ENDIF;
		ENDFOREACH;
		$arrROWS   = [];
		$retFIELDS = array_unique($retFIELDS);
		$retFIELDS = array_values($retFIELDS);

		$filters         = '';
		IF ($list_id <> '') :
			$filters .= "&filters[listid]={$list_id}";
		ENDIF;
		IF ($tag_id <> '') :
			$filters .= "&filters[tagid]={$tag_id}";
		ENDIF;

		IF ($tag_id == '') :
			$limit  = 100;
			$offset = 0;
			DO {
				$objA = $this->api("contact_paginator?sort=01&offset={$offset}&limit={$limit}" . $filters);
				IF (!$objA OR !is_object($objA) OR $objA->result_code == 0) :
					break;
				ENDIF;
				FOREACH ($objA->rows as $key => $obj) :
					IF (is_object($obj) AND isset($obj->id)) :
						$objCONTACTS[$obj->id] = $obj;
					ENDIF;
				ENDFOREACH;
				$offset += $limit;
			} WHILE (count($objA->rows) == $limit);
		ELSE:
			$limit  = 20;
			$page   = 0;
			DO {
				$cntA = 0;
				$objA = $this->api("contact_list?page=" . $page++ . $filters);
				IF (!$objA OR !is_object($objA) OR $objA->result_code == 0) :
					break;
				ENDIF;
				FOREACH ($objA as $key => $obj) :
					IF (is_object($obj) AND isset($obj->id)) :
						$cntA++;
						$objCONTACTS[$obj->id] = $obj;
					ENDIF;
				ENDFOREACH;
			} WHILE ($cntA == $limit);
		ENDIF;

		FOREACH ($objCONTACTS AS $filler => $thisREC) :
			$retROW = "<tr id='row_{$thisREC->id}'>";
			FOREACH ($arrTBLFIELDS AS $field => $label) :
				$field = lower_trim($field);
				IF ($field == 'avatar') :
					$email   = isset($thisREC->email) ? $thisREC->email : '';
					$uniqID  = uniqid();
					$retROW .= "<td><img id='{$uniqID}' width='{$avatar_size}' height='{$avatar_size}' /><script>mbr_get_gravatar('{$uniqID}', '{$email}',{$avatar_size},'{$avatar_default}');</script></td>";
				ELSE :
					$retROW .= '<td>';
					IF (isset($this->site_regular_fields[$field])) :
						$retROW .= isset($thisREC->$field) ? $this->encode($thisREC->$field) : '&nbsp;';
					ELSE :
						$perstag = upper_trim($field);
						IF (isset($this->cust_fields_perstag_key[$perstag])) :
							$field_id = $this->cust_fields_perstag_key[$perstag];
							IF (array_key_exists($field, $formats)) :
								IF ($thisREC->fields->$field_id->val) :
									$thisREC->fields->$field_id->val = date($formats[$field], strtotime($thisREC->fields->$field_id->val));
								ENDIF;
							ENDIF;
							$retROW .= $thisREC->fields->$field_id->val;
						ENDIF;
					ENDIF;
					$retROW .= '</td>';
				ENDIF;
			ENDFOREACH;
			FOREACH ($arrEDITFIELDS AS $field => $label) :
				IF (!array_key_exists($field, $arrTBLFIELDS)) :
					$retROW .=  '<td style="display:none;">' . (isset($thisREC->$field) ? $this->encode($thisREC->$field) : '&nbsp;') . '</td>';
				ENDIF;
			ENDFOREACH;
			IF ($editable == 'yes') :
				IF ($only_self_edit <> 'yes' OR ($only_self_edit == 'yes' AND $thisREC->id == $this->CONTACTID)) :
					$retROW .= "<td><span style='cursor:pointer;' class='editor_edit'>Edit</span></td>";
				ELSE:
					$retROW .= "<td></td>";
				ENDIF;
			ENDIF;
			$retROW .= '</tr>';
			$arrROWS[] = $retROW;
		ENDFOREACH;
		sort($arrROWS);
		$retSTR = implode('',$arrROWS);
		IF (isset($arrROWS)) :
			unset($arrROWS);
		ENDIF;

		$retHDR = '';
		IF (trim($retSTR) <> '') :
			IF (strtolower($headers) == 'yes') :
				$retHDR .= '<tr class="mbrmemberdirhead">';
				FOREACH ($arrTBLFIELDS AS $field => $label) :
					IF ($field == 'avatar') :
						$label = '&nbsp;';
					ENDIF;
					$retHDR .= '<th>' . ucfirst($label) . '</th>';
				ENDFOREACH;
				FOREACH ($arrEDITFIELDS AS $field => $label) :
					IF (!array_key_exists($field, $arrTBLFIELDS)) :
						$retHDR .= '<th style="display:none;"></th>';
					ENDIF;
				ENDFOREACH;
				IF ($editable == 'yes') :
					$retHDR .= '<th>Action</th>';
				ENDIF;
				$retHDR .= '</tr>';
				$thead = "<thead>{$retHDR}</thead>";
				$tfoot = "<tfoot>{$retHDR}</tfoot>";
			ENDIF;
			$ret      = '';
			static $has_loaded = 0;
			IF (!$has_loaded++) :
				$ret   .= "<script type='text/javascript' src='{$this->md5_js_url}'></script>";
				$ret   .= "<script>function mbr_get_gravatar(uniqid, email, size, default_image) { jQuery('#' + uniqid).attr('src', 'https://secure.gravatar.com/avatar/' + CryptoJS.MD5(email.toLowerCase().trim()) + '?s=' + size + '&d=' + default_image); }</script>";
			ENDIF;

			$div_id   = uniqid();
			$ret     .= "<script>var editor;jQuery(document).ready(function(){ ";
			IF ($editable == 'yes') :
				$ret     .= "editor = new jQuery.fn.dataTable.Editor({ajax:ajaxurl + '?action=ajax_update_memberdir&only_self_edit=$only_self_edit&formats=" . $json_formats . "&edit_fields=" . $json_edit_fields . "',table:'#{$div_id}',fields:[";
				IF ($automations <> 'no') :
					$ret .= "{label: 'Run automation', name: 'runautomation', type: 'select', options: [{$auSTRING}]},";
				ENDIF;

				FOREACH ($arrALLFIELDS AS $field => $label) :
					IF (in_array($field, ['gravatar', 'avatar', 'id', 'Id', 'Password', 'password']) OR !array_key_exists($field, $arrEDITFIELDS)) :
						IF (isset($arrEDITFIELDS[$field])) :
							IF (isset($arrEDITFIELDS[$field])) :
								unset($arrEDITFIELDS[$field]);
							ENDIF;
						ENDIF;
						$ret .= "{label: '{$label}', name: '{$field}', type:'hidden', data: function(row, type, val) {return row.{$field}.replace('&nbsp;', '');}},";
					ENDIF;
				ENDFOREACH;
				FOREACH ($arrEDITFIELDS AS $field => $label) :
					$ret .= "{label: '{$label}', name: '{$field}', data: function(row, type, val) {return row.{$field}.replace('&nbsp;', '');}},";
				ENDFOREACH;
				$ret     .= "]});";
				$ret     .= "jQuery('#{$div_id}').on('click', 'span.editor_edit', function (e) {e.preventDefault(); editor.edit( jQuery(this).closest('tr'), {title:'Edit record',buttons:'Update'});});";
			ENDIF;
			$ret     .= "jQuery('#{$div_id}').DataTable({{$dt_sorting},dom:'Bfrtip',columns:[";
			$json_all_fields = '';
			FOREACH ($arrALLFIELDS AS $field => $label) :
				$json_all_fields   .= "{data: '{$field}'},";
			ENDFOREACH;
			$ret .= trim($json_all_fields,',');
			IF ($editable == 'yes') :
				$ret   .= ",{data: this.value, className: 'center', defaultContent: '<span  style=\'cursor:pointer;\' class=\'editor_edit\'>Edit</span>'}";
			ENDIF;
			$ret     .= "]})});</script>";
			$ret     .= "<div id='mbrmemberdir'><table id='{$div_id}' class='display'>{$thead}{$tfoot}<tbody>{$retSTR}</tbody></table></div>" . $content;
			$this->ob_member_dir[$div_id] = $ret;  
			return "{~~~~~{$div_id}~~~~~}";
		ENDIF;
		return null;
	}

	function sc_form($parm='', $content=null, $scname='')
	{
		
		extract($this->shortcode_atts(['form_id' => null, 'status' => 'all', 'tags' => '', 'exclude_tags' => '', 'populate' => 'yes'], $parm ));
		$populate = substr(lower_trim($populate), 0,1);

		$arrFIELDS = [];
		FOREACH ($this->site_cust_fields AS $k => $cust_field) :
			$arrFIELDS[lower_trim($cust_field['perstag'])] = ['field_id' => $cust_field['id'], 'field_type' => $cust_field['type']];
		ENDFOREACH;

		$status   = substr(lower_trim($status), 0,1);
		IF (MBRADMIN) :
			$status = 'a';
		ELSEIF ($status == 'm') :
			IF (!$this->CONTACTID) :
				return;
			ENDIF;
		ELSEIF ($status == 'v') :
			IF (is_user_logged_in()) :
				return;
			ENDIF;
		ENDIF;
		IF ($status == 'm') :
			$arrTAGS      = array_flip($this->normalize_tag_ids($tags, true));
			$arrNOTTAGIDS = $this->normalize_tag_ids($exclude_tags, true);
			IF ($arrNOTTAGIDS) :
				FOREACH ($arrNOTTAGIDS as $k => $thisTAGID) :
					IF (array_key_exists($thisTAGID, $this->MBRTAGS)) :
						return;
					ENDIF;
				ENDFOREACH;
			ENDIF;
			IF ($arrTAGS AND !$this->check_member_tags($arrTAGS, false)) :
				return;
			ENDIF;
		ENDIF;

		$return = "<div class='_form_{$form_id}'></div><script src='https://{$this->ac_account_info->account}/f/embed.php?id={$form_id}' type='text/javascript' charset='utf-8'></script>";
		IF ($this->CONTACTID AND in_array($populate, ['t','y','1'])) :
			$return   .= "<script>jQuery(document).ready(function() {";

			FOREACH ($this->SESSION AS $field => $value) :
				IF ($field == 'first_name') :
					$field = 'firstname';
				ENDIF;
				IF ($field == 'last_name') :
					$field = 'lastname';
				ENDIF;
				IF ($field == 'name') :
					$field = 'fullname';
				ENDIF;

				$input_type = 'text';
				IF (!empty($arrFIELDS[$field]['field_type']) AND $input_type <> $arrFIELDS[$field]['field_type']) :
					$input_type = $arrFIELDS[$field]['field_type'];
				ENDIF;

				IF (in_array($input_type, ['text', 'date', 'hidden', 'textarea', 'dropdown'])) :
					IF ($input_type == 'textarea') :
						$value   = base64_encode($value);
						$return .= "this_value = atob('{$value}');";
					ELSE:
						$return .= "this_value = '{$value}';";
					ENDIF;
					$return   .= "if (this_value != '') {jQuery(\"._form_{$form_id} [data-name='{$field}']\").val(this_value);}";
				ELSEIF ($input_type == 'radio') :
					$return .= "jQuery(\"._form_{$form_id} [data-name='{$field}'][value='{$value}']\").prop('checked', true);";
				ELSEIF ($input_type == 'checkbox') :
					$value = trim($value, '|');
					$arrVALUES = explode('||', $value);
					FOREACH ($arrVALUES AS $k => $v) :
						$return .= "jQuery(\"._form_{$form_id} [data-name='{$field}'][value='{$v}']\").prop('checked', true);";
					ENDFOREACH;
				ELSEIF ($input_type == 'listbox') :
					$value     = trim($value, '|');
					$arrVALUES = explode('||', $value);
					FOREACH ($arrVALUES AS $k => $v) :
						$return .= "jQuery(\"._form_{$form_id} [data-name='{$field}'] option[value='{$v}']\").prop('selected', true);";
					ENDFOREACH;
				ENDIF;
			ENDFOREACH;

			$return   .= "});</script>";
		ENDIF;
		return $return;
	}

	function sc_math($parm='', $content=null, $scname='')
	{
		extract($this->shortcode_atts(['field' => '', 'operation' => '', 'value' => '', 'round' => '', 'flip' => 0, 'show' => 1, 'format' => '', 'target' => ''], $parm ));

		$field = lower_trim($field);
		IF ($field == '' OR $operation == '' OR $value == '')  :
			return null;
		ENDIF;

		$target = lower_trim($target);
		IF ($target <> 'noupdate') :
			IF ($target == '') :
				$target = $field;
			ENDIF;
		ENDIF;

		$operation = lower_trim(substr($operation,0,3));
		IF (!in_array($operation, ['add', 'sub', 'div', 'mul', 'pow', 'mod', 'sqr', 'max', 'min'])) :
			return null;
		ENDIF;

		IF ($this->CONTACTID) :
			$this->fetch_contact(['id' => $this->CONTACTID, 'local' => false, 'sync' => true], true);
		ENDIF;

		IF (isset($this->SESSION[$field])) :
			$op1 = $this->encode($this->SESSION[$field]);
		ELSE :
			$op1 = $field;
		ENDIF;

		$op2 = $value;
		IF ($this->CONTACTID) :
			IF (is_string($value)) :
				IF (isset($this->SESSION[$value])) :
					$op2 = (float)$this->SESSION[$value];
				ENDIF;
			ENDIF;
		ENDIF;

		IF ($flip == 1) :
			$tmp2 = $op2;
			$op2  = $op1;
			$op1  = $tmp2;
		ENDIF;

		$op1 = (float)$op1;
		$op2 = (float)$op2;

		$result    = 0;
		IF ($operation == 'add') :
			$result = $op1 + $op2;
		ELSEIF ($operation == 'sub') :
			$result = $op1 - $op2;
		ELSEIF ($operation == 'div') :
			$result = ($op1 == 0 OR $op2 == 0) ? 0 : $op1 / $op2;
		ELSEIF ($operation == 'mul') :
			$result = $op1 * $op2;
		ELSEIF ($operation == 'pow') :
			$result = pow($op1,$op2);
		ELSEIF ($operation == 'mod') :
			$result = ($op1 == 0 OR $op2 == 0) ? 0 : $op1 % $op2;
		ELSEIF ($operation == 'sqr') :
			$result = sqrt($op1);
		ELSEIF ($operation == 'max') :
			$result = max($op1, $op2);
		ELSEIF ($operation == 'min') :
			$result = min($op1, $op2);
		ENDIF;

		IF ($round <>'') :
			$round  = (int)$round;
			$result = round($result, $round);
		ENDIF;

		IF ($format <> '') :
			$result = sprintf($format, $result);
		ENDIF;

		IF ($target == 'noupdate') :
			return $show ? $result : null;
		ENDIF;

		IF ($this->CONTACTID) :
			$arrUPD = [];
			IF (in_array($target, $this->contact_std_fields)) :
				$arrUPD[lower_trim($target)] = $value;
			ELSE:
				FOREACH ($this->site_cust_fields AS $k => $cust_field) :
					IF ($target == lower_trim($cust_field['perstag'])) :
						$arrUPD['field[%' . strtoupper($target) . '%]'] = $result;
						break;
					ENDIF;
				ENDFOREACH;
			ENDIF;
			IF (!empty($arrUPD)) :
				$arrUPD['email'] = $this->SESSION['email'];
				$contact_sync = $this->api('contact_sync', $arrUPD);
				IF ($contact_sync->result_code == 1) :
					IF ($show) :
						return $result;
					ENDIF;
				ENDIF;
			ENDIF;
		ENDIF;

		return null;
	}

	function sc_my_account($parm, $content=null, $scname)
	{
		IF ((defined('DOING_AJAX') AND DOING_AJAX) OR (defined('DOING_CRON') AND DOING_CRON)) :
			return null;
		ENDIF;

		static $has_run = FALSE;
		IF ($has_run) :
			return null;
		ENDIF;
		$has_run = true;

		extract( $this->shortcode_atts( [ 'fields' => '', 'label' => 'top', 'min_width' => '', 'max_width' => '', 'submit_button_label' => __( 'Save', 'activemember360' ) ], $parm ) );

		IF ( !$this->CONTACTID OR empty( $fields ) ) :
			
			return null;
		ENDIF;

		$arr_not_allowed_fields = ['id', 'email', 'password'];
		$arrFIELDSTMP = explode(',', $fields);

		FOREACH ($arrFIELDSTMP AS $field) :
			$tfield = explode('|', $field);
			$arrFIELDS[$tfield[0]] = !empty($tfield[1]) ? $tfield[1] : $tfield[0];
		ENDFOREACH;

		IF (isset($_POST['mbr-submit-my-account'])) :
			unset($_POST['mbr-submit-my-account']);

			$arrUPD = [];

			FOREACH ($_POST AS $pfield => $value) :
				$pfield = lower_trim($pfield);
				IF (in_array($pfield, $arr_not_allowed_fields)) :
					continue;
				ENDIF;
				IF (in_array($pfield, $this->contact_std_fields)) :
					$arrUPD[$pfield] = $value;
				ELSE:
					FOREACH ($this->site_cust_fields AS $k => $cust_field) :
						IF ($pfield == lower_trim($cust_field['perstag'])) :
							$arrUPD['field[%' . strtoupper($pfield) . '%]'] = $value;
							break;
						ENDIF;
					ENDFOREACH;
				ENDIF;
			ENDFOREACH;

			IF (!empty($arrUPD)) :
				$arrUPD['email'] = $this->SESSION['email'];
				$contact_sync = $this->api('contact_sync', $arrUPD);
				IF ($contact_sync->result_code == 1) :
					FOREACH ($_POST AS $field => $value) :
						IF (isset($this->SESSION[$field])) :
							$this->SESSION[$field] = $value;
						ENDIF;
					ENDFOREACH;
				ENDIF;
			ENDIF;

		ENDIF;

		IF ($label == 'placeholder') :
			$form_class           = 'mbr-placeholder-form';
			$placeholder_or_label = 'placeholder';
		ELSEIF ($label == 'left') :
			$form_class           = 'mbr-label-left';
			$placeholder_or_label = 'label';
		ELSE :
			$form_class           = 'mbr-label-above';
			$placeholder_or_label = 'label';
		ENDIF;

		$arrFORM                = [];
		$arrFORM['before']      = '';
		$arrFORM['after']       = '';
		$arrFORM['form']        = ['method' => 'post', 'name'  => 'mbr_my_account', 'action' => '', 'class' => 'mbr-forms ' . $form_class];
		$arrFORM['min_width']   = !empty($min_width) ? $min_width : '';
		$arrFORM['max_width']   = !empty($max_width) ? $max_width : '';

		$arr_standard_contact_fields = ['first_name' => 'text', 'last_name' => 'text', 'email' => 'text', 'phone' => 'text'];

		$arr_contact_fields = [];

		FOREACH ($arr_standard_contact_fields AS $field => $type) :
			$arr_contact_fields[lower_trim($field)] = $type;
		ENDFOREACH;

		FOREACH ($this->site_cust_fields AS $k => $cust_field) :
			IF (!empty($cust_field['perstag'])) :
				$arr_contact_fields[lower_trim($cust_field['perstag'])] = $cust_field['type'];
			ENDIF;
		ENDFOREACH;

		FOREACH ($arrFIELDS AS $field => $field_label) :
			$size_field             = "size_{$field}";
			$maxlength_field        = "maxlength_{$field}";
			$before_field           = "before_{$field}";
			$after_field            = "after_{$field}";
			$style_field            = "style_{$field}";
			$class_field            = "class_{$field}";
			$field_type             = $field == 'password' ? 'password' : $arr_contact_fields[$field];
			$arrFORM[$field]        = [
				'type'                => $field_type,
				'value'               => !empty($this->SESSION[$field]) ? $this->SESSION[$field] : '',
				$placeholder_or_label => $field_label,
				'size'                => isset($$size_field)         ? $$size_field         : '20',
				'maxlength'           => isset($$maxlength_field)    ? $$maxlength_field    : '255',
				'before'              => isset($$before_field)       ? $$before_field       : '',
				'after'               => isset($$after_field)        ? $$after_field        : '',
				'style'               => isset($$style_field)        ? $$style_field        : '',
				'class'               => isset($$class_field)        ? $$class_field        : '',
				'id'                  => 'mbr-' . $field
			];

			IF (in_array($field, $arr_not_allowed_fields)) :
				$arrFORM[$field]['disabled'] = 'disabled';
			ENDIF;

		ENDFOREACH;

		$arrFORM['mbr-submit-my-account']  = [
			'type'                => 'submit',
			'value'               => $submit_button_label,
			'before'              => isset($before_submit_button) ? $before_submit_button : '',
			'after'               => isset($after_submit_button)  ? $after_submit_button  : '',
			'style'               => isset($style_submit_button)  ? $style_submit_button  : '',
			'class'               => isset($class_submit_button)  ? $class_submit_button  : 'mbr-submit',
			'id'                  => isset($id_submit_button)     ? $id_submit_button     : 'mbr-submit'
		];

		$retCODE = $this->build_form($arrFORM);

		return $content . $retCODE;
	}

	function inject_shortcode()
	{
		global $wp_filter;

		FOREACH ($wp_filter AS $hook => $actions) :

			IF ( in_array( $hook, ['widget_title', 'widget_text', 'the_title', 'the_content'] ) ) :
				continue;
			ENDIF;

			FOREACH ($actions as $priority => $filters) :

				FOREACH ($filters as $filter => $functions) :

					IF ( $filter == 'do_shortcode' ) :
						add_filter( $hook, 'shortcode_unautop',  $priority - 2 );
						add_filter( $hook, [$this, 'shortcode'], $priority - 1 );
					ENDIF;

				ENDFOREACH;

			ENDFOREACH;

		ENDFOREACH;
	}

	function sc_progress_tags( $parm, $content = NULL, $scname )
	{
		








		$parm        = $this->shortcode_atts( [ 'tags' => '', 'format' => 'p', 'callbacks' => '', 'round' => '2' ], $parm );

		$round       = intval( trim( $parm['round'] ) );
		$format      = lower_trim( $parm['format'] );
		$master_tags = explode( ',', $parm['tags'] );
		$master_cnt  = count( $master_tags );
		$callbacks   = $parm['callbacks'];

		$member_tags = empty( $this->CONTACTID ) ? [] : array_keys( $this->MBRTAGS );

		IF ( empty( $member_tags ) ) :
			$progress_tags = [];
			$progress_cnt  = 0;
		ELSE :
			$progress_tags = array_intersect( $member_tags, $master_tags );
			$progress_cnt  = count( $progress_tags );
		ENDIF;

		IF ( $format == 'f' ) :
			$progress_ret = $progress_cnt . '/' . $master_cnt;
		ELSEIF ( $format == 'n' ) :
			$progress_ret = round ( ( $progress_cnt / $master_cnt ), $round );
		ELSEIF ( $format == 'c' ) :
			$progress_ret = $progress_cnt;
		ELSE : 
			$progress_ret = round ( ( ( $progress_cnt / $master_cnt ) * 100 ), $round );
		ENDIF;

		IF ( ! empty( $callbacks ) ) :
			FOREACH ( explode( ',', $callbacks ) AS $k => $callback ) :
				$progress_ret = call_user_func( $callback, $progress_ret, $parm );
			ENDFOREACH;
		ENDIF;

		return $progress_ret;
	}

	function sc_progress_bar( $parm, $content = NULL, $scname )
	{
		$parm            = $this->shortcode_atts( [ 'tags' => '', 'callbacks' => '', 'round' => '0', 'style' => '', 'class' => '', 'id' => '' ], $parm );

		$round           = intval( trim( $parm['round'] ) );
		$master_tags     = explode( ',', $parm['tags'] );
		$master_cnt      = count( $master_tags );
		$callbacks       = $parm['callbacks'];

		$member_tags     = empty( $this->CONTACTID ) ? [] : array_keys( $this->MBRTAGS );

		IF ( empty( $member_tags ) ) :
			$progress_cnt  = 0;
		ELSE :
			$progress_tags = array_intersect( $member_tags, $master_tags );
			$progress_cnt  = count( $progress_tags );
		ENDIF;

		$progress_ret    = round ( ( ( $progress_cnt / $master_cnt ) * 100 ), $round );

		IF ( ! empty( $callbacks ) ) :
			FOREACH ( explode( ',', $callbacks ) AS $k => $callback ) :
				$progress_ret = call_user_func( $callback, $progress_ret, $parm );
			ENDFOREACH;
		ENDIF;

		$style   = '';
		IF ( ! empty( $parm['style'] ) ) :
			$style = "style='{$parm['style']}'";
		ENDIF;

		$class   = '';
		IF ( ! empty( $parm['class'] ) ) :
			$class = "class='{$parm['class']}'";
		ENDIF;

		$id      = '';
		IF ( ! empty( $parm['id'] ) ) :
			$id    = "id='{$parm['id']}'";
		ENDIF;

		$progress_ret    = "<progress {$style} {$class} {$id} value='{$progress_ret}' max='100' title='{$progress_ret}%'>{$progress_ret} %</progress>";

		return $progress_ret;
	}

	function sc_progress_meter( $parm, $content = NULL, $scname )
	{
		$parm            = $this->shortcode_atts( [ 'tags' => '', 'callbacks' => '', 'style' => '', 'class' => '', 'id' => '' ], $parm );

		$master_tags     = explode( ',', $parm['tags'] );
		$master_cnt      = count( $master_tags );
		$callbacks       = $parm['callbacks'];

		$member_tags     = empty( $this->CONTACTID ) ? [] : array_keys( $this->MBRTAGS );

		IF ( empty( $member_tags ) ) :
			$progress_cnt  = 0;
		ELSE :
			$progress_tags = array_intersect( $member_tags, $master_tags );
			$progress_cnt  = count( $progress_tags );
		ENDIF;

		IF ( ! empty( $callbacks ) ) :
			FOREACH ( explode( ',', $callbacks ) AS $k => $callback ) :
				$progress_cnt = call_user_func( $callback, $progress_cnt, $parm );
			ENDFOREACH;
		ENDIF;

		$style   = '';
		IF ( ! empty( $parm['style'] ) ) :
			$style = "style='{$parm['style']}'";
		ENDIF;

		$class   = '';
		IF ( ! empty( $parm['class'] ) ) :
			$class = "class='{$parm['class']}'";
		ENDIF;

		$id      = '';
		IF ( ! empty( $parm['id'] ) ) :
			$id    = "id='{$parm['id']}'";
		ENDIF;

		$title        = sprintf( __( '%s of %s', 'activemember360' ), $progress_cnt, $master_cnt );
		$progress_ret = "<meter {$style} {$class} {$id} value='{$progress_cnt}' min='0' max='{$master_cnt}' title='{$title}'>{$title}</meter>";

		return $progress_ret;
	}

}